/*--------------------------------------------------------------------------
	PRG             : MyRpt.prg
	Autor           : MyRpt de Carles Aubia Floresvi  // carles9000@gmail.com
						 : TRegla de Jose Ignacio Jimenez Alarcon
	Fecha           : 12-02-2014
	Description     : Visual Report for Fivewin for Harbour

	Notas           : Al 03-07-2014 Algunas modificaciones de Sebastin Almirn:

						  -Debido a la gran cantidad de clases y funciones que se utilizan,
							se han empaquetado de momento todas las necesarias dentro de este prg,
							para que sea ms facil incorporarlo a nuestas apps. Se han aadido
							lneas y modificado ligeramente la dll, as que de momento solo est en castellano.

						  -La clase TReport que vena se a renombrado a TRpt para
							distinguirla de la de FW

						  -Al mtodo New() de MyRpt se le han aadido los parametros:
								- documento, para abrir un documento especifico, por ejemplo
								  si queremos llamarlo para modificar el formato de factura
								- titulo, para que aparezca el titulo de la ventana de MyRpt
								  personalizado, por ejemplo Diseo de Factura
								- nombre de nuestra app, para que en ciertos mensajes aparezca
								  el nombre de nuestra app y no MyRpt
								- lmenusmart, para eliminar del men ciertas opciones, por ejemplo
								  si llamamos a MyRpt para el diseo de la factura, que no aparezcan
								  opciones de nuevo documento, eliminar, etc.
								- impresora, para que MyRpt utilice una impresora determinada y no
								  la impresora por defecto de Windows
								- oIcon, para mostrar un icono de nuestra app y no el de MyRpt
							Estos parmetros son para su uso con el diseador, mtodo activate() no Run(), y
							si se omiten los parmetros entraremos en modo completo.

						  -A los mtodos PosTop y PosBottom de TRptForm se le ha
							aadido cdigo para subir o bajar los items en el Tree del Inspector
							y que no de problemas al verlos o imprimirlos

						  -Se han modificado los mtodos Activate() y PrintSay() de RptRun,
							para que la salida impresa del documento sea exactamente igual con diferentes impresoras y SO

						  -Se ha modificado para que admita poner items encima de otros,
							por ejemplo says encima de imagenes, con lo que el "impreso" del documento
							puede serguir siendo un EMF como anteriormente o un fichero de imagen JPG, BMP, etc.

						  -Se ha aadido el array ::afixed a la clase MyRpt, para indicar que items son obligatorios,
							en cuyo caso no deja borrarlos ni cambiarles el ID, esto nos puede
							servir para que si el usuario est modificando el diseo de una
							factura, no pueda eliminar por ejemplo el CIF/NIF o el nombre del cliente

						  -Cuando el grid no est activado, se pone el tamao del grid a 0
							para que el movimiento sea sin saltos.

						  -Se ha corregido el mtodo end() de RptRun, porque la funcion pagina XX de YY no funcionaba si no era con preview

						  -Se ha aadido el mtodo PrintRTF() a RptRun para poder imprimir cadenas RichEdit, se utiliza
							para indicarlo al disearlo lo mismos que para los says. Tener en cuenta que si es multipagina se
							debe indicar en las propiedades del item

						  -Se han corregido diversos bugs.



---------------------------------------------------------------------------*/
#include "Fivewin.ch"
//#include "MyRpt.ch"
static oMyRpt
static nTime      := 0
static nSection := 0
static nIditem  := 0
static nKeyitem := 0
static aBarint25:={"00110","10001",'01001','11000','00101','10100','01100','00011','10010','01010'}
static cStartint25:='0000'
static cStopint25:='100'
static cMtStint25:='10000'
static cInStartint25 := '110'
static cInStopint25 := '101'
static ean13derecha:=[1110010110011011011001000010101110010011101010000100010010010001110100]
static ean13izda1:=  [0001101001100100100110111101010001101100010101111011101101101110001011]
static ean13izda2:=  [0100111011001100110110100001001110101110010000101001000100010010010111]
static ean13primero:=[ooooooooeoeeooeeoeooeeeooeooeeoeeooeoeeeoooeoeoeoeoeeooeeoeo]
static parity :=[eeoooeoeooeooeoeoooeoeeooooeeooooeeoeoeooeooeooeoe]
static aCode128 :={"212222",;
						 "222122",;
						 "222221",;
						 "121223",;
						 "121322",;
						 "131222",;
						 "122213",;
						 "122312",;
						 "132212",;
						 "221213",;
						 "221312",;
						 "231212",;
						 "112232",;
						 "122132",;
						 "122231",;
						 "113222",;
						 "123122",;
						 "123221",;
						 "223211",;
						 "221132",;
						 "221231",;
						 "213212",;
						 "223112",;
						 "312131",;
						 "311222",;
						 "321122",;
						 "321221",;
						 "312212",;
						 "322112",;
						 "322211",;
						 "212123",;
						 "212321",;
						 "232121",;
						 "111323",;
						 "131123",;
						 "131321",;
						 "112313",;
						 "132113",;
						 "132311",;
						 "211313",;
						 "231113",;
						 "231311",;
						 "112133",;
						 "112331",;
						 "132131",;
						 "113123",;
						 "113321",;
						 "133121",;
						 "313121",;
						 "211331",;
						 "231131",;
						 "213113",;
						 "213311",;
						 "213131",;
						 "311123",;
						 "311321",;
						 "331121",;
						 "312113",;
						 "312311",;
						 "332111",;
						 "314111",;
						 "221411",;
						 "431111",;
						 "111224",;
						 "111422",;
						 "121124",;
						 "121421",;
						 "141122",;
						 "141221",;
						 "112214",;
						 "112412",;
						 "122114",;
						 "122411",;
						 "142112",;
						 "142211",;
						 "241211",;
						 "221114",;
						 "213111",;
						 "241112",;
						 "134111",;
						 "111242",;
						 "121142",;
						 "121241",;
						 "114212",;
						 "124112",;
						 "124211",;
						 "411212",;
						 "421112",;
						 "421211",;
						 "212141",;
						 "214121",;
						 "412121",;
						 "111143",;
						 "111341",;
						 "131141",;
						 "114113",;
						 "114311",;
						 "411113",;
						 "411311",;
						 "113141",;
						 "114131",;
						 "311141",;
						 "411131",;
						 "211412",;
						 "211214",;
						 "211232",;
						 "2331112"}

static acodabar:={"101010001110",;
						"101011100010",;
						"101000101110",;
						"111000101010",;
						"101110100010",;
						"111010100010",;
						"100010101110",;
						"100010111010",;
						"100011101010",;
						"111010001010",;
						"101000111010",;
						"101110001010",;
						"11101011101110",;
						"11101110101110",;
						"11101110111010",;
						"10111011101110",;
						"10111000100010",;
						"10001000101110",;
						"10100011100010",;
						"10111000100010",;
						"10001000101110",;
						"10100010001110",;
						"10100011100010"}

static cCars := '1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ-. *$/+%'
STATIC aBarras:={'1110100010101110',;
					  '1011100010101110',;
					  '1110111000101010',;
					  '1010001110101110',;
					  '1110100011101010',;
					  '1011100011101010',;
					  '1010001011101110',;
					  '1110100010111010',;
					  '1011100010111010',;
					  '1010001110111010',;
					  '1110101000101110',;
					  '1011101000101110',;
					  '1110111010001010',;
					  '1010111000101110',;
					  '1110101110001010',;//E
					  '1011101110001010',;
					  '1010100011101110',;
					  '1110101000111010',;
					  '1011101000111010',;
					  '1010111000111010',;
					  '1110101010001110',; //K
					  '1011101010001110',;
					  '1110111010100010',;
					  '1010111010001110',;
					  '1110101110100010',;
					  '1011101110100010',;//p
					  '1010101110001110',;
					  '1110101011100010',;
					  '1011101011100010',;
					  '1010111011100010',;
					  '1110001010101110',;
					  '1000111010101110',;
					  '1110001110101010',;
					  '1000101110101110',;
					  '1110001011101010',;
					  '1000111011101010',;//Z
					  '1000101011101110',;
					  '1110001010111010',;
					  '1000111010111010',; // ' '
					  '1000101110111010',;
					  '1000100010100010',;
					  '1000100010100010',;
					  '1000101000100010',;
					  '1010001000100010'}

static cCharcodabar :='0123456789-$:/.+ABCDTN*E'
static aTxtptxt := {}
static uVarItemIP
static aCLientIP
static oTimerIP
static oMenuIP

#include "Constant.ch"
#include "common.ch"
#include 'splitter.ch'
#include 'xBrowse.ch'
#include "Objects.ch"
#include 'error.ch'
#include 'richedit.ch' 


#define RPTVERSION   OemToAnsi( "Beta 0.411" )
#define AUTOR        Chr( HexToDec( 'A9' ) ) + " 2010 Carles Aubia Floresvi - Tarragona"
#define FILE_INI     diruta()+'\MyRpt.ini'

#define BACKGROUND        Rgb(240,248,255)

#define HWND_TOP           0
#define HWND_BOTTOM        1
#define HWND_TOPMOST      -1
#define HWND_NOTOPMOST    -2

#define CLR_BACKGROUND   rgb(173,197,229)

#define ID_YES           6
#define ID_NO            7

#define SRCCOPY            13369376

#define DT_TOP                   0
#define DT_LEFT                  0
#define DT_CENTER                1
#define DT_RIGHT                 2
#define DT_VCENTER               4
#define DT_BOTTOM                8
#define DT_WORDBREAK             16
#define DT_SINGLELINE            32
#define DT_EXPANDTABS            64
#define DT_TABSTOP               128
#define DT_NOCLIP                256
#define DT_EXTERNALLEADING       512
#define DT_CALCRECT              1024
#define DT_NOPREFIX              2048
#define DT_INTERNAL              4096
#define DT_EDITCONTROL           8192
#define DT_PATH_ELLIPSIS         16384
#define DT_END_ELLIPSIS          32768
#define DT_MODIFYSTRING          65536
#define DT_RTLREADING            131072
#define DT_WORD_ELLIPSIS         262144
#define DT_NOFULLWIDTHCHARBREAK  524288
#define DT_HIDEPREFIX            1048576
#define DT_PREFIXONLY            2097152


#define GRUPO    "G"
#define CARACTER "C"
#define NUMERO   "N"
#define LOGICO   "L"
#define LISTA    "A"
#define ACCION   "B"
#define SPINNER  "S"

#define HORZSIZE            4
#define VERTSIZE            6
#define HORZRES             8
#define VERTRES            10
#define LOGPIXELSX         88
#define LOGPIXELSY         90

#define SRCCOPY            13369376

#define TXT_LON                             310
#define TXT_TEST                       pTxt(  1 )
#define TXT_SYS                        pTxt(  2 )
#define TXT_FWRPT                      pTxt(  3 )
#define TXT_SECTION                    pTxt(  4 )
#define TXT_YES                        pTxt(  5 )
#define TXT_NO                         pTxt(  6 )
#define TXT_ERROR                      pTxt(  7 )
#define TXT_INFO                       pTxt(  8 )
#define TXT_FUNCTION                   pTxt(  9 )
#define TXT_MENU_FILE                  pTxt( 11 )
#define TXT_MENU_NEW_PROJECT           pTxt( 12 )
#define TXT_MENU_OPEN                  pTxt( 13 )
#define TXT_MENU_SAVE                  pTxt( 14 )
#define TXT_MENU_SAVE_AS               pTxt( 15 )
#define TXT_MENU_CFG_PRINT             pTxt( 16 )
#define TXT_MENU_PREVIEW               pTxt( 17 )
#define TXT_MENU_EXIT                  pTxt( 18 )
#define TXT_MENU_EDIT                  pTxt( 19 )
#define TXT_MENU_UNDO                  pTxt( 20 )
#define TXT_MENU_REDO                  pTxt( 21 )
#define TXT_MENU_CUT                   pTxt( 22 )
#define TXT_MENU_DUPLICATE             pTxt( 23 )
#define TXT_MENU_FIND_ITEM             pTxt( 24 )
#define TXT_MENU_ITEM2FRONT            pTxt( 25 )
#define TXT_MENU_ITEM2BACK             pTxt( 26 )
#define TXT_MENU_PRJ                   pTxt( 27 )
#define TXT_MENU_DEF                   pTxt( 28 )
#define TXT_MENU_HELP                  pTxt( 29 )
#define TXT_MENU_ABOUT                 pTxt( 30 )
#define TXT_MENU_CREDITS               pTxt( 31 )
#define TXT_TIP_EMF                    pTxt( 32 )
#define TXT_TIP_SAY                    pTxt( 33 )
#define TXT_TIP_IMAGE                  pTxt( 34 )
#define TXT_TIP_BOX                    pTxt( 35 )
#define TXT_TIP_SECTION                pTxt( 36 )
#define TXT_TIP_VIEW_SECTION           pTxt( 37 )
#define TXT_NAME_SECTION               pTxt( 38 )
#define TXT_MENU_GRID                  pTxt( 39 )
#define TXT_DEL_ITEM                   pTxt( 40 )
#define TXT_EXIST_CHANGE               pTxt( 41 )
#define TXT_EXIT                       pTxt( 42 )
#define TXT_SAVE                       pTxt( 43 )
#define TXT_LOAD                       pTxt( 44 )
#define TXT_DEL_ALL                    pTxt( 45 )
#define TXT_EXIST_CHANGE_CONTINUE      pTxt( 46 )
#define TXT_SEL_RPT                    pTxt( 47 )
#define TXT_RPT_EXIST                  pTxt( 48 )
#define TXT_NOT_FOUND                  pTxt( 49 )
#define TXT_ITEM_VISIBLE               pTxt( 50 )
#define TXT_DEL_EMF                    pTxt( 51 )
#define TXT_INITIATING                 pTxt( 52 )
#define TXT_LOAD_REPORT                pTxt( 53 )
#define TXT_BUILD_REPORT               pTxt( 54 )
#define TXT_SAVE_OK                    pTxt( 55 )
#define TXT_LOADING                    pTxt( 56 )
#define TXT_DONT_EXIST                 pTxt( 57 )
#define TXT_REASIGN                    pTxt( 58 )
#define TXT_PROP_PRJ                   pTxt( 59 )
#define TXT_NEW_PRJ                    pTxt( 60 )
#define TXT_PORTRAIT                   pTxt( 61 )
#define TXT_LANDSCAPE                  pTxt( 62 )
#define TXT_PUBLIC                     pTxt( 63 )
#define TXT_PAPER_SIZE                 pTxt( 64 )
#define TXT_PAPER_WIDTH                pTxt( 65 )
#define TXT_PAPER_HEIGHT               pTxt( 66 )
#define TXT_PAPER_ORIENTATION          pTxt( 67 )
#define TXT_ACTIVE_GRID                pTxt( 68 )
#define TXT_TIP_CATEGORY               pTxt( 69 )
#define TXT_TIP_SORT                   pTxt( 70 )
#define TXT_TIP_EXPAND                 pTxt( 71 )
#define TXT_TIP_CLOSE_ALL              pTxt( 72 )
#define TXT_DLG_BASIC                  pTxt( 73 )
#define TXT_DLG_PAPER                  pTxt( 74 )
#define TXT_DLG_DAT                    pTxt( 75 )
#define TXT_TIP_CODEBAR                pTxt( 76 )
#define TXT_MENU_WHATSNEW              pTxt( 77 )
#define TXT_TIP_FUNCTION               pTxt( 78 )
#define TXT_MENU_PAGE_XX_OF_YY         pTxt( 79 )
#define TXT_MENU_RUN_TIME              pTxt( 80 )
#define TXT_MENU_RUN_DATE              pTxt( 81 )
#define TXT_MENU_RUN_TIMESTAMP         pTxt( 82 )
#define TXT_MENU_RUN_REPORT_NAME       pTxt( 83 )
#define TXT_MENU_RUN_COMPUTER_NAME     pTxt( 84 )
#define TXT_MENU_RUN_USER_NAME         pTxt( 85 )
#define TXT_CAPTION_PAGE_XX_OF_YY      pTxt( 90 )
#define TXT_CAPTION_RUN_TIME           pTxt( 91 )
#define TXT_CAPTION_RUN_DATE           pTxt( 92 )
#define TXT_CAPTION_RUN_TIMESTAMP      pTxt( 93 )
#define TXT_CAPTION_RUN_REPORT_NAME    pTxt( 94 )
#define TXT_CAPTION_RUN_COMPUTER_NAME  pTxt( 95 )
#define TXT_CAPTION_RUN_USER_NAME      pTxt( 96 )
#define TXT_ANIM_TITLE               pTxt( 100 )
#define TXT_ANIM_MSG                 pTxt( 101 )
#define TXT_ANIM_PRINT               pTxt( 102 )
#define TXT_RUN_RPT_NO_DEFINED       pTxt( 110 )
#define TXT_RUN_LABEL                pTxt( 111 )
#define TXT_RUN_NOT_EXIST            pTxt( 112 )
#define TXT_RUN_PRINTER_NOT_READY    pTxt( 113 )
#define TXT_PROP_JUST_LEFT           pTxt( 200 )
#define TXT_PROP_JUST_RIGHT          pTxt( 201 )
#define TXT_PROP_JUST_CENTER         pTxt( 202 )
#define TXT_PROP_WIDTH               pTxt( 203 )
#define TXT_PROP_HEIGHT              pTxt( 204 )
#define TXT_PROP_FONT                pTxt( 205 )
#define TXT_PROP_FONT_SIZE           pTxt( 206 )
#define TXT_PROP_FONT_BOLD           pTxt( 207 )
#define TXT_PROP_FONT_ITALIC         pTxt( 208 )
#define TXT_PROP_FONT_UNDERLINE      pTxt( 209 )
#define TXT_PROP_CLR_FORE            pTxt( 210 )
#define TXT_PROP_CLR_BACK            pTxt( 211 )
#define TXT_PROP_ALIGN               pTxt( 212 )
#define TXT_PROP_INTERLINE           pTxt( 213 )
#define TXT_PROP_HEADER              pTxt( 214 )
#define TXT_PROP_PRJ_NAME            pTxt( 215 )
#define TXT_PROP_DESCRIPTION         pTxt( 216 )
#define TXT_PROP_AUTOR               pTxt( 217 )
#define TXT_PROP_DATE                pTxt( 218 )
#define TXT_PROP_IT_ID               pTxt( 219 )
#define TXT_PROP_IT_TOP              pTxt( 220 )
#define TXT_PROP_IT_LEFT             pTxt( 221 )
#define TXT_PROP_IT_WIDTH            pTxt( 222 )
#define TXT_PROP_IT_HEIGHT           pTxt( 223 )
#define TXT_PROP_IT_VISIBLE          pTxt( 224 )
#define TXT_PROP_IT_FIXED            pTxt( 225 )
#define TXT_PROP_ID_EXIST            pTxt( 226 )
#define TXT_PROP_IT_CAPTION          pTxt( 227 )
#define TXT_PROP_IT_PRINT_BORDER     pTxt( 228 )
#define TXT_PROP_MEMO                pTxt( 229 )
#define TXT_PROP_MEMO_MPAGE          pTxt( 230 )
#define TXT_PROP_MEMO_INTERLINE      pTxt( 231 )
#define TXT_PROP_FILE                pTxt( 232 )
#define TXT_PROP_BORDER              pTxt( 233 )
#define TXT_PROP_FIX_HEIGHT          pTxt( 234 )
#define TXT_PROP_BOX_LINE_STYLE      pTxt( 235 )
#define TXT_PROP_BOX_LINE_CLR        pTxt( 236 )
#define TXT_PROP_BOX_CLR             pTxt( 237 )
#define TXT_PROP_BOX_LINE_WIDTH      pTxt( 238 )
#define TXT_PROP_SECTION_NAME        pTxt( 239 )
#define TXT_PROP_RECT_ALL            pTxt( 240 )
#define TXT_PROP_RECT_HT             pTxt( 241 )
#define TXT_PROP_RECT_VL             pTxt( 242 )
#define TXT_PROP_RECT_HB             pTxt( 243 )
#define TXT_PROP_RECT_VR             pTxt( 244 )
#define TXT_PROP_PIJAMA              pTxt( 245 )
#define TXT_PROP_PIJAMA_CLR1         pTxt( 246 )
#define TXT_PROP_PIJAMA_CLR2         pTxt( 247 )
#define TXT_PROP_CLASS               pTxt( 248 )
#define TXT_PROP_TITLE               pTxt( 249 )
#define TXT_PROP_CODEBAR_TIPO        pTxt( 250 )
#define TXT_PROP_BANNER              pTxt( 251 )
#define TXT_PROP_TXT_VERTICAL        pTxt( 252 )
#define TXT_PROP_CLR_SEC_FORE        pTxt( 253 )
#define TXT_PROP_CLR_SEC_BACK        pTxt( 254 )
#define TXT_PROP_CLR_SEC_LINE        pTxt( 255 )
#define TXT_PROP_CLR_ITEM_FORE       pTxt( 256 )
#define TXT_PROP_CLR_ITEM_BACK       pTxt( 257 )
#define TXT_PROP_PIJAMA_CLR3         pTxt( 258 )
#define TXT_PROP_HEADER_IMG_FILE     pTxt( 259 )
#define TXT_PROP_HEADER_IMG_SIZE     pTxt( 260 )
#define TXT_PROP_IT_SHADOW           pTxt( 261 )
#define TXT_PROP_IT_LINE_WIDTH       pTxt( 262 )
#define TXT_PROP_IT_LINE_COLOR       pTxt( 263 )
#define TXT_PROP_IT_SPECIAL          pTxt( 264 )
#define TXT_PROP_GRUP_INFO           pTxt( 290 )
#define TXT_PROP_GRUP_FONT           pTxt( 291 )
#define TXT_PROP_GRUP_SECTION        pTxt( 292 )
#define TXT_PROP_GRUP_HEADER         pTxt( 293 )
#define TXT_PROP_GRUP_APARIENCIA     pTxt( 294 )
#define TXT_PROP_GRUP_POSICION       pTxt( 295 )
#define TXT_PROP_GRUP_CODEBAR        pTxt( 296 )
#define TXT_NO_CONTINUE              pTxt( 297 )
#define TXT_NO_DELETE_ITEM_FIXED     pTxt( 298 )
#define TXT_CONFIRM_DELETE_ITEM      pTxt( 299 )
#define TXT_MEET_VERTICAL_SEPARATION pTxt( 300 )
#define TXT_MEET_HORIZONTAL_SEPARATION pTxt( 301 )
#define TXT_EQUAL_WIDTH_FIRST        pTxt( 302 )
#define TXT_EQUAL_WIDTH_LAST         pTxt( 303 )
#define TXT_EQUAL_HEIGHT_FIRST       pTxt( 304 )
#define TXT_EQUAL_HEIGHT_LAST        pTxt( 305 ) 
#define TXT_ATENTION                 pTxt( 306 )
#define TXT_ANSWER                   pTxt( 307 )
#define TXT_FIXED_ITEM               pTxt( 308 )

#define MAX_HISTORIAL    20

#define PAGE_TOP         40
#define PAGE_LEFT        40

#define RULE_TICKNESS    30
#define RULE_OFFSET      10

#define CLS_TYPE          1
#define CLS_TREE          2
#define CLS_KEY           3
#define CLS_OBJ           4
#define CLS_CARGO         5

#define O_DLG          1
#define O_FOLDER       2
#define O_NAME         3
#define O_DESCRIPTION  4
#define O_AUTOR        5
#define O_DATA         6
#define O_PAPER       10
#define O_WIDTH       11
#define O_HEIGHT      12
#define O_PAPERTYPE   14
#define O_PAPERSIZE   15
#define O_PORTRAIT    16
#define O_FONTDLG     17
#define O_FONTGET     18
#define O_DIRDAT      19
#define O_DEFINEPAPER 20
#define O_ICO_PAPER   21
#define O_FORM        22
#define O_FORMAT_DATE 23
#define O_FONTDLG2     3
#define O_FONTGET2     4
#define O_SECTION     10
#define O_GRID        10
#define O_ZOOM        10


#define BAR_TOP               1
#define BAR_LEFT              2
#define BAR_RIGHT             3
#define BAR_DOWN              4
#define BAR_FLOAT             5
#define BAR_HEIGHT           28

#define GW_HWNDFIRST          0
#define GW_HWNDLAST           1
#define GW_HWNDNEXT           2
#define GWL_STYLE           -16

#define HWND_BROADCAST    65535  // 0xFFFF

#define CS_DBLCLKS            8

#define COLOR_ACTIVECAPTION   2
#define COLOR_WINDOW          5
#define COLOR_CAPTIONTEXT     9
#define COLOR_HIGHLIGHT      13
#define COLOR_HIGHLIGHTTEXT  14
#define COLOR_BTNFACE        15
#define COLOR_BTNTEXT        18

#define WM_SETFONT           48  // 0x30

#define LINES_NONE            0
#define LINES_BLACK           1
#define LINES_GRAY            2
#define LINES_3D              3
#define LINES_DOTED           4
#define LINES_V_BLACK         5
#define LINES_V_GRAY          6
#define LINES_H_BLACK         7
#define LINES_H_GRAY          8

#define TA_LEFT               0
#define TA_RIGHT              2

#define ETO_OPAQUE            2

#define SM_CYHSCROLL          3

#define MK_MBUTTON           16

#define VSCROLL_MAXVALUE      10000  // never set values above 32767

#define CVARNAME   ::aItems[ nItem,  1 ]
#define TIPO       ::aItems[ nItem,  2 ]
#define NOMBRE     ::aItems[ nItem,  3 ]
#define VALOR      ::aItems[ nItem,  4 ]
#define NUMGRUPO   ::aItems[ nItem,  5 ]
#define ABIERTO    ::aItems[ nItem,  6 ]
#define NUMITEM    ::aItems[ nItem,  7 ]
#define ENABLE     ::aItems[ nItem,  8 ]
#define BACTION    ::aItems[ nItem,  9 ]
#define BVALIDAR   ::aItems[ nItem, 10 ]
#define OPTION     ::aItems[ nItem, 11 ]
#define XSETGET    ::aItems[ nItem, 12 ]
#define XPICTURE   ::aItems[ nItem, 13 ]
#define ACTUALIZA  ::aItems[ nItem, 14 ]

#define OBM_COMBO           32738

#define D_WIDTH           4
#define D_HEIGHT          13

#define DATA_NAME      1
#define DATA_VAL       2
#define DATA_TXT       3


//------------------------------------------------------------------------------
//                               Class MyRpt
//------------------------------------------------------------------------------

CLASS MyRpt

	 DATA   oInspect, oForm
	 DATA   oMdi, oBar, oSetGrid
	 DATA   oHand, oFont, oFontForm, oBtnalign, oFontBar
	 DATA   oItemRow, oItemCol, oItemZoom, oItemModify, oItemMsg
	 DATA   oBmpAlert, oBmpGris
	 DATA   oTimerMsg
	 DATA   cTitle                 AS CHARACTER INIT "FWH Report Design - " + Version()
	 DATA   lActive                AS LOGICAL   INIT .F.
	 DATA   lVisual                AS LOGICAL   INIT .T.
	 DATA   lExit                  AS LOGICAL   INIT .F.
	 DATA   lSetGrid               AS LOGICAL   INIT .F.
	 DATA   cDir
	 DATA   cDirDll
	 DATA   cDirRpt
	 DATA   cDirHelp
	 DATA   cDllFile
	 DATA   cFile                  AS CHARACTER INIT ''
	 DATA   bSave, bLoad
	 DATA   cnomapp
	 DATA   lmenusmart             AS LOGICAL INIT .T.
	 DATA   afixed
	 DATA   cprinter
	 DATA   oIcon

	 CLASSDATA lViewLogo           AS LOGICAL   INIT .F.

	 METHOD New(cdocu, ctitle, cnomapp, lmenusmart, cprinter )  CONSTRUCTOR
	 METHOD Activate()
	 METHOD Init()
	 METHOD Adjust()
	 METHOD End()
	 METHOD Menu()
	 METHOD BarMenu()
	 METHOD BtnAlign()
	 METHOD BtnAlignVH()
	 METHOD BtnSize()
	 METHOD BtnPos()
	 METHOD SoBleep()
	 METHOD SoClick()
	 METHOD GetoReport()
	 METHOD Save()
	 METHOD Load()
	 METHOD Print()
	 METHOD Run()
	 METHOD DeleteAll()
	 METHOD SetZoom( nZoom )

	 METHOD SetMessage( cMsg )   INLINE ( ::oMdi:oMsgBar:cMsgDef :=  cMsg , ;
													  ::oMdi:oMsgBar:refresh() )

	 METHOD MsgModify( lOnOff )
	 METHOD Msg( cText, lTimer )
	 METHOD Logo()
	 METHOD Help()
	 METHOD WhatsNew()
	 METHOD PreDeleteItem(oitem)

ENDCLASS


//------------------------------------------------------------------------------
METHOD New( cdocu, ctitle, cnomapp, lmenusmart, cprinter, oIcon) CLASS MyRpt
local	 hOldRes := GetResources()

	 DEFAULT cdocu := '', ctitle := '', cnomapp := '', lmenusmart := .f., cprinter := ''
	 ::cDir      := diruta()
	 ::cDirDll   := diruta()
	 ::cDirRpt   := diruta()
	 ::cDirHelp  := diruta() + '\Help'

	 ::cDllFile  := "MyRpt.dll"
	 SetResources( ::cDllFile )

	 ::cfile := cdocu
	 ::ctitle := ctitle
	 ::cnomapp := cnomapp
	 ::lmenusmart := lmenusmart
	 ::cprinter := cprinter
	 ::afixed := {}

	 if oIcon <> nil
		 ::oIcon := oIcon
	 else
		 ::oIcon :=  TIcon():New( ,, "MyRpt" )
	 endif

	 GetMyRpt( Self )

    SetResources( hOldRes )

return Self

//------------------------------------------------------------------------------
METHOD Activate() CLASS MyRpt
local oThis   := SELF
local hOldRes
local cDll    := ::cDirDll + '\' + ::cDllFile
local oTControl, oTCodeBar, oTImage, oTPreview
local arect := GetCoors(oWnd:hWnd)
local omenu

	 hOldRes := GetResources( )

	 SetResources( cDll )

	 if hOldRes < 32
		 MsgStop( TXT_NO_CONTINUE + cDll, TXT_ERROR )
		 SetResources( hOldRes )
		 return NIL
	 else
		 pTxtLoad()
		 ::lActive := .T.
	 endif

	 if !::lActive .OR. !::lVisual
		  SetResources( hOldRes )
		  return NIL
	 endif

	 //  Instanciamos objetos con valores por defecto...
	 oTControl          := TControl()
	 oTControl:bDelete  := {|| ::PreDeleteItem(::oForm:oControlItem) }

	 oTCodeBar          := TCodeBar()
	 oTCodeBar:cDllFile := cDll

	 oTImage            := TImage()
	 oTImage:cResFile   := ::cDirDll + '\FreeImg.dll'

	 oTPreview           := TPreview()
	 oTPreview:cResFile  := ::cDirDll + '\Prev32.dll'

	 ::oBmpAlert := TBitmap():Define( '16Alert' )
	 ::oBmpGris  := TBitmap():Define( '16Gris' )

	 DEFINE CURSOR ::oHand HAND

	 DEFINE FONT ::oFont     NAME 'Arial'   SIZE  0, -12
	 DEFINE FONT ::oFontForm NAME 'Verdana' SIZE  0, -11
	 DEFINE FONT ::oFontBar  NAME 'Verdana' SIZE  0, -11 BOLD

	 MENU oMenu
	 ENDMENU

	 DEFINE WINDOW ::oMdi MDI FROM 0,0 TO 24, 32 TITLE ::cTitle MENU oMenu COLOR nrgb(0,0,0), nrgb(100,0,100)

		::oMdi:nStyle    := nOr( WS_DLGFRAME)
		::oMdi:SetFont( ::oFont )
		::oMdi:SetIcon( ::oIcon )

		::Menu()
		::BarMenu()

		SET MESSAGE OF ::oMDI TO space(50)  NOINSET FONT ::oFontBar

		DEFINE MSGITEM ::oItemMsg    OF ::oMdi:oMsgBar SIZE 150 COLOR CLR_BLACK
		DEFINE MSGITEM ::oItemModify OF ::oMdi:oMsgBar SIZE  25 BITMAPS '' COLOR CLR_BLACK
		DEFINE MSGITEM ::oItemZoom   OF ::oMdi:oMsgBar SIZE  75 BITMAPS '16Find' COLOR CLR_BLACK
		DEFINE MSGITEM ::oItemRow    OF ::oMdi:oMsgBar SIZE  75 COLOR CLR_BLUE
		DEFINE MSGITEM ::oItemCol    OF ::oMdi:oMsgBar SIZE  75 COLOR CLR_BLUE

		DEFINE TIMER ::oTimerMsg INTERVAL 3000 ACTION ::Msg()

		::oItemZoom:bAction := {|| ::oForm:Zoom() }

		::oMdi:bValid   := {|| ::End() }
		::oMdi:bInit    := {|| ::Init(), SetResources( hOldRes ) , if( !empty(::cfile), ::load(.f.,::cfile),) }

	 ACTIVATE WINDOW ::oMdi MAXIMIZED

return NIL

//------------------------------------------------------------------------------
METHOD End() CLASS MyRpt
local nOp

	if ::oForm:lChange
		nOp := MsgYesNoCancel( TXT_EXIST_CHANGE )

		do case
			case nOp == ID_YES
				 ::Save()
			case nOp == ID_NO
			otherwise
				 return .F.
		endcase
	endif

	::oBmpAlert:End()
	::oBmpGris:End()

	SetWinCoors( ::oMdi )

	::lExit := .t.

return .T.

//------------------------------------------------------------------------------
METHOD PreDeleteItem(oItem)
local ldelete := .t., nI

for nI = 1 to len(::afixed)
	 if ::afixed[nI] = oItem:cid
		 MsgAlert(TXT_NO_DELETE_ITEM_FIXED,TXT_ATENTION)
		 ldelete := .f.
		 exit
	 endif
next nI

if ldelete = .t.
	ldelete := MsgYesNo( TXT_CONFIRM_DELETE_ITEM  + oItem:cid + ' ?', TXT_ANSWER)
endif

return ldelete

//------------------------------------------------------------------------------
METHOD Menu() CLASS MyRpt
local oMenu, oIcon

	 DEFINE ICON oIcon NAME "MyRpt"

	 MENU oMenu 2007
		 MENUITEM OemToAnsi( TXT_MENU_FILE )
		  MENU
		  if ::lmenusmart = .F.
			 MENUITEM TXT_MENU_NEW_PROJECT  NAME '16NewPrj'   ACTION ::oForm:InitForm()
			 SEPARATOR
			 MENUITEM TXT_MENU_OPEN + Chr(9) + "Ctrl+O" NAME '16FldOn'    ACTION ::Load() ;
				 ACCELERATOR ACC_CONTROL, Asc('O')
		  endif
			 MENUITEM TXT_MENU_SAVE       NAME '16Save'     ACTION ::Save(.f.)
		  if ::lmenusmart = .F.
			 MENUITEM TXT_MENU_SAVE_AS    NAME '16Save'     ACTION ::Save(.t.)
			 SEPARATOR
			 MENUITEM TXT_MENU_CFG_PRINT  NAME '16Prn1'     ACTION PrinterSetup()
			 MENUITEM TXT_MENU_PREVIEW    NAME '16Preview'  ACTION ::Print()
		  endif
			 SEPARATOR
			 MENUITEM TXT_MENU_EXIT       NAME '16EndApp'   ACTION ::oMdi:End()
		  ENDMENU

		 MENUITEM OemToAnsi( TXT_MENU_EDIT )
		  MENU
		 MENUITEM TXT_MENU_UNDO          NAME "Undo"   ACTION ::oForm:ItemUndo()  WHEN len(::oForm:astack) > 0 //::oForm:lFocus
*          MENUITEM TXT_MENU_REDO      NAME "16Redo"   ACTION msginfo('Not yet')
*			 SEPARATOR
*			 MENUITEM TXT_MENU_CUT        NAME '16Cut'    ACTION ::oForm:ItemCut()       WHEN ::oForm:lFocus
			 MENUITEM TXT_MENU_DUPLICATE  NAME '16Copy'   ACTION ::oForm:ItemDuplicate() WHEN ::oForm:lFocus
			 SEPARATOR
			 MENUITEM TXT_MENU_FIND_ITEM  NAME '16Search' ACTION ::oInspect:FindItem() WHEN ::oInspect:lActive
			 SEPARATOR
			 MENUITEM TXT_MENU_ITEM2FRONT NAME 'Top'      ACTION ::oForm:PosTop()    WHEN ::oForm:lFocus
			 MENUITEM TXT_MENU_ITEM2BACK  NAME 'Bottom'   ACTION ::oForm:PosBottom() WHEN ::oForm:lFocus
		  ENDMENU

		 MENUITEM OemToAnsi( TXT_MENU_PRJ )
		  MENU
		  if ::lmenusmart = .F.
			 MENUITEM TXT_MENU_DEF        NAME "16Form"   ACTION Rpt_Project( ::oForm ) WHEN ::oInspect:lActive
			 SEPARATOR
		  endif
			 MENUITEM TXT_MENU_GRID       NAME "16Grid"   ACTION ::oForm:Grid( ::lSetGrid )
		  ENDMENU
/*	  //if ::lmenusmart = .F.
		 MENUITEM OemToAnsi( TXT_MENU_HELP ) HELP
		  MENU
			 MENUITEM TXT_MENU_ABOUT      NAME '16Info'  ACTION ::Logo()
			 SEPARATOR
			 MENUITEM TXT_MENU_HELP       NAME '16Doc'   ACTION ::Help()
			 MENUITEM TXT_MENU_CREDITS    NAME '16Help'  ACTION ShellAbout( 'MyRpt ' + RPTVERSION, AUTOR, oIcon:hIcon )
			 SEPARATOR
			 MENUITEM TXT_MENU_WHATSNEW   NAME 'WhatsNew' ACTION ::WhatsNew()
		  ENDMENU
	  //endif
*/

	 ENDMENU

	 ::oMdi:SetMenu( oMenu )

return NIL

//------------------------------------------------------------------------------
METHOD BarMenu() CLASS MyRpt

	 ::oBtnAlign := Array(13)

	 DEFINE BUTTONBAR ::oBar SIZE 26, 27 _3D OF ::oMdi // 2007
							::oBar:bRClicked := {|| NIL }

	 DEFINE BUTTON  OF ::oBar       NOBORDER NAME '16EndApp'  ACTION ::oMdi:End() TOOLTIP TXT_MENU_EXIT
	 if ::lmenusmart = .F.
		 DEFINE BUTTON  OF ::oBar GROUP NOBORDER NAME '16NewPrj'  ACTION ::oForm:InitForm() TOOLTIP TXT_MENU_NEW_PROJECT
		 DEFINE BUTTON  OF ::oBar       NOBORDER NAME '16Form'    ACTION IF ( len( ::oInspect:aTree ) > 0, Rpt_Project( ::oForm ), ) TOOLTIP TXT_PROP_PRJ
	 endif

	 DEFINE BUTTON  OF ::oBar GROUP NOBORDER NAME '16Preview' ACTION ::Print()  TOOLTIP TXT_MENU_PREVIEW

	 DEFINE BUTTON ::oBtnAlign[1]  OF ::oBar GROUP NOBORDER NAME '16Top'   ACTION ::oForm:AlignTop() TOOLTIP TXT_PROP_ALIGN + TXT_PROP_RECT_HT
	 DEFINE BUTTON ::oBtnAlign[2]  OF ::oBar       NOBORDER NAME '16Down'  ACTION ::oForm:AlignDown() TOOLTIP TXT_PROP_ALIGN + TXT_PROP_RECT_HB
	 DEFINE BUTTON ::oBtnAlign[3]  OF ::oBar       NOBORDER NAME '16Izq'   ACTION ::oForm:AlignLeft() TOOLTIP TXT_PROP_ALIGN + TXT_PROP_RECT_VL
	 DEFINE BUTTON ::oBtnAlign[4]  OF ::oBar       NOBORDER NAME '16right' ACTION ::oForm:AlignRight() TOOLTIP TXT_PROP_ALIGN + TXT_PROP_RECT_VR

	 DEFINE BUTTON ::oBtnAlign[5]  OF ::oBar GROUP NOBORDER NAME '16AligV' ACTION ::oForm:AlignV() TOOLTIP TXT_MEET_VERTICAL_SEPARATION
	 DEFINE BUTTON ::oBtnAlign[6]  OF ::oBar       NOBORDER NAME '16AligH' ACTION ::oForm:AlignH() TOOLTIP TXT_MEET_HORIZONTAL_SEPARATION

	 DEFINE BUTTON ::oBtnAlign[7]  OF ::oBar GROUP NOBORDER NAME '16SizeH1' ACTION ::oForm:SizeHMin() TOOLTIP TXT_EQUAL_WIDTH_FIRST
	 DEFINE BUTTON ::oBtnAlign[8]  OF ::oBar       NOBORDER NAME '16SizeH2' ACTION ::oForm:SizeHMax() TOOLTIP TXT_EQUAL_WIDTH_LAST
	 DEFINE BUTTON ::oBtnAlign[9]  OF ::oBar       NOBORDER NAME '16SizeV2' ACTION ::oForm:SizeVMin() TOOLTIP TXT_EQUAL_HEIGHT_FIRST
	 DEFINE BUTTON ::oBtnAlign[10] OF ::oBar       NOBORDER NAME '16SizeV1' ACTION ::oForm:SizeVMax() TOOLTIP TXT_EQUAL_HEIGHT_LAST

	 DEFINE BUTTON ::oBtnAlign[11] OF ::oBar GROUP NOBORDER NAME 'Top'      ACTION ::oForm:PosTop() TOOLTIP TXT_MENU_ITEM2FRONT
	 DEFINE BUTTON ::oBtnAlign[12] OF ::oBar       NOBORDER NAME 'Bottom'   ACTION ::oForm:PosBottom() TOOLTIP TXT_MENU_ITEM2BACK

	 //DEFINE BUTTON                 OF ::oBar GROUP NOBORDER NAME '16Debug'  ACTION xBrowse( ::oInspect:aTree ) TOOLTIP 'Debug table aTree...'

	 @ 1, 550 CHECKBOX ::oSetGrid VAR ::lSetGrid PROMPT TXT_ACTIVE_GRID SIZE 200, 22 OF ::oBar PIXEL ON CHANGE ::oForm:SetGrid( ::lSetGrid )  WHEN ::oInspect:lActive FONT ::oFontForm

	 AEval( ::oBar:aControls,  {|x| x:oCursor := ::oHand } )


	 ::BtnAlign(.f.)
	 ::BtnAlignVH(.f.)
	 ::BtnSize(.f.)
	 ::BtnPos(.f.)

return NIL

//------------------------------------------------------------------------------
METHOD Init() CLASS MyRpt

	 ::Msg( TXT_INITIATING )
	 GetWinCoors( ::oMdi )
	 ::oForm    := TRptForm():New( Self )
	 ::oForm:Activate()
	 ::oInspect := TRptInspect():New( Self )
	 ::oInspect:Activate()
	 ::oMdi:bResized := {|| ::Adjust() }
	 ::Adjust()
	 ::oBar:aEvalWhen()

	 SysRefresh()
	 if !Empty( ::cFile )  //  Si le especficamos un Fichero, lo abrimos
		  ::Load( , ::cFile )
	 elseif ValType( ::bLoad ) == 'B'
		  ::Load()
	 endif

	 ::Msg()

	 SysRefresh()
	 if ! ::lViewLogo
		 ::Logo(1)
		 ::lViewLogo := .t.
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD Adjust() CLASS MyRpt
local oWndForm := ::oForm:oForm
local oWndInsp := ::oInspect:oInspect
local nH

	oWndForm:CoorsUpdate()
	oWndInsp:CoorsUpdate()

	nH := ::oMdi:nHeight - oWndInsp:nTop - 110        //110

	oWndInsp:aMinMaxInfo = { 300, nH,;  // xMaxSize,      yMaxSize
									 300, nH,;  // xMaxPosition,  yMaxPosition
									 200, nH,;  // 300 Max resize Left / 600 Max Resize Up
									 300, nH }  // xMaxTrackSize, yMaxTrackSize

	oWndInsp:Move( 0, 0,;
						300, ;
						::oMdi:nHeight - 110, .t. )

	oWndForm:Move( 0, 301,;
						::oMdi:nWidth - 301 - 10  , ;
						::oMdi:nHeight - 110, .t. )

return NIL

//------------------------------------------------------------------------------
METHOD BtnAlign( lOnOff ) CLASS MyRpt

	 DEFAULT lOnOff := .t.

	 if lOnOff
		 ::oBtnAlign[1]:Enable()
		 ::oBtnAlign[2]:Enable()
		 ::oBtnAlign[3]:Enable()
		 ::oBtnAlign[4]:Enable()
	 else
		 ::oBtnAlign[1]:Disable()
		 ::oBtnAlign[2]:Disable()
		 ::oBtnAlign[3]:Disable()
		 ::oBtnAlign[4]:Disable()
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD BtnAlignVH( lOnOff ) CLASS MyRpt

	 DEFAULT lOnOff := .t.

	 if lOnOff
		 ::oBtnAlign[5]:Enable()
		 ::oBtnAlign[6]:Enable()
	 else
		 ::oBtnAlign[5]:Disable()
		 ::oBtnAlign[6]:Disable()
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD BtnSize( lOnOff ) CLASS MyRpt

	 DEFAULT lOnOff := .t.

	 if lOnOff
		 ::oBtnAlign[7] :Enable()
		 ::oBtnAlign[8] :Enable()
		 ::oBtnAlign[9] :Enable()
		 ::oBtnAlign[10]:Enable()
	 else
		 ::oBtnAlign[7] :Disable()
		 ::oBtnAlign[8] :Disable()
		 ::oBtnAlign[9] :Disable()
		 ::oBtnAlign[10]:Disable()
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD BtnPos( lOnOff ) CLASS MyRpt

	 DEFAULT lOnOff := .t.

	 if lOnOff
		 ::oBtnAlign[11]:Enable()
		 ::oBtnAlign[12]:Enable()
	 else
		 ::oBtnAlign[11]:Disable()
		 ::oBtnAlign[12]:Disable()
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD SetZoom( nZoom ) CLASS MyRpt

	 DEFAULT nZoom := 0

	 if nZoom == 0
		 ::oItemZoom:SetText( Space(2) )
	 else
		 ::oItemZoom:SetText( Space(2) + ltrim(str(nZoom)) + ' %' )
	 endif

	 ::oItemZoom:Paint()
	 ::oMdi:oMsgBar:Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD MsgModify( lOnOff ) CLASS MyRpt

	DEFAULT lOnOff := .f.

	if !lOnOff
		::oItemModify:hBitmap1 := ::oBmpGris:hBitmap
	else
		::oItemModify:hBitmap1 := ::oBmpAlert:hBitmap
	endif

	::oItemModify:Paint()
	::oMdi:oMsgBar:Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD Help() CLASS MyRpt

	::Msg( 'Abrir Ayuda' )
	pVerDoc( ::cDirHelp + '\MyRpt.pdf' )
	::Msg()

return NIL

//------------------------------------------------------------------------------
METHOD WhatsNew() CLASS MyRpt

	::Msg( 'Abrir Whatsnew' )
	pVerDoc( ::cDirHelp + '\WhatsNew.txt' )
	::Msg()

return NIL


//------------------------------------------------------------------------------
METHOD Msg( cMsg, lTemporal ) CLASS MyRpt

	DEFAULT cMsg      := ''
	DEFAULT lTemporal := .f.

	if !Empty( cMsg )
		::oItemMsg:nClrPane := CLR_BLUE
		::oItemMsg:nClrText := CLR_WHITE
		::oItemMsg:SetText( cMsg )

		if lTemporal
			nTime := 6
			::oTimerMsg:nInterval  := 1000
			::oTimerMsg:Activate()
		else
			nTime := 0
		endif

	else
		 nTime--

		 do case
			 case nTime == 5
					::oItemMsg:nClrPane   := CLR_WHITE
					::oItemMsg:nClrText   := CLR_BLUE
					::oTimerMsg:Deactivate()
					::oTimerMsg:nInterval := 500
					::oTimerMsg:Activate()

			 case nTime == 4
					::oItemMsg:nClrPane   := CLR_BLUE
					::oItemMsg:nClrText   := CLR_WHITE
					::oTimerMsg:Deactivate()
					::oTimerMsg:nInterval := 250
					::oTimerMsg:Activate()

			 case nTime == 3
					::oItemMsg:nClrPane   := CLR_WHITE
					::oItemMsg:nClrText   := CLR_BLUE
					::oTimerMsg:Deactivate()
					::oTimerMsg:nInterval := 100
					::oTimerMsg:Activate()

			 case nTime == 2
					::oItemMsg:nClrPane   := CLR_BLUE
					::oItemMsg:nClrText   := CLR_WHITE
					::oTimerMsg:Deactivate()
					::oTimerMsg:nInterval := 50
					::oTimerMsg:Activate()

			 case nTime == 1
					::oItemMsg:nClrPane   := ::oMdi:oMsgBar:nClrPane
					::oItemMsg:nClrText   := CLR_BLACK
					::oTimerMsg:Deactivate()
					::oTimerMsg:nInterval := 4000
					::oTimerMsg:Activate()

			 otherwise
					::oItemMsg:nClrPane := ::oMdi:oMsgBar:nClrPane
					::oItemMsg:nClrText := CLR_BLACK
					::oItemMsg:SetText( Space(10) )
					::oTimerMsg:Deactivate()
		 endcase
	endif

	::oItemMsg:Paint()
	::oMdi:oMsgBar:Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD SoBleep() CLASS MyRpt
local hOldRes := GetResources()

	 SetResources( ::cDllFile )
	 SndPlayResource( 'Bleep', 1 )
	 SetResources( hOldRes )

return NIL

//------------------------------------------------------------------------------
METHOD SoClick() CLASS MyRpt
local hOldRes := GetResources()

	 SetResources( ::cDllFile )
	 SndPlayResource( 'Click', 1 )
	 SetResources( hOldRes )

return NIL

//------------------------------------------------------------------------------
METHOD Save( lSaveAs ) CLASS MyRpt
local oReport
local lSave

	 DEFAULT lSaveAs := .F.

	 if len( ::oInspect:aTree ) == 0
		 return .T.
	 endif

	 oReport := ::GetoReport()

	 if ValType( ::bSave ) == 'B'
		 lSave := Eval( ::bSave, oReport )
	 else
		 lSave := SaveToIni( SELF, oReport, lSaveAs )
	 endif

	 if lSave
		 ::Msg( TXT_SAVE_OK, .t. )
		 ::oForm:lChange := .F.
		 ::MsgModify( .f. )
		 ::SoBleep()
	 endif

return .T.

//------------------------------------------------------------------------------
METHOD Load( lVisual, cFile ) CLASS MyRpt
local oReport
local oMsg, oError

	 DEFAULT lVisual := .T.
	 DEFAULT cFile   := '' //::cfile+'.RPT'

	 if lVisual
		 if len( ::oInspect:aTree ) > 0
			 if !MsgYesNo( TXT_LOAD, TXT_FWRPT )
				 return .F.
			 endif
		 endif

		 if ! ::DeleteAll( .F. )
			 return .F.
		 endif
	 endif

	 if empty(cFile)
		 cfile := cGetFile( ::cDirRpt + '\*.rpt', TXT_SEL_RPT )
		 if empty(cfile)
			 return nil
		 endif
	 endif
	 ::cFile := cFile

	 if lVisual
		 ::Msg( TXT_LOAD_REPORT )
	 endif

	 if ValType( ::bLoad ) == 'B'
		 TRY
			 Eval( ::bLoad )
		 CATCH oError
			 MsgAlert( 'Ep')
			 return nil
		 END
	 endif

	 oReport := LoadFromIni( SELF )

	 if oReport:lError
		 MsgAlert( TXT_NO_NOTINUE + cfile, TXT_ERROR )
		 return nil
	 endif

	 //  Montar el Report...
	 if lVisual
		 ::Msg( TXT_BUILD_REPORT )
		 ::oForm:InitForm( oReport )
	 endif

	 if lVisual
		 ::Msg()
	 endif

return oReport


//------------------------------------------------------------------------------
METHOD Print( lVisual ) CLASS MyRpt
local oReport
local oRptRun

	 if len( ::oInspect:aTree ) == 0
		 return NIL
	 endif

	 oReport := ::GetoReport()
	 oRptRun := RptRun():New( oReport )
	 oRptRun:cDirDll  := ::cDirDll
	 oRptRun:cDllFile := ::cDllFile
	 oRptRun:lIsDemo  := .T.
	 oRptRun:Activate()

return oRptRun

//------------------------------------------------------------------------------
METHOD Run( oReport, lDummy ) CLASS MyRpt
local oRptRun
local cDll    := ::cDirDll + '\' + ::cDllFile
local hOldRes

	 DEFAULT lDummy := .F.

	 if !::lActive
		 hOldRes := GetResources()
		 SetResources( cDll )
		 pTxtLoad()
		 SetResources( hOldRes )
		 ::lActive := .T.
	 endif

	 if Valtype( oReport ) <> 'O'
		 if lDummy == .F.
			 oReport := ::Load( .f., ::cFile )
		 else
			 oReport := Trpt():New()
		 endif
	 endif

	 oRptRun := RptRun():New( oReport )
	 oRptRun:cDirDll  := ::cDirDll
	 oRptRun:cDllFile := ::cDllFile
	 oRptRun:lIsDemo  := .F.

return oRptRun

//------------------------------------------------------------------------------
METHOD DeleteAll( lMsg ) CLASS MyRpt
local oItem
local cType
local aTree := ::oInspect:aTree
local nTree := Len( aTree )
local nI

	 DEFAULT lMsg := .t.

	 if lMsg .and. !MsgYesNo( TXT_DEL_ALL, TXT_FWRPT )
		 return .F.
	 endif

	 if ::oForm:lChange
		 if !MsgNoYes( TXT_EXIST_CHANGE_CONTINUE, TXT_FWRPT )
			 return .F.
		 endif
	 endif

	 ::oForm:SetDots(.f.)
	 ::oForm:SetFormName()

	 for nI := 1 TO nTree
		  cType := aTree[nI][1]

		  do case
			  case cType == '__ITEM'
					 oItem := aTree[nI][4]
					 oItem:oObj:End()
					 oItem:oObj := NIL

		  endcase
	 next nI

	 ::MsgModify( .f. )
	 ::SetMessage( '' )

	 ::oItemZoom:SetText( Space(2) )
	 ::oItemRow:SetText ( Space(2) )
	 ::oItemCol:SetText ( Space(2) )

	 ::oInspect:DeleteAll()

	 ::oForm:oMeta:Hide()
	 ::oForm:oForm:Refresh()
	 ::oForm:ResetData()

	 SysRefresh()

	 ::cFile := ''

	 oItem := TItem():New()
	 oItem:Reset()

return .T.

//------------------------------------------------------------------------------
METHOD GetoReport() CLASS MyRpt
local nI
local nTree
local aTree
local oItem, oItemTree, oSection
local oReport
local cType

	 aTree := ::oInspect:aTree
	 nTree := Len( aTree )

	 oReport := Trpt():New()

	 oReport:cname        := ::oForm:cFormName
	 oReport:cdescription := ::oForm:cFormDescription
	 oReport:cautor       := ::oForm:cFormAutor
	 oReport:dData        := ::oForm:dFormData
	 oReport:nZoom        := ::oForm:nZoom
	 oReport:nPaperSize   := ::oForm:nPaperSize
	 oReport:cDirDat      := ::oForm:cDirDat
	 oReport:cFormatDate  := ::oForm:cFormatDate
	 oReport:nWidth       := ::oForm:nMmWidth
	 oReport:nHeight      := ::oForm:nMmHeight
	 oReport:lPortrait    := ::oForm:lPortrait
	 oReport:cFileEMF     := ::oForm:cFileEmf


	 for nI := 1 TO nTree
		  cType := aTree[nI][1]

		  do case

			  case cType == '__ITEM'
					 oItemTree := aTree[nI][4]
					 ::oForm:UpdCoorsItem( oItemTree )
					 oItem     := TItem():New(.f.)
					 oItem:CopyFromItem( oItemTree )
					 oReport:AddItem( oItem )

			  case cType == '__SECTION'
					 oItemTree := aTree[nI][4]
					 oSection   := TSection():New()
					 oSection:CopyFromSection( oItemTree )
					 oReport:AddSection( oSection )

		  endcase
	 next nI

return oReport

//------------------------------------------------------------------------------
METHOD Logo( nSeconds ) CLASS MyRpt
local oDlg, oBmp, oFont, oTmr

	 DEFAULT nSeconds := 5

	 DEFINE IMAGE oBmp FILENAME ::cDirDll + '\MyRpt.png'

	 DEFINE FONT oFont NAME 'Verdana' SIZE 0, -18

	 DEFINE DIALOG oDlg FROM 0, 0 TO oBmp:nWidth, oBmp:nHeight PIXEL ;
			  STYLE WS_POPUP FONT oFont TRANSPARENT

		 oDlg:oBrush     := TBrush():New( "NULL" )

		 @ 60,140 SAY RPTVERSION SIZE 150,12 PIXEL OF oDlg COLOR CLR_BLACK, CLR_BLACK TRANSPARENT
		 @ 160,10 SAY FWVERSION SIZE 250,12 PIXEL OF oDlg COLOR CLR_BLACK, CLR_BLACK TRANSPARENT
		 @ 170,10 SAY Version() SIZE 250,50 PIXEL OF oDlg COLOR CLR_BLACK, CLR_BLACK TRANSPARENT

		 DEFINE TIMER oTmr INTERVAL nSeconds * 1000 ACTION oDlg:End()

	 ACTIVATE DIALOG oDlg CENTERED ;
		 ON PAINT ABPaint( hDC, 10, 10, oBmp:hBitmap, 255 ) ;
		 ON LEFT CLICK oDlg:End() ;
		 ON RIGHT CLICK oDlg:End() ;
		 ON INIT ( RoundCorners( oDlg ), oTmr:Activate() )

	 oBmp:End()
	 oFont:End()

return NIL

//------------------------------------------------------------------------------
static function SaveToIni( o, oReport, lSaveAs )
local oItem, oSection
local cFile
local nItems    := Len( oReport:aItems )
local nSections := Len( oReport:aSections )
local nI
local cIni      :=  ''

	 DEFAULT lSaveAs := .F.

	 if lSaveAs .OR. Empty( o:cFile )
		 cFile     := cGetFile( o:cDirRpt + '\*.rpt', TXT_SEL_RPT )

		 if Empty(cFile)
			 return .F.
		 endif

		 if Upper( cFileExt( cFile ) ) <> 'RPT'
			 cFile += '.rpt'
		 endif

		 if File( cFile )
			 if !MsgNoYes( TXT_RPT_EXIST, TXT_FWRPT )
				 return .F.
			 endif
		 endif

		 o:cFile := cFile
	 else
		 cFile     := o:cFile
	 endif

	 cIni    :=  '[Report]'                                              + CRLF
	 cIni    +=  'cName='        + Alltrim( oReport:cname )              + CRLF
	 cIni    +=  'cDescription=' + Alltrim( oReport:cdescription)        + CRLF
	 cIni    +=  'cAutor='       + Alltrim( oReport:cautor )             + CRLF
	 cIni    +=  'dData='        + DToC( oReport:dData )                 + CRLF
	 cIni    +=  'cDirDat='      + oReport:cdirdat                       + CRLF
	 cIni    +=  'cFormatDate='  + Alltrim( oReport:cFormatDate )        + CRLF
	 cIni    +=  'cFileEmf='     + oReport:cFileEmf                      + CRLF
	 cIni    +=  'nHeight='      + Ltrim(Str(oReport:nHeight))           + CRLF
	 cIni    +=  'nWidth='       + Ltrim(Str(oReport:nWidth))            + CRLF
	 cIni    +=  'nPaperSize='   + Ltrim(Str(oReport:nPaperSize))        + CRLF
	 cIni    +=  'nZoom='        + Ltrim(Str(oReport:nZoom))             + CRLF
	 cIni    +=  'lPortrait='    + IF( oReport:lPortrait, 'Yes', 'No' )  + CRLF
	 cIni    +=  'nItems='       + Ltrim(Str(nItems))             + CRLF + CRLF


	 //  SECTIONS
	 for nI := 1 TO nSections

		  oSection := oReport:aSections[nI]

		  cIni += '[SECTION ' + Alltrim(oSection:cSection) + ']'                           + CRLF
		  cIni += 'nTop='             + ltrim(str(oSection:nTop))    + ' mm.'     + CRLF
		  cIni += 'nLeft='            + ltrim(str(oSection:nLeft))   + ' mm.'     + CRLF
		  cIni += 'nHeight='          + ltrim(str(oSection:nHeight, 8, 2)) + ' mm.'     + CRLF
		  cIni += 'nWidth='           + ltrim(str(oSection:nWidth,8, 2))  + ' mm.'     + CRLF
		  cIni += 'nInterLine='       + ltrim(str(oSection:nInterLine))  + ' mm.' + CRLF
		  cIni += 'nClrSecFore='      + ltrim(str(oSection:nClrSecFore))          + CRLF
		  cIni += 'nClrSecBack='      + ltrim(str(oSection:nClrSecBack))          + CRLF
		  cIni += 'nClrSecLine='      + ltrim(str(oSection:nClrSecLine))          + CRLF
		  cIni += 'nClrFore='         + ltrim(str(oSection:nClrFore))             + CRLF
		  cIni += 'nClrBack='         + ltrim(str(oSection:nClrBack))             + CRLF
		  cIni += 'lHeader='          + IF(oSection:lHeader, 'Yes', 'No' )        + CRLF
		  cIni += 'nFixHeight='       + ltrim(str(oSection:nFixHeight))           + CRLF
		  cIni += 'cFaceName='        + oSection:cFaceName                        + CRLF
		  cIni += 'nInpHeight='       + ltrim(str(oSection:nInpHeight))           + CRLF
		  cIni += 'lFontBold='        + IF( oSection:lFontBold, 'Yes','No')       + CRLF
		  cIni += 'lFontItalic='      + IF( oSection:lFontItalic, 'Yes','No')     + CRLF
		  cIni += 'lFontUnderline='   + IF( oSection:lFontUnderline, 'Yes','No')  + CRLF
		  cIni += 'lFixed='           + IF( oSection:lFixed        , 'Yes','No')  + CRLF
		  cIni += 'lPijama='          + IF( oSection:lPijama       , 'Yes','No')  + CRLF
		  cIni += 'nPijamaClr1='      + ltrim(str(oSection:nPijamaClr1))          + CRLF
		  cIni += 'nPijamaClr2='      + ltrim(str(oSection:nPijamaClr2))          + CRLF
		  cIni += 'nPijamaClr3='      + ltrim(str(oSection:nPijamaClr3))          + CRLF
		  cIni += 'nLineWidth='       + ltrim(str(oSection:nLineWidth))           + CRLF
		  cIni += 'nShadow='          + ltrim(str(oSection:nShadow))              + CRLF

		  cIni += CRLF

	 next nI


	 //  ITEMS
	 for nI := 1 TO nItems

		  oItem := oReport:aItems[nI]

		  cIni += '[Item' + ltrim(str(nI)) + ']'                               + CRLF
		  cIni += 'cId='              + Alltrim( oItem:cId )                   + CRLF
		  cIni += 'cClass='           + oItem:cClass                           + CRLF
		  cIni += 'nType='            + Ltrim(Str(oItem:nType))                + CRLF
		  cIni += 'nTop='             + ltrim(str(oItem:nTop))    + ' mm.'     + CRLF
		  cIni += 'nLeft='            + ltrim(str(oItem:nLeft))   + ' mm.'     + CRLF
		  cIni += 'nHeight='          + ltrim(str(oItem:nHeight,8,2)) + ' mm.' + CRLF
		  cIni += 'nWidth='           + ltrim(str(oItem:nWidth,8,2))  + ' mm.' + CRLF
		  cIni += 'lVisible='         + IF( oItem:lVisible, 'Yes','No')        + CRLF
		  cIni += 'lFixed='           + IF( oItem:lFixed, 'Yes','No')          + CRLF
		  cIni += 'nShadow='          + ltrim(str(oItem:nShadow))              + CRLF
		  cIni += 'nLineWidth='       + ltrim(str(oItem:nLineWidth))           + CRLF
		  cIni += 'lSpecial='         + IF( oItem:lSpecial, 'Yes','No')        + CRLF

		  IF ! Empty( oItem:cSection )

			  cIni += 'cSection='          + Alltrim( oItem:cSection )                + CRLF
			  cIni += 'cSecHead='          + Alltrim( oItem:cSecHead )                + CRLF
			  cIni += 'lSecFontBold='      + IF( oItem:lSecFontBold, 'Yes','No')      + CRLF
			  cIni += 'lSecFontItalic='    + IF( oItem:lSecFontItalic, 'Yes','No')    + CRLF
			  cIni += 'lSecFontUnderline=' + IF( oItem:lSecFontUnderline, 'Yes','No') + CRLF
			  cIni += 'cImgFileHeader='    + Alltrim( oItem:cImgFileHeader )          + CRLF
			  cIni += 'nImgFixHeader='     + Ltrim(Str( oItem:nImgFixHeader ))        + CRLF

		  ENDIF

		  DO CASE
			  CASE oItem:cClass == 'TSAY'

					 cIni += 'cCaption='         + oItem:cCaption                        + CRLF         //  Alltrim(oItem:cCaption) sebas
					 cIni += 'nClrFore='         + ltrim(str(oItem:nClrFore))            + CRLF
					 cIni += 'nClrBack='         + ltrim(str(oItem:nClrBack))            + CRLF
					 cIni += 'nClrLine='         + ltrim(str(oItem:nClrLine))            + CRLF
					 cIni += 'cFaceName='        + oItem:cFaceName                       + CRLF
					 cIni += 'nInpHeight='       + ltrim(str(oItem:nInpHeight))          + CRLF
					 cIni += 'nFontWidth='       + ltrim(str(oItem:nFontWidth))          + CRLF
					 cIni += 'lFontBold='        + IF( oItem:lFontBold, 'Yes','No')      + CRLF
					 cIni += 'lFontItalic='      + IF( oItem:lFontItalic, 'Yes','No')    + CRLF
					 cIni += 'lFontUnderline='   + IF( oItem:lFontUnderline, 'Yes','No') + CRLF
					 cIni += 'nPad='             + ltrim(str(oItem:nPad))                + CRLF
					 cIni += 'nInterLine='       + ltrim(str(oItem:nInterline))          + CRLF
					 cIni += 'lMemo='            + IF( oItem:lMemo, 'Yes','No')          + CRLF
					 cIni += 'lMultipage='       + IF( oItem:lMultipage, 'Yes','No')     + CRLF
					 cIni += 'lBorder='          + IF( oItem:lBorder, 'Yes','No')        + CRLF

			  CASE oItem:cClass == 'TIMAGE'

					 if at( upper(diruta()), upper(oItem:cFile) ) > 0        //aadido para que si la ruta es la misma que la app no ponga la carpeta
						 cIni += 'cFile='         + '.' + strtran(upper(oItem:cFile),upper(diruta()),'') + CRLF
					 else
						 cIni += 'cFile='         + oItem:cFile                           + CRLF
					 endif
					 cIni += 'lBorder='          + IF( oItem:lBorder, 'Yes','No')        + CRLF
					 cIni += 'nImgFixHeight='    + ltrim(str(oItem:nImgFixHeight))

			  CASE oItem:cClass == 'TBOX'

					 cIni += 'nClrFore='         + ltrim(str(oItem:nClrFore))            + CRLF
					 cIni += 'nClrBack='         + ltrim(str(oItem:nClrBack))            + CRLF
					 cIni += 'nLineWidth='       + ltrim(str(oItem:nLineWidth,8,0))      + CRLF
					 cIni += 'nLineType='        + ltrim(str(oItem:nLineType,8,0))       + CRLF

			  CASE oItem:cClass == 'TCODEBAR'

					 cIni += 'nCodeBarType='     + ltrim(str(oItem:nCodeBartype))        + CRLF
					 cIni += 'cCaption='         + Alltrim(oItem:cCaption)               + CRLF
					 cIni += 'cFaceName='        + oItem:cFaceName                       + CRLF
					 cIni += 'nImgFixHeight='    + ltrim(str(oItem:nImgFixHeight))       + CRLF
					 cIni += 'lBanner='          + IF( oItem:lBanner, 'Yes','No')        + CRLF
					 cIni += 'lVertical='        + IF( oItem:lVertical, 'Yes','No')      + CRLF

		  ENDCASE

		  cIni += CRLF

	 next nI

	 MemoWrit( cFile, cIni )

return .T.

// La carga es el punto mas lento de la aplicacion... (para optimizar...)
//------------------------------------------------------------------------------
static function LoadFromIni( o )
local oItem, oIni, oSection
local nI
local cIni     :=  ''
local cItem    :=  ''
local cSection :=  ''
local oReport
local nItems
local nTop, nLeft, nWidth, nHeight, nInterLine, nLineWidth, nLineType
local cLogic
local aSections   := {}
local cFile       := o:cFile
local nDummy

	 if Empty( cFile )
		 cFile    := diruta() + '\' + o:file + '.rpt'  
	 endif

	 if !File( cFile )
		 return NIL
	 endif

	 o:cFile := cFile
	 oReport := Trpt():New()

	 INI oIni FILENAME cFile

		  GET oReport:cName        SECTION 'Report' ENTRY 'cName'        OF oIni DEFAULT Space(12)
		  GET oReport:cDescription SECTION 'Report' ENTRY 'cDescription' OF oIni DEFAULT space(50)
		  GET oReport:cAutor       SECTION 'Report' ENTRY 'cAutor'       OF oIni DEFAULT space(30)
		  GET oReport:dData        SECTION 'Report' ENTRY 'dData'        OF oIni DEFAULT Date()
		  GET oReport:cDirDat      SECTION 'Report' ENTRY 'cDirDat'      OF oIni DEFAULT ''
		  GET oReport:cFormatDate  SECTION 'Report' ENTRY 'cFormatDate'  OF oIni DEFAULT 'DD/MM/YYYY'
		  GET oReport:cFileEmf     SECTION 'Report' ENTRY 'cFileEmf'     OF oIni DEFAULT ''
		  GET oReport:nHeight      SECTION 'Report' ENTRY 'nHeight'      OF oIni DEFAULT 0
		  GET oReport:nWidth       SECTION 'Report' ENTRY 'nWidth'       OF oIni DEFAULT 0
		  GET oReport:nPaperSize   SECTION 'Report' ENTRY 'nPaperSize'   OF oIni DEFAULT 9
		  GET oReport:nZoom        SECTION 'Report' ENTRY 'nZoom'        OF oIni DEFAULT 100
		  GET cLogic               SECTION 'Report' ENTRY 'lPortrait'    OF oIni DEFAULT 'YES'
		  oReport:lPortrait  := Upper( cLogic ) == 'YES' .OR. Empty( cLogic )
		  GET nItems               SECTION 'Report' ENTRY 'nItems'       OF oIni DEFAULT 0

	 ENDINI

	 for nI := 1 TO nItems

		  oItem := TItem():New()
		  cItem := 'Item' + ltrim(str(nI))

		  GET oItem:cId               SECTION cItem ENTRY 'cId'            OF oIni DEFAULT ''
		  GET oItem:cClass            SECTION cItem ENTRY 'cClass'         OF oIni DEFAULT ''
		  GET oItem:nType             SECTION cItem ENTRY 'nType'          OF oIni DEFAULT 0
		  GET nTop                    SECTION cItem ENTRY 'nTop'           OF oIni DEFAULT ''
		  GET nLeft                   SECTION cItem ENTRY 'nLeft'          OF oIni DEFAULT ''
		  GET nHeight                 SECTION cItem ENTRY 'nHeight'        OF oIni DEFAULT ''
		  GET nWidth                  SECTION cItem ENTRY 'nWidth'         OF oIni DEFAULT ''
		  GET oItem:cSection          SECTION cItem ENTRY 'cSection'       OF oIni DEFAULT ''
		  GET cLogic                  SECTION cItem ENTRY 'lVisible'       OF oIni DEFAULT 'YES'
				oItem:lVisible := Upper( cLogic ) == 'YES' .OR. Empty( cLogic )
		  GET cLogic                  SECTION cItem ENTRY 'lFixed'         OF oIni DEFAULT 'YES'
				oItem:lFixed   := Upper( cLogic ) == 'YES' .OR. Empty( cLogic )
		  GET nLineWidth              SECTION cItem ENTRY 'nLineWidth'     OF oIni DEFAULT '1'
		  GET nLineType               SECTION cItem ENTRY 'nLineType'      OF oIni DEFAULT '1'

		  GET oItem:cSecHead          SECTION cItem ENTRY 'cSecHead'          OF oIni DEFAULT ''

		  GET cLogic                  SECTION cItem ENTRY 'lSecFontBold'      OF oIni DEFAULT ''
				oItem:lSecFontBold   := Upper( cLogic ) == 'YES'

		  GET cLogic                  SECTION cItem ENTRY 'lSecFontItalic'    OF oIni DEFAULT ''
				oItem:lSecFontItalic := Upper( cLogic ) == 'YES'

		  GET cLogic                  SECTION cItem ENTRY 'lSecFontUnderline' OF oIni DEFAULT ''
				oItem:lSecFontUnderline := Upper( cLogic ) == 'YES'

		  GET oItem:nImgFixHeader     SECTION cItem ENTRY 'nImgFixHeader'     OF oIni DEFAULT 5
		  GET oItem:cImgFileHeader    SECTION cItem ENTRY 'cImgFileHeader'    OF oIni DEFAULT ''
		  GET oItem:nShadow           SECTION cItem ENTRY 'nShadow'           OF oIni DEFAULT  0
		  GET oItem:nLineWidth        SECTION cItem ENTRY 'nLineWidth'        OF oIni DEFAULT  1
		  GET cLogic                  SECTION cItem ENTRY 'lSpecial'          OF oIni DEFAULT 'No'
				oItem:lSpecial       := Upper( cLogic ) == 'YES'

		  do case
			  case oItem:cClass == 'TSAY'
					 GET oItem:cCaption          SECTION cItem ENTRY 'cCaption'       OF oIni DEFAULT ''
					 GET oItem:nClrFore          SECTION cItem ENTRY 'nClrFore'       OF oIni DEFAULT CLR_BLACK
					 GET oItem:nClrBack          SECTION cItem ENTRY 'nClrBack'       OF oIni DEFAULT 0
					 GET oItem:nClrLine          SECTION cItem ENTRY 'nClrLine'       OF oIni DEFAULT CLR_BLACK
					 GET oItem:cFaceName         SECTION cItem ENTRY 'cFaceName'      OF oIni DEFAULT 'Arial'
					 GET oItem:nInpHeight        SECTION cItem ENTRY 'nInpHeight'     OF oIni DEFAULT 10
					 GET oItem:nFontWidth        SECTION cItem ENTRY 'nFontWidth'     OF oIni DEFAULT  0
					 GET oItem:nPad              SECTION cItem ENTRY 'nPad'           OF oIni DEFAULT  0
					 GET oItem:nInterLine        SECTION cItem ENTRY 'nInterLine'     OF oIni DEFAULT  1
					 GET cLogic                  SECTION cItem ENTRY 'lFontBold'      OF oIni DEFAULT ''
					 oItem:lFontBold      := Upper( cLogic ) == 'YES'
					 GET cLogic                  SECTION cItem ENTRY 'lFontItalic'    OF oIni DEFAULT ''
					 oItem:lFontItalic    := Upper( cLogic ) == 'YES'
					 GET cLogic                  SECTION cItem ENTRY 'lFontUnderline' OF oIni DEFAULT ''
					 oItem:lFontUnderline := Upper( cLogic ) == 'YES'
					 GET cLogic                  SECTION cItem ENTRY 'lMemo'             OF oIni DEFAULT ''
					 oItem:lMemo          := Upper( cLogic ) == 'YES'
					 GET cLogic                  SECTION cItem ENTRY 'lMultipage'        OF oIni DEFAULT ''
					 oItem:lMultipage     := Upper( cLogic ) == 'YES'
					 GET cLogic                  SECTION cItem ENTRY 'lBorder'        OF oIni DEFAULT 'No'
					 oItem:lBorder   := Upper( cLogic ) == 'YES'

			  case oItem:cClass == 'TIMAGE'
					 GET oItem:cFile             SECTION cItem ENTRY 'cFile'          OF oIni DEFAULT ''
					 GET oItem:nImgFixHeight     SECTION cItem ENTRY 'nImgFixHeight'  OF oIni DEFAULT 5
					 GET cLogic                  SECTION cItem ENTRY 'lBorder'        OF oIni DEFAULT 'Yes'
					 oItem:lBorder   := Upper( cLogic ) == 'YES'

			  case oItem:cClass == 'TBOX'
					 GET oItem:nClrFore          SECTION cItem ENTRY 'nClrFore'       OF oIni DEFAULT 0
					 GET oItem:nClrBack          SECTION cItem ENTRY 'nClrBack'       OF oIni DEFAULT 0

			  case oItem:cClass == 'TCODEBAR'
					 GET oItem:nCodeBarType      SECTION cItem ENTRY 'nCodeBarType'   OF oIni DEFAULT 1
					 GET oItem:cCaption          SECTION cItem ENTRY 'cCaption'       OF oIni DEFAULT ''
					 GET oItem:cFaceName         SECTION cItem ENTRY 'cFaceName'      OF oIni DEFAULT 'Arial'
					 GET oItem:nImgFixHeight     SECTION cItem ENTRY 'nImgFixHeight'  OF oIni DEFAULT 5
					 GET cLogic                  SECTION cItem ENTRY 'lBanner'        OF oIni DEFAULT 'No'
					 oItem:lBanner        := Upper( cLogic ) == 'YES'
					 GET cLogic                  SECTION cItem ENTRY 'lVertical'      OF oIni DEFAULT 'No'
					 oItem:lVertical      := Upper( cLogic ) == 'YES'

		  endcase

		  // Esto lo hacemos por los decimales, ya que Ini no lo soporta
		  oItem:nTop       := Val( nTop    )
		  oItem:nTopIni    := Val( nTop    )
		  oItem:nLeft      := Val( nLeft   )
		  oItem:nWidth     := Val( nWidth  )
		  oItem:nHeight    := Val( nHeight )
		  oItem:nLineWidth := Val( nLineWidth )
		  oItem:nLineType  := Val( nLineType  )

		  oReport:AddItem( oItem )

		  if !Empty( oItem:cSection )
			  if Ascan( aSections, oItem:cSection ) == 0
				  Aadd( aSections, oItem:cSection )
			  endif
		  endif

	 next nI

	 //  Cargamos Sections...
	 for nI := 1 TO Len( aSections )

		  oSection := TSection():New()
		  cSection := 'SECTION ' + aSections[nI]

		  GET nTop                    SECTION cSection ENTRY 'nTop'           OF oIni DEFAULT ''
		  GET nLeft                   SECTION cSection ENTRY 'nLeft'          OF oIni DEFAULT ''
		  GET nHeight                 SECTION cSection ENTRY 'nHeight'        OF oIni DEFAULT ''
		  GET nWidth                  SECTION cSection ENTRY 'nWidth'         OF oIni DEFAULT ''
		  GET nInterLine              SECTION cSection ENTRY 'nInterLine'     OF oIni DEFAULT ''
		  GET oSection:nClrSecFore    SECTION cSection ENTRY 'nClrSecFore'    OF oIni DEFAULT CLR_BLACK
		  GET oSection:nClrSecBack    SECTION cSection ENTRY 'nClrSecBack'    OF oIni DEFAULT CLR_WHITE
		  GET oSection:nClrSecLine    SECTION cSection ENTRY 'nClrSecLine'    OF oIni DEFAULT CLR_WHITE
		  GET nDummy                  SECTION cSection ENTRY 'nClrFore'       OF oIni DEFAULT ''
		  oSection:nClrFore := Val( nDummy )
		  GET nDummy                  SECTION cSection ENTRY 'nClrBack'       OF oIni DEFAULT ''
		  oSection:nClrBack := Val( nDummy )
		  GET cLogic                  SECTION cSection ENTRY 'lHeader'        OF oIni DEFAULT ''
		  oSection:lHeader := Upper( cLogic ) == 'YES'
		  GET oSection:nFixHeight        SECTION cSection ENTRY 'nFixHeight'     OF oIni DEFAULT 0
		  GET oSection:cFaceName         SECTION cSection ENTRY 'cFaceName'      OF oIni DEFAULT 'Arial'
		  GET oSection:nInpHeight        SECTION cSection ENTRY 'nInpHeight'     OF oIni DEFAULT 10
		  GET cLogic                  SECTION cSection ENTRY 'lFontBold'      OF oIni DEFAULT ''
		  oSection:lFontBold      := Upper( cLogic ) == 'YES'
		  GET cLogic                  SECTION cSection ENTRY 'lFontItalic'    OF oIni DEFAULT ''
		  oSection:lFontItalic    := Upper( cLogic ) == 'YES'
		  GET cLogic                  SECTION cSection ENTRY 'lFontUnderline' OF oIni DEFAULT ''
		  oSection:lFontUnderline := Upper( cLogic ) == 'YES'
		  GET cLogic                  SECTION cSection ENTRY 'lFixed'         OF oIni DEFAULT ''
		  oSection:lFixed := Upper( cLogic ) == 'YES'
		  GET cLogic                  SECTION cSection ENTRY 'lPijama'        OF oIni DEFAULT 'No'
		  oSection:lPijama  := Upper( cLogic ) == 'YES'
		  GET oSection:nPijamaClr1    SECTION cSection ENTRY 'nPijamaClr1'    OF oIni DEFAULT CLR_GRAY
		  GET oSection:nPijamaClr2    SECTION cSection ENTRY 'nPijamaClr2'    OF oIni DEFAULT CLR_HGRAY
		  GET oSection:nPijamaClr3    SECTION cSection ENTRY 'nPijamaClr3'    OF oIni DEFAULT CLR_WHITE
		  GET oSection:nLineWidth     SECTION cSection ENTRY 'nLineWidth'     OF oIni DEFAULT 1
		  GET oSection:nShadow        SECTION cSection ENTRY 'nShadow'        OF oIni DEFAULT 0

		  // Esto lo hacemos por los decimales, ya que Ini no lo soporta
		  oSection:cSection    := aSections[nI]
		  oSection:nTop        := Val( nTop       )
		  oSection:nLeft       := Val( nLeft      )
		  oSection:nWidth      := Val( nWidth     )
		  oSection:nHeight     := Val( nHeight    )
		  oSection:nInterLine  := Val( nInterLine )

		  oReport:AddSection( oSection )

	 next nI

return oReport

//------------------------------------------------------------------------------
static function GetWinCoors( oWnd )
local oIni
local nRow, nCol, nWidth, nHeight

	  nRow    := oWnd:nTop
	  nCol    := oWnd:nLeft
	  nWidth  := oWnd:nRight - oWnd:nLeft
	  nHeight := oWnd:nBottom - oWnd:nTop

	  INI oIni FILE FILE_INI

			GET nRow SECTION "Coordenadas"    ENTRY "Fila"    DEFAULT 25  OF oIni
			GET nCol SECTION "Coordenadas"    ENTRY "Columna" DEFAULT 40  OF oIni
			GET nWidth SECTION "Coordenadas"  ENTRY "Ancho"   DEFAULT 700 OF oIni
			GET nHeight SECTION "Coordenadas" ENTRY "Alto"    DEFAULT 580 OF oIni

	  ENDINI

	  if nRow == 0 .AND. nCol == 0
			WndCenter(oWnd:hWnd)
	  else
			oWnd:Move(nRow, nCol, nWidth, nHeight)
	  endif

	  oWnd:CoorsUpdate()

return NIL

//------------------------------------------------------------------------------
static function SetWinCoors( oWnd )
local oIni
local nRow, nCol, nWidth, nHeight

	  oWnd:CoorsUpdate()
	  nRow    := oWnd:nTop
	  nCol    := oWnd:nLeft
	  nWidth  := oWnd:nRight - oWnd:nLeft
	  nHeight := oWnd:nBottom - oWnd:nTop

	  INI oIni FILE FILE_INI

			SET SECTION "Coordenadas" ENTRY "Fila"    TO nRow    OF oIni
			SET SECTION "Coordenadas" ENTRY "Columna" TO nCol    OF oIni
			SET SECTION "Coordenadas" ENTRY "Ancho"   TO nWidth  OF oIni
			SET SECTION "Coordenadas" ENTRY "Alto"    TO nHeight OF oIni

	  ENDINI

return NIL

//------------------------------------------------------------------------------
static function RoundCorners( oDlg )
local aRect, hRgn

	 aRect       := GetClientRect( oDlg:hWnd )
	 hRgn        := CreateRoundRectRgn( aRect, 20, 20 )
	 SetWindowRgn( oDlg:hWnd, hRgn )
	 DeleteObject( hRgn )

return NIL



//------------------------------------------------------------------------------
static function MsgYesNoCancel( cMsg, cTitle )

	 DEFAULT cTitle := TXT_FWRPT

return MessageBox( GetActiveWindow(), cMsg, cTitle, ;
					  nOR( MB_ICONQUESTION, MB_YESNOCANCEL ) )

//------------------------------------------------------------------------------
function GetMyRpt( o )

	 if ValType( o ) == 'O' .AND. o:ClassName() == 'MYRPT'
		 oMyRpt := o
	 endif

return oMyRpt

//------------------------------------------------------------------------------
//                      CLASS TRpt
//------------------------------------------------------------------------------

CLASS Trpt

	DATA cName              AS CHARACTER INIT 'Project'
	DATA cDescription       AS CHARACTER INIT ''
	DATA cAutor             AS CHARACTER INIT ''
	DATA dData              AS DATE      INIT Date()
	DATA cDirDat            AS CHARACTER INIT ''
	DATA cFormatDate        AS CHARACTER INIT 'DD/MM/YYYY'
	DATA cFileEmf           AS CHARACTER INIT ''
	DATA nHeight            AS NUMERIC   INIT 16
	DATA nWidth             AS NUMERIC   INIT 100
	DATA nPaperSize         AS NUMERIC   INIT 9
	DATA nZoom              AS NUMERIC   INIT 100
	DATA lPortrait          AS LOGICAL   INIT .t.
	DATA aItems             AS ARRAY     INIT {}
	DATA aSections          AS ARRAY     INIT {}
	DATA oPublic            AS OBJECT
	DATA lError             AS LOGICAL   INIT .F.

	METHOD New()            CONSTRUCTOR
	METHOD AddItem   ( oItem )   INLINE Aadd( ::aItems, oItem )
	METHOD AddSection( oPublic ) INLINE Aadd( ::aSections, oPublic )
	METHOD ToString( cString )
	METHOD FromString( cString )

ENDCLASS

//------------------------------------------------------------------------------
METHOD New() CLASS Trpt

return Self

//------------------------------------------------------------------------------
METHOD ToString() CLASS Trpt
local aData   := __objGetValueList( Self )

return HB_Serialize( aData )

//------------------------------------------------------------------------------
METHOD FromString( cString ) CLASS Trpt
local aData
local oError

	 TRY
		aData   := HB_Deserialize( cString )
		__ObjSetValueList( Self, aData )
	 CATCH oError
		::lError := .T.
	 END

return Self

//------------------------------------------------------------------------------
//                             Class RptRun
//------------------------------------------------------------------------------

CLASS RptRun

	 DATA   oReport
	 DATA   oPrn
	 DATA   oAnimate
	 DATA   nPage		   AS NUMERIC   INIT 0
	 DATA   cDir 		   AS CHARACTER INIT diruta()
	 DATA   cDirDll		AS CHARACTER INIT diruta()
	 DATA   cDllFile		AS CHARACTER INIT ''
	 DATA   cDirDat		AS CHARACTER INIT ''
	 DATA   cTitle		   AS CHARACTER INIT ''
	 DATA   lIsDemo		AS LOGICAL   INIT .F.
	 DATA   lDebug		   AS LOGICAL   INIT .T.
	 DATA   lAnimate     AS LOGICAL   INIT .F.
	 DATA   lFromUser		AS LOGICAL   INIT .F.
	 DATA   lPreview		AS LOGICAL   INIT .T.
	 DATA   nCopies		AS NUMERIC   INIT 1
	 DATA   nLastRow		AS NUMERIC   INIT -1
	 DATA   cDateStart   AS CHARACTER INIT ''
	 DATA   cTimeStart   AS CHARACTER INIT ''
	 DATA   aProperty    AS ARRAY     INIT {}
	 DATA   aSections    AS ARRAY     INIT {}
	 DATA   nRowNow      AS NUMERIC   INIT 0
	 DATA   lInitPage    AS LOGICAL   INIT .T.
	 DATA   cprinter
	 DATA   bHeader, bFooter

	 METHOD New( oReport )   CONSTRUCTOR
	 METHOD Activate()
	 METHOD Header()
	 METHOD Footer()
	 METHOD Start()
	 METHOD End()
	 METHOD IniPage()
	 METHOD EndPage()
	 METHOD PrintDemo()
	 METHOD PrintItem   ( oItem )
	 METHOD PrintSay    ( oItem )
	 METHOD PrintBox    ( oItem )
	 METHOD PrintLine   ( oItem )
	 METHOD PrintShadow ( oItem )
	 METHOD PrintImage  ( oItem )
	 METHOD PrintCodeBar( oItem )
	 METHOD PrintMemo   ( oItem )
	 METHOD PrintRTF    ( cID, cRTF )
	 METHOD PrintPijama ( oItem )
	 METHOD Info()		INLINE ShellAbout( RPTVERSION, AUTOR, ::oIcon:hIcon )
	 METHOD Data( cId, uVal )
	 METHOD Skip( nSkip )
	 METHOD SetEmf( cFileEmf )	INLINE ::oReport:cFileEmf := ::cDirDat + '\' + cFileEmf
	 METHOD GetSection( cSection )
	 METHOD Name()		INLINE ::oReport:cName
	 METHOD TimeStamp()          INLINE ::cDateStart + ' ' + ::cTimeStart
	 METHOD IsNewProperty( oItem )
	 METHOD SetProperty( cId, cProperty, uValue )
	 METHOD CheckProperty( oItem )

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( oReport ) CLASS RptRun

	 ::cDir	:= diruta()
	 ::cDirDll	:= diruta()
	 ::cDllFile	:= IF( ! IsWin64(), "MyRpt.dll", "MyRpt64.dll" )
	 ::nPage	:= 0
	 ::oReport	:= oReport
	 ::cTitle	:= oReport:cName

return Self

//------------------------------------------------------------------------------
METHOD Activate() CLASS RptRun  //  Validate ::oReport

	 if ValType( ::oReport ) <> 'O'
		 MsgAlert( TXT_RUN_RPT_NO_DEFINED, TXT_FWRPT )
		 return NIL
	 endif

	 ::cDateStart := FormatDate( Date(), ::oReport:cFormatDate )
	 ::cTimeStart := Time()

	 //  Si ofrecemos la posibilidad de cambiar el tamao, siempre deberemos
	 //  especificarlo, sino el preview no se vera bien. De momento lo ajustamos
	 //  cuando sea definido por el user, y cuando sea automatico de momento
	 //  lo ponemos a pelo para A4


	 if ::oReport:nPaperSize == 0  // USER DEFINED
		 PrnSetSize( ::oReport:nWidth * 10 , ::oReport:nHeight * 10 )
	 else
		 PrnSetSize( 209.97 * 10, 296.97 * 10 )  // A4 Pendiente de resolver para otros tipos
		 //PrnSetSize( 202 * 10, 289* 10 )  // A4 Pendiente de resolver para otros tipos       //Sebas
	 endif

	 if ::oPrn == NIL
		 ::oPrn := PrintBegin( ::cTitle , ::lFromUser, ::lPreview, oMyRpt:cprinter, .f., .f.)
		 ::oPrn:cDir := GetEnv('TMP')
		 ::oPrn:lMeta := .t.
		 ::oPrn:aMeta := {}

	 endif

	 if Empty( ::oPrn:hDC )
		 MsgAlert( TXT_RUN_PRINTER_NOT_READY, TXT_ERROR )
		 return NIL
	 endif

	 if ::oReport:nPaperSize > 0  // PAPER DEFINED
		 ::oPrn:SetPage( ::oReport:nPaperSize )
	 endif

	 if ::oReport:lPortrait
		 ::oPrn:SetPortrait()
	 else
		 ::oPrn:SetLandscape()
	 endif

	 if ::nCopies > 1
		 ::oPrn:SetCopies( ::nCopies )
	 endif

*   InfoPrn( ::oPrn )	// For debug...

	 ::Start()

	 if ::lIsDemo
		 ::PrintDemo()
		 ::End()
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD Start() CLASS RptRun

	 if ::lAnimate
		 ::oAnimate := TRptAnimate():New()
		 ::oAnimate:cDirDll  := ::cDirDll
		 ::oAnimate:cDllFile := ::cDllFile
		 ::oAnimate:Activate()
		 ::oAnimate():SetMsg( TXT_ANIM_PRINT )
		 ::oAnimate():Animate()
	 endif

	 ::IniPage()

return NIL

//------------------------------------------------------------------------------
METHOD IniPage() CLASS RptRun
local oItem, oNewItem
local nI
local nItems := Len( ::oReport:aItems )
local cCaption

	 ::nPage++

	 if ::lAnimate()
		 ::oAnimate():SetMsg( TXT_ANIM_MSG + ltrim(str( ::nPage )) )
	 endif

	 PAGE

	 ::Header()

	 for nI := 1 TO nItems

		  oItem := ::oReport:aItems[nI]

		  if empty( oItem:cSection ) .and. oItem:lVisible

			  if oItem:lSpecial
				  oNewItem := TItem():New(.f.)
				  oNewItem:CopyFromItem( oItem )

				  cCaption := oItem:cCaption

				  do case
					  case oItem:nType == 10
							 // AQUI NO SE TIENE PUEDE PROCESAR. SE ARA AL FINAL...
					  case oItem:nType == 11
							 oNewItem:cCaption := Alltrim( cCaption + ' ' + ::cTimeStart )
					  case oItem:nType == 12
							 oNewItem:cCaption := Alltrim( cCaption + ' ' + ::cDateStart )
					  case oItem:nType == 13
							 oNewItem:cCaption := ::TimeStamp()
					  case oItem:nType == 14
							 oNewItem:cCaption := Alltrim( cCaption + ' ' + ::Name() )
					  case oItem:nType == 15
							 oNewItem:cCaption := Alltrim( cCaption + ' ' + NetName() )
					  case oItem:nType == 16
							 oNewItem:cCaption := Alltrim( cCaption + ' ' + WNetGetUser() )
				  endcase

				  if oItem:nType <> 10
					 ::PrintItem( oNewItem )
				  endif

				else

				  ::PrintItem( oItem )

				endif

		  endif

	 next nI

return NIL

//------------------------------------------------------------------------------
METHOD EndPage() CLASS RptRun
local nItems := Len( ::oReport:aItems ), nI

	 ::Footer()

	 ENDPAGE

	 for nI := 1 to nItems
		  ::oReport:aItems[nI]:Repos()  //Sebas: Method Repos inicializa el ntop de los items
	 next nI

return NIL

//------------------------------------------------------------------------------
METHOD End() CLASS RptRun

	 local nI
	 local oTSection
	 local aFicheros, nHojas
	 local cCaption
	 local oItem
	 local aItems   := ::oReport:aItems
	 local nPos     := Ascan( aItems, {|o| o:lSpecial .and. o:nType == 10 } )

	 ::EndPage()


	 //  Chequear si hay un Special Item de N. Pagina
	 if nPos > 0  .and. ::oPrn:lMeta
		 aFicheros  := ::oPrn:aMeta
		 nHojas     := ::oPrn:nPage

		 ::oPrn:aMeta := {}

		 oItem    := aItems[ nPos ]
		 cCaption := oItem:cCaption

		 for nI := 1 TO  nHojas
			  oItem:cCaption := cCaption

			  if nHojas > 1      //Solo si hay mas de una pagina  Sebas
				  oItem:cCaption := StrTran( oItem:cCaption, 'XX', ltrim(str(nI)) )
				  oItem:cCaption := StrTran( oItem:cCaption, 'YY', ltrim(str(nHojas)) )
			  else
				  oItem:cCaption := ''
			  endif

			  PAGE

			  ::oPrn:ImportWMF( aFicheros[ nI ], .F.  )
			  ::PrintSay( oItem )

			  ENDPAGE

		 next nI

		 aFicheros  := ::oPrn:aMeta

		 if ::lPreview = .f.
			 ::oPrn:lPreview := .f.
			 ::oPrn:lMeta := .f.
		 endif

	 endif

	 ENDPRINT

	 if ::lPreview = .f.
		 ::oPrn := PrintBegin( ::cTitle , ::lFromUser, ::lPreview, oMyRpt:cprinter, .f., .f.)
		 for nI = 1 to nHojas
			  PAGE
			  hEMF := GetEnhMetafile( aFicheros[nI] )
			  PlayEnhMetafile(::oPrn:hDC, hEMF,, .t.)
			  DeleteEnhMetafile(hEMF)
			  ENDPAGE
		 next nI
		 ENDPRINT
	 endif



	 if ::lAnimate
		 ::oAnimate():End()
	 endif

	 //  Borrar todos los Fonts usados
	 for nI := 1 TO Len( ::oReport:aItems )
		  if valType( ::oReport:aItems[nI]:oFont ) == 'O'
			  ::oReport:aItems[nI]:oFont:End()
		  endif
	 next nI

	 //  Borrar todas las sectiones
	 for nI := 1 TO Len( ::aSections )
		  oTSection := ::aSections[nI]
		  if valType( oTSection ) == 'O'
			  oTSection:End()
		  endif
	 next nI


return NIL

//------------------------------------------------------------------------------
METHOD Header() CLASS RptRun
local cEmf := ::oReport:cFileEmf

	 if ! Empty( ::cDirDat )
		 cEmf := ::cDirDat + '\' + cFileNoPath( cEmf )
	 endif

	 if File( cEmf )
		 ::oPrn:ImportWMF( cEmf )
	 endif

	 if ValType( ::bHeader ) == 'B'
		 Eval( ::bHeader, SELF )
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD Footer() CLASS RptRun

	 if ValType( ::bFooter ) == 'B'
		 Eval( ::bFooter, SELF )
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD PrintDemo() CLASS RptRun
local nI, oItem

	for nI := 1 to Len( ::oReport:aItems )
		 oItem := ::oReport:aItems[nI]
		 do case
			 case oItem:cClass == 'TBOX'
					::PrintBox  ( oItem )

			 case oItem:cClass == 'TIMAGE'
					::PrintImage( oItem )

			 case oItem:cClass == 'TCODEBAR'
					::PrintCodeBar( oItem )

			 case oItem:cClass == 'TSAY'
					::PrintSay  ( oItem )

		 endcase
	next nI

return NIL

//------------------------------------------------------------------------------
METHOD SetProperty( cKey, cProperty, uValue ) CLASS RptRun

	 Aadd( ::aProperty, { Upper( cKey ), Upper( cProperty ), uValue } )

return NIL

//------------------------------------------------------------------------------
METHOD IsNewProperty( oItem ) CLASS RptRun
local cKey := ''

	 do case
		 case oItem:ClassName() == 'TITEM'
				cKey := Alltrim( Upper( oItem:cId ) )
		 case oItem:ClassName() == 'TSECTION'
				cKey := Alltrim( Upper( oItem:cSection ) )
	 endcase

return Ascan( ::aProperty, {|x| x[1] == cKey } ) > 0

//------------------------------------------------------------------------------
METHOD CheckProperty( oItem ) CLASS RptRun
local cKey
local nPos

	 do case
		 case oItem:ClassName() == 'TITEM'
				cKey := Alltrim( Upper( oItem:cId ) )

				do while ( nPos := Ascan( ::aProperty, {|x| x[1] == cKey } ) ) > 0
					oItem:lNewProperty := .T.

					do case
						case ::aProperty[ nPos ][ 2 ] == 'COLOR'
							  oItem:nClrFore := ::aProperty[ nPos ][ 3 ]
						case ::aProperty[ nPos ][ 2 ] == 'BOLD'
							  oItem:lFontBold := ::aProperty[ nPos ][ 3 ]
						case ::aProperty[ nPos ][ 2 ] == 'ITALIC'
							  oItem:lFontItalic := ::aProperty[ nPos ][ 3 ]
						case ::aProperty[ nPos ][ 2 ] == 'UNDERLINE'
							  oItem:lFontUnderline := ::aProperty[ nPos ][ 3 ]
					endcase

					Adel ( ::aProperty, nPos )
					ASize( ::aProperty, Len( ::aProperty ) - 1 )

				enddo

		 case oItem:ClassName() == 'TSECTION'
				cKey := Alltrim( Upper( oItem:cSection ) )

				do while ( nPos := Ascan( ::aProperty, {|x| x[1] == cKey } ) ) > 0

					if ::aProperty[ nPos ][ 2 ] == 'REMARK'
						oItem:lPijama := .t.
						oItem:nPijamaClr1 := ::aProperty[ nPos ][ 3 ]
					endif

					ADel ( ::aProperty, nPos )
					ASize( ::aProperty, Len( ::aProperty ) - 1 )

				 enddo

	 endcase

return NIL

//------------------------------------------------------------------------------
METHOD PrintItem( oItem ) CLASS RptRun
local oNewItem

	 if oItem:lBorder
		 ::PrintBox( oItem )
	 endif

	 //  Chequeamos si hay alguna propiedad cambiada on-the fly
	 if ::IsNewProperty( oItem )
		 oNewItem := TItem():New(.f.)
		 oNewItem:CopyFromItem( oItem )
		 ::CheckProperty( oNewItem )

		 do case
			 case oItem:cClass == 'TSAY'
					::PrintSay( oNewItem )
			 case oItem:cClass == 'TIMAGE'
					::PrintImage( oNewItem )
			 case oItem:cClass == 'TBOX'
					::PrintBox( oNewItem )
			 case oItem:cClass == 'TCODEBAR'
					::PrintCodeBar( oNewItem )
		 endcase

	 else

		 do case
			 case oItem:cClass == 'TSAY'
					::PrintSay( oItem )
			 case oItem:cClass == 'TIMAGE'
					::PrintImage( oItem )
			 case oItem:cClass == 'TBOX'
					::PrintBox( oItem )
			 case oItem:cClass == 'TCODEBAR'
					::PrintCodeBar( oItem )
		 endcase
	 endif

return NIL


//------------------------------------------------------------------------------
METHOD PrintSay( oItem ) CLASS RptRun
local nTop, nLeft, nWidth, nHeight, oBrush
local nBkMode   := 1  // DEfault
local oFont
local nPad
local cText

	 if oItem:lMemo .AND. !::lIsDemo
		 ::PrintMemo( oItem )
	 else
		 if oItem:lNewProperty == .T.
			 oFont := InitFont( ::oPrn, oItem )
		 else
			 if ValType( oItem:oFont ) <> 'O'
				 oFont := InitFont( ::oPrn, oItem )
				 oItem:oFont := oFont
			 else
				 oFont := oItem:oFont
			 endif
		endif

	  do case
		  case oItem:nPad == 0
				 nPad := 0
		  case oItem:nPad == 1
				 nPad := 2
		  case oItem:nPad == 2
				 nPad := 1
	  endcase

	  apos := ::oprn:mmtr2pix(oItem:nTop,oItem:nleft)
	  nTop	:= Max( 0, apos[1] + ::oPrn:nXOffset )
	  nLeft	:= Max( 0, apos[2] + ::oprn:nYOffset )
	  nWidth	:= oItem:nWidth
	  nHeight  := oItem:nHeight //Max( 0, ( oItem:nHeight   * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )


	  ::oPrn:Mmtr2Pix( 0, @nWidth )

	  nWidth += ::oPrn:nYOffset

	  // Si es Preview imprimiremos el recuadro que delimita el Item con el fin de ver el diseo
	  if ::lIsDemo
		  ::PrintBox( oItem )
		  if oItem:lVisible
			  cText := RTrim( oItem:cCaption )
		  else
			  //cText := 'ID: ' + AllTrim( oItem:cID )
		  endif

	  else
		  if oItem:lVisible
			  cText := RTrim( oItem:cCaption )
		  endif
	  endif

	  DEFINE BRUSH oBrush COLOR oItem:nClrBack
	  ::oPrn:FillRect({ntop, nLeft, ntop+nHeight, nLeft+nWidth},oBrush)
	  oBrush:end()

	  ::oPrn:Say( nTop, nLeft, cText , oFont, nWidth, oItem:nClrFore, nBkMode, nPad )

	  if oItem:lNewProperty == .T.
		  oFont:End()
		  oItem:lNewProperty := .F.
	  endif

	  ::nLastRow := oItem:nTop

	endif

return NIL
/*
*------------------------------------
METHOD PrintSay( oItem ) CLASS RptRun
*------------------------------------
	 LOCAL nTop, nLeft, nWidth
	 LOCAL nBkMode   := 1  // DEfault
	 LOCAL oFont
	 LOCAL nPad
	 LOCAL cText

	 IF oItem:lMemo .AND. !::lIsDemo
		 ::PrintMemo( oItem )
	 ELSE
		 IF oItem:lNewProperty == .T.
			 oFont := InitFont( ::oPrn, oItem )
		 ELSE
			 IF ValType( oItem:oFont ) <> 'O'
				 oFont		 := InitFont( ::oPrn, oItem )
				 oItem:oFont	 := oFont
			 ELSE
				 oFont := oItem:oFont
			 ENDIF
		 ENDIF

		 DO CASE
			 CASE oItem:nPad == 0 ; nPad := 0
			 CASE oItem:nPad == 1 ; nPad := 2
			 CASE oItem:nPad == 2 ; nPad := 1
		 ENDCASE

		 nTop	:= Max( 0, ( oItem:nTop   * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
		 nLeft	:= Max( 0, ( oItem:nLeft  * ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )
		 nWidth	:= oItem:nWidth

		 ::oPrn:Mmtr2Pix( 0, @nWidth )

		 nWidth += ::oPrn:nYOffset

//     Si es Preview, imprimiremos, el recuadro que delimita el Item con el
//     fin de ver el diseo

		 IF ::lIsDemo
			 ::PrintBox( oItem )
			 IF oItem:lVisible
				 cText := RTrim( oItem:cCaption )
			 ELSE
				 cText := 'ID: ' + AllTrim( oItem:cID )
			 ENDIF
		 ELSE
			 cText := RTrim( oItem:cCaption )
		 ENDIF

		 ::oPrn:Say( nTop, nLeft, cText , oFont,;
		 nWidth, oItem:nClrFore, nBkMode, nPad )

		 IF oItem:lNewProperty == .T.
			 oFont:End()
			 oItem:lNewProperty := .F.
		 ENDIF

		 ::nLastRow := oItem:nTop

	ENDIF

RETU NIL
*/

//------------------------------------------------------------------------------
METHOD PrintMemo( oItem ) CLASS RptRun
local cText      := oItem:cCaption
local nWidth_Pix := 0
local lOut	     := .F.
local nAt
local cLinea
local aWord
local nCount
local nRowInitial
local nRowNow
local nTop, nWidth, nHeight
local cNewLine
local nJ, ni
local nWord, cWord
local nHeightFont
local cCar

	 oItem:lMemo := .F.

	 //  La Idea es:
	 //  a) SI es FIXED empezaremos por donde se ha definido en el report
	 //  b) SI NO FIXED empezaremos por donde tenemos el cursor situado en
	 //	  este momento, PERO si el cursor aun NO se ha movido
	 //     empezaremos por donde esta definido en el report
	 if oItem:lFixed
		 nRowInitial := oItem:nTop
	 else
		 if ::nLastRow <> -1
			 nRowInitial := ::nLastRow
		 else
			 nRowInitial := oItem:nTop
		 endif
	 endif

	 nHeightFont := ::oPrn:GetTextHeight( 'B', oItem:oFont )

	 ::oPrn:Pix2Mmtr( @nHeightFont, 0 )

	 nRowNow	:= nRowInitial
	 nWidth	:= oItem:nWidth
	 nWidth_Pix	:= oItem:nWidth
	 nHeight	:= oItem:nHeight + nRowNow

	 ::oPrn:Mmtr2Pix( 0, @nWidth_Pix )

	 cNewLine := ''
	 nI := 0

	 do while ( nAt := AT( CRLF,  cText ) ) > 0 .AND. !lOut

		 cLinea := Substr( cText, 1, nAt-1 )
		 cText  := substr( cText, nAt + 2 )
		 aWord  := {}
		 nCount := 1
		 nI++

		 //  Si resulta que tenemos espacios en el primer lugar, miraremos los que hay
		 nCount := 1
		 cCar  := Substr( cLinea,nCount,1 )
		 cWord := ''
		 while cCar == ' ' .OR. Asc(cCar) == 9
				 cWord += if( Asc(cCar) == 9, Space(5), ' ' )
				 nCount++
				 cCar := Substr( cLinea,nCount,1 )
		 enddo
		 if nCount > 1
			 Aadd( aWord, cWord )
			 cLinea := Substr( cLinea, nCount )
		 endif

		 // Capturamos las palabras
		 nWord  := 1
		 do while !Empty( cWord := StrToken( cLinea, nWord , ' ' ) )
			 Aadd( aWord, cWord )
			 nWord++
		 enddo

		 nWord	:= 1
		 cNewLine := ''

		 do while nWord <= Len( aWord ) .AND. !lOut
			 cWord := aWord[ nWord ]

			 if ::oPrn:GetTextWidth( cNewLine + cWord, oItem:oFont ) <= nWidth_Pix
				 cNewLine += cWord
				 cNewLine += ' '
				 nWord++
			 else
				 oItem:cCaption := cNewLine
				 oItem:nTop	:= nRowNow
				 ::PrintSay( oItem )
				 cNewLine := ''
				 nRowNow  += nHeightFont + oItem:nInterline
			 endif

			 if ( nRowNow + nHeightFont + oItem:nInterline ) > nHeight
				 if oItem:lMultipage
					 ::EndPage()
					 ::IniPage()
					 nRowNow := nRowInitial
				 else
					 lOut := .T.
				 endif
			 endif

		 enddo

		 if !Empty( cNewLine ) .AND. !lOut
			 oItem:cCaption := cNewLine
			 oItem:nTop	  := nRowNow
			 ::PrintSay( oItem )
			 cNewLine := ''
			 nRowNow  += nHeightFont + oItem:nInterline
		 endif

		 if Len( aWord ) == 0  // Caso de que sea un SALTO DE LINEA VACIO
			 nRowNow  += nHeightFont + oItem:nInterline
		 endif

		 if ( nRowNow + nHeightFont + oItem:nInterline ) > nHeight
			 if oItem:lMultipage
				 ::EndPage()
				 ::IniPage()
				 nRowNow := nRowInitial
			 else
				 lOut := .T.
			 endif
		 endif

	 enddo

	 //  LastLine
	 if !Empty( cText ) .and. !lOut
		 if ( nRowNow + nHeightFont + oItem:nInterline ) > nHeight
			 oItem:cCaption := cText
			 oItem:ntop     := nRowNow
			 ::PrintSay( oItem )
			 nRowNow  += nHeightFont + oItem:nInterline
		 endif
	 endif

	 //  Save last row printed
	 ::nLastRow := nRowNow

	 //  Dejamos el estado inicial. Por si se vuelve a usar este item...
	 oItem:lMemo := .T.

return NIL

//------------------------------------------------------------------------------
METHOD PrintImage( oItem ) CLASS RptRun
local nTop	     := Max( 0, ( oItem:nTop   * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
local nLeft      := Max( 0, ( oItem:nLeft  * ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )
local nWidth     := oItem:nWidth
local nHeight    := oItem:nHeight
local oImage
local cFile      := Alltrim( oItem:cFile )
local lIsSection := ! Empty( oItem:cSection )
local nRatio

	 if ! File( cFile )
		 return NIL
	 endif

	 DEFINE IMAGE oImage FILE cFile

	 SysRefresh()

	 ::oPrn:Mmtr2Pix( 0, @nWidth )
	 nWidth += ::oPrn:nXOffset
	 ::oPrn:Mmtr2Pix( @nHeight, 0 )
	 nHeight := nHeight + ::oPrn:nYOffset

	 if lIsSection .AND. ! ::lIsDemo
		 ::oPrn:SayImage( nTop, nLeft, oImage,      0, nHeight, , .T. )
	 else
		 ::oPrn:SayImage( nTop,	nLeft, oImage,	nWidth, nHeight, , .T. )
	 endif

	 SysRefresh()

	 oImage:End()

return NIL

//------------------------------------------------------------------------------
METHOD PrintShadow( oItem ) CLASS RptRun
local oPen, oBrush
local nTop, nLeft, nWidth, nHeight, nBottom, nRight
local hOldBrush
local nShadow     := oItem:nShadow / 10

	 nTop           := Max( 0, ( ( oItem:nTop  + nShadow ) * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
	 nLeft          := Max( 0, ( ( oItem:nLeft + nShadow ) * ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )
	 nWidth         := oItem:nWidth
	 nHeight        := oItem:nHeight
	 nBottom        := oItem:nTop  + nShadow + oItem:nHeight
	 nRight         := oItem:nLeft + nShadow + oItem:nWidth
	 nBottom        := Max( 0, ( nBottom * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
	 nRight         := Max( 0, ( nRight  * ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )

	 DEFINE BRUSH oBrush COLOR CLR_BLACK

	 DEFINE PEN oPen WIDTH 1 OF ::oPrn COLOR CLR_BLACK

	 hOldBrush := SelectObject( ::oPrn:hDcOut, oBrush:hBrush )

	 ::oPrn:Box( nTop, nLeft, nBottom , nRight, oPen )

	 oPen:End()

	 SelectObject( ::oPrn:hDcOut, hOldBrush )

	 nTop           := Max( 0, ( oItem:nTop   * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
	 nLeft          := Max( 0, ( oItem:nLeft  * ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )
	 nWidth         := oItem:nWidth
	 nHeight        := oItem:nHeight
	 nBottom        := oItem:nTop  + oItem:nHeight
	 nRight         := oItem:nLeft + oItem:nWidth
	 nBottom        := Max( 0, ( nBottom * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
	 nRight         := Max( 0, ( nRight  * ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )

	 DEFINE BRUSH oBrush COLOR CLR_WHITE

	 DEFINE PEN oPen WIDTH 1 OF ::oPrn COLOR CLR_WHITE

	 hOldBrush := SelectObject( ::oPrn:hDcOut, oBrush:hBrush )

	 ::oPrn:Box( nTop, nLeft, nBottom , nRight, oPen )

	 oPen:End()

	 SelectObject( ::oPrn:hDcOut, hOldBrush )

return NIL


//------------------------------------------------------------------------------
METHOD PrintBox( oItem ) CLASS RptRun
local oImage, oPen, oBrush
local nTop, nLeft, nWidth, nHeight, nBottom, nRight
local hOldBrush

	 //  Chequeamos si hay Sombra
	 if oItem:nShadow > 0
		 ::PrintShadow( oItem )
	 endif

	 //  Calculamos caja...
	 nTop           := Max( 0, ( oItem:nTop   * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
	 nLeft          := Max( 0, ( oItem:nLeft  * ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )
	 nWidth         := oItem:nWidth
	 nHeight        := oItem:nHeight
	 nBottom        := oItem:nTop  + oItem:nHeight
	 nRight         := oItem:nLeft + oItem:nWidth
	 nBottom	   := Max( 0, ( nBottom * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
	 nRight	   := Max( 0, ( nRight	* ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )

	 //  Si el color de fondo es diferente de Blanco, Definimos fondo del box
	 if oItem:nClrBack <> CLR_WHITE

		 DEFINE BRUSH oBrush COLOR oItem:nClrBack
		 DEFINE PEN oPen WIDTH oItem:nLineWidth OF ::oPrn COLOR oItem:nClrLine

		 hOldBrush := SelectObject( ::oPrn:hDcOut, oBrush:hBrush )

		 ::oPrn:Box( nTop, nLeft, nBottom , nRight, oPen )

		 oPen:End()

	 endif

	 //  Creamos el box o la Line
	 DEFINE PEN oPen WIDTH oItem:nLineWidth OF ::oPrn COLOR oItem:nClrLine

	 do case
		 case oItem:nLineType == 2
				::oPrn:Line( nTop, nLeft, nTop, nRight, oPen )
		 case oItem:nLineType == 3
				::oPrn:Line( nTop, nLeft, nBottom, nLeft, oPen )
		 case oItem:nLineType == 4
				::oPrn:Line( nBottom, nLeft, nBottom, nRight, oPen )
		 case oItem:nLineType == 5
				::oPrn:Line( nTop, nRight, nBottom, nRight, oPen )
		 otherwise
				::oPrn:Line( nTop, nLeft, nTop, nRight, oPen )
				::oPrn:Line( nTop, nLeft, nBottom, nLeft, oPen )
				::oPrn:Line( nBottom, nLeft, nBottom, nRight, oPen )
				::oPrn:Line( nTop, nRight, nBottom, nRight, oPen )
	 endcase

	 if oItem:nClrBack <> CLR_WHITE
		 SelectObject( ::oPrn:hDcOut, hOldBrush )
		 oBrush:End()
	 endif

	 oPen:End()

return NIL

//------------------------------------------------------------------------------
METHOD PrintCodeBar( oItem ) CLASS RptRun
local nTop	      := Max( 0, ( oItem:nTop	* ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
local nLeft       := Max( 0, ( oItem:nLeft	* ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )
local nWidth      := oItem:nWidth  / 10
local nHeight     := oItem:nHeight / 10
local lHorizontal := .t.
local lCheck      := .t.
local lBanner     := .t.
local nColor      := CLR_BLACK
local cModo
local cCode
local cFont

	 /*
	 Code 128:
	 Admite los 128 caracteres 0 - 127

	 si solo son numeros se usa un modelo comprimido, llamado modo C
	 Si hay caracteres < 32 se usa el modo A
	 Si hay caracteres en minusculas se usa el modo B ( modo por defecto)

	 Los modos se mezclan

	 Sintaxis :

	 code128(nRow,nCol,cCode,oPrint,[cMode],[Color],[lOrientacion],[nAncho],[nAlto])

	 nRow, nCol en Prixels
	 nAncho,nAlto en Cm
	 */

	 cModo	:= 'B'
	 cCode	:= Alltrim( oItem:cCaption )
	 lHorizontal := ! oItem:lVertical

	 do case
		 case oItem:nCodeBarType == 1  // CODE128 (MODO A)
				code128( nTop, nLeft, cCode   , ::oPrn, 'A' , nColor, lHorizontal, , nHeight )
		 case oItem:nCodeBarType == 2  // CODE128 (MODO B)
				code128( nTop, nLeft, cCode   , ::oPrn, 'B' , nColor, lHorizontal, , nHeight )
		 case oItem:nCodeBarType == 3  // CODE128 (MODO C)
				code128( nTop, nLeft, cCode   , ::oPrn, 'C' , nColor, lHorizontal, , nHeight )
		 case oItem:nCodeBarType == 4  // CODE3_9
				Code3_9( nTop, nLeft, '1234568', ::oPrn, lCheck, nColor, lHorizontal, , nHeight )
		 case oItem:nCodeBarType == 5  // Ean13
				lBanner := oItem:lBanner
				cFont   := oItem:cFaceName
				Ean13( nTop, nLeft, cCode, ::oPrn, nColor, lHorizontal, , nHeight, lBanner, cFont )
		 case oItem:nCodeBarType == 6  // Ean8
				lBanner := oItem:lBanner
				cFont   := oItem:cFaceName
				Ean8 ( nTop, nLeft, cCode, ::oPrn, nColor, lHorizontal, , nHeight, lBanner, cFont )
		 case oItem:nCodeBarType == 7  // Codabar
				Codabar( nTop, nLeft, cCode, ::oPrn, nColor, lHorizontal, , nHeight )
		 case oItem:nCodeBarType == 8  // UPCA
				lBanner := oItem:lBanner
				cFont   := oItem:cFaceName
				UPCA( nTop, nLeft, cCode, ::oPrn, nColor, lHorizontal, , nHeight, lBanner, cFont )
	 endcase

return NIL

//------------------------------------------------------------------------------
METHOD PrintPijama( oItem ) CLASS RptRun
local oBrush, oPen
local hOldBrush
local nColor, nColorBorder
local nTop, nLeft, nBottom, nRight

	 nColor       := IF( oItem:lPijamaOnOff, oItem:nPijamaClr1, oItem:nPijamaClr2 )
	 nColorBorder := IF( oItem:nPijamaClr3 == CLR_WHITE, nColor, oItem:nPijamaClr3 )

	 DEFINE BRUSH oBrush COLOR nColor

	 DEFINE PEN oPen WIDTH oItem:nLineWidth OF ::oPrn COLOR nColorBorder

	 hOldBrush := SelectObject( ::oPrn:hDcOut, oBrush:hBrush )

	 nTop     := Max( 0, ( oItem:nTop	 * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
	 nLeft    := Max( 0, ( oItem:nLeft	 * ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )
	 nBottom  := Max( 0, ( oItem:nBottom  * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
	 nRight   := Max( 0, ( oItem:nRight	 * ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )

	 ::oPrn:Box( nTop, nLeft, nBottom , nRight, oPen )

	 SelectObject( ::oPrn:hDcOut, hOldBrush )

	 oBrush:End()
	 oPen:End()

return NIL

//------------------------------------------------------------------------------
METHOD PrintLine( oItem ) CLASS RptRun
local oImage, oPen, oBrush
local nTop, nLeft, nWidth, nHeight, nBottom, nRight
local hOldBrush

	 //  Calculamos Linea...
	 nTop           := Max( 0, ( oItem:nTop   * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
	 nLeft          := Max( 0, ( oItem:nLeft  * ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )
	 nBottom        := Max( 0, ( oItem:nBottom  * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
	 nRight         := Max( 0, ( oItem:nRight   * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )

	 //  Creamos el box o la Line
	 DEFINE PEN oPen WIDTH oItem:nLineWidth OF ::oPrn COLOR CLR_BLACK

	 ::oPrn:Line( nTop, nLeft, nBottom, nRight, oPen )

	 oPen:End()

return NIL

//------------------------------------------------------------------------------
METHOD Data( cId, uVal ) CLASS RptRun
local nPos, oItem

	 DEFAULT cID  := ''

	 nPos := Ascan( ::oReport:aItems, {|o| Alltrim( Upper(o:cId) ) == Upper(cId) } )

	 if nPos == 0
		 if ::lDebug
			 MsgAlert( TXT_RUN_LABEL + ' ' + cId + ' ' + TXT_RUN_NOT_EXIST, TXT_FWRPT )
		 endif
		 return .F.
	 endif

	 oItem := ::oReport:aItems[nPos]

	 do case
		 case oItem:cClass == 'TSAY'
				oItem:cCaption := ToChar( uVal )
		 case oItem:cClass == 'TIMAGE'
				oItem:cFile := ToChar( uVal )
		 case oItem:cClass == 'TBOX'
		 case oItem:cClass == 'TCODEBAR'
				oItem:cCaption := ToChar( uVal )
	 endcase

	 ::PrintItem( oItem )

return NIL

//------------------------------------------------------------------------------
METHOD Skip( nSkip ) CLASS RptRun

	 DEFAULT nSkip := 1

	 ::nLastRow += nSkip

return NIL

//------------------------------------------------------------------------------
METHOD GetSection( cSection ) CLASS RptRun
local  o := PrintSection():New( SELF, cSection )

return o

//------------------------------------------------------------------------------
METHOD PrintRTF( cID, cRTF ) CLASS RptRun
local oItem, oprtf, cxrtf, ntotlines
local ntop, nleft, nwidth, nHeight
local aRTF := { 0, 0 }, nlinertf

@ 1000, 1000 RICHEDIT oprtf VAR cxrtf OF oWnd
oprtf:loadrtf(cRTF)
ntotlines := oprtf:GetLineCount()

  nline := 1
  do whil .t.

	  nPos := Ascan( ::oReport:aItems, {|o| Alltrim( Upper(o:cId) ) == Upper(cId) } )

	  IF nPos == 0
		  IF ::lDebug
			  MsgAlert( TXT_RUN_LABEL + ' ' + cId + ' ' + TXT_RUN_NOT_EXIST, TXT_FWRPT )
		  ENDIF
		  RETU .F.
	  ENDIF

	  oItem := ::oReport:aItems[nPos]
	  if oItem:lvisible = .f.
		  oItem:cCaption := ''
		  exit
	  else

		  nTop	:= Max( 0, ( oItem:nTop   * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )
		  nLeft	:= Max( 0, ( oItem:nLeft  * ::oPrn:nHorzRes() / ::oPrn:nHorzSize() ) )
		  nWidth	:= oItem:nWidth
		  nHeight  := Max( 0, ( oItem:nHeight   * ::oPrn:nVertRes() / ::oPrn:nVertSize() ) )

		  ::oPrn:Mmtr2Pix( 0, @nWidth )
		  nWidth += ::oPrn:nYOffset


		  nright := nleft+nwidth
		  nbottom := ntop+nHeight

		  artf := oprtf:PrintBox( if(::oPrn:lMeta, ::oPrn:hDCOut, ::oPrn:hDC),;
									 ntop, nleft, nright, nBottom,;
									 aRTF[ 1 ] )
		  nlinertf := oprtf:GetLineFromChar(aRTF[1])

		  if ntotlines - nlinertf < 2
			  exit
		  endif

		  if oItem:lMultipage
			  ::EndPage()
			  ::Inipage()
		  else
			  exit
		  endif
	  endif
  enddo

  oprtf:end()
return

//------------------------------------------------------------------------------
static function InfoPrn( oPrn )
local cInfo := ''

	 cInfo += 'GetModel()       ' + Chr( VK_TAB ) + cValToChar( oPrn:GetModel()      ) + CRLF
	 cInfo += 'GetDriver()      ' + Chr( VK_TAB ) + cValToChar( oPrn:GetDriver()     ) + CRLF
	 cInfo += 'GetPort()        ' + Chr( VK_TAB ) + cValToChar( oPrn:GetPort()       ) + CRLF
	 cInfo += 'GetOrientation() ' + Chr( VK_TAB ) + cValToChar( oPrn:GetOrientation()) + CRLF
	 cInfo += '                 ' + Chr( VK_TAB ) + CRLF
	 cInfo += '-nXOffSet        ' + Chr( VK_TAB ) + cValToChar( oPrn:nXOffSet )        + CRLF
	 cInfo += '-nYOffSet        ' + Chr( VK_TAB ) + cValToChar( oPrn:nYOffSet )        + CRLF
	 cInfo += '                 ' + Chr( VK_TAB ) + CRLF
	 cInfo += 'GetPhySize()[1]  ' + Chr( VK_TAB ) + cValToChar( oPrn:GetPhySize()[1] ) + CRLF
	 cInfo += 'GetPhySize()[2]  ' + Chr( VK_TAB ) + cValToChar( oPrn:GetPhySize()[2] ) + CRLF
	 cInfo += '                 ' + Chr( VK_TAB ) + CRLF
	 cInfo += 'nVertRes()       ' + Chr( VK_TAB ) + cValToChar( oPrn:nVertRes()      ) + CRLF
	 cInfo += 'nHorzRes()       ' + Chr( VK_TAB ) + cValToChar( oPrn:nHorzRes()      ) + CRLF
	 cInfo += 'nVertSize()      ' + Chr( VK_TAB ) + cValToChar( oPrn:nVertSize()     ) + CRLF
	 cInfo += 'nHorzSize()      ' + Chr( VK_TAB ) + cValToChar( oPrn:nHorzSize()     ) + CRLF
	 cInfo += 'nLogPixelX()     ' + Chr( VK_TAB ) + cValToChar( oPrn:nLogPixelX()    ) + CRLF
	 cInfo += 'nLogPixelY()     ' + Chr( VK_TAB ) + cValToChar( oPrn:nLogPixelY()    )

	 MsgInfo( cInfo, TXT_INFO )

return NIL

//------------------------------------------------------------------------------
static function InfoItem( oItem )
local cInfo := ''

	 cInfo += 'ID     '   + Chr( VK_TAB ) + Alltrim(oItem:cId) + CRLF
	 cInfo += 'Caption'   + Chr( VK_TAB ) + Alltrim(oItem:cCaption) + CRLF
	 cInfo += 'Top    '   + Chr( VK_TAB ) + ltrim(str(oItem:nTop)) + CRLF
	 cInfo += 'Left   '   + Chr( VK_TAB ) + ltrim(str(oItem:nLeft)) + CRLF
	 cInfo += 'Width  '   + Chr( VK_TAB ) + ltrim(str(oItem:nWidth)) + CRLF
	 cInfo += 'Height '   + Chr( VK_TAB ) + ltrim(str(oItem:nHeight)) + CRLF

	 msgInfo( cInfo )

return NIL

//------------------------------------------------------------------------------
static function ToChar( u )
local cVal	:= ''
local cType := ValType( u )

	 do case
		 case cType == 'C'
				cVal := Rtrim(u)
		 case cType == 'N'
				cVal := ltrim(str(u))
		 case cType == 'D'
				cVal := DToC(u)
		 case cType == 'L'
				cVal := IF( u, TXT_YES, TXT_NO )
	 endcase

return cVal

//------------------------------------------------------------------------------
//                              Class PrintSection
//------------------------------------------------------------------------------

CLASS PrintSection                     

	 DATA   oRptRun
	 DATA   oParent
	 DATA   oChild
	 DATA   oTSection
	 DATA   oFont
	 DATA   cSection              AS CHARACTER INIT ''
	 DATA   aItems                AS ARRAY     INIT {}
	 DATA   aHeaders              AS ARRAY     INIT {}
	 DATA   aFonts                AS ARRAY     INIT {}
	 DATA   nLine                 AS NUMERIC   INIT 1
	 DATA   nHeightMax            AS NUMERIC   INIT 0
	 DATA   nOffSet               AS NUMERIC   INIT 0
	 DATA   nTop                  AS NUMERIC   INIT 0
	 DATA   nLeft                 AS NUMERIC   INIT 99999
	 DATA   nRight                AS NUMERIC   INIT 0
	 DATA   nBottom               AS NUMERIC   INIT 0
	 DATA   nHeightFontHead       AS NUMERIC   INIT 0
	 DATA   lRelative             AS LOGICAL   INIT .F.
	 DATA   lTop                  AS LOGICAL   INIT .T.
	 DATA   lOut                  AS LOGICAL   INIT .F.
	 DATA   lFirstCol             AS LOGICAL   INIT .T.
	 DATA   lFirstRow             AS LOGICAL   INIT .T.
	 DATA   oItemPijama
	 DATA   lInitPage             AS LOGICAL   INIT .T.
	 DATA   lInitSection          AS LOGICAL   INIT .T.
	 DATA   lInitRow              AS LOGICAL   INIT .T.
	 DATA   bEndSection
	 DATA   bOnChange
	 DATA   bOnBefore

	 METHOD New()   CONSTRUCTOR
	 METHOD Data( cId, uVal )
	 METHOD Skip()
	 METHOD SkipHeader()
	 METHOD Reset()

	 METHOD SetInitPage( lOnOff )      INLINE ( IF( ValType( lOnOff ) == 'L',;
																  ::oRptRun:lInitPage := lOnOff, ),;
																  ::oRptRun:lInitPage )


	 METHOD SetRowNow( nRowNow )       INLINE ( IF( ValType( nRowNow ) == 'N',;
																  ::oRptRun:nRowNow := nRowNow, ),;
																  ::oRptRun:nRowNow)
	 METHOD GetTopReal()
	 METHOD GetBottomReal()
	 METHOD SetChildInitSection()

	 METHOD ChildOf( oParent )  INLINE ( ::oParent	 := oParent,;
					::oParent:oChild := SELF   ,;
					::lRelative	 := .t. )

	 METHOD End()
	 METHOD EndPage()
	 METHOD PrintHeaders()
	 METHOD PrintVisible()
	 METHOD CheckSectionPropertys()
	 METHOD CheckPijama()
	 METHOD SetProperty( cId, cProperty, uValue ) INLINE ::oRptRun:SetProperty( cId, cProperty, uValue )
	 METHOD Uline()

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( oRptRun, cSection ) CLASS PrintSection
local aItems, aSections
local oItem, oFont, oItemHead
local nI, nItems, nPos, nHeight
local oPrn

	 cSection   := Upper( cSection )

	 ::oRptRun  := oRptRun
	 ::cSection := cSection

	 oPrn := oRptRun:oPrn

	//  Cargamos todos los Items de la Seccion:
	//     - Inicializamos lo FONTS
	//     - Calculamos tamaos y altura por linea

	 aItems  := oRptRun:oReport:aItems
	 nItems := Len( aItems )

	 for nI := 1 TO nItems
		  oItem := aItems[nI]
		  oFont := NIL

		  if Upper(oItem:cSection) == cSection
			  if oItem:cClass == 'TSAY'
				  oFont := InitFont( oPrn, oItem )
			  endif

			  Aadd( ::aItems, oItem )
			  Aadd( ::aFonts, oFont )

			  do case
				  case oItem:cClass == 'TSAY'
						 oItem:nHeightFont := oPrn:GetTextHeight( 'B', oFont )
						 oItem:nHeightFont := oPrn:Pix2Mmtr( 0, oItem:nHeightFont )[2]
						 ::nHeightMax  := Max( ::nHeightMax, oItem:nHeightFont )
				  case oItem:cClass == 'TIMAGE'
						 ::nHeightMax  := Max( ::nHeightMax, oItem:nImgFixHeight )
				  case oItem:cClass == 'TCODEBAR'
						::nHeightMax  := Max( ::nHeightMax, oItem:nImgFixHeight )

			  endcase

			  ::nTop	   := Max( ::nTop, oItem:nTop )
			  ::nBottom	:= Max( ::nBottom, ( oItem:nTop + oItem:nHeight ))
			  ::nLeft	:= Min( ::nLeft, oItem:nLeft )
			  ::nRight	:= Max( ::nRight, oItem:nLeft + oItem:nWidth )

		  endif
	 next nI

	 //  Cargamos datos de la section
	 aSections := oRptRun:oReport:aSections
	 nPos := Ascan( aSections, {|o| Upper(o:cSection) == cSection } )

	 if nPos > 0
		 ::oTSection := aSections[nPos]
		 //     Chequeamos si se imprimiran las cabeceras...
		 if ::oTSection:lHeader
			 ::oFont := InitFont( oPrn, ::oTSection )
			 nHeight	:= oPrn:GetTextHeight( 'B', ::oFont )
			 ::nHeightFontHead := oPrn:Pix2Mmtr( nHeight, 0 )[1]

			 for nI := 1 TO Len( ::aItems )
				  oItemHead                := TItem():New()
				  oItemHead:cId            := ::aItems[nI]:cId
				  oItemHead:cClass         := ::aItems[nI]:cClass
				  oItemHead:nTop           := ::aItems[nI]:nTop
				  oItemHead:nLeft          := ::aItems[nI]:nLeft
				  oItemHead:nWidth         := ::aItems[nI]:nWidth
				  oItemHead:cCaption       := ::aItems[nI]:cSecHead
				  oItemHead:nPad           := ::aItems[nI]:nPad
				  oItemHead:nClrFore       := ::oTSection:nClrSecFore
				  oItemHead:nClrBack       := ::oTSection:nClrSecBack
				  oItemHead:cImgFileHeader := ::aItems[nI]:cImgFileHeader
				  oItemHead:nImgFixHeader  := ::aItems[nI]:nImgFixHeader
				  oItemHead:oFont          := ::oFont

				  Aadd( ::aHeaders, oItemHead )

			 next nI

		 endif

	 endif

	 ::Reset()

	  Aadd( oRptRun:aSections, Self )


return SELF

//------------------------------------------------------------------------------
METHOD End() CLASS PrintSection
local nI

	 if ValType( ::bEndSection ) == 'B'
		 Eval( ::bEndSection, SELF  )
	 endif

	 for nI := 1 TO Len( ::aFonts )
		  if Valtype( ::aFonts[nI] ) == 'O'
			  ::aFonts[nI]:End()
			  ::aFonts[nI] := NIL
		  endif
	 next nI

return NIL

//------------------------------------------------------------------------------
METHOD EndPage() CLASS PrintSection

	 ::Reset()
	 ::SetInitPage( .T. )
	 ::oRptRun:EndPage()
	 ::oRptRun:IniPage()

return NIL


//------------------------------------------------------------------------------
METHOD Reset() CLASS PrintSection

	 ::nLine	  := 1
	 ::lTop	  := .t.
	 ::lOut	  := .f.
	 ::oItemPijama := NIL
	 ::lInitRow	  := .T.
	 ::SetRowNow( ::GetTopReal() )

return NIL

//------------------------------------------------------------------------------
METHOD GetTopReal() CLASS PrintSection
local nTop := 0

	 if ::lRelative
		 if ValType( ::oParent ) == 'O'
			 nTop := ::oParent:GetTopReal()
		 else
			 MsgAlert( 'No existe dependecia de padre!', 'Error' )
		 endif
	 else
		 nTop := ::nTop
	 endif

return nTop

//------------------------------------------------------------------------------
METHOD SetChildInitSection() CLASS PrintSection

	 if ValType( ::oChild ) == 'O'
		 ::oChild:lInitSection        := .T.
		 ::oChild:SetChildInitSection()
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD GetBottomReal() CLASS PrintSection
local nBottom := 0

	 if ::lRelative
		 if ValType( ::oParent ) == 'O'
			 nBottom := ::oParent:GetBottomReal()
		 else
			 MsgAlert( 'No existe dependecia de padre!', 'Error' )
		 endif
	 else
		 nBottom := ::nBottom
	 endif

return nBottom

//------------------------------------------------------------------------------
METHOD Data( cId, uVal ) CLASS PrintSection
local nPos, oItem, oItemHead, nI, oItemPijama, oNewItem, nRatio
local nHeightItem
local nHeightHead, nHeightData

	 DEFAULT cID  := ''

	 //  Buscamos el Items por su ID
	 nPos := Ascan( ::aItems, {|o| Alltrim( Upper(o:cId) ) == Upper(cId) } )

	 if nPos == 0
		 if ::oRptRun:lDebug
			 MsgAlert( TXT_RUN_LABEL + ' ' +  cId + ' ' + TXT_RUN_NOT_EXIST, TXT_SECTION )
		 endif
		 return .F.
	 endif

	 oItem := ::aItems[nPos]

	 if ::SetInitPage()
		 ::SetRowNow( ::GetTopReal() )
	 endif

	 //  Chequeamos si es la primera impresion de la Seccion
	 if ::lInitSection
		 ::nOffSet := ::SetRowNow() + ::oTSection:nHeight
		 ::SetChildInitSection()
	 endif

	 //  Miramos si la Data a imprimir cabra dentros de los lmites
	 nHeightItem   := ::SetRowNow() + ::nHeightMax

	 //  Si es un Item Relativo y se ha sobrepasado los limites no imprimimos
	 if ::lRelative .AND. nHeightItem > ::nOffSet
		 return .F.
	 endif

	 //  Si el Item sobrepasa los limites no imprimimos...
	 if nHeightItem > ::GetBottomReal()
		 ::EndPage()
	 endif

	 oItem:nTop     := ::SetRowNow()

	 if ::SetInitPage() .OR. ::lInitSection
		 if ::lInitSection
			 // Si iniciamos la seccion miraremos si la suma de la altura del
			 // titulo + la altura de una linea de datas, es superior al maximo
			 // definido de la seccion real

			 nHeightHead :=  Max( ::nHeightMax, ::oTSection:nFixHeight ) + ::oTSection:nInterLine
			 nHeightData :=  ::nHeightMax + ::oTSection:nInterLine
			 if ( ::SetRowNow() + nHeightHead + nHeightData ) > ::GetBottomReal()
				 ::EndPage()
			 endif
		 endif
		 ::PrintHeaders()   // Imprimir Cabecera si existe
	 endif

	 //  Imprimimos todos los Items staticos => VISIBLES con Data Fija
	 if ::lInitRow
		 ::PrintVisible()
		 ::CheckSectionPropertys()  // Imprime Secciones modificadas si existen
		 ::CheckPijama()            //  Si tiene definido pijama, imprimiremos...
	 endif

	 //  Tratamos Item a Imprimir
	 oItem:cCaption := ToChar( uVal )

	 do case
		 case oItem:cClass == 'TSAY'
				//  Si es un SAY y queremos una Caja, la creamos antes del STRING
				if oItem:lBorder
					oItem:nHeight := ::nHeightMax
				endif

				//       Alineacion Vertical.
				//       Si en el Item de una seccion , hay diferencias de alturas, porque
				//       por ejemplo, hay una imagen, o diferentes fuentes, centraremos
				//       automaticamente el texto verticalmente
				if ::nHeightMax > oItem:nHeightFont
					nRatio := ( ::nHeightMax - oItem:nHeightFont ) / 2
					oItem:nTop += nRatio
				endif

		  case oItem:cClass == 'TIMAGE'
				 oItem:nHeight := oItem:nImgFixHeight
				 if ValType( uVal ) == 'C'
					 oItem:cFile   := ::oRptRun:cDirDat + '\' + uVal
				 endif

		  case oItem:cClass == 'TCODEBAR'
				 oItem:nHeight := oItem:nImgFixHeight

	 endcase

	 //  Imprimimos ITEM
	 ::oRptRun:PrintItem( oItem )

	 //  Tratamiento POST-Print
	 do case
		 case oItem:cClass == 'TSAY'
		 case oItem:cClass == 'TIMAGE'
				// Si hemos imprimido una imagen y queremos un borde, lo crearemos
				// despues para remarcar la imagen, sino puede que lo tape la propia imagen
				if oItem:lBorder
					oItem:nHeight := ::nHeightMax
					::oRptRun:PrintBox( oItem )
				endif
		 case oItem:cClass == 'TCODEBAR'

	 endcase

	 //  Final de DATA...
	 ::SetInitPage( .F. )
	 ::lInitSection := .F.
	 ::lInitRow	   := .F.
	 SysRefresh()

return NIL

//------------------------------------------------------------------------------
METHOD Uline( cId ) CLASS PrintSection
local oNewItem   := TItem():New(.f.)
local nRowNow    := ::SetRowNow()
local nPos, oItem

	 DEFAULT cId := ''

	 if ! Empty( cId )
		 nPos := Ascan( ::aItems, {|o| Alltrim( Upper(o:cId) ) == Upper(cId) } )

		 if nPos == 0
			 if ::oRptRun:lDebug
				 MsgAlert( TXT_RUN_LABEL + ' ' +  cId + ' ' + TXT_RUN_NOT_EXIST, TXT_SECTION )
			 endif
			 return.F.
		 endif

		 oItem               := ::aItems[nPos]
		 oNewItem:nTop       := nRowNow
		 oNewItem:nLeft      := oItem:nLeft
		 oNewItem:nRight     := oItem:nLeft + oItem:nWidth
		 oNewItem:nBottom    := nRowNow
		 oNewItem:nLineWidth := ::oTSection:nLineWidth

	 else
		 oNewItem:nTop       := nRowNow
		 oNewItem:nLeft      := ::nLeft
		 oNewItem:nRight     := ::nRight
		 oNewItem:nBottom    := nRowNow
		 oNewItem:nLineWidth := ::oTSection:nLineWidth
	 endif

	 ::oRptRun:PrintLine( oNewItem )
	 ::SetRowNow( nRowNow + ::oTSection:nInterLine )

return NIL

//------------------------------------------------------------------------------
METHOD PrintHeaders() CLASS PrintSection
local nI, oItemHead, oItemSection, oItem
local nOffSet
local nHeight := Max( ::nHeightMax, ::oTSection:nFixHeight )
local nRatio
local nIndent
local nImgHeight := 0

	 if ::oTSection:lHeader // Chequear si imprimimos cabecera

		 // Si hay definido un fondo de Seccion, lo imprimimos...
		 if::oTSection:nShadow > 0
			 oItem          := TItem():New(.f.)
			 oItem:nTop     := ::SetRowNow()
			 oItem:nLeft    := ::nLeft
			 oItem:nHeight  := nHeight
			 oItem:nWidth   := ::nRight - ::nLeft
			 oItem:nShadow  := ::oTSection:nShadow
			 ::oRptRun:PrintShadow( oItem )
		 endif

		 if ::oTSection:nClrSecBack <> CLR_WHITE
			 oItemSection              := TSection():New()
			 oItemSection:nTop         := ::SetRowNow()
			 oItemSection:nLeft        := ::nLeft
			 oItemSection:nBottom      := ::SetRowNow() + nHeight
			 oItemSection:nRight       := ::nRight
			 oItemSection:lPijamaOnOff := .t.
			 oItemSection:nPijamaClr1  := ::oTSection:nClrSecBack
			 oItemSection:nPijamaClr3  := ::oTSection:nClrSecLine
			 oItemSection:nLineWidth   := ::oTSection:nLineWidth
			 ::oRptRun:PrintPijama( oItemSection )
		 endif

		 //     Imprimimos Datos de cabecera
		 for nI := 1 TO Len( ::aHeaders )
			  oItemHead := ::aHeaders[nI]
			  oItemHead:lBorder := .F.
			  oItemHead:nTop    := ::SetRowNow()

			  //  Alineacion Vertical.
			  //  Si en el Item de una seccion , hay diferencias de alturas, porque
			  //  por ejemplo, hay una imagen, o diferentes fuentes, centraremos
			  //  automaticamente el texto verticalmente
			  if nHeight > ::nHeightFontHead
				  nRatio := ( nHeight - ::nHeightFontHead ) / 2
				  oItemHead:nTop += nRatio
			  endif

			  do case
				  case oItemHead:cClass == 'TIMAGE'
						 oItemHead:cClass := 'TSAY'     // Force to print header...
				  case oItemHead:cClass == 'TCODEBAR'
						 oItemHead:cClass := 'TSAY'     // Force to print header...
			  endcase

			  ::oRptRun:PrintItem( oItemHead )

		 next nI

		 //    Imprimimos BITMAPS

		 for nI := 1 TO Len( ::aHeaders )
			  oItemHead         := ::aHeaders[nI]

			  if Empty( oItemHead:cCaption )
				  nIndent    := 1
				  nImgHeight := oItemHead:nImgFixHeader

				  oItem := TItem():New( .f. )

				  oItem:cClass   := 'TIMAGE'
				  oItem:cSection := ::oTSection:cSection
				  oItem:lBorder  := .T.
				  oItem:cFile    := oItemHead:cImgFileHeader

				  if nImgHeight > 0 .AND. nImgHeight < nHeight
					  oItem:nHeight  := nImgHeight
					  nIndent        := Max( ( nHeight - nImgHeight ) / 2, nIndent )
				  else
					  oItem:nHeight  := nHeight - ( nIndent * 2 )
				  endif

				  oItem:nTop     := ::SetRowNow() + nIndent
				  oItem:nLeft    := oItemHead:nLeft + nIndent
				  oItem:nWidth   := oItemHead:nWidth

				  ::oRptRun:PrintImage( oItem )
			  endif
		 next nI

		 ::SkipHeader()

	 endif

return NIL

//------------------------------------------------------------------------------
METHOD PrintVisible() CLASS PrintSection
local nI
local oItem

	 for nI := 1 TO Len( ::aItems )
		  oItem := ::aItems[nI]
		  oItem:nTop := ::SetRowNow()

		  if oItem:lVisible
			  do case
				  case oItem:cClass == 'TIMAGE'
						 oItem:nHeight := oItem:nImgFixHeight

				  case oItem:cClass == 'TCODEBAR'
						 oItem:nHeight := oItem:nImgFixHeight
			  endcase
			  ::oRptRun:PrintItem( oItem )
		  endif
	 next nI

return NIL

//------------------------------------------------------------------------------
METHOD Skip( nSkip ) CLASS PrintSection
local nI
local nRowNow := ::SetRowNow()

	 DEFAULT nSkip := 1

	 ::SetRowNow( nRowNow + ::nHeightMax + ( ::oTSection:nInterLine * nSkip ) )

	 //  Cualquier seccion que cuelgue por debajo de esta sera inicializada a
	 //  ::lNewSection := .t.
	 ::SetChildInitSection()
	 ::SetInitPage( .F. )
	 ::lInitRow := .T.
	 ::nLine++

return NIL

//------------------------------------------------------------------------------
METHOD SkipHeader( nSkip ) CLASS PrintSection
local nRowNow := ::SetRowNow()

	 DEFAULT nSkip := 1

	 ::SetRowNow( nRowNow + Max( ::nHeightMax, ::oTSection:nFixHeight )  + ;
						( ::oTSection:nInterLine * nSkip ) )


return NIL

//------------------------------------------------------------------------------
METHOD CheckSectionPropertys() CLASS PrintSection
local oNewItem

	 if ::oRptRun:IsNewProperty( ::oTSection )
		 oNewItem := TSection():New()
		 oNewItem:CopyFromSection( ::oTSection )

		 ::oRptRun:CheckProperty( oNewItem )

		 if oNewItem:lPijama
			::CheckPijama( oNewItem )            //  Si tiene definido pijama, imprimiremos...
		 endif
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD CheckPijama( oNewItem ) CLASS PrintSection
local lNewItem     := ValType( oNewItem ) == 'O'

	 if ::oTSection:lPijama
		 if ::oItemPijama == nil
			 ::oItemPijama := TSection():New()
			 ::oItemPijama:nPijamaClr1  := ::oTSection:nPijamaClr1
			 ::oItemPijama:nPijamaClr2  := ::oTSection:nPijamaClr2
			 ::oItemPijama:nPijamaClr3  := ::oTSection:nPijamaClr3
		 endif

		 ::oItemPijama:lPijamaOnOff := ! ::oItemPijama:lPijamaOnOff
		 ::oItemPijama:nTop         := ::SetRowNow()
		 ::oItemPijama:nLeft        := ::nLeft
		 ::oItemPijama:nBottom      := ::SetRowNow() + ::nHeightMax
		 ::oItemPijama:nRight       := ::nRight

		 ::oRptRun:PrintPijama( ::oItemPijama )
	 endif

	 //  Este oNewItem solo se ejecutara una sola vez...
	 if lNewItem .AND. oNewItem:lPijama
		oNewItem:lPijamaOnOff := .t.
		oNewItem:nTop         := ::SetRowNow()
		oNewItem:nLeft        := ::nLeft
		oNewItem:nBottom      := ::SetRowNow() + ::nHeightMax
		oNewItem:nRight       := ::nRight

		::oRptRun:PrintPijama( oNewItem )
	 endif

return NIL

//------------------------------------------------------------------------------
static function InitFont( oPrn, oItem )
local nGiro     := 0
local lStrike   := .f.
local oFont
local nHeight   := oItem:nInpHeight

	 oFont := TFont():New( oItem:cFaceName,;
			  0,;
			  oItem:nInpHeight ,;
			  .f.,;
			  oItem:lFontBold,;
			  0,;
			  0,;
			  0,;
			  oItem:lFontItalic,;
			  oItem:lFontUnderline,;
			  lStrike,;
			  0,;
			  0,;
			  0,;
			  0,;
			  oPrn )

	 oItem:oFont := oFont

return oFont

//------------------------------------------------------------------------------
static function FormatDate( dDate, cPicture )
local cOldFormat := Set( _SET_DATEFORMAT )
local cDate

	 DEFAULT cPicture := 'DD/MM/YYYY'

	 Set( _SET_DATEFORMAT, cPicture )
	 cDate := DToC( dDate )
	 Set( _SET_DATEFORMAT, cOldFormat )

return cDate

//------------------------------------------------------------------------------
//                             Class TRegla
//------------------------------------------------------------------------------

CLASS TRegla FROM TControl

	CLASSDATA lRegistered AS LOGICAL

	DATA   nClrPane, nClrText
	DATA   nZoom         // Zoom
	DATA   Pix2mm        // Relacion de 1 pixel en pantalla (imagen) a mm
	DATA   nMin,nMax,lHorizontal
	DATA   nPosMarca
	DATA   nGap          // Porcion de la regla sin marcar
	DATA   oFont,oPen
	DATA   lInches       // .T. Pulgadas .F. centimetros
	DATA   nMinDib       // Minimo cm en el dibujo (puede ser negativo)
	DATA   nMaxDib       // Maximo numero a dibujar
	DATA   stepcm 	      // Espaciado en cm
	DATA   stepmm        // Espaciado en mm
	DATA   hBmpRule

	METHOD New( oWnd,nRow, nCol, nWidth, nHeight,lPixel,nMin,nMax,lHorizontal,oFont,;
					oPen,lInches,nClrText,nClrBack) CONSTRUCTOR

	METHOD ReDefine( nId,oWnd,nMin,nMax,lHorizontal,;
						  oFont,oPen,lInches,nClrText,nClrBack, lUpdate )  CONSTRUCTOR

	METHOD End() INLINE ::Destroy()
	METHOD Initiate( hDlg ) INLINE ::Super:Initiate( hDlg ) //, ::Default()
	METHOD Display() INLINE ::BeginPaint(), ::Paint(), ::EndPaint(),0
	METHOD Paint()
	METHOD SetPix2mm(Pix2mm) INLINE ::Pix2mm:=IIF(::lInches,Pix2mm/2.54,Pix2mm)
	METHOD Destroy()
	METHOD ScrollDown(nPixels)
	METHOD ScrollUp(nPixels)
	METHOD SetCoors( nTop, nLeft, nWidth, nHeight )
	METHOD SaveBmp()

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( oWnd,nRow, nCol, nWidth, nHeight,lPixel,nMin,nMax,lHorizontal,;
				oFont,oPen,lInches,nClrText,nClrBack,stepcm,stepmm) CLASS TRegla

	DEFAULT nRow := 0, nCol := 0, oWnd := GetWndDefault(),;
			  nMin := 0, nMax :=100, lHorizontal:=.T.,lInches:=.F.

	DEFAULT nWidth   := 100,;
			  nHeight  := 28
	DEFAULT stepcm   := 1,stepmm:=1
	DEFAULT nClrText := CLR_BLACK
	DEFAULT nClrBack := GetSysColor( COLOR_BTNFACE )

	nClrText := nrgb(128,0,0)     //Sebas

	::nTop      = If( lPixel, nRow, nRow * WIN_CHARPIX_H ) //16
	::nLeft     = If( lPixel, nCol, nCol * WIN_CHARPIX_W ) //8
	::nBottom   = ::nTop  + nHeight
	::nRight    = ::nLeft + nWidth
	::oWnd      = oWnd
	::nStyle    = nOR( WS_BORDER, WS_CHILD, WS_VISIBLE )
	::nId       = ::GetNewId()
	::lDrag     = .f.
	::lCaptured = .f.
	::nClrPane    = nClrBack

	::nZoom       = 1.0
	::Pix2mm      = 1.0
	::nMin        = nMin
	::nMax        = nMax
	::lHorizontal = lHorizontal
	::nGap        = 0
	::lInches     = lInches
	::nMaxDib     = ::nMax-::nMin
	::nMinDib     = 0
	::stepcm      = stepcm
	::stepmm      = stepmm

	if oFont==NIl
		DEFINE FONT ::oFont NAME "MS Sans Serif" SIZE 0, -8
	else
		::oFont:=oFont
	endif

	if oPen==NIl
		DEFINE PEN ::oPen WIDTH 1 COLOR nClrText
	else
		::oPen := oPen
	endif

	#ifdef __XPP__
		DEFAULT ::lRegistered := .f.
	#endif

	::SetColor( ::nClrText, ::nClrPane )

	::Register( nOR( CS_VREDRAW, CS_HREDRAW ) )

	if ! Empty( oWnd:hWnd )
		::Create()
		oWnd:AddControl( Self )
	else
		oWnd:DefControl( Self )
	endif

return Self

//------------------------------------------------------------------------------
METHOD ReDefine( nId,oWnd,nMin,nMax,lHorizontal,;
					  oFont,oPen,lInches,nClrText,nClrBack, lUpdate,stepcm,stepmm ) CLASS TRegla

	DEFAULT nMin := 0, nMax :=100, lHorizontal:=.T.,lInches:=.F.
	DEFAULT nClrText:=CLR_BLACK,nClrBack:=GetSysColor( COLOR_BTNFACE )

	DEFAULT lUpdate := .f.

	::nId       = nId
	::oWnd      = oWnd
	::lUpdate   = lUpdate
	::lDrag     = .f.
	::lCaptured = .f.
	::nClrPane    = nClrBack

	::nZoom     =1.0
	::Pix2mm    =1.0
	::nMin      =nMin
	::nMax      =nMax
	::lHorizontal        =lHorizontal
	::nGap       = 0
	::lInches    = lInches
	::nMaxDib	=::nMax-::nMin
	::nMinDib    =0
	::stepcm     = stepcm
	::stepmm     = stepmm


	if oFont==NIl
		DEFINE FONT ::oFont NAME "MS Sans Serif" SIZE 0, -8
	else
		::oFont:=oFont
	endif

	if oPen==NIl
		DEFINE PEN ::oPen WIDTH 1 COLOR nClrText
	else
		::oPen:=oPen
	endif

	::Register( nOR( CS_VREDRAW, CS_HREDRAW ) )

	if oWnd != nil
		oWnd:DefControl( Self )
	endif

return Self

//------------------------------------------------------------------------------
METHOD Destroy() CLASS TRegla

	::oFont:End()
	::oPen:End()

	if ::hBmpRule != nil
		DeleteObject( ::hBmpRule )
	endif

	::Super:End()

return (Nil)

//------------------------------------------------------------------------------
METHOD Paint() CLASS TRegla
local hOldPen, n := 1,pos,j,posmm
local hLightPen,hOldFont
local texto,finmm
local o

	WNDRAISED(::hWnd,::hDC)

	hOldPen = SelectObject( ::hDC, ::oPen:hPen )
	hOldFont= SelectObject( ::hDC, ::oFont:hFont )
	SetTextColor(::hDC, ::oPen:nColor)
	SetBkColor( ::hDC, ::nClrPane )
	::nPosMarca  = IIF(::lHorizontal,::nHeight,::nWidth)
	finmm:=(10*::stepcm)-1.0

	if ::lHorizontal
		for n=::nMinDib to ::nMaxDib step ::stepcm
			 pos:=::nGap*::nZoom+(10*((n*::nZoom))/::Pix2mm)
			 MoveTo( ::hDC, pos, ::nPosMarca-3 )
			 LineTo( ::hDC, pos, ::nPosMarca-10 )
			 texto:= str(::nMin+n,3,0)
			 TextOut(::hDC,3,pos-::GetWidth(texto,::oFont)/2,texto)
			 for j = ::stepmm to finmm step ::stepmm
				  posmm:=pos+(((j*::nZoom))/::Pix2mm)
				  MoveTo( ::hDC, posmm, ::nPosMarca-3 )
				  LineTo( ::hDC, posmm, ::nPosMarca-6 )
			 next j
		next n
	else
		for n=::nMinDib to ::nMaxDib step ::stepcm
			 pos:=::nGap*::nZoom+(10*((n*::nZoom))/::Pix2mm)
			 MoveTo( ::hDC, ::nPosMarca-3,pos )
			 LineTo( ::hDC, ::nPosMarca-10,pos )
			 texto:= str(::nMin+n,3,0)
			 TextOut(::hDC,pos-::GetWidth(texto,::oFont)/2,3,texto)
			 for j=::stepmm to finmm step ::stepmm
				  posmm:=pos+(((j*::nZoom))/::Pix2mm)
				  MoveTo( ::hDC, ::nPosMarca-3,posmm )
				  LineTo( ::hDC, ::nPosMarca-6,posmm )
			 next j
		 next n
	endif
	SelectObject( ::hDC, hOldPen )
	SelectObject( ::hDC, hOldFont )

	::SaveBmp()

return NIL

//------------------------------------------------------------------------------
METHOD ScrollUp(nPixels) CLASS TRegla

	::nGap-=nPixels
	::Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD ScrollDown(nPixels) CLASS TRegla

	::nGap+=nPixels
	::Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD SetCoors( nTop, nLeft, nWidth, nHeight ) CLASS TRegla

	::Move( nTop, nLeft, nWidth, nHeight, .t. )

	::nTop    := nTop
	::nLeft   := nLeft
	::nWidth  := nWidth
	::nHeight := nHeight

return NIL

//------------------------------------------------------------------------------
METHOD SaveBmp() CLASS TRegla
local o

	if ::hBmpRule != nil
		DeleteObject( ::hBmpRule )
	endif

	::hBmpRule := SaveScreen( ::hDc, 0, 0, ::nHeight, ::nWidth )

return NIL

//------------------------------------------------------------------------------
//                           Class MyRptForm
//------------------------------------------------------------------------------

CLASS TRptForm

	DATA   oRpt
	DATA   oForm, oMeta, oRuleH, oRuleV
	DATA   hBmpRuleH, hBmpRuleV
	DATA   oControlItem
	DATA   oLastFocus
	DATA   oCopy
	DATA   nItemFocus                AS NUMERIC INIT 0
	DATA   aItems
	DATA   aSelect
	DATA   oBar, oHand, oCross
	DATA   cFormName                 AS CHARACTER INIT ''
	DATA   cFormDescription          AS CHARACTER INIT ''
	DATA   cFormAutor                AS CHARACTER INIT ''
	DATA   dFormData
	DATA   cDirDat                   AS CHARACTER INIT ''
	DATA   cFormatDate               AS CHARACTER INIT 'DD/MM/YYYY'
	DATA   cFileEmf                  AS CHARACTER INIT ''
	DATA   nMmWidth , nMmHeight
	DATA   nPaperSize                AS NUMERIC INIT 9
	DATA   nPixWidth, nPixHeight
	DATA   nZoom
	DATA   nGrid
	DATA   lGrid                     AS LOGICAL   INIT .F.
	DATA   cFaceName
	DATA   nInpHeight
	DATA   cFileEmf                  AS CHARACTER INIT ''
	DATA   lChange                   AS LOGICAL   INIT .F.
	DATA   lActive                   AS LOGICAL   INIT .F.
	DATA   lFocus                    AS LOGICAL   INIT .F.
	DATA   lPortrait                 AS LOGICAL   INIT .T.
	DATA   lBuilding                 AS LOGICAL   INIT .F.
	DATA   nInitialTop               AS NUMERIC INIT 0
	DATA   nInitialLeft              AS NUMERIC INIT 0
	DATA   aStack                    AS ARRAY     INIT {}
	DATA   nlinregla INIT 0

	METHOD New( oRpt )  CONSTRUCTOR
	METHOD Activate()
	METHOD ResetData()
	METHOD SetChange( lYesNo )
	METHOD AddItem()
	METHOD DelControl( oItem )
	METHOD ItemCut()
	METHOD ItemDuplicate()
	METHOD ItemCopy()
	METHOD ItemPaste()
	METHOD ItemUndo()
	METHOD InitForm()
	METHOD InitEmf()
	METHOD InitSay()
	METHOD InitImg()
	METHOD InitBox()
	METHOD InitCodeBar()
	METHOD InitFont()
	METHOD InitObj()
	METHOD DeleteEmf()
	METHOD SelectNone()
	METHOD SetDots( lOnOff )
	METHOD InfoItem( o )
	METHOD UpdCoors    ( nRow, nCol )
	METHOD UpdCoorsObj ( oObj )
	METHOD UpdCoorsItem( oItem )
	METHOD UpdInspect()               INLINE ::oRpt:oInspect:RefreshList()
	METHOD CheckKey()
	METHOD CoorsMM2Pix( oItem, nPixX, nPixY, nPixWidth, nPixHeight )
	METHOD Zoom( lRefresh )
	METHOD Grid()
	METHOD SetGrid( lOnOff )             
	METHOD CopyItem()
	METHOD BackupItem()
	METHOD RestoreItem()
	METHOD AlignTop()
	METHOD AlignDown()
	METHOD AlignLeft()
	METHOD AlignRight()
	METHOD AlignV()
	METHOD AlignH()
	METHOD PosTop()
	METHOD PosTopMost()
	METHOD PosBottom()
	METHOD SizeHMax()
	METHOD SizeHMin()
	METHOD SizeVMax()
	METHOD SizeVMin()
	METHOD SetFormName( cName )
	METHOD SetCaption ( oItem, cType )
	METHOD SetFont    ( oItem, cType )
	METHOD SetSayAlign( oItem )
	METHOD Move( oItem, nValue, cPropierty )
	METHOD SetFile( oItem )
	METHOD CheckSection( oItem )
	METHOD CheckGroup( oItem )
	METHOD SectionColor( cSection, nClrFore, nClrBack )
	METHOD RuleUpdate()
	METHOD RuleLine()

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( oRpt ) CLASS TRptForm

	 ::oRpt       := oRpt

	 ::aItems     := {}
	 ::aSelect    := {}

	 ::cFormName  := ''
	 ::cFaceName  := 'Verdana'
	 ::nInpHeight := 11

	 ::nGrid      := 8
	 ::nZoom      := 100

	 ::nMmWidth   := 202   // 210
	 ::nMmHeight  := 289   // 297
	 ::nPaperSize := 9            // Default A4

	 ::ResetData()

return SELF

//------------------------------------------------------------------------------
METHOD Activate() CLASS TRptForm
local hOldRes  := GetResources()

	 SetResources( ::oRpt:cDllFile )

	 SetGridSize( ::nGrid, ::nGrid )

	 DEFINE CURSOR ::oHand HAND
	 DEFINE CURSOR ::oCross CROSS //NAME 'CROSS'

	 DEFINE WINDOW ::oForm MDICHILD OF ::oRpt:oMdi TITLE 'Form' ;
			COLOR CLR_BLACK, CLR_BACKGROUND ;  // BACKGROUND
			NOZOOM NOICONIZE NOSYSMENU  ;
			VSCROLL HSCROLL      

			::oForm:SetIcon( TIcon():New( ,, "Report" ) )

			::oRuleH := TRegla():New( ::oForm,      0, 30 , 1, 1, .t., 0, 1, .t. )
			::oRuleV := TRegla():New( ::oForm,     30,  0 , 1, 1, .t., 0, 1, .f. )

			::oRuleH:nGap := RULE_OFFSET
			::oRuleV:nGap := RULE_OFFSET

			::oMeta  := TEnhMetaFile():New( PAGE_TOP, PAGE_LEFT,;
													  1, 1,;
													  '',;
													  ::oForm,;
													  CLR_BLACK,;
													  CLR_WHITE )

			::oMeta:lShadow   := .F.   // Shadow don't work correctly
			::oMeta:blClicked := {|r,c| ::AddItem(r,c) }   //Cuando hacemos click en el Form se aade el tipo de item seleccionado en Inspector, si lo hay
			::oMeta:bMMoved   := {|nRow, nCol| ::UpdCoors(nRow, nCol) }
			::oMeta:bPainted  := {|hDC, cPS| IF( ::lGrid , DrawGrid( ::oMeta:hWnd, hDC, @cPS, ::nGrid, ::nGrid ), NIL ) }
			::oMeta:oCursor   := ::oCross

			::oForm:bInit := {|| ( ::oMeta:Hide() ,;
										  ::oRuleH:Hide() ,;
										  ::oRuleV:Hide() ,;
										  TScrWnd():New( ::oForm,1,35,1,30) ) }

	 ACTIVATE WINDOW ::oForm VALID ::oRpt:lExit

	 SetResources( hOldRes )

return NIL

//------------------------------------------------------------------------------
METHOD ResetData() CLASS TRptForm

	 ::cFormName        := 'New Project...'
	 ::cFormDescription := Space(50)
	 ::cFormAutor       := Space(30)
	 ::dFormData        := Date()
	 ::cFileEmf         := ''

	 ::lChange          := .F.
	 ::lFocus           := .F.
	 ::lActive          := .F.
	 ::oControlItem     := NIL

return NIL

//------------------------------------------------------------------------------
METHOD SetFormName( cName ) CLASS TRptForm

	 DEFAULT cName := ''

	 ::cFormName := cName
	 ::oForm:cTitle( ::cFormName ) //'Form: ' + ::cFormName )  Sebas

return NIL

//------------------------------------------------------------------------------
METHOD InitForm( oRpt ) CLASS TRptForm
local oCoors, oMeter, oItem, oSection
local nTop       := PAGE_TOP
local nLeft      := PAGE_LEFT
local nI
local lIsReport  := ValType( oRpt ) == 'O'
local aItems, aSections
local nPos
local nSet       := 0

	 if ! lIsReport
		 if ! ::oRpt:DeleteAll(.f.)
			 return NIL
		 endif

		 if ! Rpt_Project( SELF )
			 return NIL
		 endif

		 ::nPixWidth  := hMM2Pix( ::nMmWidth  ) * ::nZoom / 100
		 ::nPixHeight := vMM2Pix( ::nMmHeight ) * ::nZoom / 100

	 else

		 ::nZoom            := oRpt:nZoom
		 ::cFormName        := oRpt:cName
		 ::cFormDescription := oRpt:cDescription
		 ::cFormAutor       := oRpt:cAutor
		 ::dFormData        := oRpt:dData
		 ::nMmWidth         := oRpt:nWidth
		 ::nMmHeight        := oRpt:nHeight
		 ::cFileEmf         := oRpt:cFileEmf
		 ::cDirDat          := oRpt:cDirDat
		 ::cFormatDate      := oRpt:cFormatDate
		 ::lPortrait        := oRpt:lPortrait

		 ::nPixWidth        := hMM2Pix( ::nMmWidth  ) * ::nZoom / 100
		 ::nPixHeight       := vMM2Pix( ::nMmHeight ) * ::nZoom / 100

	 endif

	 ::oRuleH:Show()
	 ::oRuleV:Show()
	 ::RuleUpdate()
	 ::lBuilding := .T.
	 ::oMeta:Hide()
	 ::oForm:cTitle( 'Form: ' + ::cFormName )
	 ::oRpt:SetMessage( ::cFormDescription )
	 ::oRpt:SetZoom( ::nZoom )
	 ::oRpt:oInspect:AddForm( ::cFormName )
	 ::oRpt:oInspect:AddXY  ( ::nMmWidth, ::nMmHeight, ::nPaperSize, ::lPortrait )

	 ::InitEmf( ::cFileEmf, .F. )

	 if ::lPortrait
		 oCoors := TRect():New( nTop, nLeft, ::nPixHeight + nTop , ::nPixWidth + nLeft )
	 else
		 oCoors := TRect():New( nTop, nLeft, ::nPixWidth + nTop , ::nPixHeight + nLeft )
	 endif

	 ::oMeta:SetCoors( oCoors )

	 //  Si le pasamos una estructura de reporte para montar lo hacemos ....

	 if lIsReport
		 aItems := oRpt:aItems
		 oMeter := pMeterBar( Len( aItems ), TXT_LOADING, .t., ::oRpt:oMdi )
		 ::oRpt:oInspect:Hide( .t. )

		 //     Crear
		 //     1.- Items Publics
		 //     2.- Seccions
		 //     3.- Items de Seccions
		 //     4.- Items Specials

		 //     1.- Crear todos los items PUBLICS
		 for nI := 1 TO Len( aItems )
			  oItem := aItems[nI]

			  if Empty( oItem:cSection ) .and. oItem:lSpecial == .f.

				  do case
					  case oItem:cClass == 'TSAY'
							 ::InitSay    ( oItem )
					  case oItem:cClass == 'TIMAGE'
							 ::InitImg    ( oItem )
					  case oItem:cClass == 'TBOX'
							 ::InitBox    ( oItem )
					  case oItem:cClass == 'TCODEBAR'
							 ::InitCodeBar( oItem )
				  endcase

				  oMeter:Set( nSet++ )

			  endif

		 next nI

		 //     2.- Crear todas las SECTIONS
		 for nI := 1 TO Len( aItems )
			  oItem := aItems[nI]

			  if !Empty( oItem:cSection ) .and. ! ::oRpt:oInspect:IsSection(oItem:cSection)
				  nPos     := Ascan( oRpt:aSections, {|o| o:cSection == oItem:cSection } )
				  oSection := NIL

				  if nPos > 0
					  oSection := oRpt:aSections[ nPos ]
				  endif

				  ::oRpt:oInspect:IniSection( oItem:cSection, oSection )

			  endif

		 next nI

		 //     3.- Creamos todos los items con section
		 //     Ordenamos por Secciones...
		 Asort( aItems,,, {|o, y| o:cSection < y:cSection } )

		 for nI := 1 TO Len( aItems )
			  oItem := aItems[nI]

			  if !Empty( oItem:cSection )
				  do case
					  case oItem:cClass == 'TSAY'
							 ::InitSay    ( oItem )
					  case oItem:cClass == 'TIMAGE'
							 ::InitImg    ( oItem )
					  case oItem:cClass == 'TBOX'
							 ::InitBox    ( oItem )
					  case oItem:cClass == 'TCODEBAR'
							 ::InitCodeBar( oItem )
				  endcase

				  oMeter:Set( nSet++ )

			  endif

		 next nI

		 //     4.- Creamos todos los items especiales...
		 for nI := 1 TO Len( aItems )
			  oItem := aItems[nI]

			  if Empty( oItem:cSection ) .and. oItem:lSpecial == .t. .and. oItem:cClass == 'TSAY'
				  ::InitSay    ( oItem )
			  endif

		 next nI

		 ::oRpt:oInspect:SelectForm()
		 ::oRpt:oInspect:Hide( .f. )

		 oMeter:End()

	 else
		 ::oRpt:oInspect:FindForm()
	 endif

	 //  Mostramos todo
    ::SetGrid(.f.)
	 ::oMeta:Show()
	 ::oMeta:Shadow()
	 ::lBuilding := .F.
	 ::lActive   := .T.
	 ::oRpt:oBar:aEvalWhen()

return NIL

//------------------------------------------------------------------------------
METHOD UpdCoors( nRow, nCol ) CLASS TRptForm
local nMmX   := vPix2MM( nRow ) * 100 / ::nZoom
local nMmY   := hPix2MM( nCol ) * 100 / ::nZoom

	 ::oRpt:oItemRow:SetText( 'Row ' + Str( nMmX, 5, 1 ) )
	 ::oRpt:oItemCol:SetText( 'Col ' + Str( nMmY, 5, 1 ) )

	 ::RuleLine( nRow, nCol )

return NIL

//------------------------------------------------------------------------------
METHOD RuleLine( nRow, nCol ) CLASS TRptForm
local hDcH := ::oRuleH:GetDc()
local hDcV := ::oRuleV:GetDc()

	  if ::nlinregla = 0
		  ::oRuleH:Refresh()
		  ::oRuleV:Refresh()
		  ::nlinregla := 2
	  else
		  ::nlinregla := ::nlinregla - 1
	  endif

	  if ::oRuleH:hBmpRule != NIL
		  DrawBitmap( hDcH, ::oRuleH:hBmpRule, 0, 0 )
	  endif

	  if ::oRuleV:hBmpRule != NIL
		  DrawBitmap( hDcV, ::oRuleV:hBmpRule, 0, 0 )
	  endif

	  ::oRuleH:ReleaseDC()
	  ::oRuleV:ReleaseDC()

	  ::oRuleH:Line( 0, nCol + RULE_OFFSET, 30, nCol + RULE_OFFSET )
	  ::oRuleV:Line( nRow + RULE_OFFSET, 0, nRow + RULE_OFFSET , 30 )

return NIL

//------------------------------------------------------------------------------
METHOD UpdCoorsObj( oObj ) CLASS TRptForm
local nMmX   := vPix2MM( oObj:nTop  ) * 100 / ::nZoom
local nMmY   := hPix2MM( oObj:nLeft ) * 100 / ::nZoom

	 ::oRpt:oItemRow:SetText( 'Row ' + Str( nMmX, 5, 1 ) )
	 ::oRpt:oItemCol:SetText( 'Col ' + Str( nMmY, 5, 1 ) )

return NIL

//------------------------------------------------------------------------------
METHOD UpdCoorsItem( oItem ) CLASS TRptForm
local oObj   := oItem:oObj

	 if Valtype(oObj) <> 'O'
		 return NIL
	 endif

	 oObj:CoorsUpdate()

	 oItem:nTop    := vPix2MM( oObj:nTop   ) * 100 / ::nZoom
	 oItem:nLeft   := hPix2MM( oObj:nLeft  ) * 100 / ::nZoom
	 oItem:nWidth  := hPix2MM( oObj:nWidth ) * 100 / ::nZoom
	 oItem:nHeight := vPix2MM( oObj:nHeight) * 100 / ::nZoom

return NIL

//------------------------------------------------------------------------------
METHOD InfoItem( o ) CLASS TRptForm
local nMmX    := vPix2MM( o:nTop    ) * 100 / ::nZoom
local nMmY    := hPix2MM( o:nLeft   ) * 100 / ::nZoom
local nWidth  := hPix2MM( o:nWidth  ) * 100 / ::nZoom
local nHeight := hPix2MM( o:nHeight ) * 100 / ::nZoom
local cTitle  := 'Information => ' + o:ClassName()

	 MsgInfo( '::nTop    ' + Chr(VK_TAB) + cValToChar( o:nTop    ) + ' / mm. ' + cValToChar(nMmX)    + CRLF + ;
				 '::nLeft   ' + Chr(VK_TAB) + cValToChar( o:nLeft   ) + ' / mm. ' + cValToChar(nMmY)    + CRLF + ;
				 '::nWidth  ' + Chr(VK_TAB) + cValToChar( o:nWidth  ) + ' / mm. ' + cValToChar(nWidth)  + CRLF + ;
				 '::nHeight ' + Chr(VK_TAB) + cValToChar( o:nHeight ) + ' / mm. ' + cValToChar(nHeight)          ;
				 , cTitle )

return NIL

//------------------------------------------------------------------------------
METHOD AddItem( nRow, nCol, lpostop ) CLASS TRptForm
local oItem      := TItem():New()
local nType      := ::oRpt:oInspect:nItemType
local nMmX, nMmY
local cFile
local oTSection, oTPublic
local lChange    := .T.
local nPixWidth
local n, ctipe, oItem2

DEFAULT lpostop := .t.

	 //  Adjust to pint grid
	 if ::lgrid
		 nRow       -= ( nRow % ::nGrid )
		 nCol       -= ( nCol % ::nGrid )
	 endif

	 //  Pixels to Mm
	 nMmX       := vPix2MM( nRow ) * 100 / ::nZoom
	 nMmY       := hPix2MM( nCol ) * 100 / ::nZoom

	 oItem:nType    := nType
	 oItem:nTop     := nMmX
	 oItem:nLeft    := nMmY
	 oItem:cSection := ::oRpt:oInspect:GetNameSection()

	 do case

		 case nType == 1

				if ! Empty( oItem:cSection )
					oTSection            := ::oRpt:oInspect:GetSection( oItem:cSection )
					oItem:nWidth         := oTSection:nWidth
					oItem:nHeight        := oTSection:nHeight
					oItem:cFaceName      := oTSection:cFaceName
					oItem:nInpHeight     := oTSection:nInpHeight
				 else
					oTPublic             := ::oRpt:oInspect:GetPublic()
					oItem:cCaption       := oItem:cId
					oItem:nWidth         := oTPublic:nWidth
					oItem:nHeight        := oTPublic:nHeight
					oItem:nClrFore       := oTPublic:nClrFore
					oItem:nClrBack       := oTPublic:nClrBack
					oItem:cFaceName      := oTPublic:cFaceName
					oItem:lFontBold      := oTPublic:lFontBold
					oItem:lFontItalic    := oTPublic:lFontItalic
					oItem:lFontUnderline := oTPublic:lFontUnderline
					oItem:nInpHeight     := oTPublic:nInpHeight
					oItem:nPad           := oTPublic:nPad
				endif

				::InitSay( oItem )

		 case nType == 2                 // IMAGE
				cFile := cGetFile( ::oRpt:cDir + '\*.*' )

				if File( cFile )
					oItem:nWidth     := 50
					oItem:nHeight    := 60
					oItem:cFile      := cFile

					::InitImg( oItem )
					// Hacemos que conserve las proporciones de la imagen
					nPixWidth := nBmpWidth(oItem:oObj:hBitmap)*200/nBmpHeight(oItem:oObj:hBitmap)
					oItem:oObj:Move( ,, nPixWidth,, .t. )

					if lpostop
						// Lo ponemos encima de todos los dems items
						::oRpt:oForm:Postop(oItem:oObj)
					endif

				endif

		 case nType == 3                 // BOX
				oItem:nWidth     := 50
				oItem:nHeight    := 60
				::InitBox( oItem )

				if lpostop
					// Lo ponemos encima de todos los dems items
					::oRpt:oForm:Postop(oItem:oObj)
				endif

		 case nType == 4                 // CODEBAR
				oItem:cFaceName  := 'Verdana'
				oItem:nWidth     := 20
				oItem:nHeight    := 10

				::InitCodeBar( oItem )

				if lpostop
					// Lo ponemos encima de todos los dems items
					::oRpt:oForm:Postop(oItem:oObj)
				endif

		 case nType == 5
				MsgInfo( 'No se pueden copiar un objeto', 'Sistema' )

		 case nType == 10  .OR. ;        // Page XX of YY
				nType == 11  .OR. ;        // Report Time
				nType == 12  .OR. ;        // Report Date
				nType == 13  .OR. ;        // Report TimeStamp
				nType == 14  .OR. ;        // Report Name
				nType == 15  .OR. ;        // Report Computer Name
				nType == 16                // Report User Name

				oTPublic             := ::oRpt:oInspect:GetPublic()

				oItem:cCaption       := oItem:cId
				oItem:nWidth         := oTPublic:nWidth
				oItem:nHeight        := oTPublic:nHeight
				oItem:nClrFore       := oTPublic:nClrFore
				oItem:nClrBack       := oTPublic:nClrBack
				oItem:cFaceName      := oTPublic:cFaceName
				oItem:lFontBold      := oTPublic:lFontBold
				oItem:lFontItalic    := oTPublic:lFontItalic
				oItem:lFontUnderline := oTPublic:lFontUnderline
				oItem:nInpHeight     := oTPublic:nInpHeight
				oItem:nPad           := oTPublic:nPad
				oItem:cSection       := ''
				oItem:lVisible       := .T.
				oItem:lSpecial       := .T.
				oItem:Cargo          := 10

				do case
					case nType == 10
						  oItem:cCaption       := TXT_CAPTION_PAGE_XX_OF_YY
					case nType == 11
						  oItem:cCaption       := TXT_CAPTION_RUN_TIME
					case nType == 12
						  oItem:cCaption       := TXT_CAPTION_RUN_DATE
					case nType == 13
						  oItem:cCaption       := TXT_CAPTION_RUN_TIMESTAMP
					case nType == 14
						  oItem:cCaption       := TXT_CAPTION_RUN_REPORT_NAME
					case nType == 15
						  oItem:cCaption       := TXT_CAPTION_RUN_COMPUTER_NAME
					case nType == 16
						  oItem:cCaption       := TXT_CAPTION_RUN_USER_NAME
					otherwise
						  oItem:cCaption       := ''
				endcase

				::InitSay( oItem )

				if lpostop
					// Lo ponemos encima de todos los dems items
					::oRpt:oForm:Postop(oItem:oObj)
				endif

		 otherwise
				::oRpt:oInspect:FindForm()
				lChange := .F.
	 endcase

	 if lChange
		 ::SetChange( .t. )
	 endif

	 for n = 1 to len(::oRpt:oInspect:atree)      //Sebas activar todos los items desactivados al seleccionar en el Inspector
		  cType := ::oRpt:oInspect:aTree[n,1]
		  if cType == '__ITEM'
			  oItem2 := ::oRpt:oInspect:aTree[n,4]
			  oItem2:oObj:Enable()
		  endif
	 next n

	 ::oRpt:oInspect:ResetBtn()
	 ::oMeta:oCursor := ::oCross

return NIL

//------------------------------------------------------------------------------
METHOD InitEmf( cFile, lSelect ) CLASS TRptForm

	 DEFAULT cFile   := ''
	 DEFAULT lSelect := .t.

	 if lSelect
		 cFile   := cGetFile( ::oRpt:cDir + '\IMAGES\*.emf' )
	 else
		 if !Empty( cFile ) .AND. !File( cFile )

			 if MsgYesNo( 'EMF ' + TXT_DONT_EXIST + ' ' + cFile + CRLF + TXT_REASIGN, TXT_FWRPT )
				 cFile   := cGetFile( ::oRpt:cDir + '\IMAGES\*.emf', 'Select ' + cFileNoPath( cFile ), , ::oRpt:cDirRpt )
				 if File( cFile)
					 ::SetChange(.t.)
				 endif
			 endif
		 endif
	 endif

	 //  Si el arhcivo est en blanco, se restablece el metafile
	 ::oMeta:SetFile( cFile )
	 ::oMeta:Refresh()

	 if File( cFile )

		 ::oRpt:oInspect:AddEmf( cFile )
		 ::cFileEmf := cFile

		 if !::lBuilding
			  ::SetChange(.t.)
		 endif

	 else
		 ::cFileEmf := ''
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD DeleteEmf() CLASS TRptForm

	 ::oMeta:SetFile( "" )
	 ::oMeta:Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD InitSay( oItem ) CLASS TRptForm
local nPixX, nPixY, nPixWidth, nPixHeight
local oFont, oObj, oTSection
local oTree
local lIsSection := IF( Empty(oItem:cSection), .f., .t. )
local cText
local nClrFore, nClrBack

	 //  Cuantos pixels son x mm. ?
	 ::CoorsMM2Pix( oItem, @nPixX, @nPixY, @nPixWidth, @nPixHeight )

	 if lIsSection
		 oTSection        := ::oRpt:oInspect:GetSection( oItem:cSection )
		 nClrFore         := oTSection:nClrFore
		 nClrBack         := oTSection:nClrBack
	 else
		 nClrFore         := oItem:nClrFore
		 nClrBack         := oItem:nClrBack
	 endif

	 if lIsSection .AND. !empty( oItem:cSecHead )
		 oItem:lSecFontBold      := .t.
		 oItem:lSecFontUnderline := .t.
		 cText := oItem:cSecHead  //Alltrim(oItem:cSecHead ) sebas
		 oFont := ::InitFont( oItem, 'H' )
	 else
		 cText := oItem:cCaption //alltrim( oItem:cCaption )  sebas
		 oFont := ::InitFont( oItem, 'C' )
	 endif

	 @nPixX, nPixY SAY oObj PROMPT cText ;
				SIZE 1,1 PIXEL OF ::oMeta DESIGN ;
				FONT oFont BORDER COLOR CLR_BLACK, CLR_WHITE

	 //  Cuando creamos el oSay, NO lo pone en las coordenadas exactas. Lo AJUSTAMOS
	 SetWindowPos( oObj:hWnd, HWND_TOP, nPixX, nPixY, nPixWidth, nPixHeight )
	 oObj:SetColor( nClrFore, nClrBack )
	 oObj:Move( nPixX, nPixY, nPixWidth, nPixHeight, .t. )
	 ::InitObj( oObj, oItem )

	 //  Alineacin
	 ::SetSayAlign( oItem, .T. )

	 ::UpdCoors( nPixX, nPixY )

return NIL

//------------------------------------------------------------------------------
METHOD InitImg( oItem ) CLASS TRptForm
local nPixX, nPixY, nPixWidth, nPixHeight
local oObj

	 if !Empty( oItem:cFile ) .AND. !File( oItem:cFile )

		 if MsgYesNo( 'Image ' + TXT_DONT_EXIST + ' ' + oItem:cFile + CRLF + TXT_REASIGN, TXT_FWRPT )
			 oItem:cFile   := cGetFile( ::oRpt:cDir + '\IMAGES\*.*', 'Select ' + cFileNoPath( oItem:cFile ), , ::oRpt:cDirRpt   )
			 if File( oItem:cFile )
				 ::SetChange( .t. )
			 endif
		 endif
	 endif

	 if !File( oItem:cFile )
		 return NIL
	 endif

	 //  Cuantos pixels son x mm. ?
	 ::CoorsMM2Pix( oItem, @nPixX, @nPixY, @nPixWidth, @nPixHeight )

	 @nPixX, nPixY IMAGE oObj SIZE 1, 1 OF ::oMeta ADJUST DESIGN

	 ChangeStyleWindow( oObj, WS_BORDER, NIL, oItem:lBorder )

	 //oObj:LoadBmp( oItem:cFile )
	 oObj:LoadImage(,  oItem:cFile )


	 //  Cuando creamos el oObj, lo pone en las coordenadas exactas. Lo AJUSTAMOS
	 oObj:Move( nPixX, nPixY, nPixWidth, nPixHeight, .t. )
	 ::InitObj( oObj, oItem )
	 ::UpdCoors( nPixX, nPixY )
	 ::UpdInspect()

return NIL

//------------------------------------------------------------------------------
METHOD InitBox( oItem ) CLASS TRptForm
local nPixX, nPixY, nPixWidth, nPixHeight
	 LOCAL oObj

	 //  Cuantos pixels son x mm. ?
	 ::CoorsMM2Pix( oItem, @nPixX, @nPixY, @nPixWidth, @nPixHeight )

	 oObj := TBox():New( ::oMeta, nPixX, nPixY, 10, 10 )

	 oObj:lDrag      := .t.
	 oObj:nLineWidth := oItem:nLineWidth
	 oObj:nLineType  := oItem:nLineType

	 oObj:SetColor( oItem:nClrFore, oItem:nClrBack )

	 //  Cuando creamos el oObj, lo pone en las coordenadas exactas. Lo AJUSTAMOS
	 oObj:Move( nPixX, nPixY, nPixWidth, nPixHeight, .t. )
	 ::InitObj( oObj, oItem )
	 ::UpdCoors( nPixX, nPixY )

return NIL

//------------------------------------------------------------------------------
METHOD InitCodeBar( oItem ) CLASS TRptForm
local nPixX, nPixY, nPixWidth, nPixHeight
local oObj

	 //  Cuantos pixels son x mm. ?
	 ::CoorsMM2Pix( oItem, @nPixX, @nPixY, @nPixWidth, @nPixHeight )
	 oObj := TCodeBar():New( ::oMeta, nPixX, nPixY, nPixWidth, nPixHeight )

	 //  Cuando creamos el oObj, lo pone en las coordenadas exactas. Lo AJUSTAMOS
	 oObj:Move( nPixX, nPixY, nPixWidth, nPixHeight, .t. )
	 ::InitObj( oObj, oItem )
	 ::UpdCoors( nPixX, nPixY )

return NIL

//------------------------------------------------------------------------------
METHOD InitObj( oObj, oItem ) CLASS TRptForm
local oHand


	 DEFINE CURSOR oHand HAND

	 oItem:cClass         := oObj:ClassName()
	 oItem:oObj           := oObj

	 oObj:bDrag           := {|r,c| ::UpdCoors(r,c) }

	 oObj:bPreDrag        := {|r,c| ::CopyItem( oItem )    ,;
											  ::nInitialTop  := oObj:nTop  ,;
											  ::nInitialLeft := oObj:nLeft ,;
											  ::CheckKey(  oItem )  }

	 oObj:bPostDrag       := {|| ::UpdCoorsItem ( oItem ),;
										  ::oRpt:oInspect:SetListItem( oItem ) ,;
										  ::BackupItem(),;
										  ::CopyItem( oItem ),;
										  ::SetChange(.t., oItem ),;
										  ::CheckSection ( oItem ),;
										  ::CheckGroup( oItem )   }

	 oObj:bGotFocus       := {|| ::UpdCoors( oObj:nTop, oObj:nLeft ) ,;
										  ::oControlItem := oItem             ,;
										  ::CopyItem( oItem )                 ,;
										  ::oRpt:oInspect:SelectItem( oItem ) ,;
										  ::oRpt:oInspect:SetListItem( oItem ) ,;
										  ::lFocus := .T.                     ,;
										  ::CheckSection ( oItem )            ,;
										  oObj:SetFocus() }


	 oObj:bPostDelControl := {|| ::DelControl( oItem ),  ::SetChange(.t.) }
	 oObj:oCursor         := oHand
	 oObj:cTooltip        := 'ID: ' + Alltrim( oItem:cId )
	 oObj:cargo           := oItem:cId

	 if ::oRpt:lmenusmart = .f.
		 oObj:bRClicked       := {|| xBrowse( oObj:ofont ) }     //Sebas, quitado porque no quiero que aparezca el dialogo flotante de propiedades
	 endif

	 oItem:oTree          := ::oRpt:oInspect:AddItem( oItem )
	 oObj:SetFocus()
	 oObj:bMMoved := {|nrow,ncol| ::RuleLine(nrow+oObj:ntop,ncol+oObj:nLeft) }  //Sebas, para que se siga viendo la posicin de la regla aunque est sobre un objeto

/*	 oItem:oTree:oTree:bChanged := {|| Dbg( 'Item cambiado...' ),;
												  ::UpdCoorsItem ( oItem ),;
												  ::oRpt:oInspect:SetListItem( oItem ) ,;
												  ::BackupItem(),;
												  ::CopyItem( oItem ),;
												  ::SetChange(.t., oItem ),;
												  ::CheckSection ( oItem ),;
												  ::CheckGroup( oItem )   }
*/
return NIL

//------------------------------------------------------------------------------
METHOD InitFont( oItem ) CLASS TRptForm
local nGiro     := 0
local lStrike   := .f.
local oFont     := TFont():New( oItem:cFaceName,;
												0,;
												-oItem:nInpHeight * ::nZoom/100,;
												.f.,;
												oItem:lFontBold,;
												nGiro*10,;
												0,;
												0,;
												oItem:lFontItalic,;
												oItem:lFontUnderline,;
												lStrike,;
												0,;
												0,;
												0,;
												0 )

return oFont

//------------------------------------------------------------------------------
METHOD SelectNone() CLASS TRptForm

	 ::SetDots( .f. )
	 ::oControlItem := NIL
	 ::lFocus        := .F.
	 ::CheckKey() // For default, deselected Items selected...
	 ::oRpt:BtnPos(.f.)

return NIL

//------------------------------------------------------------------------------
METHOD SetDots( lOnOff ) CLASS TRptForm

	 DEFAULT lOnOff := .t.

	 if ValType(::oControlItem) <> 'O'
		 return NIL
	 endif

	 if lOnOff == .F.
		 ::oControlItem:oObj:HideDots()
	 else
		 ::oControlItem:oObj:ShowDots()
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD CheckKey( oItem ) CLASS TRptForm
local o
local nI
local nPos

	 if ValType( oItem) <> 'O'
		 return NIL
	 endif

	 if GetKeyState( VK_SHIFT )

		 nPos := Ascan( ::aSelect, {|x| x:nKey == oItem:nKey } )

		 //    Si no lo tenemos, lo guardamos y sino lo borramos
		 if nPos == 0
			 Aadd( ::aSelect, oItem )
			 oItem:oObj:SetColor( CLR_YELLOW, CLR_HBLUE )
			 oItem:oObj:Refresh()

			 do case
				 case oItem:cClass == 'TIMAGE'
						oItem:oObj:LoadImage( ,'16Exit' )
			 endcase
		 else
			 o := ::aSelect[nPos]
			 o:oObj:SetColor( o:nClrFore, o:nClrBack )
			 o:oObj:Refresh()

			 ADel ( ::aSelect, nPos )
			 ASize( ::aSelect, Len(::aSelect)-1 )
		 endif

		 if Len( ::aSelect ) > 1
			 ::oRpt:BtnAlign(.t.)
			 ::oRpt:BtnSize (.t.)
		 else
			 ::oRpt:BtnAlign(.f.)
			 ::oRpt:BtnSize (.f.)
		 endif

		 //    Se necesitan al menos 3 items para alinear
		 if Len( ::aSelect ) > 2
			 ::oRpt:BtnAlignVH(.t.)
		 else
			 ::oRpt:BtnAlignVH(.f.)
		 endif

		 ::oRpt:SoBleep()
	 else

		if Len( ::aSelect ) > 0
			for nI := 1 TO Len( ::aSelect )
				 o := ::aSelect[nI]
				 o:oObj:SetColor( o:nClrFore, o:nClrBack )
				 o:oObj:Refresh()

				 do case
					 case o:cClass == 'TIMAGE'
							o:oObj:LoadImage( , o:cFile )
				 endcase
			 next nI

			 ::oRpt:BtnSize (.f.)
			 ::oRpt:BtnAlign(.f.)
			 ::oRpt:BtnAlignVH(.f.)

			 ::aSelect := {}

		 endif

	 endif

	 ::oRpt:BtnPos(.t.)

return NIL

//------------------------------------------------------------------------------
METHOD DelControl( oItem ) CLASS TRptForm
local nPos

	 ::oRpt:oInspect:DeleteItem( oItem )

	 oItem:oObj:End()     // Aqui tindriem de mata'l, per segueix en memoria
	 oItem:oObj := NIL

return NIL

//------------------------------------------------------------------------------
METHOD Zoom( lRefresh ) CLASS TRptForm
local nZoom    := ::nZoom
local nOldZoom := ::nZoom
local aBackup  := {}
local cId      := ''
local nPixX, nPixY, nPixWidth, nPixHeight
local oCoors, oItem, oObj, oFont
local nI, nItems
local cClass
local nFocus
local oMeter
local aItems
local nMmX, nMmY

	 if !::lActive
		 return NIL
	 endif

	 DEFAULT lRefresh := .F.

	 if !lRefresh .AND. ! MsgZoom( @nZoom )
		 return NIL
	 endif

	 ::oRpt:SetZoom( nZoom )
	 ::nZoom := nZoom

	 //  Escalamos el report
	 nPixWidth  := hMM2Pix( ::nMmWidth  ) * ::nZoom / 100
	 nPixHeight := vMM2Pix( ::nMmHeight ) * ::nZoom / 100

	 if ::lPortrait
		 oCoors := TRect():New( PAGE_TOP, PAGE_LEFT, nPixHeight + PAGE_TOP, nPixWidth + PAGE_LEFT )
	 else
		 oCoors := TRect():New( PAGE_TOP, PAGE_LEFT, nPixWidth + PAGE_LEFT, nPixHeight + PAGE_TOP )
	 endif

	 ::RuleUpdate()
	 ::SetDots(.f.)
	 ::oMeta:Hide()
	 ::oMeta:SetCoors( oCoors )

	  aItems := ::oRpt:oInspect:aTree
	  nItems := Len( aItems )

	  for nI = 1 TO nItems

			if aItems[nI][1] == '__ITEM'

				oItem := aItems[nI][4]
				oObj  := oItem:oObj

				::CoorsMM2Pix( oItem, @nPixX, @nPixY, @nPixWidth, @nPixHeight )

				do case
					case oItem:cClass == 'TSAY'
						  oFont := ::InitFont( oItem, 'H' )
						  oObj:SetFont( oFont )
						  oObj:Move( nPixX, nPixY, nPixWidth, nPixHeight, .t. )

					case oItem:cClass == 'TIMAGE'
						  oObj:Move( nPixX, nPixY, nPixWidth, nPixHeight, .t. )

					case oItem:cClass == 'TBOX'
						  oObj:Move( nPixX, nPixY, nPixWidth, nPixHeight, .t. )

					case oItem:cClass == 'TCODEBAR'
						  oObj:Move( nPixX, nPixY, nPixWidth, nPixHeight, .t. )

				endcase
			endif
	  next nI

	  if ::lFocus
		  ::oControlItem:oObj:SetFocus()
	  endif

	  //   Mostramos todo !!!
	  ::oForm:Refresh()
	  SysRefresh()
	  ::oMeta:Show()
	  ::oMeta:Shadow()

return NIL

//------------------------------------------------------------------------------
METHOD RuleUpdate() CLASS TRptForm
local nPixWidth  := hMM2Pix( ::nMmWidth  ) * ::nZoom / 100
local nPixHeight := vMM2Pix( ::nMmHeight ) * ::nZoom / 100
local hDCMem
local hDC
local rc
local nWidth, nHeight
local hOldBmp
local o

	 if ::lPortrait
		 ::oRuleH:nMax    := ::nMmWidth  / 10
		 ::oRuleV:nMax    := ::nMmHeight / 10
	 else
		 ::oRuleH:nMax    := ::nMmHeight  / 10
		 ::oRuleV:nMax    := ::nMmWidth   / 10
	 endif

	 ::oRuleH:nMaxDib := ::oRuleH:nMax - ::oRuleH:nMin
	 ::oRuleV:nMaxDib := ::oRuleV:nMax - ::oRuleV:nMin
	 ::oRuleH:SetPix2mm( hPix2MM( 1 ) * 100 / ::nZoom )
	 ::oRuleV:SetPix2mm( vPix2MM( 1 ) * 100 / ::nZoom )

	 //  Si el ancho de la pantalla es mas pequeo de 300, el intervalo de
	 //  los centimetros sera mayor para espaciar los numeros sino salen todos
	 //  pegados...
	 if nPixWidth < 300
		 ::oRuleH:stepcm := 2
	 else
		 ::oRuleH:stepcm := 1
	 endif

	 if nPixWidth < 300
		 ::oRuleV:stepcm := 2
	 else
		 ::oRuleV:stepcm := 1
	 endif

	 if ::lPortrait
		 ::oRuleH:SetCoors(  0 ,  30,  nPixWidth + RULE_OFFSET, RULE_TICKNESS )
		 ::oRuleV:SetCoors(  30,   0,  RULE_TICKNESS   ,   nPixHeight + RULE_OFFSET  )
	 else
		 ::oRuleH:SetCoors(  0 ,  30,  nPixHeight + RULE_OFFSET , RULE_TICKNESS )
		 ::oRuleV:SetCoors(  30,   0,  RULE_TICKNESS, nPixWidth + RULE_OFFSET   )
	 endif

	 SysRefresh()

	 if ::hBmpRuleH != NIL
		 DeleteObject( ::hBmpRuleH )
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD CoorsMM2Pix( oItem, nPixX, nPixY, nPixWidth, nPixHeight ) CLASS TRptForm

	 //  Cuantos pixels son x mm. ?
	 nPixX      := vMM2Pix( oItem:nTop    )
	 nPixY      := hMM2Pix( oItem:nLeft   )
	 nPixWidth  := hMM2Pix( oItem:nWidth  )
	 nPixHeight := vMM2Pix( oItem:nHeight )

	 //  Pasar pixeles a proporcion Zoom
	 nPixX      := nPixX * ::nZoom / 100
	 nPixY      := nPixY * ::nZoom / 100
	 nPixWidth  := nPixWidth * ::nZoom / 100
	 nPixHeight := nPixHeight * ::nZoom / 100

	 //  Redondeamos Pixeles
	 nPixX      := Int( Round( nPixX, 0 ) )
	 nPixY      := Int( Round( nPixY, 0 ) )
	 nPixWidth  := Int( Round( nPixWidth , 0 ) )
	 nPixHeight := Int( Round( nPixHeight, 0 ) )

return NIL

//------------------------------------------------------------------------------
METHOD Grid( lOnOff ) CLASS TRptForm
local nGrid   := ::nGrid, nI

	 DEFAULT lOnOff := .t.

	 if ! MsgGrid( @nGrid )
		 return NIL
	 endif

	 ::nGrid := nGrid
	 SetGridSize( nGrid, nGrid )
	 ::lGrid := .f.
	 ::SetGrid( lOnOff )


return NIL

//------------------------------------------------------------------------------
METHOD CopyItem( oItem ) CLASS TRptForm

	 Dbg( 'Copy Item...' )

	 ::oLastFocus := TItem():New(.f.)
	 ::oLastFocus:CopyFromItem( oItem )

return NIL

//------------------------------------------------------------------------------
METHOD BackupItem() CLASS TRptForm
local oCopyItem  := TItem():New(.f.)

	 Dbg( 'Backup Item...' )

	 oCopyItem:CopyFromItem( ::oLastFocus )

	 if Len( ::aStack ) < MAX_HISTORIAL
		 Aadd( ::aStack, oCopyItem )
	 else
		 ADel( ::aStack, 1 )
		 ::aStack[ MAX_HISTORIAL ] := oCopyItem
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD RestoreItem() CLASS TRptForm
/*
	// Pendiente de hacer
local nPos
local oBackup
local oObj, oOldObj

	 IF ::nItemFocus == 0
		 RETU NIL
	 ENDIF

	 nPos := Ascan( ::aItems, {|x| x[2]:nKey == ::nItemFocus } )

	 IF nPos > 0

		 oObj     := ::aItems[nPos][1]
		 oBackup  := ::aItems[nPos][3]

		 oObj:Hide()
		 oObj:Move( oBackup:nTop, oBackup:nLeft, oBackup:nWidth, oBackup:nHeight, .t. )
		 oObj:Show()
		 oObj:SetFocus()

	 ENDIF
*/



return NIL

//------------------------------------------------------------------------------
METHOD AlignTop() CLASS TRptForm
local nTop := 9999999
local nI, oObj
local oItem

	 if Len( ::aSelect ) <= 1
		 return NIL
	 endif

	 AEval( ::aSelect, {|o, n| o:oObj:CoorsUpdate(), nTop := Min( o:oObj:nTop, nTop ) } )

	 for nI := 1 TO Len( ::aSelect )

		  oItem := ::aSelect[nI]
		  oObj  := oItem:oObj
		  oObj:Move( nTop, oObj:nLeft, oObj:nWidth, oObj:nHeight, .t. )

		  do case
			  case oItem:cClass == 'TIMAGE'
					 oObj:LoadImage( , oItem:cFile )
		  endcase

		  ::UpdCoorsItem( oItem )
		  oObj:Refresh()

	 next nI

	 ::oControlItem:oObj:SetFocus()

return NIL

//------------------------------------------------------------------------------
METHOD AlignDown() CLASS TRptForm
local nBottom := 0
local nI, oObj
local oItem

	 if Len( ::aSelect ) <= 1
		 return NIL
	 endif

	 AEval( ::aSelect, {|o, n| o:oObj:CoorsUpdate(), nBottom := Max( o:oObj:nTop + o:oObj:nHeight, nBottom ) } )

	 for nI := 1 TO Len( ::aSelect )

		  oItem := ::aSelect[nI]
		  oObj  := oItem:oObj
		  oObj:Move( nBottom - oObj:nHeight, oObj:nLeft, oObj:nWidth, oObj:nHeight, .t. )

		  do case
			  case oItem:cClass == 'TIMAGE'
					 oObj:LoadImage( , oItem:cFile )
		  endcase

		  ::UpdCoorsItem( oItem )
		  oObj:Refresh()

	 next nI

	 ::oControlItem:oObj:SetFocus()

return NIL

//------------------------------------------------------------------------------
METHOD AlignLeft() CLASS TRptForm
local nLeft := 999999
local nI, oObj
local oItem

	 if Len( ::aSelect ) <= 1
		 return NIL
	 endif

	 AEval( ::aSelect, {|o, n| o:oObj:CoorsUpdate(), nLeft := Min( o:oObj:nLeft, nLeft ) } )

	 for nI := 1 TO Len( ::aSelect )

		  oItem := ::aSelect[nI]
		  oObj  := oItem:oObj

		  oObj:Move( oObj:nTop, nLeft, oObj:nWidth, oObj:nHeight, .t. )

		  do case
			  case oItem:cClass == 'TIMAGE'
					 oObj:LoadImage(  , oItem:cFile )
					 oObj:Refresh()
					 SysRefresh()
		  endcase

		  ::UpdCoorsItem( oItem )
		  oObj:Refresh()

	 next nI

	 ::oControlItem:oObj:SetFocus()

return NIL

//------------------------------------------------------------------------------
METHOD AlignRight() CLASS TRptForm
local nRight := 0
local nI, oObj
local oItem

	 if len( ::aSelect ) <= 1
		 return NIL
	 endif

	 AEval( ::aSelect, {|o, n| o:oObj:CoorsUpdate(), nRight := Max( o:oObj:nLeft + o:oObj:nWidth , nRight ) } )

	 for nI := 1 TO Len( ::aSelect )

		  oItem := ::aSelect[nI]
		  oObj  := oItem:oObj
		  oObj:Move( oObj:nTop, nRight - oObj:nWidth, oObj:nWidth, oObj:nHeight, .t. )

		  do case
			  case oItem:cClass == 'TIMAGE'
					 oObj:LoadImage( , oItem:cFile )
		  endcase

		  ::UpdCoorsItem( oItem )
		  oObj:Refresh()

	 next nI

	 ::oControlItem:oObj:SetFocus()

return NIL

//------------------------------------------------------------------------------
METHOD AlignV() CLASS TRptForm
local nTop      := 9999999
local nBlanks   := 0
local nItems    := len(::aSelect)
local nVObject  := 0
local nFull     := 0
local nEmpty    := 0
local nPixBlank := 0
local nOffSetV  := 0
local nI, oObj, oItem

	 if len( ::aSelect ) <= 2
		 return NIL
	 endif

	 nBlanks := nItems - 1

	 //  Actualitzaem coordenades objecte
	 AEval( ::aSelect, {|o, n| o:oObj:CoorsUpdate() } )

	 //  Ordenamos objetos por posicion mas arriba a mas abajo
	 ASort( ::aSelect,,, {|x, y| x:nTop < y:nTop } )

	 //  Calculamos el total de la altura de todos los objetos
	 AEval( ::aSelect, {|o, n| nVObject += o:oObj:nHeight } )

	 //  Calculamos el espacio total desde el objeto superior al inferior
	 nFull := ( ::aSelect[nItems]:oObj:nTop + ::aSelect[nItems]:oObj:nHeight ) - ::aSelect[1]:oObj:nTop
	 nPixBlank :=  ( nFull - nVObject ) / nBlanks
	 oItem     := ::aSelect[1]
	 oObj      := oItem:oObj
	 nOffSetV  := oObj:nTop + oObj:nHeight + nPixBlank

	 //  El primero y el ltimo no lo moveremos
	 for nI := 2 TO ( nItems - 1 )

		  oItem := ::aSelect[nI]
		  oObj  := oItem:oObj
		  oObj:Move( nOffSetV , oObj:nLeft, oObj:nWidth, oObj:nHeight, .t. )
		  oObj:CoorsUpdate()
		  nOffSetV += oObj:nHeight + nPixBlank
		  ::UpdCoorsItem( oItem )

	 next nI

return NIL

//------------------------------------------------------------------------------
METHOD AlignH() CLASS TRptForm
local nLeft     := 9999999
local nBlanks   := 0
local nItems    := len(::aSelect)
local nHObject  := 0
local nFull     := 0
local nEmpty    := 0
local nPixBlank := 0
local nOffSetH  := 0
local nI, oObj, oItem

	 if len( ::aSelect ) <= 2
		 return NIL
	 endif

	 nBlanks := nItems - 1

	 //  Actualizamos las coordenadas del objero
	 AEval( ::aSelect, {|o, n| o:oObj:CoorsUpdate() } )

	 //  Ordenamos objetos por posicion mas a la izquierda a mas derecha
	 ASort( ::aSelect,,, {|x, y| x:nLeft < y:nLeft } )

	 //  Calculamos el total de ancho de todos los objetos
	 AEval( ::aSelect, {|o, n| nHObject += o:oObj:nWidth } )

	 //  Calculamos el espacio total desde el objeto superior al inferior
	 nFull := ( ::aSelect[nItems]:oObj:nLeft + ::aSelect[nItems]:oObj:nWidth ) - ::aSelect[1]:oObj:nLeft
	 nPixBlank :=  ( nFull - nHObject ) / nBlanks

	 oItem     := ::aSelect[1]
	 oObj      := oItem:oObj
	 nOffSetH  := oObj:nLeft + oObj:nWidth + nPixBlank

	 //  El primero y el ltimo no lo movemos...
	 for nI := 2 TO ( nItems - 1 )

		  oItem := ::aSelect[nI]
		  oObj  := oItem:oObj
		  oObj:Move( oObj:nTop, nOffSetH, oObj:nWidth, oObj:nHeight, .t. )
		  oObj:CoorsUpdate()
		  nOffSetH += oObj:nWidth + nPixBlank
		  ::UpdCoorsItem( oItem )

	 next nI

return NIL

//------------------------------------------------------------------------------
METHOD SizeHMax() CLASS TRptForm

local nWidth := 0
local nI, oObj, oItem

	 if len( ::aSelect ) <= 1
		 return NIL
	 endif

	 AEval( ::aSelect, {|o, n| o:oObj:CoorsUpdate(), nWidth := Max( o:oObj:nWidth, nWidth ) } )

	 for nI := 1 TO Len( ::aSelect )

		  oItem := ::aSelect[nI]
		  oObj  := oItem:oObj
		  oObj:Move( oObj:nTop, oObj:nLeft, nWidth, oObj:nHeight, .t. )

		  ::UpdCoorsItem( oItem )
		  oObj:Refresh()

	 next nI

	 ::oControlItem:oObj:SetFocus()

return NIL

//------------------------------------------------------------------------------
METHOD SizeHMin() CLASS TRptForm
local nWidth := 99999
local nI, oObj, oItem

	 if len( ::aSelect ) <= 1
		 return NIL
	 endif

	 AEval( ::aSelect, {|o, n| o:oObj:CoorsUpdate(), nWidth := Min( o:oObj:nWidth, nWidth ) } )

	 for nI := 1 TO Len( ::aSelect )

		  oItem := ::aSelect[nI]
		  oObj  := oItem:oObj
		  oObj:Move( oObj:nTop, oObj:nLeft, nWidth, oObj:nHeight, .t. )

		  ::UpdCoorsItem( oItem )
		  oObj:Refresh()

	 next nI

	 ::oControlItem:oObj:SetFocus()

return NIL

//------------------------------------------------------------------------------
METHOD SizeVMax() CLASS TRptForm
local nHeight := 0
local nI, oObj, oItem

	 if Len( ::aSelect ) <= 1
		 return NIL
	 endif

	 AEval( ::aSelect, {|o, n| o:oObj:CoorsUpdate(), nHeight := Max( o:oObj:nHeight, nHeight ) } )

	 for nI := 1 TO Len( ::aSelect )
		  oItem := ::aSelect[nI]
		  oObj  := oItem:oObj
		  oObj:Move( oObj:nTop, oObj:nLeft, oObj:nWidth, nHeight, .t. )

		  ::UpdCoorsItem( oItem )
		  oObj:Refresh()

	 next nI

	 ::oControlItem:oObj:SetFocus()

return NIL

//------------------------------------------------------------------------------
METHOD SizeVMin() CLASS TRptForm
local nHeight := 99999
local nI, oObj, oItem

	 if Len( ::aSelect ) <= 1
		 return NIL
	 endif

	 AEval( ::aSelect, {|o, n| o:oObj:CoorsUpdate(), nHeight := Min( o:oObj:nHeight, nHeight ) } )

	 for nI := 1 TO Len( ::aSelect )

		  oItem := ::aSelect[nI]
		  oObj  := oItem:oObj
		  oObj:Move( oObj:nTop, oObj:nLeft, oObj:nWidth, nHeight, .t. )

		  ::UpdCoorsItem( oItem )
		  oObj:Refresh()

	 next nI

	 ::oControlItem:oObj:SetFocus()

return NIL

//------------------------------------------------------------------------------
METHOD SetCaption( oItem, cType ) CLASS TRptForm
local  oObj := oItem:oObj

	 DEFAULT cType := 'C'

	 do case
		 case cType == 'C'
				if Empty( oItem:cSecHead )
					oObj:VarPut( oItem:ccaption)
				endif
		 case cType == 'H'
				oObj:VarPut( oItem:cSecHead)
	 endcase

	 oObj:Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD SetFont( oItem, cType ) CLASS TRptForm
local  oObj := oItem:oObj
local oFont :=  ::InitFont( oItem )

	 DEFAULT cType := 'C'

	 if cType == 'H' .AND. !Empty( oItem:cSecHead )
		 oItem:lFontBold         := oItem:lSecFontBold
		 oItem:lFontItalic       := oItem:lSecFontItalic
		 oItem:lFontUnderline    := oItem:lSecFontUnderline
	 endif

	 oFont :=  ::InitFont( oItem )
	 oObj:SetFont( oFont )
	 oObj:Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD Move( oItem, nValue, cPropierty ) CLASS TRptForm
local  nPix
local  oObj := oItem:oObj

	 do case
		 case cPropierty == 'TOP'
				nPix      := vMM2Pix( nValue )
				nPix      := nPix * ::nZoom / 100
				nPix      := Int( Round( nPix, 0 ) )
				oObj:Move( nPix, oObj:nLeft, oObj:nWidth, oObj:nHeight, .t. )
				oObj:SetFocus()

		 case cPropierty == 'LEFT'
				nPix      := hMM2Pix( nValue  )
				nPix      := nPix * ::nZoom / 100
				nPix      := Int( Round( nPix, 0 ) )
				oObj:Move( oObj:nTop, nPix, oObj:nWidth, oObj:nHeight, .t. )
				oObj:SetFocus()

		 case cPropierty == 'WIDTH'
				nPix      := hMM2Pix( nValue  )
				nPix      := nPix * ::nZoom / 100
				nPix      := Int( Round( nPix, 0 ) )
				oObj:Move( oObj:nTop, oObj:nLeft, nPix, oObj:nHeight, .t. )
				oObj:SetFocus()

		 case cPropierty == 'HEIGHT'
				nPix      := vMM2Pix( nValue  )
				nPix      := nPix * ::nZoom / 100
				nPix      := Int( Round( nPix, 0 ) )
				oObj:Move( oObj:nTop, oObj:nLeft, oObj:nWidth, nPix, .t. )
				oObj:SetFocus()

	 endcase

	 ::UpdCoorsObj( oObj )

return NIL

//------------------------------------------------------------------------------
METHOD SetFile( oItem ) CLASS TRptForm
local oObj := oItem:oObj
local cFile := cGetFile( '\*.*' )

	 if File( cFile )
		 oItem:cFile := cFile
		 oObj:LoadImage( , cFile )
		 oObj:Refresh()
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD SetSayAlign( oItem, lRefresh ) CLASS TRptForm
local oSay := oItem:oObj

	 DEFAULT lRefresh := .T.

	 ChangeStyleWindow( oSay, 0 , NIL, .F. )  //SS_LEFT
	 ChangeStyleWindow( oSay, 1 , NIL, .F. )  //SS_CENTER
	 ChangeStyleWindow( oSay, 2 , NIL, .F. )  //SS_RIGHT

	 if lRefresh
		 oSay:Refresh()
	 endif

	 do case
		 case oItem:nPad == 0
				ChangeStyleWindow( oSay, 0, NIL, .T. )  //SS_LEFT
		 case oItem:nPad == 2
				ChangeStyleWindow( oSay, 2, NIL, .T. )  //SS_RIGHT
		 case oItem:nPad == 1
				ChangeStyleWindow( oSay, 1, NIL, .T. )   //SS_CENTER
	 endcase

	 if lRefresh
		 oSay:Refresh()
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD CheckSection( oItem ) CLASS TRptForm
local oTSection
local cSection   := oItem:cSection
local aItems
local nI
local oItemBrother

	 if Empty( cSection )
		 return NIL
	 endif

	 ::UpdCoorsItem( oItem )
	 aItems     := ::oRpt:oInspect:GetItemsSection( cSection )
	 oTSection  := ::oRpt:oInspect:GetSection( cSection )
	 oTSection:nHeight := oItem:nHeight

	 for nI := 1 To Len( aItems )
		  oItemBrother := aItems[nI]

		  oItemBrother:oObj:Move( oItem:oObj:nTop,;
										  oItemBrother:oObj:nLeft,;
										  oItemBrother:oObj:nWidth,;
										  oItem:oObj:nHeight, .t. )


		  ::UpdCoorsItem( oItemBrother )

		  // Cuando chequeamos un item de una section, pondremos toda la section en el top
		  ::PosTop( oItemBrother:oObj )
	 next nI

return NIL

//------------------------------------------------------------------------------
METHOD CheckGroup( oItem ) CLASS TRptForm
local nOffSetTop
local nOffSetLeft
local oItemBrother
local nI

	 if Len( ::aSelect ) < 2
		 return NIL
	 endif

	 oItem:oObj:CoorsUpdate()
	 nOffSetTop  :=  oItem:oObj:nTop   - ::nInitialTop
	 nOffSetLeft :=  oItem:oObj:nLeft  - ::nInitialLeft

	 if nOffSetTop == 0 .AND. nOffSetLeft == 0
		 return NIL
	 endif

	 for nI := 1 To Len( ::aSelect )
		  oItemBrother := ::aSelect[nI]

		  if oItemBrother:cID <> oItem:cId

			  oItemBrother:oObj:Move( oItemBrother:oObj:nTop  + nOffSetTop ,;
									 oItemBrother:oObj:nLeft + nOffSetLeft,;
									 oItemBrother:oObj:nWidth,;
									 oItemBrother:oObj:nHeight, .t. )

			  ::UpdCoorsItem( oItemBrother )
		  endif
	 next nI

	 oItem:oObj:CoorsUpdate()

	 ::nInitialTop  := oItem:oObj:nTop
	 ::nInitialLeft := oItem:oObj:nLeft

return NIL

//------------------------------------------------------------------------------
METHOD PosTop( oObj) CLASS TRptForm          //Mueve un item encima de todos, ultima posicin en el tree
local oitemact, csection

	 if !::lFocus
		 return NIL
	 endif

	 if oObj == NIL
		 oObj := ::oControlItem:oObj
	 endif

	 if ValType( oObj ) <> 'O'
		 return NIL
	 endif

	 oObj:CoorsUpdate()

	 SetWindowPos( oObj:hWnd, HWND_TOP   ,;
						oObj:nTop, oObj:nLeft ,;
						oObj:nWidth, oObj:nHeight )

	 cSection := ::oControlItem:cSection

	 if ::lactive .and. empty(cSection)   //Para mover el item en el tree, los items de las secciones no es necesario
		 ::oRpt:oForm:lChange := .t.
		 ::oRpt:oInspect:lactive := .f.
		 ::oRpt:oForm:lBuilding = .T.
		 oitemact := ::oControlItem
		 ::oControlItem := oitemact
		 ::oRpt:oInspect:DeleteItem(oitemact)
		 ::oRpt:oInspect:AddItem(oitemact)
		 ::oRpt:oInspect:SelectItem( oItemact )
		 ::oRpt:oForm:lBuilding = .F.
		 ::oRpt:oInspect:lactive := .t.
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD PosTopMost() CLASS TRptForm
local oObj

	 if !::lFocus
		 return NIL
	 endif

	 oObj := ::oControlItem:oObj

	 if ValType( oObj ) <> 'O'
		 return NIL
	 endif

	 oObj:CoorsUpdate()

	 SetWindowPos( oObj:hWnd, HWND_TOPMOST  ,;
						oObj:nTop, oObj:nLeft    ,;
						oObj:nWidth, oObj:nHeight )

return NIL

//------------------------------------------------------------------------------
METHOD PosBottom() CLASS TRptForm        //Mueve al fondo un item, primera posicin en el tree.
local oObj := ::oControlItem:oObj, oitemact, aitems, nI, oitemsel, csection, oitemmove

	 if ValType( oObj ) <> 'O'
		 return NIL
	 endif

	 oObj:CoorsUpdate()

	 SetWindowPos( oObj:hWnd, HWND_BOTTOM   ,;
						oObj:nTop, oObj:nLeft    ,;
						oObj:nWidth, oObj:nHeight )

	 cSection := ::oControlItem:cSection

	 if ::lactive .and. empty(cSection)     //Para mover el item en el tree, los items de las secciones no es necesario
		 ::oRpt:oInspect:oTree:Disable()    //Desactivamos el tree para que no partadee en el proceso
		 oitemact := ::oControlItem
		 ::oRpt:oForm:lChange := .t.
		 citemsel := ::oControlItem:cID
		 aItems     := ::oRpt:oInspect:GetItemsSection( cSection )

		 ::oRpt:oInspect:lactive := .f.
		 ::oRpt:oForm:lBuilding = .T.
		 for nI := 1 To Len( aItems )
			  if aitems[nI]:cID <> citemsel
				  oitemmove := aitems[nI]
				  ::oControlItem := oitemmove
				  ::oRpt:oInspect:DeleteItem(oitemmove)
				  ::oRpt:oInspect:AddItem(oitemmove)
			  endif
		 next nI
		 ::oRpt:oForm:lBuilding = .F.
		 ::oRpt:oInspect:lactive := .t.
		 ::oRpt:oInspect:SelectItem( oItemact )
		 ::oRpt:oInspect:oTree:Enable()  //Activamos de nuevo el tree
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD ItemCut() CLASS TRptForm

	if ValType( ::oControlItem ) <> 'O'
		return NIL
	endif

	::oControlItem:oObj:SetFocus()
	::oControlItem:oObj:KeyDown( VK_DELETE )

return NIL

//------------------------------------------------------------------------------
METHOD ItemDuplicate() CLASS TRptForm

	 ::ItemCopy()
	 ::ItemPaste()

return NIL

//------------------------------------------------------------------------------
METHOD ItemCopy() CLASS TRptForm

	 if ValType( ::oControlItem ) <> 'O'
		 return NIL
	 endif

	 ::oCopy :=  ::oControlItem

return NIL

//------------------------------------------------------------------------------
METHOD ItemPaste(modo) CLASS TRptForm
local oItem

	 DEFAULT modo := 1

	 if ValType( ::oCopy ) <> 'O'
		 return NIL
	 endif

	 oItem := TItem():New(.f.)   //Se pasa como .f. porque el nuevo ID se da despues
	 oItem:CopyFromItem( ::oCopy )
	 oItem:NewId()
	 oItem:nTop  += 2
	 oItem:nLeft += 2
	 if substr(oItem:cCaption,1,2) == 'ID'
		 oItem:cCaption := oItem:cID
	 endif

	 do case
		 case oItem:cClass == 'TSAY'
				::InitSay( oItem )
		 case oItem:cClass == 'TIMAGE'
				::InitImg( oItem )
		 case oItem:cClass == 'TBOX'
				::InitBox( oItem )
		 case oItem:cClass == 'TCODEBAR'
				::InitCodeBar( oItem )
	 endcase

	 if modo = 1
		 ::PosTop()
	 endif

	 oItem:oObj:SetFocus()

return NIL

//------------------------------------------------------------------------------
METHOD SetChange( lYesNo, oItem ) CLASS TRptForm

	 ::lChange := lYesNo
	 ::oRpt:MsgModify( ::lChange )

return NIL


//------------------------------------------------------------------------------
METHOD ItemUndo() CLASS TRptForm
local nI
local nLen :=  Len( ::aStack )
local oItem
local oItemReal
local nPixX, nPixY, nPixWidth, nPixHeight
local aItems

	 if nLen == 0
		 //dbg('ninguno')
		 return NIL
	 endif

	 oItem := ::aStack[ nLen ]
	 ::CoorsMM2Pix( oItem, @nPixX, @nPixY, @nPixWidth, @nPixHeight )
	 oItemReal := ::oRpt:oInspect:GetItem( oItem:nKey )

	 do case
		 case oItem:cClass == 'TSAY'
				oItemReal:oObj:Move( nPixX, nPixY, nPixWidth, nPixHeight, .t. )
		 case oItem:cClass == 'TIMAGE'
				oItemReal:oObj:Move( nPixX, nPixY, nPixWidth, nPixHeight, .t. )
		 case oItem:cClass == 'TBOX'
				oItemReal:oObj:Move( nPixX, nPixY, nPixWidth, nPixHeight, .t. )
	 endcase

	 ::UpdCoorsItem ( oItemReal )
	 ::UpdInspect()
	 ::CheckGroup( oItemReal )

	 //oItemReal:oObj:SetFocus()
	 //dbg('intemundo')
//	 ::oControlItem := oItemReal


	 ADel ( ::aStack, nLen   )
	 ASize( ::aStack, nLen-1 )

return NIL

//------------------------------------------------------------------------------
METHOD SectionColor( cSection, nClrFore, nClrBack ) CLASS TRptForm
local aItems := ::oRpt:oInspect:aTree
local nI
local oItem

	 for nI := 1 TO Len( aItems )

		  if aItems[nI][ CLS_TYPE ] == '__ITEM'
			  oItem := aItems[nI][ CLS_OBJ ]

			  if oItem:cSection == cSection .and. oItem:cClass == 'TSAY'
				  oItem:oObj:SetColor( nClrFore, nClrBack )
				  oItem:oObj:Refresh()
			  endif
		  endif
	 next nI

return NIL

//------------------------------------------------------------------------------
METHOD SetGrid(lOnOff) CLASS TRptForm
local cType, oItem, n

 if Valtype(lOnOff) == 'L'
	 ::lGrid := lOnOff
	 //::lGrid := !::lGrid
	 ::oMeta:Refresh()

	 if lOnOff = .t.
		 SetGridSize( ::nGrid, ::nGrid )
	 else
		 SetGridSize( 0, 0 )   //Si el grid no est activado se pone el tamao mnimo
	 endif

 endif

return

//------------------------------------------------------------------------------
//                              Class TRptInspect
//------------------------------------------------------------------------------

CLASS TRptInspect

	DATA   oRpt
	DATA   oTPublic
	DATA   lActive
	DATA   oInspect
	DATA   oTree, oForm, oData, oSplit, oBrw, oList
	DATA   oBar, oHand
	DATA   oBtnEmf, oBtnSay, oBtnImg, oBtnBox, oBtnCBar,oBtnSec, oBtnSee, oBtnFunc
	DATA   nItemType
	DATA   oCursor
	DATA   oFontList
	DATA   aTree             AS ARRAY INIT {}
	DATA   aPaperSize        AS ARRAY INIT {}

	METHOD New( oRpt )  CONSTRUCTOR
	METHOD Activate()
	METHOD AddForm()
	METHOD AddItem()
	METHOD AddEmf()
	METHOD AddXY( nWidth, nHeight, cPaperSize, lPortrait )
	METHOD IniTree()
	METHOD IniData()
	METHOD SelectForm()
	METHOD SelectItem( oItem )
	METHOD SetTreeForm()
	METHOD SetTreePaperSize( nX, nY, nPaperSize, lPortrait )
	METHOD SetTreeItem( oItem, nValue )
	METHOD IsSection ( cSection )
	METHOD GetSection( cSection )
	METHOD DeleteItem( oItem )
	METHOD DeleteEMF()
	METHOD GetItemsSection( cSection )
	METHOD SetListForm()
	METHOD SetListItem( oItem )
	METHOD SetListSection( cSection )
	METHOD SetListPublic()
	METHOD GetPublic()
	METHOD GetNameSection()
	METHOD GetBranchSection()
	METHOD IniPutSay()
	METHOD IniPutImg()
	METHOD IniPutBox()
	METHOD IniPutCBar()
	METHOD IniPutFunc()
	METHOD IniSection()
	METHOD FindForm()
	METHOD FindItem()
	METHOD ResetBtn()
	METHOD ResetList()             INLINE ( ::oList:Reset(), ::oList:Refresh() )
	METHOD RefreshList()           INLINE ::oList:Refresh()
	METHOD TreeChanged()
	METHOD TreeKey( nKey )
	METHOD GetItem( nKey )
	METHOD DeleteAll()
	METHOD HeaderInSection( cSection )
	METHOD ItemVisible()          INLINE MakeItemVisible( SELF )
	METHOD Hide( lOnOff )         INLINE IF( lOnOff, ( ::oTree:Hide(), ::oList:Hide() ),;
																	 ( ::oTree:Show(), ::oList:Show() ) )

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( oRpt ) CLASS TRptInspect

	 ::oRpt       := oRpt
	 ::oTPublic   := NIL
	 ::nItemType  := 0
	 ::lActive    := .f.
	 ::aPaperSize := PaperSize()

return SELF

//------------------------------------------------------------------------------
METHOD Activate() CLASS TRptInspect
local oMenuFuncs

	 MENU oMenuFuncs POPUP 2007

			MENUITEM TXT_MENU_PAGE_XX_OF_YY NAME '16Star' OF oMenuFuncs ;
						ACTION ::IniPutFunc(10)

			MENUITEM TXT_MENU_RUN_TIME NAME '16Star' OF oMenuFuncs ;
						ACTION ::IniPutFunc(11)

			MENUITEM TXT_MENU_RUN_DATE NAME '16Star' OF oMenuFuncs ;
						ACTION ::IniPutFunc(12)

			MENUITEM TXT_MENU_RUN_TIMESTAMP NAME '16Star' OF oMenuFuncs ;
						ACTION ::IniPutFunc(13)

			SEPARATOR

			MENUITEM TXT_MENU_RUN_REPORT_NAME NAME '16Star' OF oMenuFuncs ;
						ACTION ::IniPutFunc(14)

			MENUITEM TXT_MENU_RUN_COMPUTER_NAME NAME '16Star' OF oMenuFuncs ;
						ACTION ::IniPutFunc(15)

			MENUITEM TXT_MENU_RUN_USER_NAME NAME '16Star' OF oMenuFuncs ;
						ACTION ::IniPutFunc(16)


	 ENDMENU

	 DEFINE CURSOR ::oHand HAND

	 DEFINE WINDOW ::oInspect MDICHILD OF ::oRpt:oMdi TITLE 'Inspector' ;
		STYLE nOr( WS_CAPTION, WS_THICKFRAME ) COLOR nRGB(0,0,0), nRGB(255,255,255)	

		::oInspect:SetIcon( TIcon():New( ,, "Report" ) )

		DEFINE BUTTONBAR ::oBar SIZE 26, 27 _3D OF ::oInspect
							  ::oBar:bRClicked := {|| NIL }

		DEFINE BUTTON ::oBtnEmf  OF ::oBar       NOBORDER NAME '16Emf'    ACTION ::oRpt:oForm:InitEmf() WHEN ::lActive  TOOLTIP TXT_TIP_EMF
		DEFINE BUTTON ::oBtnSay  OF ::oBar GROUP NOBORDER NAME '16Say'    ACTION ::IniPutSay()   WHEN ::lActive         TOOLTIP TXT_TIP_SAY
		DEFINE BUTTON ::oBtnImg  OF ::oBar       NOBORDER NAME '16Img'    ACTION ::IniPutImg()   WHEN ::lActive         TOOLTIP TXT_TIP_IMAGE
		DEFINE BUTTON ::oBtnBox  OF ::oBar       NOBORDER NAME '16Box'    ACTION ::IniPutBox()   WHEN ::lActive         TOOLTIP TXT_TIP_BOX
		DEFINE BUTTON ::oBtnCBar OF ::oBar       NOBORDER NAME '16CBar'   ACTION ::IniPutCBar()  WHEN ::lActive         TOOLTIP TXT_TIP_CODEBAR
		DEFINE BUTTON ::oBtnFunc OF ::oBar       NOBORDER NAME '16Func'   MENU   oMenuFuncs      WHEN ::lActive         TOOLTIP TXT_TIP_FUNCTION
		DEFINE BUTTON ::oBtnSec  OF ::oBar GROUP NOBORDER NAME '16Sec'    ACTION ::IniSection()  WHEN ::lActive         TOOLTIP TXT_TIP_SECTION
		DEFINE BUTTON ::oBtnSee  OF ::oBar GROUP NOBORDER NAME '16See'    ACTION ::ItemVisible() WHEN ::lActive         TOOLTIP TXT_TIP_VIEW_SECTION

		AEval( ::oBar:aControls,  {|x| x:oCursor := ::oHand } )

		::IniTree()
		::IniData()

		@ 250,0  SPLITTER ::oSplit ;
					HORIZONTAL ;
					PREVIOUS CONTROLS ::oTree ;
					HINDS CONTROLS ::oList ;
					TOP MARGIN 80 ;
					BOTTOM MARGIN 80 ;
					SIZE 500, 4  PIXEL ;
					OF ::oInspect ;
					_3DLOOK

		::oInspect:aMinMaxInfo = { 300, 800,;  // xMaxSize,      yMaxSize
											300, 800,;  // xMaxPosition,  yMaxPosition
											300, 800,;  // 300 Max resize Left / 600 Max Resize Up
											300, 800 }  // xMaxTrackSize, yMaxTrackSize

		::oInspect:Move( 0, 0,300, ::oRpt:oMdi:nHeight - 110, .t. )

	 ACTIVATE WINDOW ::oInspect ;
				 ON RESIZE ::oSplit:AdjClient() ;
				 VALID ::oRpt:lExit

return NIL

//------------------------------------------------------------------------------
METHOD IniTree() CLASS TRptInspect
local oItem1
local oImageList := TImageList():New()  // imagelist items are zero-based!

	oImageList:Add( TBitmap():Define( "folder" ,, ::oInspect ), ;  // nImage == 0 (default if not specified)
						 TBitmap():Define( "fldMask",, ::oInspect ))

	oImageList:Add( TBitmap():Define( "16frm"   ,, ::oInspect ), ; // nImage == 1
						 TBitmap():Define( "16frmmsk",, ::oInspect ))


	oImageList:Add( TBitmap():Define( "16Emf"   ,, ::oInspect ), ; // nImage == 2
						 TBitmap():Define( "16EmfMsk",, ::oInspect ))

	oImageList:Add( TBitmap():Define( "16Dsg"   ,, ::oInspect ), ; // nImage == 3
						 TBitmap():Define( "16DsgMsk",, ::oInspect ))

	oImageList:Add( TBitmap():Define( "16Obj"   ,, ::oInspect ), ; // nImage == 4
						 TBitmap():Define( "16ObjMsk",, ::oInspect ))

	oImageList:Add( TBitmap():Define( "16Sec"   ,, ::oInspect ), ; // nImage == 5
						 TBitmap():Define( "16SecMsk",, ::oInspect ))

	oImageList:Add( TBitmap():Define( "16Say"    ,, ::oInspect ),; // nImage == 6
						 TBitmap():Define( "16SayMsk" ,, ::oInspect ))

	oImageList:Add( TBitmap():Define( "16Img"    ,, ::oInspect ),; // nImage == 7
						 TBitmap():Define( "16ImgMsk" ,, ::oInspect ))

	oImageList:Add( TBitmap():Define( "16Box"    ,, ::oInspect ),; // nImage == 8
						 TBitmap():Define( "16BoxMsk" ,, ::oInspect ))

	oImageList:Add( TBitmap():Define( "16Port"   ,, ::oInspect ),; // nImage == 9
						 TBitmap():Define( "16PortMk" ,, ::oInspect ))

	oImageList:Add( TBitmap():Define( "16CBar"   ,, ::oInspect ),; // nImage == 10
						 TBitmap():Define( "16CBarMk" ,, ::oInspect ))

	oImageList:Add( TBitmap():Define( "16Func"   ,, ::oInspect ),; // nImage == 11
						 TBitmap():Define( "16FuncMk" ,, ::oInspect ))

	::oTree := TTreeView():New( 2, 0, ::oInspect, ,, , , 300, 220 )
	::oTree:SetImageList( oImageList )
	::oTree:bChanged := {|oTree,oItem| ::TreeChanged( oTree ) }
	::oTree:bKeyDown := {|nKey| ::TreeKey( nKey ) }

return NIL

//------------------------------------------------------------------------------
METHOD IniData() CLASS TRptInspect

	 DEFINE FONT ::oFontList NAME "Verdana" SIZE 0,-11

	 ::oList := TListProp():New( 255, 0, 180, 300, , {"","",""},{20, 100, 100}, ::oInspect, , , ,,,, ::oFontList)
	 ::oList:nLineStyle := 2
	 ::oList:bModify    := {|| ::oRpt:oForm:SetChange( .t. ) }
	 ::oList:Reset()


return NIL

//------------------------------------------------------------------------------
METHOD AddForm( cFormName ) CLASS TRptInspect

	 cFormName := Alltrim( cFormName )

	 ::oForm       := ::oTree:Add( cFormName, 1 )
	 ::oForm:cargo := { '__FORM', NIL }

	 Aadd( ::aTree, { '__FORM', ::oForm, 0, NIL, cFormName } )

	 ::lActive := .t.
	 ::oBar:aEvalWhen()
	 ::oList:SetButtons( ::lActive )

return NIL

//------------------------------------------------------------------------------
METHOD TreeChanged( oTree ) CLASS TRptInspect
local Cargo
local cType, cSection
local oTreeItem, oItem, oObj

	 if oTree == NIL
		 return NIL
	 endif

	 if ::oRpt:oForm:lBuilding == .F.
		 ::oRpt:SoClick()
	 //else
	 //    RETU NIL  // Pendiente de chequear...Cuando se construya todo
	 endif

	 oTreeItem := oTree:GetSelected()
	 cargo     := oTreeItem:cargo

	 if ValType( cargo ) == 'A'
		 cType := cargo[1]

		 do case
			 case cType == '__ITEM'
					oItem := cargo[2]
					if oItem:lShow
						oObj  := oItem:oObj
						oObj:SetFocus()
						::oRpt:BtnPos(.t.)
					endif

			 case cType == '__SECTION'
					::oRpt:oForm:SelectNone()
					 cSection := cargo[2]
					::SetListSection( cSection )
					::oRpt:BtnPos(.f.)

			 case cType == '__PUBLIC'
					::oRpt:oForm:SelectNone()
					::SetListPublic()
					::oRpt:BtnPos(.f.)

			 case cType == '__FORM'
					::oRpt:oForm:SelectNone()
					::SetListForm()
					::oRpt:BtnPos(.f.)

			 otherwise   // Si NO es un item, treiem els punts del ultim control
					::ResetList()
					::oRpt:oForm:SelectNone()
					::oRpt:BtnPos(.f.)

		 endcase
	 endif

	 oTree:SetFocus()

return NIL

//------------------------------------------------------------------------------
METHOD ResetBtn() CLASS TRptInspect

	 do case
		 case ::nItemType == 1
				::oBtnSay:lPressed := .f.
				::oBtnSay:Refresh()

		 case ::nItemType == 2
				::oBtnImg:lPressed := .f.
				::oBtnImg:Refresh()

		 case ::nItemType == 3
				::oBtnBox:lPressed := .f.
				::oBtnBox:Refresh()

		 case ::nItemType == 4
				::oBtnCBar:lPressed := .f.
				::oBtnCBar:Refresh()

	 endcase

	 ::nItemType := 0
	 ::oRpt:oForm:oMeta:oCursor := ::oRpt:oForm:oCross

return NIL

//------------------------------------------------------------------------------
METHOD IniPutSay() CLASS TRptInspect
local hOldRes  := GetResources()
local lPressed := ::nItemType == 1
local oitem, cType, n

	 SetResources( ::oRpt:cDllFile )

	 ::ResetBtn()

	 if !lPressed
		 ::nItemType        := 1
		 ::oBtnSay:lPressed := .t.
		 ::oBtnSay:Refresh()

		 DEFINE CURSOR ::oCursor NAME 'PutSay'

		 ::oRpt:oForm:oMeta:oCursor := ::oCursor

		 for n = 1 to len(::atree)      //Sebas para poder poner says encima de las imagenes
			  cType := ::aTree[n,1]
			  if cType == '__ITEM'
				  oItem := ::aTree[n,4]
				  oItem:oObj:Disable()
			  endif
		 next n

	 endif

	 SetResources( hOldRes )

return NIL

//------------------------------------------------------------------------------
METHOD IniPutImg() CLASS TRptInspect
local hOldRes  := GetResources()
local lPressed := ::nItemType == 2
local oitem, cType, n

	 SetResources( ::oRpt:cDllFile )

	 ::ResetBtn()

	 if !lPressed
		 ::nItemType        := 2
		 ::oBtnImg:lPressed := .t.
		 ::oBtnImg:Refresh()

		 DEFINE CURSOR ::oCursor NAME 'PutBmp'

		 ::oRpt:oForm:oMeta:oCursor := ::oCursor

		 for n = 1 to len(::atree)      //Sebas para poder poner says encima de las imagenes
			  cType := ::aTree[n,1]
			  if cType == '__ITEM'
				  oItem := ::aTree[n,4]
				  oItem:oObj:Disable()
			  endif
		 next n

	 endif

	 SetResources( hOldRes )

return NIL

//------------------------------------------------------------------------------
METHOD IniPutBox() CLASS TRptInspect
local hOldRes  := GetResources()
local lPressed := ::nItemType == 3
local oitem, cType, n

	 SetResources( ::oRpt:cDllFile )

	 ::ResetBtn()

	 if !lPressed
		 ::nItemType        := 3
		 ::oBtnBox:lPressed := .t.
		 ::oBtnBox:Refresh()

		 DEFINE CURSOR ::oCursor NAME 'PutBox'

		 ::oRpt:oForm:oMeta:oCursor := ::oCursor

		 for n = 1 to len(::atree)      //Sebas para poder poner says encima de las imagenes
			  cType := ::aTree[n,1]
			  if cType == '__ITEM'
				  oItem := ::aTree[n,4]
				  oItem:oObj:Disable()
			  endif
		 next n

	 endif

	 SetResources( hOldRes )

return NIL

//------------------------------------------------------------------------------
METHOD IniPutCBar() CLASS TRptInspect
local hOldRes  := GetResources()
local lPressed := ::nItemType == 4
local oitem, cType, n

	 SetResources( ::oRpt:cDllFile )

	 ::ResetBtn()

	 if !lPressed
		 ::nItemType         := 4
		 ::oBtnCBar:lPressed := .t.
		 ::oBtnCBar:Refresh()

		 DEFINE CURSOR ::oCursor NAME 'PutBox'

		 ::oRpt:oForm:oMeta:oCursor := ::oCursor

		 for n = 1 to len(::atree)      //Sebas para poder poner says encima de las imagenes
			  cType := ::aTree[n,1]
			  if cType == '__ITEM'
				  oItem := ::aTree[n,4]
				  oItem:oObj:Disable()
			  endif
		 next n

	 endif

	 SetResources( hOldRes )

return NIL

//------------------------------------------------------------------------------
METHOD IniPutFunc( nType ) CLASS TRptInspect
local hOldRes  := GetResources()
local lPressed
local oitem, cType, n

	 DEFAULT nType := 10

	 lPressed := ::nItemType == nType

	 SetResources( ::oRpt:cDllFile )

	 ::ResetBtn()

	 if !lPressed
		 ::nItemType   := nType

		 DEFINE CURSOR ::oCursor NAME 'PutFunc'
		 ::oRpt:oForm:oMeta:oCursor := ::oCursor

		 for n = 1 to len(::atree)      //Sebas para poder poner says encima de las imagenes
			  cType := ::aTree[n,1]
			  if cType == '__ITEM'
				  oItem := ::aTree[n,4]
				  oItem:oObj:Disable()
			  endif
		 next n

	 endif

	 SetResources( hOldRes )

return NIL

//------------------------------------------------------------------------------
METHOD AddItem( oItem ) CLASS TRptInspect
local nPosForm, nPosCtrl
local oForm, oCtrl, oTreeItem
local nImage
local oBranch
local cSection
local oTPublic
local lIsSection

	 nPosForm := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__FORM'} )

	//  Si NO existe el FORMULARIO, algo pasa :-( ...

	 if nPosForm == 0
		 return NIL
	 endif

	 //  Seleccionen RAIZ del arbre
	 oForm    := ::aTree[ nPosForm ][ 2 ]

	 //  Creamos rama para el Item nuevo
	 do case
		 case oItem:cClass == 'TSAY'
				nImage := 6
		 case oItem:cClass == 'TIMAGE'
				nImage := 7
		 case oItem:cClass == 'TBOX'
				nImage := 8
		 case oItem:cClass == 'TCODEBAR'
				nImage := 10
	 endcase

	//  Chequeamos si hay alguna section activada
	 cSection   := oItem:cSection
	 lIsSection := !Empty( cSection )

	 if lIsSection
		 oBranch := ::GetBranchSection( cSection )

		 if oBranch == NIL // ESTO NO PUEDE O DEBE DE SER !!!
			 MsgAlert( 'ERROR' )
			 return NIL
		 endif
	 endif

	 do case
		 case lIsSection .AND. oItem:lSpecial == .F. .AND. oBranch <> NIL .AND. oBranch:cargo[1] == '__SECTION'
				oTreeItem        := oBranch:Add( oItem:cId, nImage )
				oTreeItem:cargo  := { '__ITEM', oItem }
				Aadd( ::aTree, { '__ITEM', oTreeItem, oItem:nKey, oItem, NIL } )
				oForm:Expand()
				oBranch:Expand()


		 case !lIsSection .AND. oItem:lSpecial == .F.
				// Si NO existe la rama PUBLIC creamos una rama, sino la seleccionamos...
				nPosCtrl := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__PUBLIC'} )

				if nPosCtrl == 0
					oTPublic    := ::GetPublic()
					oCtrl       := oForm:Add( TXT_PUBLIC, 4 )
					oCtrl:cargo := { '__PUBLIC', oTPublic }
					Aadd( ::aTree, { '__PUBLIC', oCtrl, 0, oTPublic, NIL } )
				else
					oCtrl := ::aTree[ nPosCtrl ][ CLS_TREE ]
				endif

				oTreeItem       := oCtrl:Add( oItem:cId, nImage )
				oTreeItem:cargo := { '__ITEM', oItem }
				Aadd( ::aTree, { '__ITEM', oTreeItem, oItem:nKey, oItem, NIL } )
				oForm:Expand()

				if nPosCtrl == 0
					oCtrl:Expand()
				endif


		 case oItem:lSpecial == .T.
				nPosCtrl := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__FUNCTION'} )

				if nPosCtrl == 0
					oCtrl       := oForm:Add( TXT_FUNCTION, 11 )
					oCtrl:cargo := { '__FUNCTION', oTPublic }
					Aadd( ::aTree, { '__FUNCTION', oCtrl, 0, NIL, NIL } )
				else
					oCtrl := ::aTree[ nPosCtrl ][ CLS_TREE ]
				endif

				oTreeItem       := oCtrl:Add( oItem:cId, nImage )
				oTreeItem:cargo := { '__ITEM', oItem }
				Aadd( ::aTree, { '__ITEM', oTreeItem, oItem:nKey, oItem, NIL } )
				oForm:Expand()

				if nPosCtrl == 0
					oCtrl:Expand()
				endif

	 endcase

	 ::oTree:Select( oTreeItem )


return oTreeItem

//------------------------------------------------------------------------------
METHOD AddEMF( cFile ) CLASS TRptInspect
local nPos, nPosEmf
local oTreeItem, oForm, oEmf

	 nPos := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__FORM'} )

	 //  Si NO existe el FORMULARIO, algo pasa :-( ...
	 if nPos == 0
		 return NIL
	 endif

	 nPosEmf := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__EMF'} )

	 //  Si NO existe EMF creamos una rama, sino modificamos sus propiedades...
	 if nPosEmf == 0
		 oForm       := ::aTree[nPos][ CLS_TREE ]
		 oEmf        := oForm:Add( 'Emf: ' + cFileNoPath(cFile), 2 )
		 oEmf:cargo  := { '__EMF', cFile }
		 oForm:Expand()
		 Aadd( ::aTree, { '__EMF', oEmf, 0, NIL, cFile } )
	 else
		 oTreeItem       := ::aTree[nPosEmf][ CLS_TREE ]
		 oTreeItem:cargo := { '__EMF', cFile }
		 oTreeItem:SetText( 'Emf: ' + cFileNoPath(cFile) )
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD AddXY( nWidth, nHeight, nPaperSize, lPortrait ) CLASS TRptInspect
local nPos, nPosEmf
local oTreeItem, oX, oY, oSize, oOrienta

	 DEFAULT nPaperSize := 9
	 DEFAULT lPortrait  := .t.

	 nPos := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__FORM'} )

	 //  Si NO existe el FORMULARIO, algo pasa :-( ...
	 if nPos == 0
		 return NIL
	 endif

	 oTreeItem   := ::aTree[nPos][ CLS_TREE ]
	 oSize       := oTreeItem:Add( TXT_PAPER_SIZE        + ': ' + PaperType( nPaperSize ), 3 )
	 oX          := oTreeItem:Add( TXT_PAPER_WIDTH       + ': ' + ltrim(str(nWidth))  , 3 )
	 oY          := oTreeItem:Add( TXT_PAPER_HEIGHT      + ': ' + ltrim(str(nHeight)), 3 )
	 oOrienta    := oTreeItem:Add( TXT_PAPER_ORIENTATION + ': ' + IF( lPortrait, TXT_PORTRAIT, TXT_LANDSCAPE ) ,9 )

	 oSize:cargo    := { '__SIZE'   , nPaperSize }
	 oX:cargo       := { '__X'      , nWidth  }
	 oY:cargo       := { '__Y'      , nHeight }
	 oOrienta:cargo := { '__ORIENTA', NIL     }

	 Aadd( ::aTree, { '__SIZE'   , oSize   , 0, NIL, nPaperSize   } )
	 Aadd( ::aTree, { '__X'      ,    oX   , 0, NIL, nWidth       } )
	 Aadd( ::aTree, { '__Y'      ,    oY   , 0, NIL, nHeight      } )
	 Aadd( ::aTree, { '__ORIENTA', oOrienta, 0, NIL, NIL          } )

	 oTreeItem:Expand()

return NIL

//------------------------------------------------------------------------------
METHOD GetPublic() CLASS TRptInspect

	 if ::oTPublic == NIL
		 ::oTPublic := LoadPublic()
	 endif

return ::oTPublic

//------------------------------------------------------------------------------
METHOD GetSection( cSection ) CLASS TRptInspect
local nPosSection := Ascan( ::aTree, {|x| x[ CLS_TYPE  ] == '__SECTION' .AND. ;
															 x[ CLS_CARGO ] == cSection } )
return ::aTree[nPosSection][ CLS_OBJ ]

//------------------------------------------------------------------------------
METHOD IsSection( cSection ) CLASS TRptInspect
local nPosSection := Ascan( ::aTree, {|x| x[ CLS_TYPE  ] == '__SECTION' .AND. ;
															 x[ CLS_CARGO ] == cSection } )
return IF( nPosSection == 0, .f., .t. )

//------------------------------------------------------------------------------
METHOD SetListForm() CLASS TRptInspect
local nGroup
local o

	 ::oList:Reset()

	 nGroup := ::oList:AddGroup( TXT_PROP_GRUP_INFO )

	 o := ::oList:AddItem( "NAME", TXT_PROP_PRJ_NAME, ::oRpt:oForm:cFormName, CARACTER, nGroup )
	 o:SetWhen( {|| .f. } )
	 o := ::oList:AddItem( "DESCRIPTION", TXT_PROP_DESCRIPTION, ::oRpt:oForm:cFormDescription, CARACTER, nGroup )
	 o:SetWhen( {|| .f. } )
	 o := ::oList:AddItem( "AUTOR", TXT_PROP_AUTOR, ::oRpt:oForm:cFormAutor, CARACTER, nGroup )
	 o:SetWhen( {|| .f. } )
	 o := ::oList:AddItem( "DATE", TXT_PROP_DATE, DToC( ::oRpt:oForm:dFormData ), CARACTER, nGroup )
	 o:SetWhen( {|| .f. } )

	 ::oList:Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD SetListSection( cSection ) CLASS TRptInspect
local nGroup
local oTSection
local o

	 oTSection            := ::GetSection( cSection )

	 ::oList:Reset()

	 nGroup := ::oList:AddGroup( TXT_PROP_GRUP_INFO )
	 o := ::oList:AddItem( "SECCION", TXT_PROP_SECTION_NAME, oTSection:cSection, CARACTER, nGroup )
	 o:SetWhen( {|| .f. } )

	 nGroup := ::oList:AddGroup( TXT_PROP_GRUP_POSICION )
	 o := ::oList:AddItem( "HEIGHT", TXT_PROP_HEIGHT , oTSection:nHeight, NUMERO, nGroup )
	 o:SetPicture( '999' )
	 o:SetValid( {|uVal| oTSection:nHeight := uVal, .t. } )

	 o := ::oList:AddItem( "INTERLINE", TXT_PROP_INTERLINE , oTSection:nInterLine, SPINNER, nGroup )
	 o:SetPicture( '99' )
	 o:SetValid( {|uVal| oTSection:nInterLine := uVal, .t. } )

	 nGroup := ::oList:AddGroup( TXT_PROP_GRUP_HEADER )
	 o := ::oList:AddItem( "HEADER", TXT_PROP_HEADER, oTSection:lHeader, LOGICO, nGroup )
	 o:SetUpdate ()
	 o:SetValid  ( {|uVal| oTSection:lHeader := uVal, .t. } )

	 o := ::oList:AddItem( "LINE_WIDTH", TXT_PROP_IT_LINE_WIDTH, oTSection:nLineWidth, SPINNER, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetValid  ( {|uVal| oTSection:nLineWidth := uVal, .t. } )

	 o := ::oList:AddItem( "SHADOW", TXT_PROP_IT_SHADOW, oTSection:nShadow, SPINNER, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetValid  ( {|uVal| oTSection:nShadow := uVal, .t. } )

	 o := ::oList:AddItem( "FIXHEIGHT", TXT_PROP_FIX_HEIGHT, oTSection:nFixHeight, NUMERO, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetPicture( '99' )
	 o:SetValid( {|uVal| oTSection:nFixHeight := uVal, .t. } )

	 o := ::oList:AddItem( "FONT", TXT_PROP_FONT , oTSection:cFaceName, LISTA, nGroup )
	 o:SetWhen  ( {|| oTSection:lHeader } )
	 o:SetTable ( {|| GetFonts() } )
	 o:SetValid ( {|uVal| oTSection:cFaceName := uVal, .t. } )

	 o := ::oList:AddItem( "SIZE", TXT_PROP_FONT_SIZE, oTSection:nInpHeight, SPINNER, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetPicture( '99' )
	 o:SetValid  ( {|uVal| oTSection:nInpHeight := uVal, .t. } )

	 o := ::oList:AddItem( "BOLD", TXT_PROP_FONT_BOLD, oTSection:lFontBold, LOGICO, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetValid  ( {|uVal| oTSection:lFontBold := uVal, .t. } )

	 o := ::oList:AddItem( "ITALIC", TXT_PROP_FONT_ITALIC, oTSection:lFontItalic, LOGICO, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetValid  ( {|uVal| oTSection:lFontItalic := uVal, .t. } )

	 o := ::oList:AddItem( "UNDERLINE", TXT_PROP_FONT_UNDERLINE, oTSection:lFontUnderline, LOGICO, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetValid  ( {|uVal| oTSection:lFontUnderline := uVal, .t. } )

	 o := ::oList:AddItem( "COLOR_SEC_TEXTO", TXT_PROP_CLR_SEC_FORE, oTSection:nClrSecFore, ACCION, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetAction ( {|| oTSection:nClrSecFore := ChooseColor( oTSection:nClrSecFore ), oTSection:nClrSecFore } )
	 o:SetValid  ( {|uVal| oTSection:nClrSecFore := uVal, .t. } )

	 o := ::oList:AddItem( "COLOR_SEC_BACK", TXT_PROP_CLR_SEC_BACK, oTSection:nClrSecBack, ACCION, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetAction ( {|| oTSection:nClrSecBack := ChooseColor( oTSection:nClrSecBack ), oTSection:nClrSecBack } )
	 o:SetValid  ( {|uVal| oTSection:nClrSecBack := uVal, .t. } )

	 o := ::oList:AddItem( "COLOR_SEC_LINE", TXT_PROP_CLR_SEC_LINE, oTSection:nClrSecLine, ACCION, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetAction ( {|| oTSection:nClrSecLine := ChooseColor( oTSection:nClrSecLine ), oTSection:nClrSecLine } )
	 o:SetValid  ( {|uVal| oTSection:nClrSecLine := uVal, .t. } )


	 o := ::oList:AddItem( "COLOR_ITEM_TEXTO", TXT_PROP_CLR_ITEM_FORE, oTSection:nClrFore, ACCION, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetAction ( {|| oTSection:nClrFore := ChooseColor( oTSection:nClrFore ), oTSection:nClrFore } )
	 o:SetValid  ( {|uVal| ::oRpt:oForm:SectionColor( oTSection:cSection, oTSection:nClrFore, oTSection:nClrBack ),;
							oTSection:nClrFore := uVal, .t. } )

	 o := ::oList:AddItem( "COLOR_ITEM_BACK" , TXT_PROP_CLR_ITEM_BACK, oTSection:nClrBack, ACCION, nGroup )
	 o:SetWhen   ( {|| oTSection:lHeader } )
	 o:SetAction ( {|| oTSection:nClrBack := ChooseColor( oTSection:nClrBack ), oTSection:nClrBack } )
	 o:SetValid  ( {|uVal| ::oRpt:oForm:SectionColor( oTSection:cSection, oTSection:nClrFore, oTSection:nClrBack ),;
							oTSection:nClrBack := uVal, .t. } )

	 nGroup := ::oList:AddGroup( TXT_PROP_GRUP_APARIENCIA )
	 o := ::oList:AddItem( "FIXED", TXT_PROP_IT_FIXED, oTSection:lFixed, LOGICO, nGroup )
	 o:SetValid  ( {|uVal| oTSection:lFixed := uVal, .t. } )
	 o := ::oList:AddItem( "PIJAMA", TXT_PROP_PIJAMA, oTSection:lPijama, LOGICO, nGroup )
	 o:SetUpdate()
	 o:SetValid ( {|uVal| oTSection:lPijama := uVal, .t. } )

	 o := ::oList:AddItem( "PIJAMA_CLR1" , TXT_PROP_PIJAMA_CLR1, oTSection:nPijamaClr1, ACCION, nGroup )
	 o:SetWhen   ( {|| oTSection:lPijama } )
	 o:SetAction ( {|| oTSection:nPijamaClr1 := ChooseColor( oTSection:nPijamaClr1 ), oTSection:nPijamaClr1 } )
	 o:SetValid  ( {|uVal| oTSection:nCPijamaClr1 := uVal, .t. } )

	 o := ::oList:AddItem( "PIJAMA_CLR2" , TXT_PROP_PIJAMA_CLR2, oTSection:nPijamaClr2, ACCION, nGroup )
	 o:SetWhen   ( {|| oTSection:lPijama } )
	 o:SetAction ( {|| oTSection:nPijamaClr2 := ChooseColor( oTSection:nPijamaClr2 ), oTSection:nPijamaClr2 } )
	 o:SetValid  ( {|uVal| oTSection:nCPijamaClr2 := uVal, .t. } )

	 o := ::oList:AddItem( "PIJAMA_CLR3" , TXT_PROP_PIJAMA_CLR3, oTSection:nPijamaClr3, ACCION, nGroup )
	 o:SetWhen   ( {|| oTSection:lPijama } )
	 o:SetAction ( {|| oTSection:nPijamaClr3 := ChooseColor( oTSection:nPijamaClr3 ), oTSection:nPijamaClr3 } )
	 o:SetValid  ( {|uVal| oTSection:nPijamaClr3 := uVal, .t. } )

	 ::oList:Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD SetListPublic() CLASS TRptInspect
local aAlign     := { TXT_PROP_JUST_LEFT, TXT_PROP_JUST_CENTER ,TXT_PROP_JUST_RIGHT }
local nGroup
local o

	 ::oList:Reset()

	 nGroup := ::oList:AddGroup( TXT_PROP_GRUP_APARIENCIA )

	 o := ::oList:AddItem( "WIDTH", TXT_PROP_WIDTH , ::oTPublic:nWidth, NUMERO, nGroup )
	 o:SetPicture( '99' )
	 o:SetValid( {|uVal| ::oTPublic:nWidth := uVal, .t. } )

	 o := ::oList:AddItem( "HEIGHT", TXT_PROP_HEIGHT, ::oTPublic:nHeight, NUMERO, nGroup )
	 o:SetPicture( '99' )
	 o:SetValid( {|uVal| ::oTPublic:nHeight := uVal, .t. } )

	 o := ::oList:AddItem( "ALIGMENT", TXT_PROP_ALIGN , aAlign[ ::oTPublic:nPad+1 ], LISTA, nGroup )
	 o:SetTable ( {|| aAlign } )
	 o:SetValid ( {|uVal| ::oTpublic:nPad := Ascan( aAlign, uVal ) - 1, .t. } )

	 nGroup := ::oList:AddGroup( TXT_PROP_GRUP_FONT )
	 o := ::oList:AddItem( "NAME", TXT_PROP_FONT , ::oTPublic:cFaceName, LISTA, nGroup )
	 o:SetTable ( {|| GetFonts() } )
	 o:SetValid ( {|uVal| ::oTPublic:cFaceName := uVal, .t. } )

	 o := ::oList:AddItem( "SIZE", TXT_PROP_FONT_SIZE, ::oTPublic:nInpHeight, SPINNER, nGroup )
	 o:SetPicture( '99' )
	 o:SetValid  ( {|uVal| ::oTPublic:nInpHeight := uVal, .t. } )

	 o := ::oList:AddItem( "BOLD", TXT_PROP_FONT_BOLD, ::oTPublic:lFontBold, LOGICO, nGroup )
	 o:SetValid  ( {|uVal| ::oTPublic:lFontBold := uVal, .t. } )

	 o := ::oList:AddItem( "ITALIC", TXT_PROP_FONT_ITALIC, ::oTPublic:lFontItalic, LOGICO, nGroup )
	 o:SetValid  ( {|uVal| ::oTPublic:lFontItalic := uVal, .t. } )

	 o := ::oList:AddItem( "ITALIC", TXT_PROP_FONT_UNDERLINE, ::oTPublic:lFontUnderline, LOGICO, nGroup )
	 o:SetValid  ( {|uVal| ::oTPublic:lFontUnderLine := uVal, .t. } )

	 o := ::oList:AddItem( "COLOR_TEXTO", TXT_PROP_CLR_FORE, ::oTPublic:nClrFore, ACCION, nGroup )
	 o:SetAction( {|| ::oTPublic:nClrFore := ChooseColor( ::oTPublic:nClrFore ), ::oTPublic:nClrFore } )
	 o:SetValid ( {|uVal| ::oTpublic:nClrFore := uVal, .t. } )

	 o := ::oList:AddItem( "COLOR_TEXTO", TXT_PROP_CLR_BACK, ::oTPublic:nClrBack, ACCION, nGroup )
	 o:SetAction( {|| ::oTPublic:nClrBack := ChooseColor( ::oTPublic:nClrBack ), ::oTPublic:nClrBack } )
	 o:SetValid ( {|uVal| ::oTpublic:nClrBack := uVal, .t. } )

	 ::oList:Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD SetListItem( oItem ) CLASS TRptInspect
local nGroup
local oObj         := oItem:oObj
local cClass       := oItem:cClass
local lIsSection   :=  ! Empty( oItem:cSection )
local nZoom        := ::oRpt:oForm:nZoom
local nTop         := vPix2MM( oObj:nTop    ) * 100 / nZoom
local nLeft        := hPix2MM( oObj:nLeft   ) * 100 / nZoom
local nWidth       := hPix2MM( oObj:nWidth  ) * 100 / nZoom
local nHeight      := vPix2MM( oObj:nHeight ) * 100 / nZoom
local aAlign       := { TXT_PROP_JUST_LEFT   ,;
									 TXT_PROP_JUST_CENTER ,;
									 TXT_PROP_JUST_RIGHT  }
local aTypeBox     := { TXT_PROP_RECT_ALL    ,;
									 TXT_PROP_RECT_HT     ,;
									 TXT_PROP_RECT_VL     ,;
									 TXT_PROP_RECT_HB     ,;
									 TXT_PROP_RECT_VR     }
local aTypeCodeBar := { 'Code128 (Mode A)'   ,;
									 'Code128 (Mode B)'   ,;
									 'Code128 (Mode C)'   ,;
									 'Code3_9'            ,;
									 'Ean13'              ,;
									 'Ean8'               ,;
									 'Codabar'            ,;
									 'UPCA'               }
local o

	 ::oList:Reset()

	 nGroup := ::oList:AddGroup( TXT_PROP_GRUP_INFO )
	 o := ::oList:AddItem( "CLASS" , TXT_PROP_CLASS , oItem:cClass, CARACTER, nGroup )
	 o:SetWhen( {|| .f. } )

	 o := ::oList:AddItem( "ID"    , TXT_PROP_IT_ID , oItem:cId   , CARACTER, nGroup )
	 o:SetPicture( '@!' )
	 o:SetValid( {|uVal| IF( ValidID( oItem, ::aTree, uVal ),;
						  ( oItem:cId := uVal , ::SetTreeItem( oItem, uVal ), .t. ), .f. )  } )

	 if oItem:lSpecial
		 o := ::oList:AddItem( "SPECIAL", TXT_PROP_IT_SPECIAL , Special2Txt( oItem ), CARACTER, nGroup )
		 o:SetWhen( {|| .f. } )
	 endif

	 nGroup := ::oList:AddGroup( TXT_PROP_GRUP_POSICION )
	 o := ::oList:AddItem( "TOP", TXT_PROP_IT_TOP , oItem:nTop, NUMERO, nGroup )
	 o:SetPicture( '999.9' )
	 o:SetValid( {|uVal|  ::oRpt:oForm:move( oItem, uVal, 'TOP' ), oItem:nTop := uVal, .t. } )

	 o := ::oList:AddItem( "LEFT", TXT_PROP_IT_LEFT , nLeft, NUMERO, nGroup )
	 o:SetPicture( '999.9' )
	 o:SetValid( {|uVal| ::oRpt:oForm:move( oItem, uVal, 'LEFT' ), .t. } )

	 o := ::oList:AddItem( "WIDTH", TXT_PROP_IT_WIDTH , nWidth, NUMERO, nGroup )
	 o:SetPicture( '999.9' )
	 o:SetValid( {|uVal| ::oRpt:oForm:move( oItem, uVal, 'WIDTH' ), .t. } )

	 o := ::oList:AddItem( "HEIGHT", TXT_PROP_IT_HEIGHT , nHeight, NUMERO, nGroup )
	 o:SetPicture( '999.9' )
	 o:SetValid( {|uVal| ::oRpt:oForm:move( oItem, uVal, 'HEIGHT' ), .t. } )

	 if lIsSection .AND. ::HeaderInSection( oItem:cSection )
		 nGroup := ::oList:AddGroup( TXT_PROP_GRUP_SECTION )
		 o := ::oList:AddItem( "HEADER"    , TXT_PROP_TITLE , oItem:cSecHead  , CARACTER, nGroup )
		o:SetValid( {|uVal| oItem:cSecHead := uVal , .t. } )

		 o := ::oList:AddItem( "HEADER_FILE" , TXT_PROP_HEADER_IMG_FILE , cFileNoPath( oItem:cImgFileHeader ), ACCION, nGroup )
		 o:SetAction( {|| SelectImgHeader( oItem ), cFileNoPath( oItem:cImgFileHeader ) } )

		 o := ::oList:AddItem( "HEADER_IMG_SIZE", TXT_PROP_HEADER_IMG_SIZE, oItem:nImgFixHeader, SPINNER, nGroup )
		 o:SetPicture( '99' )
		 o:SetValid  ( {|uVal| oItem:nImgFixHeader := uVal, .t. } )

	 endif

	 nGroup := ::oList:AddGroup( TXT_PROP_GRUP_APARIENCIA )
	 o := ::oList:AddItem( "VISIBLE", TXT_PROP_IT_VISIBLE, oItem:lVisible, LOGICO, nGroup )
	 o:SetValid  ( {|uVal| oItem:lVisible := uVal, .t. } )

	 if oItem:lSpecial
		 o:SetWhen( {|| .f. } )
	 endif

	 o := ::oList:AddItem( "BORDER", TXT_PROP_IT_PRINT_BORDER, oItem:lBorder, LOGICO, nGroup )
	 o:SetUpdate ()
	 o:SetValid  ( {|uVal| oItem:lBorder := uVal, .t. } )

	 o := ::oList:AddItem( "SHADOW", TXT_PROP_IT_SHADOW, oItem:nShadow, SPINNER, nGroup )
	 o:SetWhen   ( {|| oItem:lBorder } )
	 o:SetPicture( '99' )
	 o:SetValid  ( {|uVal| oItem:nShadow := uVal, .t. } )

	 do case
		 case cClass == 'TSAY'
				o := ::oList:AddItem( "CAPTION", TXT_PROP_IT_CAPTION , oItem:cCaption, CARACTER, nGroup )
				o:SetValid( {|uVal| oItem:cCaption := uVal, ::oRpt:oForm:SetCaption( oItem, 'C' ), .t. } )

				o := ::oList:AddItem( "LINE_WIDTH", TXT_PROP_IT_LINE_WIDTH, oItem:nLineWidth, SPINNER, nGroup )
				o:SetWhen   ( {|| oItem:lBorder } )
				o:SetPicture( '99' )
				o:SetValid  ( {|uVal| oItem:nLineWidth := uVal, .t. } )

				o := ::oList:AddItem( "COLOR_LINE", TXT_PROP_IT_LINE_COLOR, oItem:nClrLine, ACCION, nGroup )
				o:SetAction( {|| oItem:nClrLine := ChooseColor( oItem:nClrLine ) } )
				o:SetValid ( {|uVal| oItem:nClrLine := uVal, .t. } )

				o := ::oList:AddItem( "COLOR_TEXTO", TXT_PROP_CLR_FORE, oItem:nClrFore, ACCION, nGroup )
				o:SetAction( {|| oItem:oObj:SelColor(.t.), oItem:oObj:nClrText } )
				o:SetValid ( {|uVal| oItem:nClrFore := uVal, .t. } )

				o := ::oList:AddItem( "COLOR_BACK", TXT_PROP_CLR_BACK, oItem:nClrBack, ACCION, nGroup )
				o:SetAction( {|| oItem:oObj:SelColor(.f.), oItem:oObj:nClrPane } )
				o:SetValid ( {|uVal| oItem:nClrBack := uVal, .t. } )

				o := ::oList:AddItem( "ALIGMENT", TXT_PROP_ALIGN , aAlign[ oItem:nPad+1 ], LISTA, nGroup )
				o:SetTable ( {|| aAlign } )
				o:SetValid ( {|uVal| oItem:nPad := Ascan( aAlign, uVal ) - 1, ::oRpt:oForm:SetSayAlign( oItem ),.t. } )

				o := ::oList:AddItem( "MEMO", TXT_PROP_MEMO, oItem:lMemo, LOGICO, nGroup )
				o:SetUpdate ()
				o:SetValid  ( {|uVal| oItem:lMemo := uVal, .t. } )

				o := ::oList:AddItem( "MULTIPAGE", TXT_PROP_MEMO_MPAGE, oItem:lMultiPage, LOGICO, nGroup )
				o:SetWhen   ( {|| oItem:lMemo } )
				o:SetValid  ( {|uVal| oItem:lMultipage := uVal, .t. } )

				o := ::oList:AddItem( "MEMO_INTERLINE", TXT_PROP_MEMO_INTERLINE, oItem:nInterline, SPINNER, nGroup )
				o:SetWhen   ( {|| oItem:lMemo } )
				o:SetPicture( '99' )
				o:SetValid  ( {|uVal| oItem:nInterline := uVal, .t. } )

				nGroup := ::oList:AddGroup( "Fonts" )
				o := ::oList:AddItem( "NAME", TXT_PROP_FONT , oItem:cFaceName, LISTA, nGroup )
				o:SetTable ( {|| GetFonts() } )
				o:SetValid ( {|uVal| oItem:cFaceName := uVal, ::oRpt:oForm:Setfont( oItem, 'C' ),.t. } )

				o := ::oList:AddItem( "SIZE", TXT_PROP_FONT_SIZE, oItem:nInpHeight, SPINNER, nGroup )
				o:SetPicture( '99' )
				o:SetValid  ( {|uVal| oItem:nInpHeight := uVal, ::oRpt:oForm:Setfont( oItem ) ,.t. } )

				o := ::oList:AddItem( "BOLD", TXT_PROP_FONT_BOLD, oItem:lFontBold, LOGICO, nGroup )
				o:SetValid  ( {|uVal| oItem:lFontBold := uVal, ::oRpt:oForm:Setfont( oItem ) ,.t. } )

				o := ::oList:AddItem( "ITALIC", TXT_PROP_FONT_ITALIC, oItem:lFontItalic, LOGICO, nGroup )
				o:SetValid  ( {|uVal| oItem:lFontItalic := uVal, ::oRpt:oForm:Setfont( oItem ) ,.t. } )

				o := ::oList:AddItem( "UNDERLINE", TXT_PROP_FONT_UNDERLINE, oItem:lFontItalic, LOGICO, nGroup )
				o:SetValid  ( {|uVal| oItem:lFontUnderline := uVal, ::oRpt:oForm:Setfont( oItem ) ,.t. } )

		 case cClass == 'TIMAGE'
				o := ::oList:AddItem( "LINE_WIDTH", TXT_PROP_IT_LINE_WIDTH, oItem:nLineWidth, SPINNER, nGroup )
				o:SetWhen   ( {|| oItem:lBorder } )
				o:SetPicture( '99' )
				o:SetValid  ( {|uVal| oItem:nLineWidth := uVal, .t. } )

				o := ::oList:AddItem( "FILE", TXT_PROP_FILE, cFileNoPath( oItem:cFile ), ACCION, nGroup )
				o:SetAction( {|| ::oRpt:oForm:SetFile( oItem ), cFileNoPath( oItem:cFile ) } )

				o := ::oList:AddItem( "BORDER", TXT_PROP_BORDER, oItem:lBorder, LOGICO, nGroup )
				o:SetUpdate ()
				o:SetValid  ( {|uVal| oItem:lBorder := uVal,;
										  ::oRpt:oForm:Setfont( oItem ),;
											ChangeStyleWindow( oItem:oObj, WS_BORDER, NIL, oItem:lBorder ) ,;
											oItem:oObj:Hide() ,;
											oItem:oObj:Show() ,;
											::oRpt:oForm:Setfont( oItem ),;
											.T.  } )

				o := ::oList:AddItem( "FIXHEIGHT", TXT_PROP_FIX_HEIGHT, oItem:nImgFixHeight, NUMERO, nGroup )
				o:SetPicture( '99' )
				o:SetValid( {|uVal| oItem:nImgFixHeight := uVal, .t. } )

		 case cClass == 'TBOX'
				o := ::oList:AddItem( "LINE_WIDTH", TXT_PROP_BOX_LINE_WIDTH, oItem:nLineWidth, SPINNER, nGroup )
				o:SetPicture( '99' )
				o:SetValid  ( {|uVal| oItem:nLineWidth := uVal, ;
											oItem:oObj:nLineWidth := uVal ,;
											oItem:oObj:Hide(),;
											oItem:oObj:Show(),;
											.T. } )

				o := ::oList:AddItem( "LINE_STYLE", TXT_PROP_BOX_LINE_STYLE , aTypeBox[ oItem:nLineType ], LISTA, nGroup )
				o:SetTable ( {|| aTypeBox } )
				o:SetValid ( {|uVal| oItem:nLineType := Ascan( aTypeBox, uVal ),;
										  oItem:oObj:nLineType := oItem:nLineType ,;
										  oItem:oObj:Hide(),;
										  oItem:oObj:Show(),;
										  .T. } )

				o := ::oList:AddItem( "COLOR_LINE", TXT_PROP_BOX_LINE_CLR, oItem:nClrFore, ACCION, nGroup )
				o:SetAction( {|| oItem:oObj:SelColor(.t.), oItem:oObj:nClrText } )
				o:SetValid ( {|uVal| oItem:nClrFore := uVal, .t. } )

				o := ::oList:AddItem( "COLOR_BACK", TXT_PROP_BOX_CLR, oItem:nClrBack, ACCION, nGroup )
				o:SetAction( {|| oItem:oObj:SelColor(.f.), oItem:oObj:nClrPane } )
				o:SetValid ( {|uVal| oItem:nClrBack := uVal, .t. } )

		 case cClass == 'TCODEBAR'
				o := ::oList:AddItem( "LINE_WIDTH", TXT_PROP_IT_LINE_WIDTH, oItem:nLineWidth, SPINNER, nGroup )
				o:SetWhen   ( {|| oItem:lBorder } )
				o:SetPicture( '99' )
				o:SetValid  ( {|uVal| oItem:nLineWidth := uVal, .t. } )

				nGroup := ::oList:AddGroup( TXT_PROP_GRUP_CODEBAR )
				o := ::oList:AddItem( "CODEBAR", TXT_PROP_CODEBAR_TIPO , aTypeCodeBar[ oItem:nCodeBarType ], LISTA, nGroup )
				o:SetUpdate()
				o:SetTable ( {|| aTypeCodeBar } )
				o:SetValid ( {|uVal| oItem:nCodeBarType := Ascan( aTypeCodeBar, uVal ), .T. } )

				o := ::oList:AddItem( "CAPTION", TXT_PROP_IT_CAPTION , oItem:cCaption, CARACTER, nGroup )
				o:SetValid( {|uVal| oItem:cCaption := uVal, .t. } )

				o := ::oList:AddItem( "FIXHEIGHT", TXT_PROP_FIX_HEIGHT, oItem:nImgFixHeight, NUMERO, nGroup )
				o:SetPicture( '99' )
				o:SetValid( {|uVal| oItem:nImgFixHeight := uVal, .t. } )

				o := ::oList:AddItem( "VERTICAL", TXT_PROP_TXT_VERTICAL, oItem:lVertical, LOGICO, nGroup )
				o:SetValid  ( {|uVal| oItem:lVertical := uVal, .t. } )

				o := ::oList:AddItem( "BANNER", TXT_PROP_BANNER, oItem:lBanner, LOGICO, nGroup )
				o:SetWhen   ( {|| oItem:nCodeBarType == 3 .OR. ;
									  oItem:nCodeBarType == 4 .OR. ;
									  oItem:nCodeBarType == 6 } )
				o:SetValid  ( {|uVal| oItem:lBanner := uVal, .t. } )

				o := ::oList:AddItem( "NAME", TXT_PROP_FONT , oItem:cFaceName, LISTA, nGroup )
				o:SetWhen   ( {|| oItem:nCodeBarType == 3 .OR. ;
									  oItem:nCodeBarType == 4 .OR. ;
									  oItem:nCodeBarType == 6 } )
				o:SetTable ( {|| GetFonts() } )
				o:SetValid ( {|uVal| oItem:cFaceName := uVal, .t. } )

	 endcase

	 ::oList:Refresh()

return NIL

//------------------------------------------------------------------------------
METHOD SetTreeForm( cValue ) CLASS TRptInspect
local nPos := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__FORM'} )
local oTree

	 DEFAULT cValue := ''

	 oTree := ::aTree[nPos][ CLS_TREE ]
	 oTree:SetText( cValue )

return NIL

//------------------------------------------------------------------------------
METHOD SetTreeItem( oItem, cValue ) CLASS TRptInspect
local nPos := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__ITEM' .AND. ;
											  x[ CLS_KEY ] == oItem:nKey } )
local oTree

	 if nPos == 0
		 return NIL
	 endif

	 DEFAULT cValue := ''

	 oTree := ::aTree[nPos][ CLS_TREE ]
	 oTree:SetText( Alltrim(cValue) )

return NIL

//------------------------------------------------------------------------------
METHOD GetItem( nKey ) CLASS TRptInspect
local nPos := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__ITEM' .AND. ;
													x[ CLS_KEY  ] == nKey } )
	 if nPos == 0
		 return NIL
	 endif

return ::aTree[ nPos ][ CLS_OBJ ]

//------------------------------------------------------------------------------
METHOD SetTreePaperSize( nX, nY, nPaperSize, lPortrait ) CLASS TRptInspect
local oTree
local nPos
local cPaper       := ''

	 DEFAULT nX         := 0
	 DEFAULT nY         := 0
	 DEFAULT nPaperSize := 0

	 cPaper := PaperType( nPaperSize )

	 //  Width
	 nPos := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__X'} )
	 oTree := ::aTree[nPos][ CLS_TREE ]
	 oTree:cargo[ CLS_TREE ] := nX
	 oTree:SetText( 'Width mm.: ' + ltrim(str(nX)) )

	 //  Height
	 nPos := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__Y'} )
	 oTree := ::aTree[nPos][ CLS_TREE ]
	 oTree:cargo[2] := nY
	 oTree:SetText( 'Height mm.: ' + ltrim(str(nY)) )

	 //  Paper Size
	 nPos := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__SIZE'} )
	 oTree := ::aTree[nPos][ CLS_TREE ]
	 oTree:cargo[2] := nPaperSize
	 oTree:SetText( 'Paper Size: ' + cPaper )

	 //  Orientation
	 nPos := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__ORIENTA'} )
	 oTree := ::aTree[nPos][ CLS_TREE ]
	 oTree:cargo[2] := lPortrait
	 oTree:SetText( 'Orientation: ' + IF( lPortrait, TXT_PORTRAIT, TXT_LANDSCAPE ) )

return NIL

//------------------------------------------------------------------------------
METHOD SelectForm() CLASS TRptInspect
local nPos   := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__FORM' } )

	 if nPos > 0
		 ::oTree:Select( ::aTree[ nPos ][ CLS_TREE ] )
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD SelectItem( oItem ) CLASS TRptInspect
local nPos   := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__ITEM' .AND. x[ CLS_KEY ] == oItem:nKey } )

	 if nPos > 0
		 ::oTree:Select( ::aTree[ nPos ][ CLS_TREE ] )
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD DeleteEMF() CLASS TRptInspect
local nPos   := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__EMF' } )
local nPosFillEnPare
local oTreeItem
local oPare

	 if nPos > 0
		 // Podria tener oTreeItem  :=  ::oTree:GetSelected(), pero de esta menra lo tengo todo ms atado
		 oTreeItem       :=  ::aTree[ nPos ][ CLS_TREE ]
		 oTreeItem:cargo :=  NIL
		 oPare           :=  oTreeItem:GetParent()
		 nPosFillenPare  := Ascan( oPare:aItems, {|o| o:hItem == oTreeItem:hItem } )

		 // Esta funcin borra la rama, pero NO elimina del array de barnque
		 //     del apre... No se por que

		 TVDeleteItem( ::oTree:hWnd, oTreeItem:hItem )
		 ADel ( ::aTree, nPos )
		 ASize( ::aTree, Len(::aTree) - 1 )

		 // Ahora tenemos que borrar la rama que hace referencia en el padre
		 ADel ( oPare:aItems, nPosFillEnPare )
		 ASize( oPare:aItems, Len(oPare:aItems)-1 )

		 ::oRpt:oForm:DeleteEmf()

	 endif

return NIL

//------------------------------------------------------------------------------
METHOD DeleteItem( oItem ) CLASS TRptInspect
local nPos   := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__ITEM' .AND. x[ CLS_KEY ] == oItem:nKey } )
local nPosFillEnPare
local oTreeItem
local oPare


	 if nPos > 0
		 // Podria tener oTreeItem  :=  ::oTree:GetSelected(), pero de esta menra lo tengo todo ms atado
		 oTreeItem       :=  ::aTree[ nPos ][ CLS_TREE ]
		 oTreeItem:cargo :=  NIL
		 oPare           :=  oTreeItem:GetParent()
		 nPosFillenPare  := Ascan( oPare:aItems, {|o| o:hItem == oTreeItem:hItem } )

		 // Esta funcin borra la rama, pero NO elimina del array de barnque
		 //     del apre... No se por que

		 TVDeleteItem( ::oTree:hWnd, oTreeItem:hItem )
		 ADel ( ::aTree, nPos )
		 ASize( ::aTree, Len(::aTree) - 1 )

		 // Ahora tenemos que borrar la rama que hace referencia en el padre
		 ADel ( oPare:aItems, nPosFillEnPare )
		 ASize( oPare:aItems, Len(oPare:aItems)-1 )

	 endif

return NIL

//------------------------------------------------------------------------------
METHOD IniSection( cSection, oItemSection ) CLASS TRptInspect
local nPosForm    := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__FORM'} )
local nPosSection
local oForm, oSection
local aData
local oTSection

	 DEFAULT cSection := ''

	 //  Si NO existe el FORMULARIO, algo pasa :-( ...
	 if nPosForm == 0
		 return NIL
	 endif

	 if Empty( cSection )
		 cSection := Space(10)

		 if !MsgSection( @cSection ) .OR. Empty( cSection )
			 return NIL
		 endif
	 endif

	 cSection    := Upper(Alltrim( cSection ))
	 oForm       := ::aTree[nPosForm][ CLS_TREE ]
	 nPosSection := Ascan( ::aTree, {|x| x[ CLS_TYPE  ] == '__SECTION' .AND. ;
													 x[ CLS_CARGO ] == cSection } )

	 //  Si NO existe la rama CTRL creamos una rama, sino la seleccionamos...
	 if nPosSection == 0

		 if ValType( oItemSection ) == 'O'
			 oTSection      := oItemSection
		 else
			 oTSection      := TSection():New( cSection )
		 endif

		 oSection       := oForm:Add( 'Section: ' + cSection, 5 )
		 oSection:cargo := { '__SECTION', cSection }

		 aData := { Date(), Time() }
		 Aadd( ::aTree, { '__SECTION', oSection, 0, oTSection, cSection } )

	 else
		 oSection := ::aTree[nPosSection][ CLS_TREE ]
	 endif

	 ::oTree:Select( oSection )

return oSection

//------------------------------------------------------------------------------
METHOD GetNameSection() CLASS TRptInspect
local cSection := ''
local oBranch  := ::oTree:GetSelected()
local oParent

	//  Si estamos encima de una rama de section
	if oBranch <> NIL .AND. oBranch:cargo[1] == '__SECTION'
		cSection := oBranch:cargo[2]
		return cSection
	endif

	// Si estamos colgando de una rama section
	if oBranch <> NIL .AND. oBranch:cargo[1] == '__ITEM'
		oParent := oBranch:GetParent()

		if oParent <> NIL .AND. oParent:cargo[1] == '__SECTION'
			cSection := oParent:cargo[2]
			return cSection
		endif
	endif

return cSection

//------------------------------------------------------------------------------
METHOD GetBranchSection( cSection ) CLASS TRptInspect
local nPosSection := Ascan( ::aTree, {|x| x[ CLS_TYPE  ] == '__SECTION' .AND. ;
															 x[ CLS_CARGO ] == cSection } )
local oBranch

	 if nPosSection > 0
		 oBranch := ::aTree[nPosSection][ CLS_TREE ]
	 endif

return oBranch

//------------------------------------------------------------------------------
METHOD TreeKey( nKey ) CLASS TRptInspect
local oBranch, oItem, cType, oObj

	 do case
		 case nKey == VK_DELETE
				oBranch  := ::oTree:GetSelected()
				cType    := oBranch:cargo[1]

				do case
					case cType == '__ITEM'
						  oItem := oBranch:cargo[2]
						  oItem:oObj:KeyDown( VK_DELETE )

					case cType == '__EMF'
						  if MsgYesNo( TXT_DEL_EMF, TXT_FWRPT )
							  ::DeleteEMF()
						  endif
				endcase
	 endcase

return NIL

//------------------------------------------------------------------------------
METHOD DeleteAll() CLASS TRptInspect

	 ::oTree:DeleteAll()
	 ::ResetList()
	 ::aTree   := {}
	 ::lActive := .f.
	 ::oBar:aEvalWhen()

return NIL

//------------------------------------------------------------------------------
METHOD GetItemsSection( cSection ) CLASS TRptInspect
local aItems := {}
local oItem
local nI

	 cSection := Upper( cSection )

	 for nI := 1 TO Len( ::aTree )
		  if ::aTree[nI][ CLS_TYPE ] == '__ITEM'
			  oItem := ::aTree[nI][ CLS_OBJ ]
			  if oItem:cSection == cSection
				  Aadd( aItems, oItem )
			  endif
		  endif
	 next nI

return aItems

//------------------------------------------------------------------------------
METHOD HeaderInSection( cSection ) CLASS TRptInspect
local lHeader := .t.
local oTSection
local nPosSection := Ascan( ::aTree, {|x| x[ CLS_TYPE  ] == '__SECTION' .AND. ;
															 x[ CLS_CARGO ] == cSection } )

	 if nPosSection > 0
		 oTSection := ::aTree[nPosSection][ CLS_OBJ ]
		 lHeader := oTSection:lHeader
	 endif

return lHeader

//------------------------------------------------------------------------------
METHOD FindItem( cId ) CLASS TRptInspect
local nPos
local oTreeItem

	 DEFAULT cId := Space(20)

	 if ! ::lActive
		 return NIL
	 endif

	 if Empty( cId )
		 if ! MsgGet( 'ID', 'Item', @cId ) .OR. Empty( cId )
			 return NIL
		 endif
	 endif

	 cId := Upper( Alltrim( cId ) )
	 nPos   := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__ITEM' .AND. Upper(Alltrim(x[ CLS_OBJ ]:cId) ) == cId } )

	 if nPos > 0
		 oTreeItem := ::aTree[nPos][ CLS_TREE ]
		 ::oTree:Select( oTreeItem )
	 else
		 MsgAlert( 'ID ' + cId + ', ' + TXT_NOT_FOUND, TXT_SYS )
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD FindForm() CLASS TRptInspect
local nPos      := Ascan( ::aTree, {|x| x[ CLS_TYPE ] == '__FORM' } )
local oTreeItem

	 if nPos > 0
		 oTreeItem := ::aTree[nPos][ CLS_TREE ]
		 ::oTree:Select( oTreeItem )
	 endif

return NIL

//------------------------------------------------------------------------------
static function GetFonts()
local hDC    := GetDC( 0 )
local aFonts := GetFontNames( hDC )

	 ReleaseDC( 0, hDC )

return ASort( aFonts )

// Por defecto TPublic ya inicializa valores, pero esta funcion esta preparada
// para cuando tengamos valores de usuario que los carge y los asigne
//------------------------------------------------------------------------------
static function LoadPublic()
local oTPublic := TPublic():New()

    oTPublic:nHeight   := 4
    oTPublic:nWidth    := 50
    oTPublic:cFaceName := 'Verdana'  // 'Andale Mono'

return oTPublic


// --- Enabled / Disabled Items -----------------------------------------
//------------------------------------------------------------------------------
static function MakeItemVisible( o )
local aTree   := o:aTree
local oDlg, oTree
local hOldRes := GetResources()

	 SetResources( o:oRpt:cDllFile )

	 o:oRpt:oForm:SetDots( .f. )

	 DEFINE DIALOG oDlg FROM 0, 0 TO 30,20 TITLE TXT_ITEM_VISIBLE
						oDlg:lHelpIcon := .f.

		  oTree = TTreeView():New( 0, 0, oDlg,,,,,1,1,,.t.)
		  oTree:OnClick := { |n,c| CheckBranca( n,c, oTree ) }

		  oDlg:oClient := oTree
			oDlg:bStart  := {|| InitChecks( oTree ) }

	 ACTIVATE DIALOG oDlg CENTERED ;
				 ON INIT ( DlgBar( oDlg, oTree )     ,;
							  oDlg:Resize()             ,;
							  BuildTree( oTree, aTree ) ,;
							  SetResources( hOldRes ) )

return NIL

//------------------------------------------------------------------------------
static function DlgBar( oDlg, oTree )
local oBar, oMa

	 DEFINE CURSOR oMa HAND

	 DEFINE BUTTONBAR oBar 3D SIZE 24, 26 OF oDlg
							oBar:bRClicked := {|| NIL }

	 DEFINE BUTTON OF oBar       NOBORDER NAME '16Exit'    ;
			  TOOLTIP TXT_EXIT                               ;
			  ACTION oDlg:End()

	 DEFINE BUTTON OF oBar GROUP NOBORDER NAME '16FldOff'    ;
			  ACTION oTree:CollapseAll( oTree ), oTree:SetFocus()

	 DEFINE BUTTON OF oBar       NOBORDER NAME '16FldOn'     ;
			  ACTION oTree:Expand(), oTree:SetFocus()

	 AEval( oBar:aControls, { | o | o:oCursor := oMa } )

return NIL

//------------------------------------------------------------------------------
static function BuildTree( oTree, aTree )
local nI, nJ
local ntotal := Len( aTree )
local oItem
local oSection, oPublic, oBranch
local cSection
local nPos

	 //  Chequeamos si existe algun ITEM PUBLICO
	 nPos := Ascan( aTree, {|a| a[ CLS_TYPE ] == '__ITEM' .AND. Empty(a[ CLS_OBJ ]:cSection)} )

	 if nPos > 0
		 oPublic := oTree:Add( 'Public' )

		 for nI := 1 to nTotal
			  if aTree[nI][ CLS_TYPE ] == '__ITEM' .AND. Empty( aTree[nI][ CLS_OBJ ]:cSection )
				  oBranch       := oPublic:Add( aTree[nI][ CLS_OBJ ]:cID )
				  oBranch:cargo := aTree[nI][ CLS_OBJ ]

				  if aTree[nI][ CLS_OBJ ]:lShow
					  oBranch:SetCheck( oBranch, .T. )
					  SysRefresh()
				  endif
			  endif
		 next nI

		 SysRefresh()
	 endif

	 //  Chequeamos todas las SECCIONES Posibles
	 for nI := 1 to nTotal
		  if aTree[nI][ CLS_TYPE ] == '__SECTION'
			  cSection := aTree[nI][ CLS_OBJ ]:cSection
			  oSection := oTree:Add( cSection )

			  for nJ := 1 TO nTotal

					if aTree[nJ][ CLS_TYPE ] == '__ITEM' .AND. aTree[nJ][ CLS_OBJ ]:cSection == cSection
						oBranch       := oSection:Add( aTree[nJ][ CLS_OBJ ]:cID )
						oBranch:cargo := aTree[nJ][ CLS_OBJ ]

						if aTree[nJ][ CLS_OBJ ]:lShow
							oTree:SetCheck( oBranch, .T. )
							SysRefresh()
						endif
					endif
			  next nJ
		  endif
	 next nI

	 SysRefresh()

return NIL

//------------------------------------------------------------------------------
static function CheckBranca( nLin, nCol, oTree )
local oBranch := oTree:HitTest( nLin, nCol )
local oItem
local nI
local lCheck

	 if oBranch == NIL
		 return NIL
	 endif

	 if Len( oBranch:aItems ) > 0
		 lCheck := oTree:GetCheck( oBranch )

		 for nI := 1 TO Len( oBranch:aItems )
			  oItem := oBranch:aItems[nI]:cargo

			  if lCheck
				  oTree:SetCheck( oBranch:aItems[nI], .T. )
				  oItem:oObj:Show()
				  oItem:lShow := .T.
			  else
				  oTree:SetCheck( oBranch:aItems[nI], .F. )
				  oItem:oObj:Hide()
				  oItem:lShow := .F.
			  endif

		  next nI

		else

		  oItem := oBranch:cargo

		  if oTree:GetCheck( oBranch )
			  oItem:oObj:Show()
			  oItem:lShow := .T.
		  else
			  oItem:oObj:Hide()
			  oItem:lShow := .F.
		  endif

	 endif

return NIL

//------------------------------------------------------------------------------
static function InitChecks( oTree )
local aItems  := oTree:aItems
local nI, nJ
local oBranch, oItem
local lShowAll

	 for nI = 1 to Len( aItems )
		  oBranch  := aItems[nI]
		  lShowAll := .t.

		  for nJ := 1 to len( oBranch:aItems )
				oItem := oBranch:aItems[nJ]:cargo

				if oItem:lShow
					oTree:SetCheck( oBranch:aItems[nj], oItem:lshow )
					SysRefresh()
				else
					lShowAll := .f.
				endif

		  next nJ

		  oTree:SetCheck( oBranch, lShowAll )

		  SysRefresh()

	 next nI

	 SysRefresh()

return NIL

//------------------------------------------------------------------------------
static function ValidId( oItem, aTree, uValue )
local nKey := oItem:nKey
local nPos

	 uValue := Upper( Alltrim( uValue ) )

	 nPos   := Ascan( aTree, {|a| a[ CLS_TYPE ] == '__ITEM' .and. ;
									  Upper( Alltrim( a[ CLS_OBJ ]:cId) ) == uValue .and. ;
									  a[ CLS_KEY ] <> nKey } )
	 if nPos > 0
		 MsgAlert( TXT_PROP_ID_EXIST + ' ' + uValue , TXT_FWRPT )
		 return .F.
	 endif

return .T.

//------------------------------------------------------------------------------
static function SelectImgHeader( oItem )
local cFile := cGetFile( '*.*' )

	 if File( cFile )
		 oItem:cImgFileHeader := cFile
	 endif

return NIL

//------------------------------------------------------------------------------
static function Special2txt( oItem )
local cTxt := ''

	 if oItem:lSpecial

		 do case
			 case oItem:nType == 10
					cTxt := TXT_MENU_PAGE_XX_OF_YY
			 case oItem:nType == 11
					cTxt := TXT_MENU_RUN_TIME
			 case oItem:nType == 12
					cTxt := TXT_MENU_RUN_DATE
			 case oItem:nType == 13
					cTxt := TXT_MENU_RUN_TIMESTAMP
			 case oItem:nType == 14
					cTxt := TXT_MENU_RUN_REPORT_NAME
			 case oItem:nType == 15
					cTxt := TXT_MENU_RUN_COMPUTER_NAME
			 case oItem:nType == 16
					cTxt := TXT_MENU_RUN_USER_NAME
		 endcase

	 endif

return cTxt

//------------------------------------------------------------------------------
//                            funciones rptproj
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
function Rpt_Project( oForm )
local o       := Array( 30 )
local v       := Array( 30 )
local lOk     := .f.
local cTitle  := IF( oForm:lActive, TXT_PROP_PRJ, TXT_NEW_PRJ )
local hOldRes := GetResources()
local aSize
local nPaperSize

	 SetResources( oForm:oRpt:cDirDll + '\' + oForm:oRpt:cDllFile )

	 o[ O_FORM        ] := oForm

	 v[ O_NAME        ] := PadR(oForm:cFormName       , 12 )
	 v[ O_DESCRIPTION ] := PadR(oForm:cFormDescription, 50 )
	 v[ O_AUTOR       ] := PadR(oForm:cFormAutor      , 30 )
	 v[ O_DATA        ] := oForm:dFormData
	 v[ O_DIRDAT      ] := oForm:cDirDat
	 v[ O_FORMAT_DATE ] := PadR(oForm:cFormatDate     , 10 )

	 v[ O_DEFINEPAPER ] := DefinePaper()
	 v[ O_PAPERTYPE   ] := PaperType()
	 v[ O_PORTRAIT    ] := IF( oForm:lPortrait, 1, 2 )
	 v[ O_ICO_PAPER   ] := IF( oForm:lPortrait, 'Portrait', 'Landscap' )
	 v[ O_PAPER       ] := PaperType( oForm:nPaperSize )
	 v[ O_PAPERSIZE   ] := PaperSize( oForm:nPaperSize )

	 v[ O_WIDTH       ] := v[ O_PAPERSIZE ][ 1 ]
	 v[ O_HEIGHT      ] := v[ O_PAPERSIZE ][ 2 ]

//	 DEFINE FONT o[ O_FONTDLG ]  NAME 'Verdana' SIZE 0, -12
//	 DEFINE FONT o[ O_FONTGET ]  NAME 'Verdana' SIZE 0, -12 BOLD

	 DEFINE DIALOG o[ O_DLG ] NAME 'Project' TITLE cTitle

						o[ O_DLG ]:lHelpIcon := .F.
						//o[ O_DLG ]:SetFont( o[ O_FONTDLG ] )

	  REDEFINE FOLDER o[ O_FOLDER ] ID 800 OF o[ O_DLG ]   ;
		  PROMPTS TXT_DLG_BASIC, TXT_DLG_PAPER, TXT_DLG_DAT ;
		  DIALOGS "Prj_Head", "Prj_Paper", "Prj_Dat"

		  REDEFINE GET  o[ O_NAME        ] VAR v[ O_NAME        ] ID 200 OF o[ O_FOLDER ]:aDialogs[1] VALID !empty( v[ O_NAME ] )//FONT o[ O_FONTGET ]
		  REDEFINE GET  o[ O_DESCRIPTION ] VAR v[ O_DESCRIPTION ] ID 210 OF o[ O_FOLDER ]:aDialogs[1] //FONT o[ O_FONTGET ]
		  REDEFINE GET  o[ O_AUTOR       ] VAR v[ O_AUTOR       ] ID 220 OF o[ O_FOLDER ]:aDialogs[1] //FONT o[ O_FONTGET ]
		  REDEFINE GET  o[ O_DATA        ] VAR v[ O_DATA        ] ID 230 OF o[ O_FOLDER ]:aDialogs[1] //FONT o[ O_FONTGET ]

		  REDEFINE COMBOBOX o[ O_PAPER ] VAR v[ O_PAPER ] ITEMS v[ O_PAPERTYPE ] ;
			  ID 600 OF o[ O_FOLDER ]:aDialogs[2] ;
			  ON CHANGE SelPaper( o, v )

		  REDEFINE GET   o[ O_WIDTH       ] VAR v[ O_WIDTH       ] ID 200 OF o[ O_FOLDER ]:aDialogs[2] PICTURE '999' WHEN o[ O_PAPER ]:nAt == 1  //FONT o[ O_FONTGET ]
		  REDEFINE GET   o[ O_HEIGHT      ] VAR v[ O_HEIGHT      ] ID 210 OF o[ O_FOLDER ]:aDialogs[2] PICTURE '999' WHEN o[ O_PAPER ]:nAt == 1  //FONT o[ O_FONTGET ]

		  REDEFINE ICON  o[ O_ICO_PAPER   ] NAME v[ O_ICO_PAPER ]  ID 700      OF o[ O_FOLDER ]:aDialogs[2]
							  o[ O_ICO_PAPER   ]:lTransparent := .t.

		  REDEFINE RADIO o[ O_PORTRAIT    ] VAR v[ O_PORTRAIT    ] ID 220, 221 OF o[ O_FOLDER ]:aDialogs[2] ;
			  ON CHANGE ChangeIco( o, v )

		  REDEFINE GET   o[ O_DIRDAT      ] VAR v[ O_DIRDAT      ] ID 200 OF o[ O_FOLDER ]:aDialogs[3] ;
					  ACTION SelectDir( o, v ) BITMAP '16FldOff'  //FONT o[ O_FONTGET ]

					  o[ O_DIRDAT ]:lReadOnly := .T.

		  REDEFINE GET  o[ O_FORMAT_DATE ] VAR v[ O_FORMAT_DATE ] ID 210 OF o[ O_FOLDER ]:aDialogs[3] PICTURE '@!'  //FONT o[ O_FONTGET ]

		REDEFINE BUTTON  ID 100 OF o[ O_DLG ] ACTION ( lOk := .t., o[ O_DLG ]:End() )

	 ACTIVATE DIALOG o[ O_DLG ] CENTERED ON INIT SetResources( hOldRes )

//	 o[ O_FONTDLG ]:End()
//	 o[ O_FONTGET ]:End()

	 if lOk
		 oForm:SetChange( .T. )
		 oForm:cFormName         := Alltrim( v[ O_NAME        ] )
		 oForm:cFormDescription  := Alltrim( v[ O_DESCRIPTION ] )
		 oForm:cFormAutor        := Alltrim( v[ O_AUTOR       ] )
		 oForm:cFormatDate       := Alltrim( v[ O_FORMAT_DATE ] )
		 oForm:dFormData         := v[ O_DATA        ]
		 oForm:lPortrait         := IF( v[ O_PORTRAIT ] == 1, .t., .f. )

		 nPaperSize              := v[ O_DEFINEPAPER ][ o[ O_PAPER ]:nAt ][ 1 ]

		 oForm:nMMWidth          := v[ O_WIDTH       ]
		 oForm:nMMHeight         := v[ O_HEIGHT      ]
		 oForm:nPaperSize        := nPaperSize

		 oForm:cDirDat           := Alltrim( v[ O_DIRDAT ] )

		 if oForm:lActive
			 oForm:Zoom( .t. )
			 oForm:oRpt:oInspect:SetTreePaperSize( v[ O_WIDTH ], v[ O_HEIGHT ], nPaperSize, oForm:lPortrait )
			 oForm:oRpt:oInspect:SetTreeForm     ( oForm:cFormName )
			 oForm:oRpt:SetMessage( oForm:cFormDescription )
			 oForm:oRpt:oInspect:SetListForm()
			 oForm:SetFormName( oForm:cFormName )
		 endif
	 endif

return lOk

//------------------------------------------------------------------------------
static function SelPaper( o, v )
local nAt          := o[ O_PAPER ]:nAt

	v[ O_WIDTH       ] := v[ O_DEFINEPAPER ][ nAt ][ 2 ]
	v[ O_HEIGHT      ] := v[ O_DEFINEPAPER ][ nAt ][ 3 ]

	o[ O_WIDTH       ]:Refresh()
	o[ O_HEIGHT      ]:Refresh()

   o[ O_FOLDER ]:aDialogs[2]:AEvalWhen()

return NIL

//------------------------------------------------------------------------------
static function SelectDir( o, v )
local cDir := cGetDir( 'Select Data Directory', v[ O_DIRDAT ] )

	 if !Empty( cDir )
		 v[ O_DIRDAT ] := cDir
		 o[ O_DIRDAT ]:Refresh()
	 endif

return NIL

//------------------------------------------------------------------------------
static function ChangeIco( o, v )
local hOldRes := GetResources()
	 LOCAL oForm   := o[ O_FORM ]

	 SetResources( oForm:oRpt:cDirDll + '\' + oForm:oRpt:cDllFile )

	 o[ O_ICO_PAPER  ]:Hide()

	 if v[ O_PORTRAIT   ] == 1
		 o[ O_ICO_PAPER  ]:SetName( 'Portrait' )
	 else
		 o[ O_ICO_PAPER  ]:SetName( 'Landscap' )
	 endif

	 o[ O_ICO_PAPER  ]:Show()
	 o[ O_ICO_PAPER  ]:Refresh()

	 SetResources( hOldRes )

return NIL

//------------------------------------------------------------------------------
//                            funciones de rptmsg
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function MsgSection( cSection )
local o       := Array( 20 )
local v       := Array( 20 )
local lOk     := .f.
local hOldRes := GetResources()

	 DEFAULT cSection := Space( 20 )

	 SetResources( oMyRpt:cDirDll + '\' + oMyRpt:cDllFile )

	 v[ O_SECTION     ] := cSection

//	 DEFINE FONT o[ O_FONTDLG2 ]  NAME 'Verdana' SIZE 0, -12
//	 DEFINE FONT o[ O_FONTGET2 ]  NAME 'Verdana' SIZE 0, -12 BOLD

	 DEFINE DIALOG o[ O_DLG ] NAME 'Section'

						o[ O_DLG ]:lHelpIcon := .F.
						//o[ O_DLG ]:SetFont( o[ O_FONTDLG2 ] )

	  REDEFINE ICON RESOURCE "section" ID 1 OF o[ O_DLG ]

	  REDEFINE GET  o[ O_SECTION  ] VAR v[ O_SECTION  ] ID 200 OF o[ O_DLG ] PICTURE '@!' FONT o[ O_FONTGET2 ]

	  REDEFINE BUTTON  ID 100 OF o[ O_DLG ] ACTION ( lOk := .f., o[ O_DLG ]:End() )
	  REDEFINE BUTTON  ID 110 OF o[ O_DLG ] ACTION ( lOk := .t., o[ O_DLG ]:End() )

	 ACTIVATE DIALOG o[ O_DLG ] CENTERED ON INIT SetResources( hOldRes )

//	 o[ O_FONTDLG2 ]:End()
//	 o[ O_FONTGET2 ]:End()

	 if lOk
		 cSection := Alltrim( v[ O_SECTION ] )
	 endif

return lOk

//------------------------------------------------------------------------------
function MsgGrid( nGrid )
local o       := Array( 20 )
local v       := Array( 20 )
local lOk     := .f.
local hOldRes := GetResources()

	 DEFAULT nGrid := 8

	 SetResources( oMyRpt:cDirDll + '\' + oMyRpt:cDllFile )

	 v[ O_GRID ] := nGrid

//	 DEFINE FONT o[ O_FONTDLG2 ]  NAME 'Verdana' SIZE 0, -12
//	 DEFINE FONT o[ O_FONTGET2 ]  NAME 'Verdana' SIZE 0, -12 BOLD

	 DEFINE DIALOG o[ O_DLG ] NAME 'Grid'

						o[ O_DLG ]:lHelpIcon := .F.
						//o[ O_DLG ]:SetFont( o[ O_FONTDLG2 ] )

	  REDEFINE ICON RESOURCE "grid" ID 1 OF o[ O_DLG ]

	  REDEFINE GET  o[ O_GRID  ] VAR v[ O_GRID  ] ID 200 OF o[ O_DLG ] PICTURE '99' //FONT o[ O_FONTGET2 ]

	  REDEFINE BUTTON  ID 100 OF o[ O_DLG ] ACTION ( lOk := .f., o[ O_DLG ]:End() )
	  REDEFINE BUTTON  ID 110 OF o[ O_DLG ] ACTION ( lOk := .t., o[ O_DLG ]:End() )

	 ACTIVATE DIALOG o[ O_DLG ] CENTERED ON INIT SetResources( hOldRes )

//	 o[ O_FONTDLG2 ]:End()
//	 o[ O_FONTGET2 ]:End()

	 if lOk
		 nGrid := v[ O_GRID ]
	 endif

return lOk

//------------------------------------------------------------------------------
function MsgZoom( nZoom )
local o       := Array( 20 )
local v       := Array( 20 )
local lOk     := .f.
local hOldRes := GetResources()

	 DEFAULT nZoom := 100

	 SetResources( oMyRpt:cDirDll + '\' + oMyRpt:cDllFile )

	 v[ O_GRID ] := nZoom

//	 DEFINE FONT o[ O_FONTDLG2 ]  NAME 'Verdana' SIZE 0, -12
//	 DEFINE FONT o[ O_FONTGET2 ]  NAME 'Verdana' SIZE 0, -12 BOLD

	 DEFINE DIALOG o[ O_DLG ] NAME 'Zoom'

						o[ O_DLG ]:lHelpIcon := .F.
//						o[ O_DLG ]:SetFont( o[ O_FONTDLG2 ] )

	  REDEFINE GET  o[ O_ZOOM  ] VAR v[ O_ZOOM  ] ID 200 OF o[ O_DLG ] PICTURE '999' //FONT o[ O_FONTGET2 ]

	  REDEFINE BUTTON  ID 100 OF o[ O_DLG ] ACTION ( lOk := .f., o[ O_DLG ]:End() )
	  REDEFINE BUTTON  ID 110 OF o[ O_DLG ] ACTION ( lOk := .t., o[ O_DLG ]:End() )

	 ACTIVATE DIALOG o[ O_DLG ] CENTERED ON INIT SetResources( hOldRes )

//	 o[ O_FONTDLG2 ]:End()
//	 o[ O_FONTGET2 ]:End()

	 if lOk
		 nZoom := v[ O_ZOOM ]
	 endif

return lOk

//------------------------------------------------------------------------------
//                              Class TRptAnimate
//------------------------------------------------------------------------------

CLASS TRptAnimate

	 DATA oDlg, oBmp, oPage, oTimer, oFont
	 DATA cDirDll, cDllFile
	 DATA cCaption
	 DATA cPrompt
	 DATA aTab
	 DATA nCount
	 DATA lActive           AS LOGICAL INIT .F.
	 DATA lEnd              AS LOGICAL INIT .F.

	 METHOD New( cCaption )  CONSTRUCTOR
	 METHOD Activate()
	 METHOD Animate()
	 METHOD SetMsg( cPrompt )      INLINE ( ::cPrompt := cPrompt,;
														 ::oPage:Refresh(),;
														 ::Animate() )

	 METHOD End()

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( cCaption ) CLASS TRptAnimate

	 DEFAULT cCaption := TXT_ANIM_TITLE

	 ::cDirDll   := diruta()
	 ::cDllFile  := IF( ! IsWin64(), "Rpt.dll", "Rpt64.dll" )
	 ::cCaption  := cCaption

return SELF

//------------------------------------------------------------------------------
METHOD Activate() CLASS TRptAnimate
local oWnd    := GetWndApp()
local cDll    := ::cDirDll + '\' + ::cDllFile
local hOldRes := GetResources()

	 SetResources( cDll )

	 ::cPrompt  := TXT_ANIM_MSG
	 ::nCount   := 1
	 ::lEnd     := .F.

	 ::aTab     := Array( 6 )
	 ::aTab[1]  := TBitmap():Define( "16Prn_1" )
	 ::aTab[2]  := TBitmap():Define( "16Prn_2" )
	 ::aTab[3]  := TBitmap():Define( "16Prn_3" )
	 ::aTab[4]  := TBitmap():Define( "16Prn_4" )
	 ::aTab[5]  := TBitmap():Define( "16Prn_5" )
	 ::aTab[6]  := TBitmap():Define( "16Prn_6" )

	 DEFINE FONT ::oFont NAME 'Arial' SIZE 0, -12

	 DEFINE DIALOG ::oDlg NAME "PrintAnimate" TITLE ::cCaption
		::oDlg:lHelpIcon := .F.

		REDEFINE BITMAP ::oBmp NAME "16Prn_1" ID 100 OF ::oDlg
		  ::oBmp:lTransparent := .t.
		REDEFINE SAY ::oPage PROMPT ::cPrompt ID 110 OF ::oDlg FONT ::oFont
		DEFINE TIMER ::oTimer INTERVAL 100  ACTION ::Animate()
		::oDlg:bStart := {|| ::oTimer:Activate(), ::lActive := .t. }
		::oDlg:bValid := {|| ::lEnd == .T. }

	 ACTIVATE DIALOG ::oDlg CENTER NOMODAL ON INIT SetResources( hOldRes )

	 SysRefresh()

return NIL

//------------------------------------------------------------------------------
METHOD End() CLASS TRptAnimate

	  ::lEnd    := .T.
	  ::lActive := .F.
	  ::oTimer:End()
	  ::oDlg:End()
	  ::oFont:End()

	  ::aTab[1]:End()
	  ::aTab[2]:End()
	  ::aTab[3]:End()
	  ::aTab[4]:End()
	  ::aTab[5]:End()
	  ::aTab[6]:End()

return .T.

//------------------------------------------------------------------------------
METHOD Animate() CLASS TRptAnimate

	 if !::lActive
		 return .F.
	 endif

	 ::nCount++
	 ::oTimer:Deactivate()

	 if ::nCount > 6
		 ::nCount := 1
	 endif

	 ::oBmp:hBitmap  := ::aTab[ ::nCount ]:hBitmap
	 ::oBmp:Refresh()

	 SysRefresh()

	 ::oTimer:Activate()

return  NIL

//------------------------------------------------------------------------------
//                          funciones de Miscelaneos
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function ChangeStyleWindow( hoWnd, naStyle, nStyleType, lAdd )
local aStyles:= {}, n, hWnd, nStyleReturn:= 0

	if ValType(hoWnd)$"O"
		hWnd:= hoWnd:hWnd
	else
		hWnd:= hoWnd
	endif

	if ValType(naStyle)$"N;A"
		if ValType(naStyle)$"N"
			 aStyles:= { naStyle }
		else
			 aStyles:= aClone( naStyle )
		endif
		aEval(aStyles, {|nStyle| nStyleReturn:= __ChangeStyleWindow( hWnd, nStyle, nStyleType, lAdd )  } )
	endif

return nStyleReturn

//------------------------------------------------------------------------------
static function __ChangeStyleWindow( hWnd, nStyle, nStyleType, lAdd )
local nOldStyle, lExistStyle
local nStyleReturn:= 0

	DEFAULT nStyleType := GWL_STYLE,;
			  lAdd := .T.

	if ValType(hWnd)$"N" .and. ValType(nStyle)$"N" .and. ValType(nStyleType)$"N" .and. ValType(lAdd)$"L"
		nOldStyle  := GetWindowLong( hWnd, nStyleType )
		lExistStyle:= lAnd( nStyle, nOldStyle )
		if lAdd .and. !lExistStyle
			SetWindowLong( hWnd, nStyleType, nOr( nOldStyle, nStyle ) )
		elseif !lAdd .and. lExistStyle
			SetWindowLong( hWnd, nStyleType, nAnd( nOldStyle, nNot(nStyle) ) )
		endif
		nStyleReturn:= GetWindowLong( hWnd, nStyleType )
	endif

return nStyleReturn

//------------------------------------------------------------------------------
function PaperType( nType )
local aSize     := {}
local aDef      := DefinePaper()
local nTotal    := Len( aDef )
local cPaper    := ''
local lGetPaper := ValType( nType ) == 'N'
local nPos, nI

  if lGetPaper
		nPos := Ascan( aDef, {|a| a[1] == nType} )

		if nPos > 0
			cPaper := aDef[ nPos ][4]
		endif

  else
		for nI := 1 To nTotal
			 Aadd( aSize, aDef[nI][4] )
		next nI
  endif

return IF( lGetPaper, cPaper, aSize )

//------------------------------------------------------------------------------
function PaperSize( nType )

local aDef      := DefinePaper()
local nPos

  DEFAULT nType := 0

  nPos      := Ascan( aDef, {|a| a[1] == nType } )

return if( nPos > 0, { aDef[nPos][2], aDef[nPos][3] }, {0,0} )

//------------------------------------------------------------------------------
function DefinePaper()
local aDef  := {}

//               Type  Width Height  Description
//               ----  ----- ------  -----------

	 Aadd( aDef, {  0 ,  100 ,  100 , "Defined User   " } ) // #define DMPAPER_USER                 0
	 Aadd( aDef, {  9 ,  202 ,  289 , "A4 210 x 297 mm" } ) // #define DMPAPER_A4                   9

return aDef

//------------------------------------------------------------------------------
//                            Class IItemProp
//------------------------------------------------------------------------------

CLASS TItemProp

	 DATA aProperty

	 METHOD SetValid( bValid )       INLINE ::aProperty[ 10 ] := bValid
	 METHOD SetPicture( cPicture )   INLINE ::aProperty[ 13 ] := cPicture
	 METHOD SetTable ( bTable  )     INLINE ::aProperty[  9 ] := bTable
	 METHOD SetAction( bAction )     INLINE ::aProperty[  9 ] := bAction
	 METHOD SetWhen  ( bWhen   )     INLINE ::aProperty[  8 ] := bWhen
	 METHOD SetUpdate()              INLINE ::aProperty[ 14 ] := {|| .t. }


	 METHOD New( aProperty )  CONSTRUCTOR

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( aProperty ) CLASS TItemProp

	 ::aProperty := aProperty

return SELF

//------------------------------------------------------------------------------
//                         class TListProp
//------------------------------------------------------------------------------

CLASS TListProp FROM TGridExtended

		CLASSDATA lRegistered AS LOGICAL

		DATA aGroups
		DATA aItems
		DATA hMinus
		DATA hPlus
		DATA nTipoSort
		DATA nGrupos
		DATA nItem
		DATA aRectBtn
		DATA oObject
		DATA oDlg
		DATA oGet
		DATA oSpinner
		DATA lModify
		DATA bModify
		DATA lActive          AS LOGICAL INIT .F.

		METHOD New( nRow, nCol, nWidth, nHeigth, bLine, aHeaders, ;
					aColSizes, oWnd, cField, uVal1, uVal2, bChange,;
					bLDblClick, bRClick, oFont, oCursor, nClrFore,;
					nForeBack, cMsg, lUpdate, cAlias, lPixel, bWhen,;
					lDesign, bValid, bLClick, aActions ) CONSTRUCTOR

		METHOD AddGroup( cGroup ) INLINE ::AddItem( Upper( cGroup ), cGroup,"",GRUPO,++::nGrupos), ::nGrupos
		METHOD AddItem( cVarName, cName, uVal, nTipo, nGroup, lAbierto, bEnable, bAction, bValid, nOption, xSETGET, cPicture, bUpdate )
		METHOD GetLine()
		METHOD nGetElement( n )
		METHOD CalcLen()
		METHOD Open( lOpen )
		METHOD OpenClose( nRow, nCol )
		METHOD Click( nRow, nCol )

		METHOD Teclas( nKey, nFlags )
		METHOD wBrwLine( hWnd, hDC, nRowPos, aValues, aColSizes,;
								  nColPos, nClrText, nClrPane,;
								  hFont, lTree, aJustify, nPressed, nLineStyle,;
								  nColAct, lFocused, oVScroll, bLogicLen, lBar )
		METHOD PaintBtn( hDC, aRect, nItem )
		METHOD Sort()
		METHOD OpenAll()
		METHOD CloseAll()
		METHOD EditCol( nCol, uVar, cPicture, bValid, nClrFore, nClrBack, aItems, bAction )
		METHOD GetAction( nItem )
		METHOD SetObject( oObject )
		METHOD aGetRectSel()
		METHOD Reset()
		METHOD ReSize( nSizeType, nWidth, nHeight )
		METHOD Validar( nItem )
		METHOD GoNextCtrl() VIRTUAL
		METHOD KeyDown( nKey, nFlags )
		METHOD PierdeFoco()
		METHOD LButtonDown( nRow, nCol, nKeyFlags )

//		METHOD SetModify( lModify )   INLINE ( ::lModify := lModify, Eval( ::bModify ) )
		METHOD SetModify( lModify )

		METHOD SetValue( cVarName, uValue )
		METHOD SetButtons( lOnOff )     INLINE ( ::lActive := lOnOff, ::oBar:aEvalWhen() )

ENDCLASS



//------------------------------------------------------------------------------
METHOD New( nRow, nCol, nWidth, nHeigth, bLine, aHeaders, ;
					aColSizes, oWnd, cField, uVal1, uVal2, bChange,;
					bLDblClick, bRClick, oFont, oCursor, nClrFore,;
					nForeBack, cMsg, lUpdate, cAlias, lPixel, bWhen,;
					lDesign, bValid, bLClick, aActions ) CLASS TListProp

local o := self
local oHand

	 lPixel := .t.

	 DEFAULT bValid   := {||.t.}

		 ::Super:New( nRow, nCol, nWidth, nHeigth, bLine, {"","",""}, ;
					aColSizes, oWnd, cField, uVal1, uVal2, bChange,;
					bLDblClick, bRClick, oFont, oCursor, nClrFore,;
					nForeBack, cMsg, lUpdate, cAlias, lPixel, bWhen,;
					lDesign, bValid, bLClick, aActions )

		 ::nItem     := 0
		 ::nGrupos   := 0
		 ::aItems    := {}
		 ::aHeaders  := {"","",""}
		 ::aColSizes := {20, 140, 120}
		 ::aJustify  := {.f., .f., .f.}
		 ::bLogicLen := {|| o:CalcLen() }
		 ::nAt := 0
		 ::bGoTop    = { || ::nAt := 1 }
		 ::bGoBottom = { || ::nAt := Eval( ::bLogicLen, Self ) }
		 ::bSkip     = { | nSkip, nOld | nOld := ::nAt, ::nAt += nSkip,;
						::nAt := Min( Max( ::nAt, 1 ), Eval( ::bLogicLen, Self ) ),;
						::nAt - nOld }
		 ::hMinus := LoadBitmap( GetResources(), "minus" )
		 ::hPlus  := LoadBitmap( GetResources(), "plus" )
		 ::bKeyDown := {|nKey, nFlags| o:Teclas( nKey, nFlags ) }
		 ::aGroups := {}

		 ::bLine := {|| o:GetLine() }
		 ::bLClicked := {|nRow,nCol| o:Click( nRow, nCol ) }
		 ::bLDblClick := {|nRow,nCol| o:Click( nRow, nCol ) }
		 ::nTipoSort := 1 // categorias
		 ::lModify := .f.       // CAF
		 ::bModify := {|| NIL }  // CAF

		 DEFINE CURSOR oHand HAND

		 DEFINE BUTTONBAR ::oBar OF SELF SIZE 26,27 _3D
								::oBar:bRClicked := {|| NIL }
								::oBar:bLClicked := {|| NIL }

		 DEFINE BUTTON OF ::oBar  NAME "btn1"        NOBORDER TOOLTIP TXT_TIP_CATEGORY  WHEN ::lActive   ACTION ( o:nTipoSort := 1,::Sort(), ::GoTop(),o:SetFocus(),o:Refresh())
		 DEFINE BUTTON OF ::oBar  NAME "btn2"        NOBORDER TOOLTIP TXT_TIP_SORT      WHEN ::lActive   ACTION ( o:nTipoSort := 2,::Sort(), ::GoTop(),o:SetFocus(),o:Refresh())
		 DEFINE BUTTON OF ::oBar  NAME "plus" GROUP  NOBORDER TOOLTIP TXT_TIP_EXPAND    WHEN ::lActive   ACTION ::OpenAll()
		 DEFINE BUTTON OF ::oBar  NAME "minus"       NOBORDER TOOLTIP TXT_TIP_CLOSE_ALL WHEN ::lActive   ACTION ::CloseAll()

		 AEval( ::oBar:aControls,  {|x| x:oCursor := oHand } )

		 ::aRectBtn := {}
		 ::bLostFocus := {|| ::PierdeFoco() }


return self

//------------------------------------------------------------------------------
METHOD SetModify( lModify ) CLASS TListProp
local oItem := oMyRpt:oForm:oLastFocus


  ::lModify := lModify
  Eval( ::bModify )

  Dbg( 'Item cambiado...' )
  oMyRpt:oForm:UpdCoorsItem ( oItem )
  oMyRpt:oForm:BackupItem()
  oMyRpt:oForm:CopyItem( oItem )
  oMyRpt:oForm:SetChange(.t., oItem )
//  oMyRpt:oForm:CheckSection ( oItem )
  oMyRpt:oForm:CheckGroup( oItem )

return
//------------------------------------------------------------------------------
METHOD PierdeFoco() CLASS TListProp
local hFocus := GetFocus()
return 0

//------------------------------------------------------------------------------
METHOD LButtonDown( nRow, nCol, nKeyFlags ) CLASS TListProp
return ::super:LButtonDown( nRow, nCol, nKeyFlags )

//------------------------------------------------------------------------------
METHOD KeyDown( nKey, nFlags ) CLASS TListProp
return ::super:KeyDown( nKey, nFlags )

//------------------------------------------------------------------------------
METHOD Sort() CLASS TListProp

	if ::nTipoSort == 1
		::aItems := ASORT(::aItems,,, { |x, y| x[7] < y[7] })
	else
		::aItems := ASORT(::aItems,,, { |x, y| x[3] < y[3] })
	endif

return nil

//------------------------------------------------------------------------------
METHOD SetValue( cVarName, uValue ) CLASS TListProp
local nPos

	 cVarName := Upper( cVarName )
	 nPos := Ascan( ::aItems , {|x| Upper(x[1]) == cVarName } )

	 if nPos > 0
		 ::aItems[nPos][4] := uValue
		 ::SetModify( .T. )
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD aGetRectSel() CLASS TListProp
local nTop, nLeft, nBottom, nRight
local aRect := GetClientRect(::hWnd)

	nTop    := (::nRowPos)*::nHLine
	nLeft   := ::aColSizes[1]+::aColsizes[2]
	nBottom := nTop + ::nHLine
	nRight  := aRect[4]

return {nTop, nLeft, nBottom, nRight}


//------------------------------------------------------------------------------
METHOD AddItem( cVarName, cName, uVal, nTipo, nGroup, lAbierto, bEnable, bAction, bValid, nOption, xSETGET, cPicture, bUpdate ) CLASS TListProp
local aProperty
local nPos

	DEFAULT lAbierto := .t.
	DEFAULT nTipo    := CARACTER
	DEFAULT nGroup   := 1
	DEFAULT bEnable  := {|| .t.} // CAF
	DEFAULT bAction  := .f.
	DEFAULT bValid   := {|| .t. }
	DEFAULT bUpdate  := {|| .f. } // CAF

	if valtype(uVal) == "L"
		nTipo := LOGICO
	endif

	::nItem += 5
	aProperty := { cVarName, nTipo, cName, uVal, nGroup, lAbierto, ::nItem, bEnable, bAction, bValid, nOption, xSETGET, cPicture, bUpdate }

	//  Si creamos un Item en que cVarName EXISTE, lo SUSTITUIMOS
	nPos := Ascan( ::aItems, {|x| x[1] == cVarName } )

	if nPos > 0
		::aItems[ nPos ] := aProperty
	else
		aadd( ::aItems, aProperty )
	endif

return TItemProp():New( aProperty )

//------------------------------------------------------------------------------
METHOD GetLine() CLASS TListProp
local aLine := {"",""}
local nItem := ::nGetElement( ::nAt )
local lGrupo
local uVal

	if nItem == 0
		return nil
	endif

	lGrupo := TIPO == GRUPO

	if lGrupo
		aLine := {if(ABIERTO,::hMinus,::hPlus), NOMBRE, cValToChar(VALOR) }
	else
		uVal  := VALOR
		if valtype( uVal ) == "N"
			uVal := str(uVal,10)
		endif
		if ValType( XPICTURE ) == 'C'              // CAF
			uVal  := Transform( VALOR, XPICTURE )   // CAF
		else                                     // CAF
			uVal  := cValToChar(VALOR)
		endif
		if uVal == ".T."
			uVal := TXT_YES
		else
			if uVal == ".F."
				uVal := TXT_NO
			endif
		endif
		aLine := {0, NOMBRE, uVal }
	endif

return aLine

//------------------------------------------------------------------------------
METHOD nGetElement( n ) CLASS TListProp
local nLenItems := len( ::aItems )
local nCount := 0
local lOpened := .t.
local nItem
local lGrupo

	if ::nTipoSort == 1 // grupos
		for nItem := 1 to nLenItems
			 if TIPO == GRUPO
				 nCount++
				 lOpened := ABIERTO
			 else
				 if lOpened
					 nCount++
				 endif
			 endif
			 if nCount == n
				 return nItem
			 endif
		 next nItem
	else // sin grupos
		for nItem := 1 to nLenItems
			 if TIPO != GRUPO
				 nCount++
			 endif
			 if nCount == n
				 return nItem
			 endif
		 next nItem
	endif

return 0

//------------------------------------------------------------------------------
METHOD CalcLen() CLASS TListProp
local nLen := len( ::aItems )
local nCount := 0
local nGroup := 0
local lOpened := .t.
local nItem

	if ::nTipoSort == 2
		nCount = nLen - ::nGrupos
	else
		for nItem := 1 to nLen
			 if TIPO == GRUPO
				 nCount++
				 lOpened := ABIERTO
			 else
				 if lOpened
					 nCount++
				 endif
			 endif
		next nItem
	endif

return nCount

//------------------------------------------------------------------------------
METHOD Open( lOpen ) CLASS TListProp
local nItem := ::nGetElement( ::nAt )

	DEFAULT lOpen := .t.

	if TIPO != GRUPO
		return nil
	endif

	ABIERTO := lOpen
	::Refresh()

return nil

//------------------------------------------------------------------------------
METHOD OpenClose( nRow, nCol ) CLASS TListProp
local nItem := ::nGetElement( ::nAt )
local lOpen := .t.

	if TIPO != GRUPO
		return nil
	endif

	if nCol != nil
		if nCol <= ::aColsizes[1]
			ABIERTO := !ABIERTO
			::Refresh()
		endif
	endif

return nil

//------------------------------------------------------------------------------
METHOD Click( nRow, nCol,lEditCol ) CLASS TListProp
local nItem := ::nGetElement( ::nAt ), nI
local aRect, oLbx, cVar, aItems, cAux
local oDlg, aPos,n, cPos
local oFont
local cType := "A"
local uVar
local hDC
local lGrupo := TIPO == GRUPO
local bValid := {||.t.}
local nMax := 0
local uOldVar


	if nitem = 3   //no se pueden cambiar los ID de los marcados fijos
		for nI = 1 to len(oMyRpt:aFixed)
			 if VALOR = oMyRpt:aFixed[nI]
				 MsgAlert(TXT_FIXED_ITEM,TXT_ATENTION)
				 return .t.
			 endif
		next n
	endif

	DEFAULT lEditCol := .f.

	SetFocus(::hWnd)

	if  (::oGet     != nil .and. IsWindowVisible( ::oGet:hWnd   ))   .or.;
		 (::oSpinner != nil .and. IsWindowVisible( ::oSpinner:hWnd ))
	endif


	if Eval( ENABLE )  // CAF
		if lGrupo .and. nCol <= ::aColsizes[1]
			ABIERTO := !ABIERTO
			::Refresh()
			return nil
		endif

		if !empty( ::aRectBtn )
			ReleaseCapture()

			if PtInRect( nRow, nCol, ::aRectBtn ) .or. nRow < 0 .OR. TIPO == LISTA

				do case
					case TIPO == LOGICO
						  if Eval( BVALIDAR, !VALOR )  // CAF
							  VALOR     := !VALOR
							  ::SetModify( .T. )   // CAF
							  ::DrawSelect()

							  if !empty( ::oObject )
								  if !empty( CVARNAME )
									  if valtype( ::oObject ) == "O"
										  OSend( ::oObject, "_" + alltrim( CVARNAME ), VALOR )
										  OSend( ::oObject, "Refresh")
									  else
										  ASend( ::oObject, "_" + alltrim( CVARNAME ), VALOR )
										  ASend( ::oObject, "Refresh")
									  endif
								  endif
							  endif

							  if Eval( ACTUALIZA )
								  ::Refresh()
							  endif
						  endif

					case TIPO == LISTA
						  aRect := ::aGetRectSel()

						  if BACTION != NIL
							  //Si lo quiero ordenado, se lo paso ya ordenado pues...
							  // aItems := asort(eval( BACTION ))

							  aItems := Eval( BACTION )

							  if !empty( OPTION )
								  cVar := aItems[ OPTION ]
							  else
								  cVar   := VALOR
							  endif

						  endif

						  dbg( cVar )

						  uOldVar := cVar

						  if ::oGet != nil
								::oGet:Hide()
						  endif
						  if ::oSpinner != nil
							  ::oSpinner:Hide()
						  endif

						  if !empty( aItems )
							  xSetItem( cVar )
							  MENU oMenuIP POPUP
							  for n := 1 to len( aItems )
									cAux := "{|oMenuItem| xSetItem('"+ALLTRIM(aItems[n])+"')}"
									MenuAddItem (aItems[n],, .f.,, &(cAux) ,,,,,,, .F. )
									if cVar == aItems[n]
										cPos := str(n-1)
									endif
							  next n
							  ENDMENU

							  if !empty( cPos )
								  SetMenuDefaultItem( oMenuIP:hMenu, val(cPos))
							  endif

							  ACTIVATE POPUP oMenuIP AT aRect[3], aRect[2] OF Self
							  oMenuIP := nil
						  endif

						  cVar := xGetItem()

						  if !empty(cVar ) .and. uOldVar != cVar
							  if Eval( BVALIDAR, cVar )  // CAF
								  ::SetModify( .T. )   // CAF

								  if XSETGET != nil
									  if valtype( ::oObject ) == "O"
										  oSend( ::oObject,"_" + XSETGET, cVar )
									  else
										  ASend( ::oObject,"_" + XSETGET, cVar )
									  endif
								  else
									  if valtype( ::oObject ) == "O"
										  oSend( ::oObject,"_" + CVARNAME, cVar )
									  else
										  aSend( ::oObject,"_" + CVARNAME, cVar )
									  endif
								 endif
								 VALOR     := cVar
								 if valtype( ::oObject ) == "O"
									 ::oObject:Refresh()
								 else
									 asend(::oObject,"Refresh" )
								 endif

								 ::Refresh()

							 endif
						  endif

					case TIPO == ACCION
						  uVar := eval( BACTION, VALOR )

						  if uVar != VALOR
							  if Eval( BVALIDAR, uVar )  // CAF
								  VALOR := uVar

								  if valtype( ::oObject ) == "O"
									  oSend( ::oObject,"_" + CVARNAME, VALOR )
									  oSend( ::oObject,"Refresh" )
								  else
									  aSend( ::oObject,"_" + CVARNAME, VALOR )
									  aSend( ::oObject,"Refresh" )
								  endif

								  ::SetModify( .T. )

								  if Eval( ACTUALIZA )
									  ::Refresh()
								  endif
							  endif
						  endif

						  ::Refresh()
						  return VALOR

				endcase
			endif
		else

			if (nCol > ::aColSizes[1]+::aColSizes[2] .OR. lEditCol ) .and. !lGrupo
				::EditCol( VALOR, nItem, XPICTURE )
			endif
		endif

	endif

return .t.

//------------------------------------------------------------------------------
function xSetItem( uVal )

	uVarItemIP := uVal

return uVarItemIP

//------------------------------------------------------------------------------
function xGetItem()
return uVarItemIP

//------------------------------------------------------------------------------
METHOD EditCol( uVar, nItem2, cPicture, bValid, nClrFore, nClrBack, aItems, bAction ) CLASS TListProp
local oFont
local uTemp
local aPos
local cType
local nWidth, nHeight
local nTop, nLeft, nBottom, nRight
local nItem := ::nGetElement( ::nAt )
local o := Self
local aRect

	uTemp   := uVar
	nTop    := (::nRowPos)*::nHLine+2
	nLeft   := ::aColSizes[1]+::aColsizes[2]+1
	nBottom := nTop + ::nHLine-5
	nRight  := nLeft + ::aColSizes[3]
	aRect   := ::aGetRectSel()
	nTop    := aRect[1]+2
	nLeft   := aRect[2]
	nBottom := aRect[3]-2
	nRight  := aRect[4]


	cType   := ValType( uVar )
	if cType == "C"
		uVar := padr(uVar,100)
	endif

	DEFAULT bValid   := nil

	if ::oFont != nil
		oFont = TFont():New( ::oFont:cFaceName, ::oFont:nInpWidth,::oFont:nInpHeight, .f., ::oFont:lBold )
	endif

	if ::oGet     != nil; ::oGet:Hide();     endif
	if ::oSpinner != nil; ::oSpinner:Hide(); endif

	if TIPO == SPINNER

		if ::oSpinner <> nil  // CAF                                                                                     //
			::oSpinner:End()   // CAF
			::oSpinner := NIL  // CAF
		endif                 // CAF

		if ::oSpinner == nil                                                                                      //
			::oSpinner := TGet2():New(nTop + 1,nLeft + 1,{ | u | If(PCount()==0,uVar,uVar:= u ) },Self,nRight-nLeft-20,nBottom-nTop, cPicture,       ,::nClrText,::nClrPane,oFont,     .F.,        ,    .T.,    ,     .F.,      ,     .F.,    .F.,         ,       .F.,       .F.,       .T.,,      .t.,{||::oSpinner++, ::Refresh()}, {||::oSpinner--, ::Refresh()}, {||0}, {||3600} )
			::oSpinner:bLostFocus := {|| ::oSpinner:Hide() }
		endif

		::oSpinner:SetFocus()

	else

		// La version anterior Craemos y ocultamos el oGet, pero si cambiamos los
		// picture da problemas. Total si existe, lo cierro, creo uno nuevo y listo...

		 if ::oGet <> nil   // CAF
			 ::oGet:End()    // CAF
			 ::oGet := NIL   // CAF
		 endif              // CAF

		 ::oGet := TGet2():New( nTop + 1, nLeft + 1, { | u | If( PCount()==0, uVar, uVar:= u ) }, Self, nRight-nLeft, nBottom-nTop, cPicture,, ::nClrText, ::nClrPane, oFont, .F.,, .T.,, .F.,, .F., .F.,, .F., .F., .T., )
		 ::oGet:bLostFocus := {|| ::oGet:Hide() }

		 ::oGet:SetFocus()

	endif


return uVar

//------------------------------------------------------------------------------
METHOD GetAction( nItem ) CLASS TListProp
return nil

//------------------------------------------------------------------------------
METHOD Teclas( nKey, nFlags ) CLASS TListProp
local nItem := ::nGetElement(::nAt)
local lGrupo := TIPO == GRUPO
local uVal
local oGet

	do case
		case nKey == VK_SPACE

			  if lGrupo
				  ABIERTO := !ABIERTO
				  ::Refresh()
			  else
				  if TIPO == LISTA
					  ::Click(-1)
				  else
					  if TIPO == LOGICO
						  ::Click( -1 )
						  ::DrawSelect()
					  endif
				  endif
			  endif

		case nKey == VK_F4

			  if TIPO == LISTA
				  ::Click(-1)
			  endif

		case nKey == VK_RETURN

			 if TIPO == LISTA
				 ::Click(-1)
			 else

				 if TIPO == SPINNER
					 oGet := ::oSpinner
				 else
					 oGet := ::oGet
				 endif

				 if oGet != nil
					 if IsWindowVisible( oGet:hWnd )
						 oGet:Assign()

						 if Eval( BVALIDAR, oGet:oGet:VarGet() )
							 oGet:VarPut( oGet:oGet:VarGet())
							 uVal := oGet:VarGet()
							 if valtype( uVal ) == "C"
								 if !empty( trim( uVal ) )
									 uVal := trim( uVal )
								 endif
							 endif
							 if valtype( ::oObject ) == "O"
								 oSend( ::oObject,"_" + CVARNAME, uVal ) //valorize( ::oGet:VarGet, CVARNAME ))
							 else
								 ASend( ::oObject,"_" + CVARNAME, uVal ) //valorize( ::oGet:VarGet, CVARNAME ))
							 endif

							 if !( VALOR == uVal )
								  ::SetModify( .T. )
							 endif

							 VALOR := uVal

							 if Eval( ACTUALIZA )
								 ::Refresh()
							 endif

							 if ::oGet != nil
								 ::oGet:Refresh()
							 endif
							 if ::oSpinner != nil
								 ::oSpinner:Refresh()
							 endif
							 oGet:Hide()
							 SetFocus(::hWnd)

						 endif

					 else
						 ::Click(-1,-1,.t.)
					 endif
				 else
					 ::Click(-1,-1,.t.)
				 endif
			 endif

		case lGrupo .and. nKey == VK_SUBTRACT

			  if ABIERTO
				  ABIERTO := .f.
				  ::Refresh()
			  endif

		case lGrupo .and. nKey == VK_ADD
			  if !ABIERTO
				  ABIERTO := .t.
				  ::Refresh()
			  endif

		case nKey == VK_ESCAPE

			  if ::oGet     != nil
				  ::oGet:Hide()
			  endif
			  if ::oSpinner != nil
				  ::oSpinner:Hide()
			  endif

	endcase

return nil

//------------------------------------------------------------------------------
METHOD wBrwLine( hWnd, hDC, nRowPos, aValues, aColSizes,;
								  nColPos, nClrText, nClrPane,;
								  hFont, lTree, aJustify, nPressed, nLineStyle,;
								  nColAct, lFocused, oVScroll, bLogicLen, lBar ) CLASS TListProp

local nItem, aRect
local lGrupo := .f.
local lHDC := .f.

	DEFAULT lBar := .f.

	::super:wBrwLine( hWnd, hDC, nRowPos, aValues, aColSizes,;
								  nColPos, nClrText, nClrPane,;
								  hFont, lTree, aJustify, nPressed, nLineStyle,;
								  nColAct, lFocused, oVScroll, bLogicLen, lBar )


	if lBar
		nItem := ::nGetElement( ::nAt )

		if ! Eval( ENABLE )
			return nil
		endif

		aRect := GetClientRect( ::hWnd )

		if ::hDC == nil
			::hDC := ::GetDC()
			lHDC := .t.
		endif

		aRect[1] := (nRowPos)*::nHLine
		aRect[3] := aRect[1]+::nHLine
		aRect[4] := aRect[4]-1

		::PaintBtn( ::hDC, aRect, nItem )

		if lHDC
			::ReleaseDC()
		endif

	endif

return nil

//------------------------------------------------------------------------------
METHOD PaintBtn( hDC, aRect, nItem ) CLASS TListProp
local nTipo := TIPO
local hBmp
local nMedH := (aRect[3]-aRect[1]) / 2
local nMedW := (aRect[4]-aRect[2]) / 2
local nTop  := aRect[1] + nMedH
local nLeft := aRect[4] - 20

	aRect[2] := aRect[4]-( aRect[3]-aRect[1])
	do case
		case nTipo == LOGICO
			  aRect[1] := nTop  - 6
			  aRect[2] := nLeft - 6
			  aRect[3] := nTop  + 7
			  aRect[4] := nLeft + 7

			  DrawFrameControl( hDC, aRect, 4, if(VALOR,1024,0)  )//+16384
			  ::aRectBtn := aRect

		case nTipo == LISTA
			  aRect[1]+=1
			  aRect[2]+=1
			  aRect[3]-=1
			  aRect[4]-=1
			  aRect[2] := aRect[4]-18

			  hBmp := LoadBitmap( , OBM_COMBO )
			  DrawFrameControl( hDC, aRect, 4, 16 ) //+16384
			  DrawMasked( hDC, hBmp, nTop -5, aRect[2]+3 )
			  //aRect[1]+5, aRect[2]+5 )
			  DeleteObject( hBmp )
			  ::aRectBtn := aRect

		case TIPO == ACCION
			  DrawFrameControl( hDC, aRect, 4, 16 )//+16384
			  SetBkMode( hDC, 1 )
			  TextOut( hDC, aRect[1]+2, aRect[2]+5, "...")
			  ::aRectBtn := aRect

	otherwise
			  ::aRectBtn := {}
	endcase

return nil

//------------------------------------------------------------------------------
METHOD OpenAll() CLASS TListProp
local nItem

	for nItem := 1 to len( ::aItems )
		 if TIPO == GRUPO
			 ABIERTO := .t.
		 endif
	next nItem

	::GoTop()
	::Refresh()

return nil
//------------------------------------------------------------------------------
METHOD CloseAll() CLASS TListProp
local nItem

	for nItem := 1 to len( ::aItems )
		 if TIPO == GRUPO
			 ABIERTO := .f.
		 endif
	next nItem

	::GoTop()
	::Refresh()

return nil

//------------------------------------------------------------------------------
METHOD Validar( nItem ) CLASS TListProp
local uVal

	DEFAULT nItem := ::nAt


	if ::oGet != nil
		if nItem <= len( ::aItems ) .and. !empty( CVARNAME )
			uVal := ::oGet:VarGet()

			if valtype( ::oObject ) == "O"
				oSend( ::oObject,"_" + CVARNAME, uVal ) //valorize( ::oGet:VarGet, CVARNAME ))
			else
				ASend( ::oObject,"_" + CVARNAME, uVal ) //valorize( ::oGet:VarGet, CVARNAME ))
			endif
			VALOR := uVal
		endif

		if BVALIDAR != nil
			eval( BVALIDAR, VALOR )
		endif

		dbg(  ' oReport():Refresh()' )

	endif

return .t.

//------------------------------------------------------------------------------
METHOD Reset( ) CLASS TListProp
local n, nItem, nLen

	asize(::aItems, 0 )
	asize(::aGroups, 0 )
	::aItems  := {}
	::aGroups := {}
	::nAt     := 0
	::nItem   := 0
	::nGrupos := 0
	::lModify := .F.   // CAF

	::GoTop()

return nil

//------------------------------------------------------------------------------
METHOD SetObject( oObject ) CLASS TListProp
local n, nItem, nLen

	 asize(::aItems, 0 )
	 asize(::aGroups, 0 )
	 ::nItem := 0
	 ::nGrupos := 0

	 ::oObject := oObject

	 nLen := len( oObject:aProperties )
	 nItem := 1
	 aadd( ::aItems, array(8) )
	 TIPO     := GRUPO
	 NOMBRE   := oObject:ClassName()
	 VALOR    := ""
	 NUMGRUPO :=  ++::nGrupos
	 ABIERTO  := .T.
	 NUMITEM  := ( ::nItem += 5 )
	 ENABLE   := {|| .T. } // CAF
	 BACTION  := {||.T.}

	 for n := 1 to nLen
		  nItem := n+1
		 aadd( ::aItems, array(8) )
		 TIPO     := valtype( OSend( oObject, oObject:aProperties[n] ) )
		 NOMBRE   := oObject:aProperties[n]
		 VALOR    := OSend( oObject, oObject:aProperties[n] )
		 NUMGRUPO := ::nGrupos
		 ABIERTO  := .T.
		 NUMITEM  := ( ::nItem += 5 )
		 ENABLE   := {|| .T. } // CAF
		 BACTION  := {||.T.}
	next n

	::GoTop()
	::Refresh()

return nil

//------------------------------------------------------------------------------
METHOD ReSize( nSizeType, nWidth, nHeight ) CLASS TListProp
local aC := GetClientRect( ::hWnd )
local nWC := aC[4]-aC[2]
local nW := ::aColSizes[1]+::aColSizes[2]

	::aColSizes[3] := nWC - nW

return ::Super:ReSize( nSizeType, nWidth, nHeight )

//------------------------------------------------------------------------------
//                           class TGridExtended
//------------------------------------------------------------------------------

CLASS TGridExtended FROM TControl

	DATA   cAlias, cField, uValue1, uValue2
	DATA   bLine, bSkip, bGoTop, bGoBottom, bLogicLen, bChange
	DATA   nRowPos, nColPos, nLen, nAt, nColAct
	DATA   nMaxFilter      // Maximum number of records to count
								  // on indexed filters
	DATA   lHitTop, lHitBottom, lCaptured, lMChange
	DATA   lAutoEdit, lAutoSkip
	DATA   lCellStyle AS LOGICAL INIT .f.
	DATA   aHeaders, aColSizes
	DATA   nClrBackHead, nClrForeHead
	DATA   nClrBackFocus, nClrForeFocus
	DATA   aJustify, aActions
	DATA   oGet
	DATA   nLineStyle
	DATA   lIconView, aIcons, bIconDraw, bIconText
	DATA   nIconPos, nVScrollPos
	DATA   nHLine

	CLASSDATA lRegistered AS LOGICAL

	METHOD New( nRow, nCol, nWidth, nHeigth, bLine, aHeaders, ;
					aColSizes, oWnd, cField, uVal1, uVal2, bChange,;
					bLDblClick, bRClick, oFont, oCursor, nClrFore,;
					nForeBack, cMsg, lUpdate, cAlias, lPixel, bWhen,;
					lDesign, bValid, bLClick, aActions ) CONSTRUCTOR

	METHOD ReDefine( nId, bLine, oDlg, aHeaders, aColSizes, cField, uVal1,;
						  uVal2, bChange, bLDblClick, bRClick, oFont,;
						  oCursor, nClrFore, nClrBack, cMsg, lUpdate,;
						  cAlias, bWhen, bValid, bLClick, aActions ) CONSTRUCTOR

	METHOD nAtCol( nCol )
	METHOD nAtIcon( nRow, nCol )
	METHOD LDblClick( nRow, nCol, nKeyFlags )
	METHOD Default()
	METHOD Display()
	METHOD DrawIcons()
	METHOD DrawLine( nRow ) INLINE ;
					::wBrwLine( ::hWnd, ::hDC, If( nRow == nil, ::nRowPos, nRow ), ;
					Eval( ::bLine, Self ), ::GetColSizes(), ::nColPos,;
					::nClrText, ::nClrPane,;
					If( ::oFont != nil, ::oFont:hFont, 0 ),;
					ValType( ::aColSizes ) == "B", ::aJustify, nil, ::nLineStyle,,, ::oVScroll,;
					::bLogicLen  )

	METHOD DrawSelect()
	METHOD EraseBkGnd( hDC ) INLINE 1
	METHOD GetColSizes() INLINE ;
			 If( ValType( ::aColSizes ) == "A", ::aColSizes, Eval( ::aColSizes, Self ) )

	METHOD GetDlgCode( nLastKey )
	METHOD GoUp()
	METHOD GoDown()
	METHOD GoLeft()
	METHOD GoRight()
	METHOD GoTop()
	METHOD GoBottom()

	METHOD GotFocus() INLINE ::Super:GotFocus(),;
						If( ::nLen > 0 .and. ! Empty( ::cAlias ) .and. ;
							 ! ::lIconView, ::DrawSelect(),)

	METHOD HScroll( nWParam, nLParam )

	MESSAGE DrawIcon METHOD _DrawIcon( nIcon, lFocused )

	METHOD Initiate( hDlg ) INLINE ::Super:Initiate( hDlg ), ::Default()
	METHOD IsColVisible( nCol )
	METHOD KeyDown( nKey, nFlags )
//	METHOD KeyChar( nKey, nFlags )
	METHOD LButtonDown( nRow, nCol, nKeyFlags )
	METHOD LButtonUp( nRow, nCol, nKeyFlags )


	METHOD LostFocus( hCtlFocus ) INLINE ::Super:LostFocus( hCtlFocus ),;
						 If( ::nLen > 0 .and. ! Empty( ::cAlias ) .and. ;
						 ! ::lIconView, ::DrawSelect(),)

	METHOD MouseMove( nRow, nCol, nKeyFlags )
	METHOD MouseWheel( nKeys, nDelta, nXPos, nYPos )
	METHOD PageUp( nLines )
	METHOD PageDown( nLines )
	METHOD Paint()

	METHOD ReSize( nSizeType, nWidth, nHeight )
	METHOD nRowCount() INLINE aClientIP := GetClientRect(::hWnd), int( ( aClientIP[3]-aClientIP[1]) / ::nHLine )-1
	METHOD SetArray( aArray )
	METHOD SetCols( aData, aHeaders, aColSizes )
	METHOD ShowSizes()
	METHOD Skip( n )
	METHOD VertLine( nColPos, nColInit )
	METHOD VScroll( nWParam, nLParam )

	METHOD VSetPos( nPos ) INLINE ::nVScrollPos := nPos,;
											::oVScroll:SetPos( iif( ::nLen <= VSCROLL_MAXVALUE,;
																			nPos,;
																			Int( nPos * VSCROLL_MAXVALUE / ::nLen ) ) )

	METHOD VThumbPos( nPos ) INLINE ::nVScrollPos := ::VGetThumbPos( nPos ),;
											  ::oVScroll:SetPos( nPos )

	METHOD VGetPos()       INLINE ::nVScrollPos

	METHOD VSetRange()     INLINE ::nVScrollPos := 1,;
											::oVScroll:SetRange( Min( 1, ::nLen ), Min( VSCROLL_MAXVALUE, ::nLen ) )

	METHOD VGetMax()       INLINE ::oVScroll:nMax * iif( ::nLen <= VSCROLL_MAXVALUE,;
																		  1,;
																		  ::nLen / VSCROLL_MAXVALUE )

	METHOD VGoDown()       INLINE ::VSetPos( ::nVScrollPos + 1 )
	METHOD VGoUp()         INLINE ::VSetPos( ::nVScrollPos - 1 )

	METHOD VGetThumbPos( nPos ) INLINE iif( ::nLen <= VSCROLL_MAXVALUE,;
														 nPos,;
														 Int( nPos * ::nLen / VSCROLL_MAXVALUE ) )

	METHOD VGoBottom() INLINE ::VSetPos( ::nLen )

	METHOD VGoTop() INLINE ::VSetPos( 1 )

	METHOD wBrwLine( hWnd, hDC, nRowPos, aValues, aColSizes,;
								  nColPos, nClrText, nClrPane,;
								  hFont, lTree, aJustify, nPressed, nLineStyle,;
								  nColAct, lFocused, oVScroll, bLogicLen, lBar )

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( nRow, nCol, nWidth, nHeigth, bLine, aHeaders, aColSizes, oWnd,;
				cField, uVal1, uVal2, bChange, bLDblClick, bRClick,;
				oFont, oCursor, nClrFore, nClrBack, cMsg, lUpdate, cAlias,;
				lPixel, bWhen, lDesign, bValid, bLClick, aActions ) CLASS TGridExtended

#ifdef __XPP__
	#undef New
#endif

	DEFAULT nRow := 0, nCol := 0, nHeigth := 100, nWidth := 100,;
			  oWnd := GetWndDefault(), oFont := oWnd:oFont, nClrFore := CLR_BLACK,;
			  nClrBack := GetSysColor( COLOR_WINDOW ),;
			  lUpdate  := .f., cAlias := Alias(), lPixel := .f.,;
			  lDesign  := .f., bValid := {||.t.}

	#ifdef __XPP__
		DEFAULT cAlias := ""
	#endif
	::aProperties := {"nTop","nLeft","nBottom","nRight","nClrPane","nClrText","nColPos","nId","lAutoEdit","nHLine","lCellStyle","cAlias"}
	::cCaption   = ""
	::nTop       = nRow * If( lPixel, 1, BRSE_CHARPIX_H ) // 14
	::nLeft      = nCol * If( lPixel, 1, BRSE_CHARPIX_W )  //8
	::nBottom    = ::nTop + nHeigth - 1
	::nRight     = ::nLeft + nWidth - 1
	::oWnd       = oWnd
	::lHitTop    = .f.
	::lHitBottom = .f.
	::lFocused   = .f.
	::lCaptured  = .f.
	::lMChange   = .t.
	::nRowPos    = 1
	::nColPos    = 1
	::nColAct    = 1

	::nStyle     = nOr( WS_CHILD, WS_VSCROLL, ;
							  WS_VISIBLE, WS_TABSTOP,;
							  If( lDesign, WS_CLIPSIBLINGS, 0 ) )  // WS_HSCROLL, WS_BORDER


	::nId        = ::GetNewId()
	::cAlias     = cAlias
	::bLine      = bLine
	::lAutoEdit  = .f.
	::lAutoSkip  = .f.
	::lIconView  = .f.
	::lCellStyle = .f.
	::nIconPos   = 0
	::nHLine     := 26  // 23 CAF
	::bLogiclen  = { || 0 }  // CAF

	::aHeaders   = aHeaders
	::aColSizes  = aColSizes
	::nLen       = 0
	::lDrag      = lDesign
	::lCaptured  = .f.
	::lMChange   = .t.
	::bChange    = bChange
	::bLClicked  = bLClick
	::bLDblClick = bLDblClick
	::bRClicked  = bRClick

	::oCursor    = oCursor

	//::nLineStyle    := LINES_3D
	::nLineStyle    := CLR_BACKGROUND // rgb(173,197,229) //LINES_GRAY
	::nClrBackHead  := GetSysColor( COLOR_BTNFACE )
	::nClrForeHead  := GetSysColor( COLOR_BTNTEXT )
	::nClrBackFocus := GetSysColor( COLOR_HIGHLIGHT )
	::nClrForeFocus := CLR_WHITE

	::cMsg          = cMsg
	::lUpdate       = lUpdate
	::bWhen         = bWhen
	::bValid        = bValid
	::aActions      = aActions
	::nVScrollPos   = 0

	::SetColor( nClrFore, nClrBack )

	#ifdef __XPP__
		DEFAULT ::lRegistered := .f.
	#endif

	::Register( nOr( CS_VREDRAW, CS_HREDRAW, CS_DBLCLKS ) )

	if ! Empty( oWnd:hWnd )
		::Create()
		if oFont != nil
			::SetFont( oFont )
		endif
		::Default()
		::lVisible = .t.
		oWnd:AddControl( Self )
	else
		::oFont := oFont
		oWnd:DefControl( Self )
		::lVisible = .f.
	endif

	if lDesign
		::CheckDots()
	endif

return Self

//------------------------------------------------------------------------------
METHOD ReDefine( nId, bLine, oDlg, aHeaders, aColSizes, cField, uVal1, uVal2,;
					  bChange, bLDblClick, bRClick, oFont, oCursor,;
					  nClrFore, nClrBack, cMsg, lUpdate, cAlias,;
					  bWhen, bValid, bLClick, aActions ) CLASS TGridExtended

	DEFAULT oDlg := GetWndDefault(), nClrFore := CLR_BLACK,;
			  nClrBack := GetSysColor( COLOR_WINDOW ), lUpdate := .f., cAlias := Alias()

	::lHitTop    = .f.
	::lHitBottom = .f.
	::lFocused   = .f.
	::nId        = nId
	::nRowPos    = 1
	::nColPos    = 1
	::nColAct    = 1
	::cAlias     = cAlias
	::oWnd       = oDlg
	::aHeaders   = aHeaders
	::aColSizes  = aColSizes
	::nClrPane   = CLR_LIGHTGRAY
	::nClrText   = CLR_WHITE
	::nLen       = 0
	::lDrag      = .f.
	::lCaptured  = .f.
	::lVisible   = .f.
	::lCaptured  = .f.
	::lMChange   = .t.

	::bLine      = bLine
	::bChange    = bChange
	::bLClicked  = bLClick
	::bLDblClick = bLDblClick
	::bRClicked  = bRClick

	::oCursor    = oCursor
	::oFont      = oFont

	::nLineStyle    := LINES_GRAY
	::nClrBackHead  := GetSysColor( COLOR_BTNFACE )
	::nClrForeHead  := CLR_BLACK
	::nClrBackFocus := GetSysColor( COLOR_HIGHLIGHT )
	::nClrForeFocus := CLR_WHITE

	::cMsg          = cMsg
	::lUpdate       = lUpdate
	::bWhen         = bWhen
	::bValid        = bValid
	::aActions      = aActions
	::lAutoEdit     = .f.
	::lAutoSkip     = .f.
	::lIconView     = .f.
	::lCellStyle    = .f.
	::nIconPos      = 0
	::nVScrollPos   = 0
	::bLogiclen     = { || 0 }

	::SetColor( nClrFore, nClrBack )

	::Register( nOr( CS_VREDRAW, CS_HREDRAW, CS_DBLCLKS ) )

	oDlg:DefControl( Self )

return Self

//------------------------------------------------------------------------------
METHOD DrawSelect() CLASS TGridExtended

	if ::lCellStyle
		::DrawLine()
		::wBrwLine( ::hWnd, ::hDC, ::nRowPos, Eval( ::bLine, Self ),;
					 ::GetColSizes(), ::nColPos, ::nClrForeFocus,;
					 If( ::lFocused, ::nClrBackFocus, CLR_GRAY ),;
					 If( ::oFont != nil, ::oFont:hFont, 0 ),;
					 ValType( ::aColSizes ) == "B", ::aJustify,, ::nLineStyle,;
					 ::nColAct, ::lFocused, ::oVScroll, ::bLogicLen )
	else
		::wBrwLine( ::hWnd, ::hDC, ::nRowPos, Eval( ::bLine, Self ),;
					 ::GetColSizes(), ::nColPos, ::nClrForeFocus,;
					 If( ::lFocused, ::nClrBackFocus, CLR_GRAY ),;
					 If( ::oFont != nil, ::oFont:hFont, 0 ),;
					 ValType( ::aColSizes ) == "B", ::aJustify,, ::nLineStyle, nil,;
					 ::lFocused, ::oVScroll, ::bLogicLen, .t. )
	endif

return nil

//------------------------------------------------------------------------------
METHOD DrawIcons() CLASS TGridExtended
local nWidth := ::nWidth(), nHeight := ::nHeight()
local nRow := 10, nCol := 10
local n := 1, nIcons := Int( nWidth / 50 ) * Int( nHeight / 50 )
local hIcon := ExtractIcon( "user.exe", 0 )
local oFont, cText

	DEFINE FONT oFont NAME GetSysFont() SIZE 0, -8 UNDERLINE

	SelectObject( ::hDC, oFont:hFont )
	SetBkColor( ::hDC, CLR_BLUE )
	SetTextColor( ::hDC, CLR_WHITE )

	while n <= nIcons .and. ! ( ::cAlias )->( EoF() )
		if ::bIconDraw != nil .and. ::aIcons != nil
			hIcon = ::aIcons[ Eval( ::bIconDraw, Self ) ]
		endif
		DrawIcon( ::hDC, nRow, nCol, hIcon )
		if ::bIconText != nil
			cText = cValToChar( Eval( ::bIconText, Self ) )
		else
			cText = Str( ( ::cAlias )->( RecNo() ) )
		endif
		DrawText( ::hDC, cText, { nRow + 35, nCol - 5, nRow + 48, nCol + 40 },;
					 1 )
		nCol += 50
		if nCol >= nWidth - 32
			nRow += 50
			nCol  = 10
		endif
		( ::cAlias )->( DbSkip() )
		n++
	end
	( ::cAlias )->( DbSkip( 1 - n ) )

	oFont:End()

return nil

//------------------------------------------------------------------------------
METHOD ReSize( nSizeType, nWidth, nHeight ) CLASS TGridExtended
local aC := GetClientRect( ::hWnd )
local nWC := aC[4]-aC[2]
local nW := ::aColSizes[1]+::aColSizes[2]

	::nRowPos = Min( ::nRowPos, Max( ::nRowCount(), 1 ) )
	::aColSizes[3] := nWC - nW

return ::Super:ReSize( nSizeType, nWidth, nHeight )

//------------------------------------------------------------------------------
METHOD SetArray( aArray ) CLASS TGridExtended

	::nAt       = 1
	::cAlias    = "ARRAY"
	::bLogicLen = { || ::nLen := Len( aArray ) }
	::bGoTop    = { || ::nAt := 1 }
	::bGoBottom = { || ::nAt := Eval( ::bLogicLen, Self ) }
	::bSkip     = { | nSkip, nOld | nOld := ::nAt, ::nAt += nSkip,;
						::nAt := Min( Max( ::nAt, 1 ), Eval( ::bLogicLen, Self ) ),;
						::nAt - nOld }
return nil

//------------------------------------------------------------------------------
METHOD Paint() CLASS TGridExtended
local n := 1, nSkipped := 1, nLines
local aInfo := ::DispBegin()

	FillRect( ::hDC, GetClientRect( ::hWnd ), ::oBrush:hBrush )

	if ::lIconView
		::DrawIcons()
		return 0
	endif

	if ::nRowPos == 1 .and. ! Empty( ::cAlias ) .and. ;
		Upper( ::cAlias ) != "ARRAY"
		if ! ( ::cAlias )->( EoF() )
			( ::cAlias )->( DbSkip( -1 ) )
			if ! ( ::cAlias )->( BoF() )
				( ::cAlias )->( DbSkip() )
			endif
		endif
	endif

	::wBrwLine( ::hWnd, ::hDC, 0, ::aHeaders, ::GetColSizes(),;
					::nColPos, ::nClrForeHead, ::nClrBackHead,;
					If( ::oFont != nil, ::oFont:hFont, 0 ),.f.,;
						::aJustify, nil, ::nLineStyle,,, ::oVScroll, ::bLogicLen )

	if ( ::nLen := Eval( ::bLogicLen, Self ) ) > 0
		::Skip( 1 - ::nRowPos )

		#ifndef __CLIPPER__
			nLines = ::nRowCount()
			while n <= nLines .and. nSkipped == 1
				::DrawLine( n )
				nSkipped = ::Skip( 1 )
				if nSkipped == 1
					n++
				endif
			end
			::Skip( ::nRowPos - n )
		#else
			 // WBrwPane() returns the n of visible rows
			 // WBrwPane recieves at aColSizes the Array or a Block
			 // to get dinamically the Sizes !!!
			::Skip( ::nRowPos - wBrwPane( ::hWnd, ::hDC, Self, ::bLine,;
				  ::aColSizes, ::nColPos, ::nClrText, ::nClrPane,;
				  If( ::oFont != nil, ::oFont:hFont, 0 ), ::aJustify, ::nLineStyle ) )
		#endif

		if ::nLen < ::nRowPos
			::nRowPos = ::nLen
		endif

		::DrawSelect()
	endif

	if ! Empty( ::cAlias ) .and. Upper( ::cAlias ) != "ARRAY"
		::lHitTop    = ( ::cAlias )->( BoF() )
		::lHitBottom = ( ::cAlias )->( EoF() )
	endif

	::DispEnd( aInfo )

return 0

//------------------------------------------------------------------------------
METHOD GoUp() CLASS TGridExtended
local nLines := ::nRowCount()

	if ( ::nLen := Eval( ::bLogicLen, Self ) ) < 1
		return nil
	endif

	if ! ::lHitTop
		::DrawLine()
		if ::Skip( -1 ) == -1
			::lHitBottom = .f.
			if ::nRowPos > 1
				::nRowPos--
			else
				WBrwScroll( ::hWnd, -1, If( ::oFont != nil, ::oFont:hFont, 0 ), ::nHLine )
			endif
		else
			::lHitTop = .t.
		endif
		::DrawSelect()
		if ::oVScroll != nil
			::VGoUp()
		endif
		if ::bChange != nil
			Eval( ::bChange, Self )
		endif
	endif

return nil

//------------------------------------------------------------------------------
METHOD GoDown() CLASS TGridExtended
local nLines := ::nRowCount()

	if ( ::nLen := Eval( ::bLogicLen, Self ) ) < 1
		return nil
	endif

	if ! ::lHitBottom
		::DrawLine()
		if ::Skip( 1 ) == 1
			::lHitTop = .f.
			if ::nRowPos < nLines
				::nRowPos++
			else
				WBrwScroll( ::hWnd, 1, If( ::oFont != nil, ::oFont:hFont, 0 ), ::nHLine )
			endif
		else
			::lHitBottom = .t.
		endif
		::DrawSelect()
		if ::oVScroll != nil
			::VGoDown()
		endif
		if ::bChange != nil
			Eval( ::bChange, Self )
		endif
	endif

return nil

//------------------------------------------------------------------------------
METHOD GoLeft()  CLASS TGridExtended

	if ::nColAct > 1
		if ::lCellStyle .and. ::IsColVisible( ::nColAct-1 )
			::nColAct--
			::DrawSelect()
		else
			::nColPos--
			::nColAct--
			::Refresh()
		endif
		if ::oHScroll != nil
			::oHScroll:GoUp()
		endif
	endif

return nil

//------------------------------------------------------------------------------
METHOD GoRight() CLASS TGridExtended
local lColVisible

	if ::nColAct < Len( ::GetColSizes() )
		lColVisible = ::IsColVisible( ::nColAct + 1 )
		::nColAct++
		do while ! ::IsColVisible( ::nColAct ) .and. ::nColPos < ::nColAct
			::nColPos++
		enddo
		if ! ::lCellStyle
			::nColPos := ::nColAct
			::Refresh()
		else
			if lColVisible
				::DrawSelect()
			else
				::Refresh()
			endif
		endif
		if ::oHScroll != nil
			::oHScroll:GoDown()
		endif
	endif

return nil

//------------------------------------------------------------------------------
METHOD GoTop() CLASS TGridExtended

	if ( ::nLen := Eval( ::bLogicLen, Self ) ) < 1
		return nil
	endif

	if ! ::lHitTop
		Eval( ::bGoTop, Self )
		::lHitTop = .t.
		::lHitBottom = .f.
		::nRowPos = 1
		::Refresh( .f. )
		if ::oVScroll != nil
			::VGoTop()
		endif
		if ::bChange != nil
			Eval( ::bChange, Self )
		endif
	endif

return nil

//------------------------------------------------------------------------------
METHOD GoBottom() CLASS TGridExtended
local nSkipped
local nLines := ::nRowCount()
local n

	if ( ::nLen := Eval( ::bLogicLen, Self ) ) < 1
		return nil
	endif

	if ! ::lHitBottom
		::lHitBottom = .t.
		::lHitTop    = .f.

		Eval( ::bGoBottom, Self )

		nSkipped = ::Skip( -( nLines - 1 ) )
		::nRowPos = 1 - nSkipped

		::GetDC()
		for n = 1 to -nSkipped
			 ::DrawLine( n )
			 ::Skip( 1 )
		next n
		::DrawSelect()
		::ReleaseDC()
		if ::oVScroll != nil
			::nLen = Eval( ::bLogicLen, Self )
			if ::VGetMax() != ::nLen
				::VSetRange()
			endif
			::VGoBottom()
		endif
		if ::bChange != nil
			Eval( ::bChange, Self )
		endif
	endif

return nil

//------------------------------------------------------------------------------
METHOD LDblClick( nRow, nCol, nKeyFlags ) CLASS TGridExtended
local nClickRow := nWRow( ::hWnd, ::hDC, nRow,;
									  If( ::oFont != nil, ::oFont:hFont, 0 ), ::nHLine )
local nBrwCol

	if nClickRow == ::nRowPos .and. ::nLen > 0
		nBrwCol = ::nAtCol( nCol )
		if ::lAutoEdit
			::Edit( nBrwCol )
		else
			return ::Super:LDblClick( nRow, nCol, nKeyFlags )
		endif
	endif

return nil

//------------------------------------------------------------------------------
static function nWRow( hWnd, hDC, nRow, oFont, nHLine )
local aRect := GetClientRect( hWnd )

	nRow := int( nRow/nHLine)

return nRow

//------------------------------------------------------------------------------
METHOD LButtonDown( nRow, nCol, nKeyFlags ) CLASS TGridExtended
local nClickRow, nSkipped
local nColPos := 0, nColInit := ::nColPos - 1
local nAtCol

	SetFocus(::hWnd)

	if ::oGet != nil
		::oGet:Hide()
	endif

	if ::lDrag
		return ::Super:LButtonDown( nRow, nCol, nKeyFlags )
	endif

	nClickRow = nWRow( ::hWnd, ::hDC, nRow, If( ::oFont != nil, ::oFont:hFont, 0 ),::nHline )

	if ::nLen < 1 .and. nClickRow != 0
		return nil
	endif

	if ::lMChange .and. AScan( ::GetColSizes(),;
				 { | nColumn | nColPos += nColumn,;
									nColInit++,;
									nCol >= nColPos - 1 .and. ;
									nCol <= nColPos + 1 }, ::nColPos ) != 0
		if ! ::lCaptured
			::lCaptured = .t.
			::Capture()
			::VertLine( nColPos, nColInit )
		endif
		return nil
	endif

	::SetFocus()

	if nClickRow == 0 .and. Valtype(nKeyFlags) == "N"
		if ::aActions != nil .and. ;
			( nAtCol := ::nAtCol( nCol ) ) <= Len( ::aActions )
				if ::aActions[ nAtCol ] != nil
					::wBrwLine( ::hWnd, ::GetDC(), 0, ::aHeaders, ::GetColSizes(),;
								 ::nColPos, ::nClrForeHead, ::nClrBackHead,;
								 If( ::oFont != nil, ::oFont:hFont, 0 ),.f.,;
								 ::aJustify, nAtCol, ::nLineStyle,,, ::oVScroll, ::bLogicLen )
					::ReleaseDC()
					Eval( ::aActions[ nAtCol ], Self, nRow, nCol )
					::wBrwLine( ::hWnd, ::GetDC(), 0, ::aHeaders, ::GetColSizes(),;
								 ::nColPos, ::nClrForeHead, ::nClrBackHead,;
								 If( ::oFont != nil, ::oFont:hFont, 0 ),.f.,;
								 ::aJustify,, ::nLineStyle,,, ::oVScroll, ::bLogicLen )
					::ReleaseDC()
				else
					MsgBeep()
				endif
		else
			MsgBeep()
		endif
	endif

	if nClickRow > 0 .and. nClickRow != ::nRowPos .and. ;
		nClickRow < ::nRowCount() + 1
		::DrawLine()
		nSkipped  = ::Skip( nClickRow - ::nRowPos )
		::nRowPos += nSkipped
		if ::oVScroll != nil
			::VSetPos( ::VGetPos() + nSkipped )
		endif
		if ::lCellStyle
			  ::nColAct := ::nAtCol( nCol )
			  if ::oHScroll != nil
				  ::oHScroll:SetPos(::nColAct)
			  endif
		endif
		::DrawSelect()
		::lHitTop = .f.
		::lHitBottom = .f.
		if ::bChange != nil
			Eval( ::bChange, Self )
		endif
	else
		if ::lCellStyle
			  ::nColAct := ::nAtCol( nCol )
			  if ::oHScroll != nil
				  ::oHScroll:SetPos(::nColAct)
			  endif
			  ::Refresh(.f.)
		endif
	endif

	::Super:LButtonDown( nRow, nCol, nKeyFlags )

return 0

//------------------------------------------------------------------------------
METHOD LButtonUp( nRow, nCol, nFlags ) CLASS TGridExtended
local aC := GetClientRect( ::hWnd )
local nWC := aC[4]-aC[2]
local nW := ::aColSizes[1]+::aColSizes[2]

	if ::lDrag
		return ::Super:LButtonUp( nRow, nCol, nFlags )
	endif

	if ::lCaptured
		::lCaptured = .f.
		ReleaseCapture()
		::aColSizes[3] := nWC - nW
		::VertLine()
		::Refresh()
	endif

	::Super:LButtonUp( nRow, nCol, nFlags )

return nil

//------------------------------------------------------------------------------
METHOD Default() CLASS TGridExtended
local n, aFields
local cAlias := Alias()
local nElements, nTotal := 0

	DEFAULT ::aHeaders := {}, ::aColSizes := {}

	if ::bLine == nil
		if Empty( ::cAlias )
			::cAlias = cAlias
		else
			cAlias = ::cAlias
		endif
		::bLine  = {|| {} }
		if ::aJustify == nil
			::aJustify = Array( nElements := Len( Eval( ::bLine, Self ) ) )
			for n = 1 to nElements
				 ::aJustify[ n ] = ( ValType( ( cAlias )->( FieldGet( n ) ) ) == "N" )
			next n
		endif
	endif

	DEFAULT nElements := Len( Eval( ::bLine, Self ) )

	if Len( ::aHeaders ) < nElements
		if ::Cargo == nil
			::aHeaders = Array( nElements )
			for n = 1 to nElements
				 ::aHeaders[ n ] = ( cAlias )->( FieldName( n ) )
			next n
		else
			::aHeaders = { "" }
		endif
	endif

	if Len( ::GetColSizes() ) < nElements
		::aColSizes = Afill(Array( nElements ), 0 )
		aFields = Eval( ::bLine, Self )
		for n = 1 to nElements
			 ::aColSizes[ n ] := If( ValType( aFields[ n ] ) != "C",;
											  15,; // Bitmap handle
											  GetTextWidth( 0, Replicate( "B", ;
											  Max( Len( ::aHeaders[ n ] ), ;
													 Len( aFields[ n ] ) ) + 1 ),;
											  If( ! Empty( ::oFont ), ::oFont:hFont,) ) )
		next n
	endif

	if lAnd( GetWindowLong( ::hWnd, GWL_STYLE ), WS_VSCROLL ) .or. ;
		GetClassName( ::hWnd ) == "ListBox"
		DEFINE SCROLLBAR ::oVScroll VERTICAL OF Self
		::nLen := Eval( ::bLogicLen, Self )
		::oVScroll:SetPage( Min( ::nRowCount(), ::nLen - 1 ) )
		::VSetRange()
	endif

	if lAnd( GetWindowLong( ::hWnd, GWL_STYLE ), WS_HSCROLL )
		if ::Cargo == nil // it is not a tree
			DEFINE SCROLLBAR ::oHScroll HORIZONTAL OF Self ;
				RANGE 1, Len( ::GetColSizes() )
			AEval( ::GetColSizes(), { | nSize | nTotal += nSize } )
			::oHScroll:SetPage( nTotal / ::nWidth() )
		endif
	endif

	if ::uValue1 != nil
		Eval( ::bGoTop, Self )
	endif
	if ::bChange != nil
		Eval( ::bChange, Self )
	endif

return nil

//------------------------------------------------------------------------------
METHOD KeyDown( nKey, nFlags ) CLASS TGridExtended

	do case
		case nKey == VK_UP
			  ::GoUp()

		case nKey == VK_DOWN
			  ::GoDown()

		case nKey == VK_LEFT
			  ::GoLeft()

		case nKey == VK_RIGHT
			  ::GoRight()

		case nKey == VK_HOME
			  ::GoTop()

		case nKey == VK_END
			  ::GoBottom()

		case nKey == VK_PRIOR
			  if GetKeyState( VK_CONTROL )
				  ::GoTop()
			  else
				  ::PageUp()
			  endif

		case nKey == VK_NEXT
			  if GetKeyState( VK_CONTROL )
				  ::GoBottom()
			  else
				  ::PageDown()
			  endif

		otherwise
			  return ::Super:KeyDown( nKey, nFlags )
	endcase

return 0

/*
//------------------------------------------------------------------------------
METHOD KeyChar( nKey, nFlags ) CLASS TGridExtended

return ::Super:KeyChar( nKey, nFlags )
ALERT('kEY: ' + STR(nkey) )

	do case
		case nKey == K_PGUP
			  ::oVScroll:PageUp()

		case nKey == K_PGDN
			  ::oVScroll:PageDown()

		otherwise
			  return ::Super:KeyChar( nKey, nFlags )
	endcase

return 0
*/
//------------------------------------------------------------------------------
METHOD PageUp( nLines ) CLASS TGridExtended
local nSkipped

	DEFAULT nLines := ::nRowCount()

	nSkipped = ::Skip( -nLines )

	if ( ::nLen := Eval( ::bLogicLen, Self ) ) < 1
		return nil
	endif

	if ! ::lHitTop
		if nSkipped == 0
			::lHitTop = .t.
		else
			::lHitBottom = .f.
			if -nSkipped < nLines
				::nRowPos = 1
				if ::oVScroll != nil
					::VSetPos( 1 )
				endif
			else

				nSkipped = ::Skip( -nLines )
				::Skip( -nSkipped )

				if ::oVScroll != nil
					::VSetPos( ::VGetPos() + nSkipped )
				endif

			endif
			::Refresh( .f. )
			if ::bChange != nil
				Eval( ::bChange, Self )
			endif

		endif

	else
		if ::oVScroll != nil
			::VGoTop()
		endif
	endif

return nil

//------------------------------------------------------------------------------
METHOD PageDown( nLines ) CLASS TGridExtended
local nSkipped, n

	DEFAULT nLines := ::nRowCount()

	if ( ::nLen := Eval( ::bLogicLen, Self ) ) < 1
		return nil
	endif

	if ! ::lHitBottom
		::DrawLine()
		nSkipped = ::Skip( ( nLines * 2 ) - ::nRowPos )

		if nSkipped != 0
			::lHitTop = .f.
		endif

		do case
			case nSkipped == 0 .or. nSkipped < nLines
				  if nLines - ::nRowPos < nSkipped
					  ::GetDC()
					  ::Skip( -( nLines ) )
					  for n = 1 to ( nLines - 1 )
							::Skip( 1 )
							::DrawLine( n )
					  next n
					  ::ReleaseDC()
					  ::Skip( 1 )
				  endif
				  ::nRowPos = Min( ::nRowPos + nSkipped, nLines )
				  ::lHitBottom = .t.
				  if ::oVScroll != nil
					  ::VGoBottom()
				  endif

			otherwise
				  ::GetDC()
				  for n = nLines to 1 step -1
						::DrawLine( n )
						::Skip( -1 )
				  next n
				  ::ReleaseDC()
				  ::Skip( ::nRowPos )
		endcase
		::DrawSelect()
		if ::bChange != nil
			Eval( ::bChange, Self )
		endif

		if ::oVScroll != nil
			if ! ::lHitBottom
				::VSetPos( ::VGetPos() + nSkipped - ( nLines - ::nRowPos ) )
			else
				::VGoBottom()
			endif
		endif
	endif

return nil

//------------------------------------------------------------------------------
METHOD VScroll( nWParam, nLParam ) CLASS TGridExtended
local nLines := ::nRowCount()
local nLen

	#ifdef __CLIPPER__
		local nScrHandle  := nHiWord( nLParam )
		local nScrollCode := nWParam
		local nPos        := nLoWord( nLParam )
	#else
		local nScrHandle  := nLParam
		local nScrollCode := nLoWord( nWParam )
		local nPos        := nHiWord( nWParam )
	#endif

	if GetFocus() != ::hWnd
		SetFocus( ::hWnd )
	endif

	if nScrHandle == 0                   // Window ScrollBar
		if ::oVScroll != nil
						do case
						case nScrollCode == SB_LINEUP
								  ::GoUp()

						case nScrollCode == SB_LINEDOWN
								  ::GoDown()

						case nScrollCode == SB_PAGEUP
								  ::PageUp()

						case nScrollCode == SB_PAGEDOWN
								  ::PageDown()

						case nScrollCode == SB_TOP
								  ::GoTop()

						case nScrollCode == SB_BOTTOM
								  ::GoBottom()

						case nScrollCode == SB_THUMBPOSITION
					if ( ::nLen := Eval( ::bLogicLen, Self ) ) < 1
								  return 0
								  endif

					if nPos <= 1
								  ::GoTop()
								  elseif nPos == ::oVScroll:GetRange()[ 2 ]
								  ::GoBottom()
								  else
								  CursorWait()
						::Skip( ::VGetThumbPos( nPos ) - ::VGetPos() )
								  ::lHitTop = .f.
								  ::lHitBottom = .f.
								  CursorArrow()
								  endif
					::VThumbPos( nPos )

					nLen = Eval( ::bLogicLen, Self )
								  if nPos - ::oVScroll:nMin < nLines
								  ::nRowPos = 1
								  endif
								  if ::oVScroll:nMax - nPos < Min( nLines, nLen )
								  ::nRowPos = Min( nLines, nLen ) - ( ::oVScroll:nMax - nPos )
								  endif
								  ::Refresh( .f. )
								  if ::bChange != nil
								  Eval( ::bChange, Self )
								  endif

						otherwise
								  return nil
								  endcase
								  endif
						endif

return 0

//------------------------------------------------------------------------------
METHOD HScroll( nWParam, nLParam ) CLASS TGridExtended
local nCol := ::nColPos

	#ifdef __CLIPPER__
	 local nScrHandle  := nHiWord( nLParam )
	 local nScrollCode := nWParam
	 local nPos        := nLoWord( nLParam )
	#else
	 local nScrHandle  := nLParam
	 local nScrollCode := nLoWord( nWParam )
	 local nPos        := nHiWord( nWParam )
	#endif

	if ::oGet != nil .and. ! Empty( ::oGet:hWnd )
		::oGet:Hide()
	endif

	do case
		case nScrollCode == SB_LINEUP
			  ::GoLeft()

		case nScrollCode == SB_LINEDOWN
			  ::GoRight()

		case nScrollCode == SB_PAGEUP
			  while ::nColPos > 1 .and. ;
					 (::IsColVisible( nCol ) .or. ::nColPos == nCol)
				  ::nColPos--
			  end
			  ::nColAct := ::nColPos
			  ::oHScroll:SetPos( ::nColAct )
			  ::Refresh( .f. )

		case nScrollCode == SB_PAGEDOWN
			  while nCol < Len( ::GetColSizes() ) .and. ;
					 (::IsColVisible( nCol ) .or. ::nColPos == nCol)
				  nCol++
			  end
			  ::nColPos := nCol
			  ::nColAct := nCol
			  ::oHScroll:SetPos( nCol )
			  ::Refresh( .f. )

		case nScrollCode == SB_TOP
			  ::nColPos = 1
			  ::nColAct = 1
			  ::oHScroll:SetPos( 1 )
			  ::Refresh( .f. )

		case nScrollCode == SB_BOTTOM
			  ::nColPos = Len( ::GetColSizes() )
			  ::nColAct = ::nColPos
			  ::oHScroll:SetPos( ::nColPos )
			  ::Refresh( .f. )

		case nScrollCode == SB_THUMBPOSITION
			  ::nColPos = nPos
			  ::nColAct = ::nColPos
			  ::oHScroll:SetPos( nPos )
			  ::Refresh( .f. )

		otherwise
			  return nil
	endcase

return 0

//------------------------------------------------------------------------------
METHOD Skip( n ) CLASS TGridExtended
return Eval( ::bSkip, n, Self )

//------------------------------------------------------------------------------
static function GenLocal( aArray, nPos )
return { || If( nPos <= Len( aArray ), aArray[ nPos ], "  " ) }

//------------------------------------------------------------------------------
static function GenBlock( bLine, nPos )
return { || Eval( bLine )[ nPos ] }

//------------------------------------------------------------------------------
METHOD MouseMove( nRow, nCol, nKeyFlags ) CLASS TGridExtended
/*
	local nColPos := 0
	local aColSizes

	if ::lDrag
		return ::Super:MouseMove( nRow, nCol, nKeyFlags )
	endif

	if ::lCaptured
		CursorWE()
		::VertLine( nCol )
		return 0
	endif
	aColSizes := ::GetColSizes()
	if ::lMChange .and. AScan( aColSizes,;
				  { | nColumn | nColPos += nColumn,;
									 nCol >= nColPos - 1 .and. ;
									 nCol <= nColPos + 1 }, ::nColPos ) != 0
		if nColPos > aColSizes[1]+2
			CursorWE()
		endif
	else
		if !empty( ::aRectBtn ) .and. PtInRect( nRow, nCol, ::aRectBtn )
			CursorHand()
		else
			::Super:MouseMove( nRow, nCol, nKeyFlags )
		endif
	endif
 */
return 0

//------------------------------------------------------------------------------
METHOD MouseWheel( nKeys, nDelta, nXPos, nYPos ) CLASS TGridExtended
local aPos := { nYPos, nXPos }

	aPos = ScreenToClient( ::hWnd, aPos )

	if lAnd( nKeys, MK_MBUTTON )
		if nDelta > 0
			::PageUp()
		else
			::PageDown()
		endif
	else
		if nDelta > 0
			::GoUp()
		else
			::GoDown()
		endif
	endif

return nil

//------------------------------------------------------------------------------
#ifndef __HARBOUR__
Dll32 Static Function GetMsgInfo() AS LONG PASCAL ;
		FROM "GetMessageExtraInfo" LIB "User32.dll"
#endif

//------------------------------------------------------------------------------
METHOD VertLine( nColPos, nColInit ) CLASS TGridExtended
local oRect, aSizes, nFor
local nCol, nWidth, nMin, nOldPos := 0  //Declaradas anteriormente como static

	if nColInit != nil
		nCol    = nColInit
		nWidth  = nColPos
		nOldPos = 0
		nMin := 0
		aSizes := ::GetColSizes()

		for nFor := ::nColPos TO nColInit - 1
			 nMin += aSizes[nFor]
		next nFor

		nMin += 5
	endif

	if nColPos == nil .and. nColInit == nil   // We have finish draging
		::aColSizes[ nCol ] -= ( nWidth - nOldPos )
		::Refresh()
	endif

	if nColPos != nil
	  nColPos := Max(nColPos, nMin)
	endif

	oRect = ::GetRect()
	::GetDC()
	if nOldPos != 0
		InvertRect( ::hDC, { 0, nOldPos - 2, oRect:nBottom, nOldPos + 2 } )
		nOldPos = 0
	endif
	if nColPos != nil .and. ( nColPos - 2 ) > 0
		InvertRect( ::hDC, { 0, nColPos - 2, oRect:nBottom, nColPos + 2 } )
		nOldPos = nColPos
	endif
	::ReleaseDC()

return nil

//------------------------------------------------------------------------------
METHOD nAtCol( nColPixel ) CLASS TGridExtended
local nColumn := ::nColPos - 1
local aSizes  := ::GetColSizes()
local nPos    := 0

	DEFAULT nColPixel := 0

	while nPos < nColPixel .and. nColumn < Len( aSizes )
		nPos += aSizes[ nColumn + 1 ]
		nColumn++
	end

return nColumn

//------------------------------------------------------------------------------
METHOD nAtIcon( nRow, nCol ) CLASS TGridExtended
local nIconsByRow := Int( ::nWidth() / 50 )

	nRow -= 9
	nCol -= 1

	if ( nCol % 50 ) >= 9 .and. ( nCol % 50 ) <= 41
		return Int( ( nIconsByRow * Int( nRow / 50 ) ) + Int( nCol / 50 ) ) + 1
	else
		return 0
	endif

return nil

//------------------------------------------------------------------------------
METHOD Display() CLASS TGridExtended
local nRecs

	::BeginPaint()
	if ::oVScroll != nil   // They generate WM_PAINT msgs when range 0
		nRecs := Eval( ::bLogicLen, Self )
		if ::VGetMax() != nRecs .or. nRecs != ::nLen
			::nLen := nRecs
			::VSetRange()
			::oVScroll:SetPage( Min( ::nRowCount(), ::nLen - 1 ), .t. )
		endif
	endif                  // so here we avoid 'flicking'
	if ::oHScroll != nil
		//::oHScroll:SetRange( 1, Len( ::GetColSizes() ) )
		::oHScroll:SetRange( 0, 0 )
	endif
	::Paint()
	::EndPaint()

return 0

//------------------------------------------------------------------------------
METHOD GetDlgCode( nLastKey ) CLASS TGridExtended

	// This method is very similar to TControl:GetDlgCode() but it is
	// necessary to have WHEN working

	if .not. ::oWnd:lValidating
		if nLastKey == VK_UP .or. nLastKey == VK_DOWN ;
			.or. nLastKey == VK_RETURN .or. nLastKey == VK_TAB
			::oWnd:nLastKey = nLastKey
		else
			::oWnd:nLastKey = 0
		endif
	endif

return If( IsWindowEnabled( ::hWnd ), DLGC_WANTALLKEYS, 0 )

//------------------------------------------------------------------------------
METHOD SetCols( aData, aHeaders, aColSizes ) CLASS TGridExtended
local aFields
local nElements, n

	nElements   := Len( aData )

	::aHeaders  := If( aHeaders  != nil, aHeaders, ::aHeaders )
	::aColSizes := If( aColSizes != nil, aColSizes, {} )
	::bLine     := {|| _aData( aData ) }
	::aJustify  := AFill( Array( nElements ), .F. )

	if Len( ::GetColSizes() ) < nElements
		::aColSizes = AFill( Array( nElements ), 0 )
		aFields = Eval( ::bLine, Self )
		for n = 1 to nElements
			 ::aColSizes[ n ] := If( ValType( aFields[ n ] ) != "C",;
											  15,; // Bitmap handle
											  GetTextWidth( 0, Replicate( "B", ;
											  Max( Len( ::aHeaders[ n ] ), ;
													 Len( aFields[ n ] ) ) + 1 ),;
											  If( ! Empty( ::oFont ), ::oFont:hFont,) ) )
		next n
	endif

	if ::oHScroll != nil
		::oHScroll:nMax := ::GetColSizes()
	endif

return nil

//------------------------------------------------------------------------------
METHOD ShowSizes() CLASS TGridExtended
local cText := ""

	AEval( ::aColSizes,;
			 { | v,e | cText += ::aHeaders[ e ] + ": " + Str( v, 3 ) + CRLF } )

	MsgInfo( cText )

return nil

//------------------------------------------------------------------------------
METHOD _DrawIcon( nIcon, lFocused ) CLASS TGridExtended
local nIconsByRow := Int( ::nWidth() / 50 )
local nRow := Int( --nIcon / nIconsByRow )
local nCol := If( nRow > 0, nIcon % ( nRow * nIconsByRow ), nIcon )

	DEFAULT lFocused := .f.

	if lFocused
		DrawIconFocus( ::GetDC(), ( nRow * 50 ) + 10, ( nCol * 50 ) + 10,;
							ExtractIcon( "user.exe" ) )
	else
		DrawIcon( ::GetDC(), ( nRow * 50 ) + 10, ( nCol * 50 ) + 10,;
					 ExtractIcon( "user.exe" ) )
	endif

return nil

//------------------------------------------------------------------------------
METHOD IsColVisible( nCol ) CLASS TGridExtended
local nCols, nFirstCol, nLastCol, nWidth, nBrwWidth

	nCols     := Len( ::GetColSizes() )
	nFirstCol := ::nColPos
	nLastCol  := nFirstCol
	nWidth    := 0
	nBrwWidth := ::nWidth - If( ::oVScroll != nil, 16, 0 )

	if nCol < nFirstCol
		return .f.
	endif

	while nWidth < nBrwWidth .and. nLastCol <= nCol
		nWidth += ::GetColSizes()[ nLastCol ]
		nLastCol++
	end

	if nCol <= --nLastCol
		// La columna es solo visible en parte por ser muy larga
		if nWidth > nBrwWidth
			 return .f.
		endif
		return .t.
	endif

return .F.

//------------------------------------------------------------------------------
static function _aData( aFields )
local aFld
local nFor, nLen

  nLen = Len( aFields )
  aFld = Array( nLen )

  for nFor = 1 to nLen
	  aFld[ nFor ] = Eval( aFields[ nFor ] )
  next nFor

return aFld

//------------------------------------------------------------------------------
#ifndef __CLIPPER__

METHOD wBrwLine( hWnd, hDC, nRowPos, aValues, aColSizes,;
								  nColPos, nClrText, nClrPane,;
								  hFont, lTree, aJustify, nPressed, nLineStyle,;
								  nColAct, lFocused, oVScroll, bLogicLen, lBar ) CLASS TGridExtended
	local nTxtHeight, hOldFont
	local nColStart  := -1
	local nWidth     := WndWidth( hWnd ) - If( oVScroll != nil .and. ;
							  Eval( bLogicLen ) > 1,;
							  GetSysMetrics( SM_CYHSCROLL ) + 3, 0 )
	local nRow := nRowPos, nTop, nBottom, nLeft, nRight, n
	local lReleaseDC := .f.
	local nForeColor, nBackColor
	local  hPen, hOld, hBrush
	local hFontBold, nLenText
	local nItem
	local o

	DEFAULT lTree := .f., lBar := .f.

	if Empty( hDC )
		hDC = GetDC( hWnd )
		lReleaseDC = .t.
	endif

	try
		if valtype( aValues[1]) == "N" .and. n == 2 .and. aValues[1] != 0
			hFontBold  := CreateBold( hFont )
			hOldFont   := SelectObject( hDC, hFontBold )
		else
			hOldFont   := SelectObject( hDC, hFont )
		endif
	catch o
		xBrowse(avalues)
		xBrowse(o)
	end

	nTxtHeight = ::nHLine //GetTextHeight( hWnd, hDC ) + 1

	nTop    = nTxtHeight * nRow
	nBottom = nTop + nTxtHeight - 1

	SetTextColor( hDC, If( ValType( nClrText ) == "B",;
					  nClrText := Eval( nClrText ), nClrText ) )
	SetBkColor( hDC, If( ValType( nClrPane ) == "B",;
					nClrPane := Eval( nClrPane ), nClrPane ) )

	for n := nColPos to Len( aValues )

		if valtype( aValues[1]) == "N" .and. n == 2 .and. aValues[1] != 0
			hFontBold  := CreateBold( hFont )
			hOldFont   = SelectObject( hDC, hFontBold )
		else
			hOldFont   = SelectObject( hDC, hFont )
		endif

		nLeft   = nColStart + 1
		nRight  = Min( nColStart := ( nLeft + aColSizes[ n ] - 1 ), nWidth )
		if nLeft > nWidth
			exit
		endif
		if n == Len( aValues )
			nRight = nWidth
		endif

		if ValType( aValues[ n ] ) == "N" .or. nRowPos == 0
			if n <= 1
				hBrush = CreateSolidBrush( CLR_BACKGROUND ) // rgb(173,197,229) ) //rgb(212,208,200)
			else
				//if lBar .and. n == 3
				//   hBrush = CreateSolidBrush( ::nClrPane )
				//else
					hBrush = CreateSolidBrush( GetBkColor( hDC ) )
				//endif
			endif
			hOld   = SelectObject( hBrush )
			FillRect( hDC, { nTop, nLeft, nBottom, nRight + If( ( nLineStyle == ;
						 LINES_NONE .or. nLineStyle == LINES_H_GRAY .or. nLineStyle == ;
						 LINES_H_BLACK ) .and. nRowPos != 0, 2, 0 ) }, hBrush )
			DrawMasked( hDC, aValues[ n ], nTop+3, nLeft + 0 )
			SelectObject( hOld )
			DeleteObject( hBrush )
		else
			if nColAct != nil .and. n == nColAct
				SetTextColor( hDC, nClrText )
				SetBkColor( hDC, nClrPane )
			else
				if nRowPos != 0
					if n == 3
						SetTextColor( hDC, ::nClrText )
						if aValues[1] != 0
							SetBkColor( hDC, CLR_BACKGROUND ) // rgb(173,197,229) ) //rgb(212,208,200) )
						else
							SetBkColor( hDC, ::nClrPane )
						endif
					else
						SetTextColor( hDC, If( nColAct != nil, GetSysColor( COLOR_BTNTEXT ), if( aValues[1] != 0,::nClrText,nClrText) ) )
						//SetBkColor( hDC, If( nRowPos == 0, rgb(212,208,200) , If( nColAct == nil, if( aValues[1] != 0,rgb(212,208,200),nClrPane), GetSysColor( COLOR_WINDOW ) ) ) )
						SetBkColor( hDC, If( nRowPos == 0, CLR_BACKGROUND , If( nColAct == nil, if( aValues[1] != 0,CLR_BACKGROUND,nClrPane), GetSysColor( COLOR_WINDOW ) ) ) )
					endif
				endif
			endif

			nItem := ::nGetElement(::nAt) // CAF
			if nRowPos != 0 .and. ! Eval( ENABLE )  .and. n > 2
				SetTextColor( hDC, CLR_GRAY )
			endif

			if ! lTree
				if aJustify != nil .and. aJustify[ n ]
					SetTextAlign( hDC, TA_RIGHT )
					ExtTextOut( hDC, nTop, nRight - 2,;
									{ nTop, nLeft, nBottom, nRight + If( (nLineStyle == ;
									LINES_NONE .or. nLineStyle == LINES_H_GRAY .or. ;
								nLineStyle == LINES_H_BLACK ) .and. nRowPos != 0, 2, 0 ) },; //socs + If((nLineStyle == LINES_NONE .OR. nLineStyle == LINES_H_GRAY .OR. nLineStyle == LINES_H_BLACK) .AND. nRowPos#0 ,2,0),;
									"" )
					DrawText( hDC, cValToChar( aValues[n] ), { nTop, nLeft+3, nBottom, nRight + If( (nLineStyle == ;
									LINES_NONE .or. nLineStyle == LINES_H_GRAY .or. ;
								nLineStyle == LINES_H_BLACK ) .and. nRowPos != 0, 2, 0 ) }, nOr( DT_VCENTER, DT_RIGHT,DT_SINGLELINE ) )

				else
					ExtTextOut( hDC, nTop, nLeft + 2,;
									{ nTop, nLeft, nBottom, nRight + If( ( nLineStyle == ;
									LINES_NONE .or. nLineStyle == LINES_H_GRAY .or. ;
								nLineStyle == LINES_H_BLACK ) .and. nRowPos != 0, 2, 0 ) },;
									"" )
					DrawText( hDC, cValToChar( aValues[n] ), { nTop, nLeft+3, nBottom, nRight + If( (nLineStyle == ;
									LINES_NONE .or. nLineStyle == LINES_H_GRAY .or. ;
								nLineStyle == LINES_H_BLACK ) .and. nRowPos != 0, 2, 0 ) }, nOr( DT_VCENTER, DT_END_ELLIPSIS,DT_SINGLELINE ) )


				endif
				if n == 3 .and. at( "color",lower(aValues[2])) != 0
					FillSolidRect( hDC, { nTop, nLeft, nBottom, nRight }, val( aValues[3] ) )
				endif
				if lBar
					if n == 2 .and. aValues[1] != 0
						nLenText := GetTextWidth( hDC, aValues[n], hFontBold )
						DrawFocusRect( hDC, nTop+3, nLeft, nTop+18, nLeft+nLenText + 8 )
					endif
				endif

			else
				DrawText( hDC, cValToChar( aValues[ n ] ),;
							 { nTop, nLeft + 4, nBottom, nRight } )
			endif
		endif
		if ! lTree
			if nRowPos == 0

			else
				nLeft += 1
				do case
					case nLineStyle == LINES_BLACK
						  WndBox( hDC, nTop - 1, nLeft - 1, nBottom, nRight )

					case nLineStyle == LINES_GRAY
						  hPen = CreatePen( PS_SOLID, 1, CLR_BACKGROUND )//rgb(212,208,200) )
						  hOld = SelectObject( hDC, hPen )
						  MoveTo( hDC, nLeft - 2, nTop - 2 )
						  LineTo( hDC, nLeft - 2, nBottom )
						  LineTo( hDC, nRight , nBottom )
						  SelectObject( hDC, hOld )
						  DeleteObject( hPen )

					case nLineStyle == LINES_3D
						  WndBoxRaised( hDC, nTop, nLeft, nBottom, nRight )

					case nLineStyle == LINES_DOTED
						  SetTextColor( hDC, CLR_BLACK )
						  FrameDot( hDC, nTop - 1, nLeft - 1, nBottom, nRight )

					case nLineStyle == LINES_V_BLACK
						  hPen = CreatePen( PS_SOLID, 1, CLR_BLACK )
						  hOld = SelectObject( hDC, hPen )
						  MoveTo( hDC, nLeft - 1, nTop - 2 )
						  LineTo( hDC, nLeft - 1, nBottom )
						  SelectObject( hDC, hOld )
						  DeleteObject( hPen )

					case nLineStyle == LINES_V_GRAY
						  hPen = CreatePen( PS_SOLID, 1, CLR_GRAY )
						  hOld = SelectObject( hDC, hPen )
						  MoveTo( hDC, nLeft - 1, nTop - 2 )
						  LineTo( hDC, nLeft - 1, nBottom )
						  SelectObject( hDC, hOld )
						  DeleteObject( hPen )

					case nLineStyle == LINES_H_BLACK
						  hPen = CreatePen( PS_SOLID, 1, CLR_BLACK )
						  hOld = SelectObject( hDC, hPen )
						  MoveTo( hDC, nLeft - 2, nBottom )
						  LineTo( hDC, nRight , nBottom )
						  SelectObject( hDC, hOld )
						  DeleteObject( hPen )

					case nLineStyle == LINES_H_GRAY
						  hPen = CreatePen( PS_SOLID, 1, CLR_GRAY )
						  hOld = SelectObject( hDC, hPen )
						  MoveTo( hDC, nLeft - 2, nBottom )
						  LineTo( hDC, nRight , nBottom )
						  SelectObject( hDC, hOld )
						  DeleteObject( hPen )
				endcase
			endif
		endif

		if nColPos > nWidth
			exit
		endif
		SelectObject( hDC, hOldFont )
		if hFontBold != nil
			DeleteObject( hFontBold )
		endif

	next n

	if lReleaseDC
		ReleaseDC( hWnd, hDC )
	endif

return nil


#endif

//------------------------------------------------------------------------------
//                            class TComboBox2
//------------------------------------------------------------------------------

CLASS TComboBox2 FROM TComboBox

		CLASSDATA lRegistered AS LOGICAL

		METHOD KeyDown( nKey, nFlags )

ENDCLASS

//------------------------------------------------------------------------------
METHOD KeyDown( nKey, nFlags ) CLASS TComboBox2

if nKey == VK_RETURN .or. nKey == VK_ESCAPE
	::Close()
	return ::oWnd:Teclas( nKey, nFlags )
endif

return ::super:KeyDown( nKey, nFlags )

//------------------------------------------------------------------------------
//                         class TGet2
//------------------------------------------------------------------------------

CLASS TGet2 FROM TGet

		CLASSDATA lRegistered AS LOGICAL

		METHOD KeyDown( nKey, nFlags )

ENDCLASS

//------------------------------------------------------------------------------
METHOD KeyDown( nKey, nFlags ) CLASS TGet2

	if nKey == VK_UP .OR. nKey == VK_DOWN
		::oWnd:KeyDown( nKey, nFlags )
		::oWnd:SetFocus()
		::oWnd:Refresh()
		return 0
	endif

	if nKey == VK_RETURN .or. nKey == VK_ESCAPE
		::oWnd:Teclas( nKey )
		return 0
	endif

return ::Super:KeyDown( nKey, nFlags )



//------------------------------------------------------------------------------
//                       funciones ptxt
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function pTxt( nId )
return aTxtptxt[ nId ]

//------------------------------------------------------------------------------
function pTxtLoad()

	 aTxtptxt       := Array( TXT_LON )

	 AFill( aTxtptxt, '' )

	 aTxtptxt[  1  ] := LoadString( GetResources(), 01 ) // TXT_TEST
	 aTxtptxt[  2  ] := LoadString( GetResources(), 02 ) // TXT_SYS
	 aTxtptxt[  3  ] := LoadString( GetResources(), 03 ) // TXT_FWRPT
	 aTxtptxt[  4  ] := LoadString( GetResources(), 04 ) // TXT_SECTION
	 aTxtptxt[  5  ] := LoadString( GetResources(), 05 ) // TXT_YES
	 aTxtptxt[  6  ] := LoadString( GetResources(), 06 ) // TXT_NO
	 aTxtptxt[  7  ] := LoadString( GetResources(), 07 ) // TXT_ERROR
	 aTxtptxt[  8  ] := LoadString( GetResources(), 08 ) // TXT_INFO
	 aTxtptxt[  9  ] := LoadString( GetResources(), 09 ) // TXT_FUNCTION

	 aTxtptxt[  11 ] := LoadString( GetResources(), 11 ) // TXT_MENU_FILE
	 aTxtptxt[  12 ] := LoadString( GetResources(), 12 ) // TXT_MENU_NEW_PROJECT
	 aTxtptxt[  13 ] := LoadString( GetResources(), 13 ) // TXT_MENU_OPEN
	 aTxtptxt[  14 ] := LoadString( GetResources(), 14 ) // TXT_MENU_SAVE
	 aTxtptxt[  15 ] := LoadString( GetResources(), 15 ) // TXT_MENU_SAVE_AS
	 aTxtptxt[  16 ] := LoadString( GetResources(), 16 ) // TXT_MENU_CFG_PRINT
	 aTxtptxt[  17 ] := LoadString( GetResources(), 17 ) // TXT_MENU_PREVIEW
	 aTxtptxt[  18 ] := LoadString( GetResources(), 18 ) // TXT_MENU_EXIT
	 aTxtptxt[  19 ] := LoadString( GetResources(), 19 ) // TXT_MENU_EDIT
	 aTxtptxt[  20 ] := LoadString( GetResources(), 20 ) // TXT_MENU_UNDO
	 aTxtptxt[  21 ] := LoadString( GetResources(), 21 ) // TXT_MENU_REDO
	 aTxtptxt[  22 ] := LoadString( GetResources(), 22 ) // TXT_MENU_CUT
	 aTxtptxt[  23 ] := LoadString( GetResources(), 23 ) // TXT_MENU_DUPLICATE
	 aTxtptxt[  24 ] := LoadString( GetResources(), 24 ) // TXT_MENU_FIND_ITEM
	 aTxtptxt[  25 ] := LoadString( GetResources(), 25 ) // TXT_MENU_ITEM2FRONT
	 aTxtptxt[  26 ] := LoadString( GetResources(), 26 ) // TXT_MENU_ITEM2BACK
	 aTxtptxt[  27 ] := LoadString( GetResources(), 27 ) // TXT_MENU_PRJ
	 aTxtptxt[  28 ] := LoadString( GetResources(), 28 ) // TXT_MENU_DEF
	 aTxtptxt[  29 ] := LoadString( GetResources(), 29 ) // TXT_MENU_HELP
	 aTxtptxt[  30 ] := LoadString( GetResources(), 30 ) // TXT_MENU_ABOUT
	 aTxtptxt[  31 ] := LoadString( GetResources(), 31 ) // TXT_MENU_CREDITS
	 aTxtptxt[  32 ] := LoadString( GetResources(), 32 ) // TXT_TIP_EMF
	 aTxtptxt[  33 ] := LoadString( GetResources(), 33 ) // TXT_TIP_SAY
	 aTxtptxt[  34 ] := LoadString( GetResources(), 34 ) // TXT_TIP_IMAGE
	 aTxtptxt[  35 ] := LoadString( GetResources(), 35 ) // TXT_TIP_BOX
	 aTxtptxt[  36 ] := LoadString( GetResources(), 36 ) // TXT_TIP_SECTION
	 aTxtptxt[  37 ] := LoadString( GetResources(), 37 ) // TXT_TIP_VIEW_SECTION
	 aTxtptxt[  38 ] := LoadString( GetResources(), 38 ) // TXT_NAME_SECTION
	 aTxtptxt[  39 ] := LoadString( GetResources(), 39 ) // TXT_MENU_GRID

	 aTxtptxt[  40 ] := LoadString( GetResources(), 40 ) // TXT_DEL_ITEM
	 aTxtptxt[  41 ] := LoadString( GetResources(), 41 ) // TXT_EXIST_CHANGE
	 aTxtptxt[  42 ] := LoadString( GetResources(), 42 ) // TXT_EXIT
	 aTxtptxt[  43 ] := LoadString( GetResources(), 43 ) // TXT_SAVE
	 aTxtptxt[  44 ] := LoadString( GetResources(), 44 ) // TXT_LOAD
	 aTxtptxt[  45 ] := LoadString( GetResources(), 45 ) // TXT_DEL_ALL
	 aTxtptxt[  46 ] := LoadString( GetResources(), 46 ) // TXT_EXIST_CHANGE_CONTINUE
	 aTxtptxt[  47 ] := LoadString( GetResources(), 47 ) // TXT_SEL_RPT
	 aTxtptxt[  48 ] := LoadString( GetResources(), 48 ) // TXT_RPT_EXIST
	 aTxtptxt[  49 ] := LoadString( GetResources(), 49 ) // TXT_NOT_FOUND
	 aTxtptxt[  50 ] := LoadString( GetResources(), 50 ) // TXT_ITEM_VISIBLE
	 aTxtptxt[  51 ] := LoadString( GetResources(), 51 ) // TXT_DEL_EMF
	 aTxtptxt[  52 ] := LoadString( GetResources(), 52 ) // TXT_INITIATING
	 aTxtptxt[  53 ] := LoadString( GetResources(), 53 ) // TXT_LOAD_REPORT
	 aTxtptxt[  54 ] := LoadString( GetResources(), 54 ) // TXT_BUILD_REPORT
	 aTxtptxt[  55 ] := LoadString( GetResources(), 55 ) // TXT_SAVE_OK
	 aTxtptxt[  56 ] := LoadString( GetResources(), 56 ) // TXT_LOADING
	 aTxtptxt[  57 ] := LoadString( GetResources(), 57 ) // TXT_DONT_EXIST
	 aTxtptxt[  58 ] := LoadString( GetResources(), 58 ) // TXT_REASIGN
	 aTxtptxt[  59 ] := LoadString( GetResources(), 59 ) // TXT_PROP_PRJ
	 aTxtptxt[  60 ] := LoadString( GetResources(), 60 ) // TXT_NEW_PRG
	 aTxtptxt[  61 ] := LoadString( GetResources(), 61 ) // TXT_PORTRAIT
	 aTxtptxt[  62 ] := LoadString( GetResources(), 62 ) // TXT_LANDSCAPE
	 aTxtptxt[  63 ] := LoadString( GetResources(), 63 ) // TXT_PUBLIC
	 aTxtptxt[  64 ] := LoadString( GetResources(), 64 ) // TXT_PAPER_SIZE
	 aTxtptxt[  65 ] := LoadString( GetResources(), 65 ) // TXT_PAPER_WIDTH
	 aTxtptxt[  66 ] := LoadString( GetResources(), 66 ) // TXT_PAPER_HEIGHT
	 aTxtptxt[  67 ] := LoadString( GetResources(), 67 ) // TXT_PAPER_ORIENTATION
	 aTxtptxt[  68 ] := LoadString( GetResources(), 68 ) // TXT_ACTIVE_GRID
	 aTxtptxt[  69 ] := LoadString( GetResources(), 69 ) // TXT_TIP_CATEGORY
	 aTxtptxt[  70 ] := LoadString( GetResources(), 70 ) // TXT_TIP_SORT
	 aTxtptxt[  71 ] := LoadString( GetResources(), 71 ) // TXT_TIP_EXPAND
	 aTxtptxt[  72 ] := LoadString( GetResources(), 72 ) // TXT_TIP_CLOSE_ALL
	 aTxtptxt[  73 ] := LoadString( GetResources(), 73 ) // TXT_DLG_BASIC
	 aTxtptxt[  74 ] := LoadString( GetResources(), 74 ) // TXT_DLG_PAPER
	 aTxtptxt[  75 ] := LoadString( GetResources(), 75 ) // TXT_DLG_DAT
	 aTxtptxt[  76 ] := LoadString( GetResources(), 76 ) // TXT_TIP_CODEBAR
	 aTxtptxt[  77 ] := LoadString( GetResources(), 77 ) // TXT_MENU_WHATSNEW
	 aTxtptxt[  78 ] := LoadString( GetResources(), 78 ) // TXT_TIP_FUNCTION
	 aTxtptxt[  79 ] := LoadString( GetResources(), 79 ) // TXT_MENU_PAGE_XX_OF_YY
	 aTxtptxt[  80 ] := LoadString( GetResources(), 80 ) // TXT_MENU_RUN_TIME
	 aTxtptxt[  81 ] := LoadString( GetResources(), 81 ) // TXT_MENU_RUN_DATE
	 aTxtptxt[  82 ] := LoadString( GetResources(), 82 ) // TXT_MENU_RUN_TIMESTAMP
	 aTxtptxt[  83 ] := LoadString( GetResources(), 83 ) // TXT_MENU_RUN_REPORT_NAME
	 aTxtptxt[  84 ] := LoadString( GetResources(), 84 ) // TXT_MENU_RUN_COMPUTER_NAME
	 aTxtptxt[  85 ] := LoadString( GetResources(), 85 ) // TXT_MENU_RUN_USER_NAME
	 aTxtptxt[  90 ] := LoadString( GetResources(), 90 ) // TXT_CAPTION_PAGE_XX_OF_YY
	 aTxtptxt[  91 ] := LoadString( GetResources(), 91 ) // TXT_CAPTION_RUN_TIME
	 aTxtptxt[  92 ] := LoadString( GetResources(), 92 ) // TXT_CAPTION_RUN_DATE
	 aTxtptxt[  93 ] := LoadString( GetResources(), 93 ) // TXT_CAPTION_RUN_TIMESTAMP
	 aTxtptxt[  94 ] := LoadString( GetResources(), 94 ) // TXT_CAPTION_RUN_REPORT_NAME
	 aTxtptxt[  95 ] := LoadString( GetResources(), 95 ) // TXT_CAPTION_RUN_COMPUTER_NAME
	 aTxtptxt[  96 ] := LoadString( GetResources(), 96 ) // TXT_CAPTION_RUN_USER_NAME

	 aTxtptxt[ 100 ] := LoadString( GetResources(), 100) // TXT_ANIM_TITLE
	 aTxtptxt[ 101 ] := LoadString( GetResources(), 101) // TXT_ANIM_MSG
	 aTxtptxt[ 102 ] := LoadString( GetResources(), 102) // TXT_ANIM_PRINT

	 aTxtptxt[ 110 ] := LoadString( GetResources(), 110) // TXT_RUN_RPT_NOT_DEFINED
	 aTxtptxt[ 111 ] := LoadString( GetResources(), 111) // TXT_RUN_LABEL
	 aTxtptxt[ 112 ] := LoadString( GetResources(), 112) // TXT_RUN_NOT_EXIST
	 aTxtptxt[ 113 ] := LoadString( GetResources(), 113) // TXT_RUN_PRINTER_NOT_READY

	 aTxtptxt[ 200 ] := LoadString( GetResources(), 200 ) // TXT_PROP_JUST_LEFT
	 aTxtptxt[ 201 ] := LoadString( GetResources(), 201 ) // TXT_PROP_JUST_RIGHT
	 aTxtptxt[ 202 ] := LoadString( GetResources(), 202 ) // TXT_PROP_JUST_CENTER
	 aTxtptxt[ 203 ] := LoadString( GetResources(), 203 ) // TXT_PROP_WIDTH
	 aTxtptxt[ 204 ] := LoadString( GetResources(), 204 ) // TXT_PROP_HEIGHT
	 aTxtptxt[ 205 ] := LoadString( GetResources(), 205 ) // TXT_PROP_FONT
	 aTxtptxt[ 206 ] := LoadString( GetResources(), 206 ) // TXT_PROP_FONT_SIZE
	 aTxtptxt[ 207 ] := LoadString( GetResources(), 207 ) // TXT_PROP_FONT_BOLD
	 aTxtptxt[ 208 ] := LoadString( GetResources(), 208 ) // TXT_PROP_FONT_ITALIC
	 aTxtptxt[ 209 ] := LoadString( GetResources(), 209 ) // TXT_PROP_FONT_UNDERLINE
	 aTxtptxt[ 210 ] := LoadString( GetResources(), 210 ) // TXT_PROP_CLR_FORE
	 aTxtptxt[ 211 ] := LoadString( GetResources(), 211 ) // TXT_PROP_CLR_BACK
	 aTxtptxt[ 212 ] := LoadString( GetResources(), 212 ) // TXT_PROP_ALIGN
	 aTxtptxt[ 213 ] := LoadString( GetResources(), 213 ) // TXT_PROP_INTERLINE
	 aTxtptxt[ 214 ] := LoadString( GetResources(), 214 ) // TXT_PROP_HEADER
	 aTxtptxt[ 215 ] := LoadString( GetResources(), 215 ) // TXT_PROP_PRJ_NAME
	 aTxtptxt[ 216 ] := LoadString( GetResources(), 216 ) // TXT_PROP_DESCRIPTION
	 aTxtptxt[ 217 ] := LoadString( GetResources(), 217 ) // TXT_PROP_AUTOR
	 aTxtptxt[ 218 ] := LoadString( GetResources(), 218 ) // TXT_PROP_DATE
	 aTxtptxt[ 219 ] := LoadString( GetResources(), 219 ) // TXT_PROP_IT_ID
	 aTxtptxt[ 220 ] := LoadString( GetResources(), 220 ) // TXT_PROP_IT_TOP
	 aTxtptxt[ 221 ] := LoadString( GetResources(), 221 ) // TXT_PROP_IT_LEFT
	 aTxtptxt[ 222 ] := LoadString( GetResources(), 222 ) // TXT_PROP_IT_WIDTH
	 aTxtptxt[ 223 ] := LoadString( GetResources(), 223 ) // TXT_PROP_IT_HEIGHT
	 aTxtptxt[ 224 ] := LoadString( GetResources(), 224 ) // TXT_PROP_IT_VISIBLE
	 aTxtptxt[ 225 ] := LoadString( GetResources(), 225 ) // TXT_PROP_IT_FIXED
	 aTxtptxt[ 226 ] := LoadString( GetResources(), 226 ) // TXT_PROP_ID_EXIST
	 aTxtptxt[ 227 ] := LoadString( GetResources(), 227 ) // TXT_PROP_IT_CAPTION
	 aTxtptxt[ 228 ] := LoadString( GetResources(), 228 ) // TXT_PROP_IT_PRINT_BORDER
	 aTxtptxt[ 229 ] := LoadString( GetResources(), 229 ) // TXT_PROP_MEMO
	 aTxtptxt[ 230 ] := LoadString( GetResources(), 230 ) // TXT_PROP_MEMO_MPAGE
	 aTxtptxt[ 231 ] := LoadString( GetResources(), 231 ) // TXT_PROP_MEMO_INTERLINE
	 aTxtptxt[ 232 ] := LoadString( GetResources(), 232 ) // TXT_PROP_FILE
	 aTxtptxt[ 233 ] := LoadString( GetResources(), 233 ) // TXT_PROP_BORDER
	 aTxtptxt[ 234 ] := LoadString( GetResources(), 234 ) // TXT_PROP_FIX_HEIGHT
	 aTxtptxt[ 235 ] := LoadString( GetResources(), 235 ) // TXT_PROP_BOX_LINE_STYLE
	 aTxtptxt[ 236 ] := LoadString( GetResources(), 236 ) // TXT_PROP_BOX_LINE_CLR
	 aTxtptxt[ 237 ] := LoadString( GetResources(), 237 ) // TXT_PROP_BOX_CLR
	 aTxtptxt[ 238 ] := LoadString( GetResources(), 238 ) // TXT_PROP_BOX_LINE_WIDTH
	 aTxtptxt[ 239 ] := LoadString( GetResources(), 239 ) // TXT_PROP_SECTION_NAME
	 aTxtptxt[ 240 ] := LoadString( GetResources(), 240 ) // TXT_PROP_RECT_ALL
	 aTxtptxt[ 241 ] := LoadString( GetResources(), 241 ) // TXT_PROP_RECT_HT
	 aTxtptxt[ 242 ] := LoadString( GetResources(), 242 ) // TXT_PROP_RECT_VL
	 aTxtptxt[ 243 ] := LoadString( GetResources(), 243 ) // TXT_PROP_RECT_HB
	 aTxtptxt[ 244 ] := LoadString( GetResources(), 244 ) // TXT_PROP_RECT_VR
	 aTxtptxt[ 245 ] := LoadString( GetResources(), 245 ) // TXT_PROP_PIJAMA
	 aTxtptxt[ 246 ] := LoadString( GetResources(), 246 ) // TXT_PROP_PIJAMA_CLR1
	 aTxtptxt[ 247 ] := LoadString( GetResources(), 247 ) // TXT_PROP_PIJAMA_CLR2
	 aTxtptxt[ 248 ] := LoadString( GetResources(), 248 ) // TXT_PROP_CLASS
	 aTxtptxt[ 249 ] := LoadString( GetResources(), 249 ) // TXT_PROP_TITLE
	 aTxtptxt[ 250 ] := LoadString( GetResources(), 250 ) // TXT_PROP_CODEBAR_TIPO
	 aTxtptxt[ 251 ] := LoadString( GetResources(), 251 ) // TXT_PROP_BANNER
	 aTxtptxt[ 252 ] := LoadString( GetResources(), 252 ) // TXT_PROP_TXT_VERTICAL
	 aTxtptxt[ 253 ] := LoadString( GetResources(), 253 ) // TXT_PROP_CLR_SEC_FORE
	 aTxtptxt[ 254 ] := LoadString( GetResources(), 254 ) // TXT_PROP_CLR_SEC_BACK
	 aTxtptxt[ 255 ] := LoadString( GetResources(), 255 ) // TXT_PROP_CLR_SEC_LINE
	 aTxtptxt[ 256 ] := LoadString( GetResources(), 256 ) // TXT_PROP_CLR_ITEM_FORE
	 aTxtptxt[ 257 ] := LoadString( GetResources(), 257 ) // TXT_PROP_CLR_ITEM_BACK
	 aTxtptxt[ 258 ] := LoadString( GetResources(), 258 ) // TXT_PROP_PIJAMA_CLR3
	 aTxtptxt[ 259 ] := LoadString( GetResources(), 259 ) // TXT_PROP_HEADER_IMG_FILE
	 aTxtptxt[ 260 ] := LoadString( GetResources(), 260 ) // TXT_PROP_HEADER_IMG_SIZE
	 aTxtptxt[ 261 ] := LoadString( GetResources(), 261 ) // TXT_PROP_IT_SHADOW
	 aTxtptxt[ 262 ] := LoadString( GetResources(), 262 ) // TXT_PROP_IT_LINE_WIDTH
	 aTxtptxt[ 263 ] := LoadString( GetResources(), 263 ) // TXT_PROP_IT_LINE_COLOR
	 aTxtptxt[ 264 ] := LoadString( GetResources(), 264 ) // TXT_PROP_IT_SPECIAL

	 aTxtptxt[ 290 ] := LoadString( GetResources(), 290 ) // TXT_PROP_GRUP_INFO
	 aTxtptxt[ 291 ] := LoadString( GetResources(), 291 ) // TXT_PROP_GRUP_FONT
	 aTxtptxt[ 292 ] := LoadString( GetResources(), 292 ) // TXT_PROP_GRUP_SECTION
	 aTxtptxt[ 293 ] := LoadString( GetResources(), 293 ) // TXT_PROP_GRUP_HEADER
	 aTxtptxt[ 294 ] := LoadString( GetResources(), 294 ) // TXT_PROP_GRUP_APARIENCIA
	 aTxtptxt[ 295 ] := LoadString( GetResources(), 295 ) // TXT_PROP_GRUP_POSICION
	 aTxtptxt[ 296 ] := LoadString( GetResources(), 296 ) // TXT_PROP_GRUP_CODEBAR
	 aTxtptxt[ 297 ] := LoadString( GetResources(), 297 ) // TXT_NO_CONTINUE
	 aTxtptxt[ 298 ] := LoadString( GetResources(), 298 ) // TXT_NO_DELETE_ITEM_FIXED
	 aTxtptxt[ 299 ] := LoadString( GetResources(), 299 ) // TXT_CONFIRM_DELETE_ITEM
	 aTxtptxt[ 300 ] := LoadString( GetResources(), 300 ) // TXT_MEET_VERTICAL_SEPARATION
	 aTxtptxt[ 301 ] := LoadString( GetResources(), 301 ) // TXT_MEET_HORIZONTAL_SEPARATION
	 aTxtptxt[ 302 ] := LoadString( GetResources(), 302 ) // TXT_EQUAL_WIDTH_FIRST
	 aTxtptxt[ 303 ] := LoadString( GetResources(), 303 ) // TXT_EQUAL_WIDTH_LAST
	 aTxtptxt[ 304 ] := LoadString( GetResources(), 304 ) // TXT_EQUAL_HEIGHT_FIRST
	 aTxtptxt[ 305 ] := LoadString( GetResources(), 305 ) // TXT_EQUAL_HEIGHT_LAST
	 aTxtptxt[ 306 ] := LoadString( GetResources(), 306 ) // TXT_ATENTION
	 aTxtptxt[ 307 ] := LoadString( GetResources(), 307 ) // TXT_ANSWER
	 aTxtptxt[ 308 ] := LoadString( GetResources(), 308 ) // TXT_FIXED_ITEM

	 AEval( aTxtptxt, {|x,n| if( empty(x), aTxtptxt[n] := '<??? ' + ltrim(str(n)) + '>', ) } )

return NIL


//------------------------------------------------------------------------------
//                          funciones pverdoc
//------------------------------------------------------------------------------

#define SW_SHOW 5

//------------------------------------------------------------------------------
function pVerDoc( cFile )
local nRet
local oWnd           := GetWndApp()

	 DEFAULT cFile := ''

	 if Empty( cFile )
		 return .F.
	 endif
	 if ! File( cFile )
		 MsgAlert( 'Documento ' + cFile + ' no existe', 'Sistema' )
		 return .F.
	 endif

	 nRet := ShellExecute( oWnd, ,cFile, ,cFilePath( cFile ), SW_SHOW )

	 if nRet >= 0 .and. nRet < 32
		 MsgAlert( nRet, 'ShellExecute' )
	 endif

return NIL

//------------------------------------------------------------------------------
//                          funciones banner
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function barlen13(cCode,oPrint,nRow,nCol,Color,lHorz,nWidth,nLen,cFont)
local oFont, nLenChar, l ,Control,k,n,nWidthChar
local oFont2

	 DEFAULT lHorz := .t.
	 DEFAULT nWidth := 0.025 // 1/3 M/mm
	 DEFAULT nLen := 1.5 // Cmm.
	 DEFAULT cFont := 'arial'
	 DEFAULT Color := CLR_BLACK

	 k:=left(alltrim(cCode)+'000000000000',12) // padding with '0'
	 // calculo del digito de control
	 k:=k+EAN13_CHECK(k)                           // Chaeck Digit en EAN13
	 if !lHorz
		  nWidth :=round ( nWidth * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
	 else
		 nWidth :=round  ( nWidth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
	 end
	 // Len of bar
	 if lHorz
		  nLen :=round ( nLen * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
	 else
		 nLen :=round  ( nLen * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
	 end

	 DEFINE FONT oFont name cFont of oPrInt size nWidth*5.6 , nLen*0.04 ;
					 nescapement if(lHorz,0,13500)

	 if lHorz
		  oPrint:say(nRow+nLen*0.9,nCol-nWidth*8,left(k,1),oFont,,Color)
		  oPrint:say(nRow+nLen*0.9,nCol+nWidth*3,substr(k,2,6),oFont,,Color)
		  oPrint:say(nRow+nLen*0.9,nCol+nWidth*50,substr(k,8,6),oFont,,Color)
	 else
		  oPrint:say(nRow-nWidth*8,nCol+nLen*0.1,left(k,1),oFont,,Color)
		  oPrint:say(nRow+nWidth*3,nCol+nLen*0.1,substr(k,2,6),oFont,,Color)
		  oPrint:say(nRow+nWidth*50,nCol+nLen*0.1,substr(k,8,6),oFont,,Color)
	 end

return nil

//------------------------------------------------------------------------------
function barlen(cCode,nDigs,oPrint,nRow,nCol,Color,lHorz,nWidth,nLen,cFont)
local oFont, nLenChar, l ,Control,k,s1,s2,n, Izda, dCha

	 DEFAULT lHorz := .t.
	 DEFAULT nWidth := 0.025 // 1/3 M/mm
	 DEFAULT nLen := 1.5 // Cmm.
	 DEFAULT cFont := 'arial'
	 DEFAULT Color := CLR_BLACK
	 DEFAULT nDigs := 11

	// calculo del digito de control
	 k:=left(alltrim(cCode)+'000000000000',nDigs) // padding with '0'
	// calculo del digito de control
	 k=k+Upc_CHECK(cCode,nDigs)                     // cCode,nLen
	 nDigs++
	 dcha:=Right(K,nDigs/2)
	 izda:=Left(k,nDigs/2)

	 if !lHorz
		  nWidth :=round ( nWidth * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
	 else
		 nWidth :=round  ( nWidth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
	 end
	 // Len of bar
	 if lHorz
		  nLen :=round ( nLen * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
	 else
		 nLen :=round  ( nLen * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
	 end

	 DEFINE FONT oFont name cFont of oPrInt size nWidth*5.6 , nLen*0.04 ;
					 nescapement if(lHorz,0,13500)

	 // fisrt letter
	 if lHorz
		  oPrint:say(nRow+nLen*0.9,nCol+nWidth*3,Izda,oFont,,Color)
		  oPrint:say(nRow+nLen*0.9,nCol+nWidth*(int(nDigs)/2*7+8),dcha,oFont,,Color)
	 else
		  oPrint:say(nRow+nWidth*3,nCol+nLen*0.1,izda,oFont,,Color)
		  oPrint:say(nRow+nWidth*(nDigs/2+8),nCol+nLen*0.1,dcha,oFont,,Color)
	 end

return nil

//------------------------------------------------------------------------------
function ban5(cCode,oPrint,nRow,nCol,Color,lHorz,nWidth,nLen,cFont)
local oFont, nLenChar, k,n, oPen

	 DEFAULT lHorz := .t.
	 DEFAULT nWidth := 0.025 // 1/3 M/mm
	 DEFAULT nLen := 1.5 // Cmm.
	 DEFAULT cFont := 'arial'
	 DEFAULT Color := CLR_BLACK

	 ccode:=left(alltrim(cCode)+'000000000000',5) // padding with '0'

	 if !lHorz
		  nWidth :=round ( nWidth * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
	 else
		 nWidth :=round  ( nWidth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
	 end
	 // Len of bar
	 if lHorz
		  nLen :=round ( nLen * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
	 else
		 nLen :=round  ( nLen * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
	 end



	 DEFINE FONT oFont name cFont of oPrInt size nWidth*5.6 , nLen*0.04 ;
					 nescapement if(lHorz,0,13500)

	 DEFINE PEN oPen color CLR_WHITE of oPrint

	 k:=''
	 for n:=1 to 4
		  k+=substr(cCode,n,1)+ ' '
	 end
	 cCode := k+right(cCOde,1)

	 if lHorz
		  oPrint:box(nrow,ncol,nrow+nLen*.3,nCol+48*nWidth,oPen)
	 else
		  oPrint:box(nrow,ncol,nrow+41*nWidth,nCol+nLen*.3+48*nWidth,oPen)
	 end
	 oPrint:say(nRow,nCol,cCode,oFont,,Color)

	 release oPen
return nil

//------------------------------------------------------------------------------
function UPCA_barlen(cCode,oPrint,nRow,nCol,Color,lHorz,nWidth,nLen,cFont)
local oFont, nLenChar, l ,Control,k,n, Izda, dCha, nDigs:=11,oFont2

	 DEFAULT lHorz := .t.
	 DEFAULT nWidth := 0.025 // 1/3 M/mm
	 DEFAULT nLen := 1.5 // Cmm.
	 DEFAULT cFont := 'arial'
	 DEFAULT Color := CLR_BLACK


	 // calculo del digito de control
	 k:=left(alltrim(cCode)+'000000000000',nDigs) // padding with '0'
	 // calculo del digito de control
	 k=k+Upc_CHECK(cCode,nDigs)                     // cCode,nLen
	 nDigs++
	 dcha:=Right(K,nDigs/2)
	 izda:=Left(k,nDigs/2)

	 if !lHorz
		  nWidth :=round ( nWidth * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
	 else
		 nWidth :=round  ( nWidth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
	 end
	 // Len of bar
	 if lHorz
		  nLen :=round ( nLen * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
	 else
		 nLen :=round  ( nLen * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
	 end

	 DEFINE FONT oFont name cFont of oPrInt size nWidth*5.6 , nLen*0.04 ;
					 nescapement if(lHorz,0,13500)

	 DEFINE FONT oFont2 name cFont of oPrInt size nWidth*5.6 , nLen*0.025 ;
					 nescapement if(lHorz,0,13500)

	 // fisrt letter
	 if lHorz
		  oPrint:say(nRow+nLen*0.9,nCol-nWidth*8,left(k,1),oFont2,,Color)
		  oPrint:say(nRow+nLen*0.9,nCol+nWidth*10,right(Izda,5),oFont,,Color)
		  oPrint:say(nRow+nLen*0.9,nCol+nWidth*50,left(dcha,5),oFont,,Color)
		  oPrint:say(nRow+nLen*0.9,nCol+nWidth*95,right(k,1),oFont2,,Color)

	 else
		  oPrint:say(nRow-nWidth*8,nCol+nLen*0.1,left(k,1),oFont2,,Color)
		  oPrint:say(nRow+nWidth*10,nCol+nLen*0.1,right(izda,5),oFont,,Color)
		  oPrint:say(nRow+nWidth*50,nCol+nLen*0.1,left(dcha,5),oFont,,Color)
		  oPrint:say(nRow+nWidth*95,nCol+nLen*0.1,right(k,1),oFont2,,Color)

	 end

return nil

//------------------------------------------------------------------------------
//                             funciones barlib
//------------------------------------------------------------------------------
// funciones de llamadas de barlib
// chequean las posibles concordancias de datos
// y dan los errores

//#include 'fivewin.ch'

// CODE 128

/*

	 Code 128:

	 Admite los 128 caracteres 0 - 127

	 si slo son nmeros se usa un modelo comprimido, llamado
	 modo C
	 Si hay caracteres < 32 se usa el mdo A
	 Si hay caracteres en minusculas se usa el modo B ( modo por defecto)

	 Los modos se mezclan

	 Sintaxis :

	 code128(nRow,nCol,cCode,oPrint,[cMode],[Color],
			  [lOrientacion],[nAncho],[nAlto])

	 nRow, nCol en Prixels
	 nAncho,nAlto en Cm
*/

//------------------------------------------------------------------------------
function Code128(nRow,nCol,cCode,oPrint,cMode,Color,lHorz,nWidth,nHeigth)

	 go_code(_code128(cCode,cMode),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth)

return nil

//------------------------------------------------------------------------------
function c_Code128(nRow,nCol,cCode,oPrint,cMode,Color,lHorz,nWidth,nHeigth)

	 oPrint:Cmtr2Pix(@nRow, @nCol)

return Code128(nRow,nCol,cCode,oPrint,cMode,Color,lHorz,nWidth,nHeigth)

//------------------------------------------------------------------------------
function Code3_9(nRow,nCol,cCode,oPrint,lCheck,Color,lHorz,nWidth,nHeigth)

	 go_code(_code3_9(cCode,lCheck),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth)

return nil

//------------------------------------------------------------------------------
function c_Code3_9(nRow,nCol,cCode,oPrint,lCheck,Color,lHorz,nWidth,nHeigth)

	 oPrint:Cmtr2Pix(@nRow, @nCol)

return Code3_9(nRow,nCol,cCode,oPrint,lCheck,Color,lHorz,nWidth,nHeigth)

//------------------------------------------------------------------------------
function ean13(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth,lBanner,cFont)
local nLen

	 DEFAULT nHeigth := 1.5
	 DEFAULT lBanner:=.f.
	 // desplazamiento...
	 if lHorz
		  go_code(_ean13(cCode),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth*0.90)
	 else
		  nLen :=round  ( nHeigth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )*0.1
		 // 10% espacios
				go_code(_ean13(cCode),nRow,nCol+nLen,oPrint,lHorz,Color,nWidth,nHeigth*0.90)
	 endif
	 go_code(_ean13Bl(),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth)
	 if lBanner
		  barlen13(cCode,oPrint,nRow,nCol,Color,lHorz,nWidth,nHeigth,cFont)
	 endif

return nil

//------------------------------------------------------------------------------
function c_ean13(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth)

	 oPrint:Cmtr2Pix(@nRow, @nCol)

return ean13(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth)

//------------------------------------------------------------------------------
function UPCA(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth,lBanner,cFont)
local nLen

	 DEFAULT nHeigth := 1.5
	 DEFAULT lBanner:=.f.

	 if lHorz
		  go_code(_UPC(cCode),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth*0.90)
	 else
		  nLen :=round  ( nHeigth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )*0.1
		 // 10% espacios
				go_code(_UPC(cCode),nRow,nCol+nLen,oPrint,lHorz,Color,nWidth,nHeigth*0.90)
	 end
	 go_code(_UPCABl(cCode),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth)
	 if lBanner
		  UPCA_barlen(cCode,oPrint,nRow,nCol,Color,lHorz,nWidth,nHeigth,cFont)
	 end

return nil

//------------------------------------------------------------------------------
function c_UPCA(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth)

	 oPrint:Cmtr2Pix(@nRow, @nCol)

return UPCA(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth)

//------------------------------------------------------------------------------
function ean8(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth,lBanner,cFont)
local nLen

	 DEFAULT nHeigth := 1.5
	 DEFAULT lBanner:=.f.

	 if lHorz
		  go_code(_UPC(cCode,7),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth*0.90)
	 else
		  nLen :=round  ( nHeigth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )*0.1
		 // 10% espacios
				go_code(_UPC(cCode,7),nRow,nCol+nLen,oPrint,lHorz,Color,nWidth,nHeigth*0.90)
	 end
	 go_code(_ean13Bl(8),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth)
	 if lBanner
		  barlen(cCode,7,oPrint,nRow,nCol,Color,lHorz,nWidth,nHeigth,cFont)
	 end

return nil

//------------------------------------------------------------------------------
function c_ean8(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth)

	 oPrint:Cmtr2Pix(@nRow, @nCol)

return ean8(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth)

//------------------------------------------------------------------------------
function sup5(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth,lBanner,cFOnt)

	 go_code(_sup5(cCode),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth)
	 if lBANNER
		  ban5(cCode,oPrint,nRow,nCol,Color,lHorz,nWidth,nhEIGTH,cFont)
	 end

return nil

//------------------------------------------------------------------------------
function c_Sup5(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth,lBanner,cFont)

	 oPrint:Cmtr2Pix(@nRow, @nCol)

return sup5(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth,lBanner,cFont)

//------------------------------------------------------------------------------
function Codabar(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth)

	 go_code(_Codabar(cCode),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth)

return nil

//------------------------------------------------------------------------------
function c_Codabar(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth)

	 oPrint:Cmtr2Pix(@nRow, @nCol)

return Codabar(nRow,nCol,cCode,oPrint,Color,lHorz,nWidth,nHeigth)

//------------------------------------------------------------------------------
function int25(nRow,nCol,cCode,oPrint,lCheck,Color,lHorz,nWidth,nHeigth)

	 go_code(_int25(cCode,lCheck),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth)

return nil

//------------------------------------------------------------------------------
function c_int25(nRow,nCol,cCode,oPrint,lCheck,Color,lHorz,nWidth,nHeigth)

	 oPrint:Cmtr2Pix(@nRow, @nCol)

return int25(nRow,nCol,cCode,oPrint,lCheck,Color,lHorz,nWidth,nHeigth)

//------------------------------------------------------------------------------
function ind25(nRow,nCol,cCode,oPrind,lCheck,Color,lHorz,nWidth,nHeigth)

	 go_code(_ind25(cCode,lCheck),nRow,nCol,oPrind,lHorz,Color,nWidth,nHeigth)

return nil

//------------------------------------------------------------------------------
function c_ind25(nRow,nCol,cCode,oPrint,lCheck,Color,lHorz,nWidth,nHeigth)

	 oPrint:Cmtr2Pix(@nRow, @nCol)

return ind25(nRow,nCol,cCode,oPrint,lCheck,Color,lHorz,nWidth,nHeigth)

//------------------------------------------------------------------------------
function mat25(nRow,nCol,cCode,oPrint,lCheck,Color,lHorz,nWidth,nHeigth)

	 go_code(_mat25(cCode,lCheck),nRow,nCol,oPrint,lHorz,Color,nWidth,nHeigth)

return nil

//------------------------------------------------------------------------------
function c_mat25(nRow,nCol,cCode,oPrint,lCheck,Color,lHorz,nWidth,nHeigth)

	 oPrint:Cmtr2Pix(@nRow, @nCol)

return mat25(nRow,nCol,cCode,oPrint,lCheck,Color,lHorz,nWidth,nHeigth)

//------------------------------------------------------------------------------
//                           funciones codabar
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function _codabar( cCode )
local n, cBarra := '', nCar

	 cCode := upper( cCode )
	 for n:=1 to len( cCode )
		  if (nCar:=at(substr(cCode,n,1),cCharcodabar)) > 0
				cBarra += aCodaBar[ nCar ]
		  endif
	 next n

return cBarra

//------------------------------------------------------------------------------
//                             funciones code128
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function _code128(cCode,cMode)

local nSum:=0, cBarra, cCar
local cTemp, n, nCAr, nCount:=0
local lCodeC := .f. ,lCodeA:= .f.


	 // control de errores
	 if valtype(cCode) !='C'
		  alert('Barcode c128 required a Character value. ')
		  return nil
	 end
	 if !empty(cMode)
		  if valtype(cMode)='C' .and. Upper(cMode)$'ABC'
				cMode := Upper(cMode)
		  else
				alert('Code 128 Modes are A,B o C. Character values.')
		  end
	 end
	 if empty(cMode) // modo variable
		  // anlisis de tipo  de cdigo...
		  if str(val(cCode),len(cCode))=cCode // slo nmeros
				lCodeC := .t.
				cTemp:=aCode128[106]
				nSum := 105
		  else
				for n:=1 to len(cCode)
					 nCount+=if(substr(cCode,n,1)>31,1,0) // no cars. de control
				end
				if nCount < len(cCode) /2
					 lCodeA := .t.
					 cTemp := aCode128[104]
					 nSum := 103
				else
					 cTemp := aCode128[105]
					 nSum := 104
				end
		  end
	 else
		  if cMode =='C'
				lCodeC := .t.
				cTemp:=aCode128[106]
				nSum := 105
		  elseif cMode =='A'
				lCodeA := .t.
				cTemp := aCode128[104]
				nSum := 103
		  else
				cTemp := aCode128[105]
				nSum := 104
		  end
	 end

	 nCount := 0 // caracter registrado
	 for n:= 1 to len(cCode)
		  nCount ++
		  cCar := substr(cCode,n,1)
		  if lCodeC
				if len(cCode)=n  // ultimo caracter
					 CTemp += aCode128[101] // SHIFT Code B
					 nCar := asc(cCar)-31
				else
					 nCar := Val(substr(cCode,n,2))+1
					 n++
				end
		  elseif lCodeA
				if cCar> '_' // Shift Code B
					 cTemp += aCode128[101]
					 nCar := asc(cCar)-31
				elseif cCar <= ' '
					 nCar := asc(cCar)+64
				else
					 nCar := asc(cCar)-31
				endif
		  else // code B standard
				if cCar <= ' ' // shift code A
					 cTemp += aCode128[102]
					 nCar := asc(cCar)+64
				else
					 nCar := asc(cCar)-31
				end
		  endif
		  nSum += (nCar-1)*nCount
		  cTemp := cTemp +aCode128[nCar]
	 next n
	 nSum := nSum%103 +1
	 cTemp := cTemp + aCode128[ nSum ] +aCode128[107]
	 cBarra := ''
	 for n:=1 to len(cTemp) step 2
		  cBarra+=replicate('1',val(substr(cTemp,n,1)))
		  cBarra+=replicate('0',val(substr(cTemp,n+1,1)))
	 next n

return cBarra

//------------------------------------------------------------------------------
//                        funciones code3de9
//------------------------------------------------------------------------------
function _Code3_9( cCode, lCheck )
local cCar,m, n, n1,n2, cBarra := '',  nCheck := 0

	 default lCheck := .f.
	 cCode := upper(cCode)
	 if len(cCode )>32
		  cCode := left(cCode,32)
	 endif
	 cCode := '*'+cCode+'*'
	 for n:= 1 to len( cCode )
		  cCar := substr( cCode,n,1)
		  m:=at( cCar, cCars )
		  if n>0 // otros caracteres se ignoran :-))
				cBarra := cBarra + aBarras[m]
				nCheck += (m-1)
		  endif
	 next n

	if lCheck
	 cBarra+= aBarras[nCheck%43 +1]
	endif

return cBarra

//------------------------------------------------------------------------------
//                              funciones ean13
//------------------------------------------------------------------------------
function _ean13( cCode )
	local l,s1,s2,controln,ac,cad,cadena,cadena2, n1, n2, NUmero
	local Izda, Dcha, String, Mascara, k  ,n
	k:=left(alltrim(cCode)+'000000000000',12)     // padding with '0'
	// calculo del digito de control
	k:=k+EAN13_CHECK(k)                           // Chaeck Digit en EAN13
	// preparacion de la cadena de impresion
	cadena:=[]
	dcha:=SUBSTR(K,8,6)
	izda:=substr(k,2,6)
	mascara:=substr(ean13primero,(val(substr(k,1,1))*6)+1,6)

	// barra de delimitacion
	cadena:=[101]
	// parte izda
	for n=1 to 6
		numero:=val(substr(izda,n,1))
		if substr(mascara,n,1)=[o]
			string:=substr(ean13izda1,numero*7+1,7)
		else
			string:=substr(ean13izda2,numero*7+1,7)
		end
		*  ? strzero(numero,1)+[->]+string
		cadena:=cadena+string

	next n
	cadena:=cadena+[01010]
	// LADO DERECHO
	for n=1 to 6
		numero:=val(substr(dcha,n,1))
		string:=substr(ean13derecha,numero*7+1,7)
		*  ? strzero(numero,1)+[->]+string
		cadena:=cadena+string
	next n
	cadena:=cadena+[101]

return Cadena

//------------------------------------------------------------------------------
function EAN13_CHECK(cCode)
local s1,s2,l,Control,n

	s1:=0                                         // suma de impares
	s2:=0                                         // suma de pares
	for n=1 to 6
		s1:=s1+val(substr(cCode,(n*2)-1,1))
		s2:=s2+val(substr(cCode,(n*2),1))
	next n
	control:=(s2*3)+s1
	l:=10
	do while control>l
		l:=l+10
	end
	control:=l-control

return sTr(control,1,0)

//------------------------------------------------------------------------------
function _ean13BL(nLen)

	DEFAULT nLen to 12
	nLen:=int(nLen/2)

return '101'+replicate('0',nLen*7)+'01010'+replicate('0',nLen*7)+'101'

//------------------------------------------------------------------------------
function _UPC( cCode, nLen )
local l,s1,s2,control,n,ac,cad,cadena, n1, n2, NUmero
local Izda, Dcha, String, Mascara, k

	DEFAULT nLen to 11
	DEFAULT cCode to '0'

	// valid values for nLen are 11,7
	k:=left(alltrim(cCode)+'000000000000',nLen)   // padding with '0'
	// calculo del digito de control
	k=k+Upc_CHECK(cCode,nLen)                     // cCode,nLen
	nLen++
	// preparacion de la cadena de impresion
	cadena:=[]
	dcha:=Right(K,nLen/2)
	izda:=Left(k,nLen/2)
	// barra de delimitacion
	cadena:=[101]
	// parte izda
	for n=1 to len(Izda)
		numero:=val(substr(izda,n,1))
		cadena+=substr(ean13izda1,numero*7+1,7)
	next n
	cadena:=cadena+[01010]
	// LADO DERECHO
	for n=1 to len(dcha)
		numero:=val(substr(dcha,n,1))
		cadena+=substr(ean13derecha,numero*7+1,7)
	next n
	cadena:=cadena+[101]

return Cadena

//------------------------------------------------------------------------------
function _UPCABL(cCode)
local cadena, k

	k:=left(alltrim(cCode)+'000000000000',11)   // padding with '0'
	// calculo del digito de control
	k=k+Upc_CHECK(cCode,11)                     // cCode,nLen
	// preparacion de la cadena de impresion
	cadena:=[101]
	// parte izda
		cadena+=substr(ean13izda1,val(left(k,1))*7+1,7)
		cadena+=replicate('0',35) // resto
	cadena:=cadena+[01010] //centro
	// LADO DERECHO
		cadena+=replicate('0',35) // resto
		cadena+=substr(ean13derecha,val(right(k,1))*7+1,7)
	cadena:=cadena+[101]

return Cadena

//------------------------------------------------------------------------------
function Upc_CHECK(cCode,nLen)
local s1,s2,n,l,control

	s1:=0                                         // suma de impares
	s2:=0                                         // suma de pares
	for n=1 to nLen step 2
		s1:=s1+val(substr(cCode,n,1))
		s2:=s2+val(substr(cCode,n+1,1))
	next n
	control:=(s1*3)+s2
	l:=10
	do while control>l
		l:=l+10
	end
	control:=l-control

return str(Control,1,0)

//------------------------------------------------------------------------------
// suplemento de 5 digitos
function _Sup5(cCode)
local l, k, control, n, cBarras := '1011',nCar

	k:=left(alltrim(cCode)+'00000',5)             // padding with '0'
	control := right( str( val(substr(k,1,1))*3 + val(substr(k,3,1))*3 ;
		+ val(substr(k,5,1))*3 + val(substr(k,2,1))*9+;
		val(substr(k,4,1))*9,5,0 ),1)
	control:=substr(ean13primero,val(control)*6+2,5)
	for n:=1 to 5
		nCar:=val(substr(k,n,1))
		if substr(control,n,1)='o'
			cBarras+=substr(ean13Izda2,nCar*7+1,7)
		else
			cBarras+=substr(ean13Izda1,nCar*7+1,7)
		end
		if n<5
			cBarras+='01'
		end
	next n

return cBarras


//------------------------------------------------------------------------------
//                               funciones go_code
//------------------------------------------------------------------------------
function go_code( cBarra, nx,ny,oPrint,lHoRz, nColor, nWidth, nLen)
local n, oBr

	 if empty(nColor)
		  nColor := CLR_BLACK
	 end

	 DEFAULT lHorz := .t.
	 DEFAULT nWidth := 0.025 // 1/3 M/mm
	 DEFAULT nLen := 1.5 // Cmm.

	 DEFINE BRUSH oBr color nColor

	 //    Width of Bar
	 if !lHorz
		  nWidth :=round ( nWidth * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
	 else
		 nWidth :=round  ( nWidth * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
	 end
	 // Len of bar
	 if lHorz
		  nLen :=round ( nLen * 10 * oPrint:nVertRes() / oPrint:nVertSize() ,0 )
	 else
		 nLen :=round  ( nLen * 10 * oPrint:nHorzRes() / oPrint:nHorzSize(), 0 )
	 end

	 for n:=1 to len(cBarra)
		  if substr(cBarra,n,1) ='1'
				if lHorz
					 oPrint:fillRect({nx,ny,nx+nLen,(ny+=nWidth)},oBr)
				else
					 oPrint:fillRect({nx,ny,(nx+=nWidth),ny+nLen},oBr)
				end
			 else
			 if lHorz
				ny+=nWidth
				else
				nx += nWidth
			  end
		  end
	 next n

	 oBr:end()

return nil

//------------------------------------------------------------------------------
//                                funciones int25
//------------------------------------------------------------------------------
function _int25(cCode,lMode)
local n,cBar:='', cIz:='',cDer:='',nLen:=0,nCheck:=0,cBarra:=''
local m

	 DEFAULT lMode to .f.
	 cCode:=trans(cCode,'@9') // elimina caracteres

	 if (nLen%2=1.and.!lMode)
		  nLen++
		  cCode+='0'
	 end
	 if lMode
		  for n:=1 to len(cCode) step 2
				nCheck+=val(substr(cCode,n,1))*3+val(substr(cCode,n+1,1))
		  next n
		  cCode += right(str(nCheck,10,0),1)
	 end

	 nLen:=len(cCode)
	 cBarra:= cStartint25
	 // preencoding .. interlaving

	 for n:=1 to nLen step 2
		  cIz:=aBarint25[val(substr(cCode,n,1))+1]
		  cDer:=aBarint25[val(substr(cCode,n+1,1))+1]
		  for m:=1 to 5
				cBarra+=substr(cIz,m,1)+substr(cDer,m,1)
		  next m
	 next n
	 cBarra+=cStopint25
	 for n:=1 to len(cBarra) step 2
		  if substr(cBarra,n,1)='1'
				cBar+='111'
		  else
				cBar+='1'
		  end
		  if substr(cBarra,n+1,1)='1'
				cBar+='000'
		  else
				cBar+='0'
		  end
	 next n

return cBar

//------------------------------------------------------------------------------
function _MAT25(cCode,lCheck)
local cBar:='',cBarra:='', nCheck,n

	 DEFAULT lCheck to .f.

	 cCode:=trans(cCode,'@9') // only digits
	 if lCheck
		  for n:=1 to len(cCode) step 2
				nCheck+=val(substr(cCode,n,1))*3+val(substr(cCode,n+1,1))
		  next n
		  cCode += right(str(nCheck,10,0),1)
	 end
	 cBar:=cMtStint25
	 for n:=1 to len(cCode)
		  cBar+=aBarint25[val(substr(cCode,n,1))+1]+'0'
	 next n
	 cBar+=cMtStint25
	 for n:=1 to len(cBar) step 2
		  if substr(cBar,n,1)='1'
				cBarra+='111'
		  else
				cBarra+='1'
		  end
		  if substr(cBar,n+1,1)='1'
				cBarra+='000'
		  else
				cBarra+='0'
		  end
	 next n

return cBarra

//------------------------------------------------------------------------------
function _Ind25(cCode,lCheck)
local cBar:='',cBarra:='', nCheck,n

	 DEFAULT lCheck to .f.

	 cCode:=trans(cCode,'@9') // only digits
	 if lCheck
		  for n:=1 to len(cCode) step 2
				nCheck+=val(substr(cCode,n,1))*3+val(substr(cCode,n+1,1))
		  next n
		  cCode += right(str(nCheck,10,0),1)
	 end
	 cBar:=cInStartint25
	 for n:=1 to len(cCode)
		  cBar+=aBarint25[val(substr(cCode,n,1))+1]+'0'
	 next n
	 cBar+=cInStopint25
	 for n:=1 to len(cBar)
		  if substr(cBar,n,1)='1'
				cBarra+='1110'
		  else
				cBarra+='10'
		  end
	 next n

return cBarra


//------------------------------------------------------------------------------
//                             funciones suport
//------------------------------------------------------------------------------
// Autor: Paco Garcia

//------------------------------------------------------------------------------
function vPix2MM( nPix )
local nMMs := 0
local hdc      := CreateDC( "DISPLAY",0,0,0 )
local hres     := GetDeviceCaps(hdc,HORZRES)    // {display width in pixels}
local vres     := GetDeviceCaps(hdc,VERTRES)    // {display height in pixels}
local hsiz     := GetDeviceCaps(hdc,HORZSIZE)   // {display width in mm}
local vsiz     := GetDeviceCaps(hdc,VERTSIZE)   // {display height in mm}
local HPixByMM := (hres/hsiz )                  // pixels hay en un mm horizontal
local VPixByMM := (vres/vsiz )                  // pixels hay en un mm vertical

	DeleteDC( hdc )

	nMMs :=  nPix / VPixByMM

return nMMs

//------------------------------------------------------------------------------
function hPix2MM( nPix )
local nMMs := 0
local hdc      := CreateDC( "DISPLAY",0,0,0 )
local hres     := GetDeviceCaps(hdc,HORZRES)    // {display width in pixels}
local vres     := GetDeviceCaps(hdc,VERTRES)    // {display height in pixels}
local hsiz     := GetDeviceCaps(hdc,HORZSIZE)   // {display width in mm}
local vsiz     := GetDeviceCaps(hdc,VERTSIZE)   // {display height in mm}
local HPixByMM := (hres/hsiz )                  // pixels hay en un mm horizontal
local VPixByMM := (vres/vsiz )                  // pixels hay en un mm vertical

	DeleteDC( hdc )
	nMMs := nPix / HPixByMM

return nMMs

//------------------------------------------------------------------------------
function vMM2Pix( nMMs )
local nPix := 0
local hdc      := CreateDC( "DISPLAY",0,0,0 )
local hres     := GetDeviceCaps(hdc,HORZRES)    // {display width in pixels}
local vres     := GetDeviceCaps(hdc,VERTRES)    // {display height in pixels}
local hsiz     := GetDeviceCaps(hdc,HORZSIZE)   // {display width in mm}
local vsiz     := GetDeviceCaps(hdc,VERTSIZE)   // {display height in mm}
local HPixByMM := (hres/hsiz )                  // pixels hay en un mm horizontal
local VPixByMM := (vres/vsiz )                  // pixels hay en un mm vertical

	DeleteDC( hdc )
	nPix :=  nMMs * VPixByMM

return nPix

//------------------------------------------------------------------------------
function hMM2Pix( nMMs )
local nPix := 0
local hdc      := CreateDC( "DISPLAY",0,0,0 )
local hres     := GetDeviceCaps(hdc,HORZRES)    // {display width in pixels}
local vres     := GetDeviceCaps(hdc,VERTRES)    // {display height in pixels}
local hsiz     := GetDeviceCaps(hdc,HORZSIZE)   // {display width in mm}
local vsiz     := GetDeviceCaps(hdc,VERTSIZE)   // {display height in mm}
local HPixByMM := (hres/hsiz )                  // pixels hay en un mm horizontal
local VPixByMM := (vres/vsiz )                  // pixels hay en un mm vertical

	DeleteDC( hdc )
	nPix := nMMs * HPixByMM

return nPix
//------------------------------------------------------------------------------
function Savescreen( hDC, nTop, nLeft, nBottom, nRight )
local hBmpMem, hOldBmp
local hDCMem
local nWidth, nHeight

	hDCMem  := CreateCompatibleDC( hDC )

	nWidth  := nRight - nLeft
	nHeight := nBottom - nTop

	hBmpMem := CreateCompatibleBitmap( hDC, nWidth, nHeight )
	hOldBmp := SelectObject( hDCMem, hBmpMem )

	BitBlt( hDCMem, 0, 0, nWidth, nHeight, hDC, nLeft, nTop, SRCCOPY )
	SelectObject( hDCMem, hOldBmp )
	DeleteDC( hDCMem )

return hBmpMem


//------------------------------------------------------------------------------
//                            Class TBox
//------------------------------------------------------------------------------

CLASS TBox FROM TControl

	CLASSDATA lRegistered AS LOGICAL

	DATA nLineType        AS NUMERIC
	DATA nLineWidth       AS NUMERIC
	DATA nRound           AS NUMERIC
	DATA lShadow          AS LOGIC


	METHOD New( oWnd, nTop, nLeft, nBottom, nRight ) CONSTRUCTOR

	METHOD Paint()
	METHOD Display() INLINE ::BeginPaint(), ::Paint(), ::EndPaint(), 1
	METHOD RButtonDown( nRow, nCol, nFlags )

	METHOD Notify( nIdCtrl, nPtrNMHDR ) INLINE ::oWnd:Notify( nIdCtrl, nPtrNMHDR )

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( oWnd, nTop, nLeft, nBottom, nRight ) CLASS TBox

	DEFAULT nTop := 20, nLeft := 20, nBottom := 10, nRight := 100,;
			  oWnd := GetWndDefault()

	::nTop       := nTop
	::nLeft      := nLeft
	::nBottom    := nBottom
	::nRight     := nRight
	::oWnd       := oWnd
	::nStyle     := nOr( WS_CHILD, WS_VISIBLE )
	::lDrag      := .t.
	::nLineType  := 1
	::nLineWidth := 2
	::nRound     := 0
	::nClrPane   := CLR_WHITE
	::nClrText   := CLR_BLACK
	::lShadow    := .t.

	::SetBrush( TBrush():New( "NULL" ) )

	#ifdef __XPP__
		DEFAULT ::lRegistered := .f.
	#endif

	::Register()

	if ! Empty( ::oWnd:hWnd )
		::Create()
		::oWnd:AddControl( Self )
	else
		::oWnd:DefControl( Self )
	endif

	if ::lDrag
		::CheckDots()
	endif

return Self

//------------------------------------------------------------------------------
METHOD Paint() CLASS TBox
local nTop, nLeft, nHeight, nWidth, nBevel
local n, hPen, hOldPen, hOldBrush
local nAmpla, nOld
local oPen, oBrush, oDummy

	::CoorsUpdate()

	hPen := CreatePen( 0, ::nLineWidth / 10, ::nClrText )
	hOldPen := SelectObject( ::hDc, hPen )
	nAmpla := ::nLineWidth / 10

	do case
		case ::nLinetype == 1
			  ::nRound := 0
			  MoveTo( ::hDC, nAmpla, nAmpla )
			  LineTo(::hDC, nAmpla, ::nHeight - nAmpla , hPen )
			  LineTo(::hDC, ::nWidth - nAmpla, ::nHeight - nAmpla , hPen )
			  LineTo(::hDC, ::nWidth - nAmpla , nAmpla, hPen )
			  LineTo(::hDC, nAmpla, nAmpla, 0, hPen )

		case ::nLinetype == 2
			  ::nRound := 0
			  MoveTo( ::hDC, nAmpla, nAmpla )
			  LineTo(::hDC, ::nWidth - nAmpla, nAmpla )

		case ::nLinetype == 3
			  ::nRound := 0
			  MoveTo( ::hDC, nAmpla, nAmpla )
			  LineTo(::hDC, nAmpla, ::nHeight -  nAmpla )

		case ::nLinetype == 4
			  ::nRound := 0
			  MoveTo( ::hDC, nAmpla, ::nHeight - nAmpla )
			  LineTo(::hDC, ::nWidth - nAmpla, ::nHeight - nAmpla )

		case ::nLinetype == 5
			  ::nRound := 0
			  MoveTo( ::hDC, ::nWidth - nAmpla, ::nHeight - nAmpla )
			  LineTo(::hDC, ::nWidth - nAmpla,  nAmpla )

		case ::nLinetype == 6
			  if  ::nRound == 0
					::nRound := 25
			  endif

			  ::CoorsUpdate()
			  oDummy := ::GetCliRect()
			  Roundrect( ::hDC, nAmpla, nAmpla, ::nWidth - nAmpla, ::nHeight - nAmpla, ::nRound, ::nRound )

	endcase

	SelectObject( ::hDc, hOldPen )
	DeleteObject( hPen )

return NIL

//------------------------------------------------------------------------------
METHOD RButtonDown( nRow, nCol, nFlags ) CLASS TBox
local oMenu, oClp, cText
local nWidth

/*
	MENU oMenu POPUP
		  MENUITEM "&Rectangulo"          ACTION ::nLinetype := 1
		  MENUITEM "&Horizontal Top"      ACTION ::nLinetype := 2
		  MENUITEM "&Vertical Izquierda"  ACTION ::nLinetype := 3
		  MENUITEM "&Horizontal Bottom"   ACTION ::nLinetype := 4
		  MENUITEM "&Vertical Derecha"    ACTION ::nLinetype := 5
		  MENUITEM "&Redondeado"          ACTION ::nLinetype := 6
		  SEPARATOR
		  MENUITEM "Color Fondo" ACTION ::SelColor(.f.)
		  MENUITEM "Color Borde" ACTION ::SelColor(.t.)
		  SEPARATOR
		  MENUITEM "Borde"       ACTION ( nWidth := ::nLineWidth ,;
													 MsgGet( 'Borde', 'Ancho', @nWidth ),;
													 IF( nWidth > 0, ( ::nLineWidth := nWidth, ::Refresh() ), ) )
		  MENUITEM "Redondeado"  ACTION ( nWidth := ::nRound ,;
													 MsgGet( 'Redondeo', 'Factor', @nWidth ),;
													 IF( nWidth > 0, ( ::nLinetype := 6, ::nRound := nWidth, ::Refresh() ), ) )
		  SEPARATOR

		  MENUITEM "Top"     ACTION ( SetWindowPos( ::hWnd, HWND_TOP   , ::nTop, ::nLeft, ::nWidth, ::nHeight ), ::Refresh() )
		  MENUITEM "Bottom"  ACTION ( SetWindowPos( ::hWnd, HWND_BOTTOM, ::nTop, ::nLeft, ::nWidth, ::nHeight ), ::Refresh() )

	ENDMENU

	ACTIVATE POPUP oMenu AT nRow, nCol OF Self


	::SetSize( ::nWidth+1, ::nHeight, .f. )
	::SetSize( ::nWidth-1, ::nHeight, .t. )

*-

	::SetFocus()

*/

return 0             // Message already processed

//------------------------------------------------------------------------------
//                           Class TCodeBar
//------------------------------------------------------------------------------

CLASS TCodeBar FROM TImage

	CLASSDATA lRegistered              AS LOGICAL
	CLASSDATA cDllFile                 AS CHARACTER INIT ''

	METHOD New( oWnd, nTop, nLeft, nWidth, nHeight ) CONSTRUCTOR
	METHOD Notify( nIdCtrl, nPtrNMHDR ) INLINE ::oWnd:Notify( nIdCtrl, nPtrNMHDR )

ENDCLASS


//------------------------------------------------------------------------------
METHOD New( oWnd, nTop, nLeft, nWidth, nHeight ) CLASS TCodeBar
local hOldRes   := GetResources()
local lNoBorder := .t.
local lStretch  := .t.
local lPixel    := .t.
local lDesign   := .t.

	 DEFAULT nTop := 20, nLeft := 20, nWidth := 20, nHeight := 10,;
				oWnd := GetWndDefault()

	::Register()

	 SetResources( ::cDllFile )

	::Super:New( nTop, nLeft, nWidth, nHeight, 'CodeBar', , lNoBorder,;
				  oWnd,         ,          ,        , lStretch,        ,;
						,       ,      , lPixel,       , lDesign )

	SetResources( hOldRes )

return Self

//------------------------------------------------------------------------------
//                             Class TItem
//------------------------------------------------------------------------------

CLASS TItem

	 DATA oObj
	 DATA oTree
	 DATA oFont
	 DATA nKey               AS NUMERIC   INIT 0
	 DATA cId                AS CHARACTER INIT ''
	 DATA Cargo
	 DATA cClass             AS CHARACTER INIT ''
	 DATA cFile              AS CHARACTER INIT ''
	 DATA cImgFileHeader     AS CHARACTER INIT ''
	 DATA nTop               AS NUMERIC   INIT 0
	 DATA nTopIni            AS NUMERIC   INIT 0
	 DATA nLeft              AS NUMERIC   INIT 0
	 DATA nHeight            AS NUMERIC   INIT 16
	 DATA nWidth             AS NUMERIC   INIT 100
	 DATA nBottom            AS NUMERIC   INIT 0
	 DATA nRight             AS NUMERIC   INIT 0
	 DATA nClrFore           AS NUMERIC   INIT CLR_BLACK
	 DATA nClrBack           AS NUMERIC   INIT CLR_WHITE
	 DATA nClrLine           AS NUMERIC   INIT CLR_BLACK
	 DATA cFaceName          AS CHARACTER INIT ''
	 DATA nInpHeight         AS NUMERIC   INIT -10
	 DATA nFontWidth         AS NUMERIC   INIT 0
	 DATA lFontBold          AS LOGICAL   INIT .f.
	 DATA lFontItalic        AS LOGICAL   INIT .f.
	 DATA lFontUnderline     AS LOGICAL   INIT .f.
	 DATA lBorder            AS LOGICAL   INIT .f.
	 DATA lMemo              AS LOGICAL   INIT .f.
	 DATA lMultiPage         AS LOGICAL   INIT .f.
	 DATA cCaption           AS CHARACTER INIT ''
	 DATA cSection           AS CHARACTER INIT ''
	 DATA cSecHead           AS CHARACTER INIT ''
	 DATA lSecFontBold       AS LOGICAL   INIT .f.
	 DATA lSecFontItalic     AS LOGICAL   INIT .f.
	 DATA lSecFontUnderline  AS LOGICAL   INIT .f.
	 DATA lVisible           AS LOGICAL   INIT .F.
	 DATA lShow              AS LOGICAL   INIT .T.
	 DATA lFixed             AS LOGICAL   INIT .T.
	 DATA lNewProperty       AS LOGICAL   INIT .F.
	 DATA nPad               AS NUMERIC   INIT 0
	 DATA nInterLine         AS NUMERIC   INIT 1
	 DATA nLineWidth         AS NUMERIC   INIT 1
	 DATA nLineType          AS NUMERIC   INIT 1
	 DATA nImgFixHeight      AS NUMERIC   INIT 5
	 DATA nImgFixHeader      AS NUMERIC   INIT 5
	 DATA nHeightFont        AS NUMERIC   INIT 5
	 DATA nCodeBarType       AS NUMERIC   INIT 2
	 DATA nShadow            AS NUMERIC   INIT 0
	 DATA lBanner            AS LOGICAL   INIT .T.
	 DATA lVertical          AS LOGICAL   INIT .F.
	 DATA lSpecial           AS LOGICAL   INIT .F.
	 DATA nType              AS NUMERIC   INIT 0

	 METHOD New()   CONSTRUCTOR

	 METHOD Reset()          INLINE ( nIditem := 0, nKeyitem := 0 )

	 METHOD NewId()

	 METHOD CopyFromItem( oItem )

	 METHOD Repos( )

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( lNewId ) CLASS TItem

	 DEFAULT lNewId := .T.

	 if lNewId
		 ::NewId()
	 endif

return Self

//------------------------------------------------------------------------------
METHOD NewID() CLASS TItem

	 nIditem++
	 nKeyitem++

	 ::cId   := 'ID' + PadL( nIditem, 3, '0' )
	 ::nKey  := nKeyitem

return NIL

//------------------------------------------------------------------------------
METHOD Repos( ) CLASS TItem

	 ::nTop := ::nTopIni

return nil

//------------------------------------------------------------------------------
METHOD CopyFromItem( oItem ) CLASS TItem

	 ::nKey              := oItem:nKey
	 ::cId               := oItem:cId
	 ::Cargo             := oItem:Cargo
	 ::cClass            := oItem:cClass
	 ::nType             := oItem:nType
	 ::nTop              := oItem:nTop
	 ::nLeft             := oItem:nLeft
	 ::nHeight           := oItem:nHeight
	 ::nWidth            := oItem:nWidth
	 ::nBottom           := oItem:nBottom
	 ::nRight            := oItem:nRight
	 ::nClrFore          := oItem:nClrFore
	 ::nClrBack          := oItem:nClrBack
	 ::nClrLine          := oItem:nClrLine
	 ::cSection          := oItem:cSection
	 ::lVisible          := oItem:lVisible
	 ::lFixed            := oItem:lFixed
	 ::nLineWidth        := oItem:nLineWidth
	 ::nLineType         := oItem:nLineType
	 ::nShadow           := oItem:nShadow
	 ::cSecHead          := oItem:cSecHead
	 ::lSecFontBold      := oItem:lSecFontBold
	 ::lSecFontItalic    := oItem:lSecFontItalic
	 ::lSecFontUnderline := oItem:lSecFontUnderline
	 ::lBorder           := oItem:lBorder
	 ::lSpecial          := oItem:lSpecial
	 ::nImgFixHeader     := oItem:nImgFixHeader
	 ::cImgFileHeader    := oItem:cImgFileHeader

	 do case
		 case oItem:cClass == 'TSAY'
				::cCaption          := oItem:cCaption
				::cFaceName         := oItem:cFaceName
				::nInpHeight        := oItem:nInpHeight
				::nFontWidth        := oItem:nFontWidth
				::lFontBold         := oItem:lFontBold
				::lFontItalic       := oItem:lFontItalic
				::lFontUnderline    := oItem:lFontUnderline
				::lMemo             := oItem:lMemo
				::lMultiPage        := oItem:lMultiPage
				::nPad              := oItem:nPad
				::nInterLine        := oItem:nInterLine
				::nHeightFont       := oItem:nHeightFont

		 case oItem:cClass == 'TIMAGE'
				::cFile             := oItem:cFile
				::nImgFixHeight     := oItem:nImgFixHeight

		 case oItem:cClass == 'TCODEBAR'
				::cCaption          := oItem:cCaption
				::cFaceName         := oItem:cFaceName
				::nCodeBarType      := oItem:nCodeBarType
				::lBanner           := oItem:lBanner
				::lVertical         := oItem:lVertical

	 endcase

return NIL

//------------------------------------------------------------------------------
//                             Class tmeterbar
//------------------------------------------------------------------------------

CLASS TMeterBar


	DATA   oWnd
	DATA   oMeter
	DATA   cOldMsg
	DATA   nAncho

	METHOD New( nTotal, cTitul, lCien, oWnd ) CONSTRUCTOR
	METHOD Set( nI )
	METHOD End()

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( nTotal, cTitul, lCien, oWnd ) CLASS TMeterBar
local nInicial
local nLin, nCol, nAlt
local nAltMeter

	 DEFAULT cTitul := ""
	 DEFAULT lCien  := .F.
	 DEFAULT oWnd   := GetWndApp()

	 ::oWnd    := oWnd
	 ::cOldMsg := ::oWnd:oMsgBar:cMsgDef
	 ::nAncho  := 100

	 nCol    := GetTextWidth( ::oWnd:hDc, cTitul, ::oWnd:oFont )

	 ::oWnd:oMsgbar:cMsgDef := cTitul
	 ::oWnd:oMsgbar:SetMsg( cTitul )
	 ::oWnd:oMsgbar:Refresh()

	 nAlt := IF( ::oWnd:oMsgbar:lInset, 11, 14 )
	 nLin := IF( ::oWnd:oMsgbar:lInset, 5, 4 )

	 if lCien
		 @nLin, nCol+20 METER ::oMeter VAR nInicial TOTAL nTotal OF ::oWnd:oMsgBar PIXEL              SIZE ::nAncho, nAlt
	 else
		 @nLin, nCol+20 METER ::oMeter VAR nInicial TOTAL nTotal OF ::oWnd:oMsgBar PIXEL NOPERCENTAGE SIZE ::nAncho, nAlt
	 endif

	 ::oMeter:nClrBar := CLR_BLUE
	 ::Set( 0 )

return SELF

//------------------------------------------------------------------------------
METHOD Set( nI ) CLASS TMeterBar

	 DEFAULT nI := 1

	 ::oMeter:Set( nI )
	 SysRefresh()

return NIL

//------------------------------------------------------------------------------
METHOD End() CLASS TMeterBar

	 ::oMeter:End()
	 ::oWnd:oMsgbar:cMsgDef := ::cOldMsg
	 ::oWnd:oMsgbar:SetMsg( ::cOldMsg )
	 ::oWnd:oMsgbar:Refresh()

return NIL

//------------------------------------------------------------------------------
function pMeterBar( nTotal, cTitul, lCien, oWnd )
return TMeterBar():New( nTotal, cTitul, lCien, oWnd )

//------------------------------------------------------------------------------
//                            Class TPublic
//------------------------------------------------------------------------------

CLASS TPublic

	 DATA oTree
	 DATA nHeight            AS NUMERIC   INIT 4
	 DATA nWidth             AS NUMERIC   INIT 40
	 DATA nClrFore           AS NUMERIC   INIT CLR_BLACK
	 DATA nClrBack           AS NUMERIC   INIT CLR_WHITE
	 DATA cFaceName          AS CHARACTER INIT 'Arial'
	 DATA nInpHeight         AS NUMERIC   INIT 10
	 DATA nFontWidth         AS NUMERIC   INIT 0
	 DATA lFontBold          AS LOGICAL   INIT .f.
	 DATA lFontItalic        AS LOGICAL   INIT .f.
	 DATA lFontUnderline     AS LOGICAL   INIT .f.
	 DATA lBorder            AS LOGICAL   INIT .t.
	 DATA cCaption           AS CHARACTER INIT '...'
	 DATA nPad               AS NUMERIC   INIT 0
	 DATA lVisible           AS LOGICAL   INIT .t.

	 METHOD New()   CONSTRUCTOR

ENDCLASS

//------------------------------------------------------------------------------
METHOD New() CLASS TPublic
return Self

//------------------------------------------------------------------------------
//                          Class TScrWnd
//------------------------------------------------------------------------------

CLASS TScrWnd


	DATA oWnd
	DATA nVPos,nHPos

	METHOD New( oWnd,nV1,nV2,nH1,nH2 ) CONSTRUCTOR
	METHOD SetScroll( nV1,nV2,nH1,nH2 )
	METHOD VScroll()
	METHOD VScrollThumb()
	METHOD VScrollTrack()
	METHOD VScrollPgDown()
	METHOD VScrollPgUp()
	METHOD HScroll()
	METHOD HScrollThumb()
	METHOD HScrollTrack()
	METHOD HScrollPgDown()
	METHOD HScrollPgUp()

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( oWnd,nV1,nV2,nH1,nH2 ) CLASS TScrWnd

	::nVPos := 0
	::nHPos := 0
	::oWnd := oWnd
	::SetScroll( nV1,nV2,nH1,nH2 )

return Self

//------------------------------------------------------------------------------
METHOD SetScroll( nV1,nV2,nH1,nH2 ) CLASS TScrWnd
local aCoors1:={},aCoors2:={}

	 // Vertical Scroll Bar
	 if ::oWnd:oVScroll != NIL
		 ::oWnd:oVScroll:SetRange( nV1,nV2 )
		 ::nVPos := ::oWnd:oVScroll:GetPos()
		 ::oWnd:oVScroll:bGoDown   := {|| ::VScroll() }
		 ::oWnd:oVScroll:bGoUp     := {|| ::VScroll() }
		 ::oWnd:oVScroll:bPageUp   := {|| ::VScrollPgUp() }
		 ::oWnd:oVScroll:bPageDown := {|| ::VScrollPgDown() }
		 ::oWnd:oVScroll:bGoTop    := {|| ::VScroll() }
		 ::oWnd:oVScroll:bGoBottom := {|| ::VScroll() }
		 ::oWnd:oVScroll:nPgStep   := 10
		 ::oWnd:oVScroll:bPos      := {|nPos| ::VScrollThumb(nPos) }
		 ::oWnd:oVScroll:bTrack    := {|nPos| ::VScrollTrack(nPos) }
	 endif

	 // Horizontal Scroll Bar
	 if ::oWnd:oHScroll != NIL
		 ::oWnd:oHScroll:SetRange( nH1,nH2 )
		 ::nHPos := ::oWnd:oHScroll:GetPos()
		 ::oWnd:oHScroll:bGoDown   := {|| ::HScroll() }
		 ::oWnd:oHScroll:bGoUp     := {|| ::HScroll() }
		 ::oWnd:oHScroll:bPageUp   := {|| ::HScrollPgUp() }
		 ::oWnd:oHScroll:bPageDown := {|| ::HScrollPgDown() }
		 ::oWnd:oHScroll:bGoTop    := {|| ::HScroll() }
		 ::oWnd:oHScroll:bGoBottom := {|| ::HScroll() }
		 ::oWnd:oHScroll:nPgStep   := 10
		 ::oWnd:oHScroll:bPos      := {|nPos| ::HScrollThumb(nPos) }
		 ::oWnd:oHScroll:bTrack    := {|nPos| ::HScrollTrack(nPos) }
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD VScroll() CLASS TScrWnd
local nNewPos

	if ::nVPos >= ::oWnd:oVScroll:nMin   ;
		.and. ::nVPos <= ::oWnd:oVScroll:nMax
		nNewPos := ::oWnd:oVScroll:GetPos()
		SysRefresh()

		ScrollWindow( ::oWnd:hWnd, 0,  ;
			(  ::nVPos-nNewPos )*D_HEIGHT,    ;
			0 , GetClientRect(::oWnd:hWnd) )
		::nVPos := nNewPos
	endif

return( NIL )

//------------------------------------------------------------------------------
METHOD VScrollThumb(nNewPos) CLASS TScrWnd

	if ::nVPos >= ::oWnd:oVScroll:nMin   ;
		.and. ::nVPos <= ::oWnd:oVScroll:nMax
		::oWnd:oVScroll:SetPos(nNewPos)
		SysRefresh()
		ScrollWindow( ::oWnd:hWnd, 0,  ;
			(::nVPos - nNewPos )*D_HEIGHT,    ;
			0 , GetClientRect(::oWnd:hWnd) )
		::nVPos := nNewPos
	endif

return( NIL )

//------------------------------------------------------------------------------
METHOD VScrollTrack(nNewPos) CLASS TScrWnd

	if ::nVPos >= ::oWnd:oVScroll:nMin   ;
		.and. ::nVPos <= ::oWnd:oVScroll:nMax
		::oWnd:oVScroll:SetPos(nNewPos)
		SysRefresh()
		ScrollWindow( ::oWnd:hWnd, 0,  ;
			(::nVPos - nNewPos )*D_HEIGHT,    ;
			0 , GetClientRect(::oWnd:hWnd) )
		::nVPos := nNewPos
	endif

return( NIL )

//------------------------------------------------------------------------------
METHOD VScrollPgDown() CLASS TScrWnd
local nNewPos

	if ::nVPos < ::oWnd:oVScroll:nMax
		nNewPos := ::nVPos + ::oWnd:oVScroll:nPgStep
		nNewPos := iif(nNewPos > ::oWnd:oVScroll:nMax, ::oWnd:oVScroll:nMax, nNewPos)
		SysRefresh()
		ScrollWindow( ::oWnd:hWnd, 0,  ;
			( ::nVPos - nNewPos )*D_HEIGHT,    ;
			0 , GetClientRect(::oWnd:hWnd) )
		::nVPos := nNewPos
	endif

return( NIL )

//------------------------------------------------------------------------------
METHOD VScrollPgUp() CLASS TScrWnd
local nNewPos

	if ::nVPos > ::oWnd:oVScroll:nMin
		nNewPos := ::nVPos - ::oWnd:oVScroll:nPgStep
		nNewPos := iif(nNewPos < ::oWnd:oVScroll:nMin,::oWnd:oVScroll:nMin,nNewPos)
		SysRefresh()
		ScrollWindow( ::oWnd:hWnd, 0,  ;
			( ::nVPos - nNewPos )*D_HEIGHT,    ;
			0 , GetClientRect(::oWnd:hWnd) )
		::nVPos := nNewPos
	endif

return( NIL )

//------------------------------------------------------------------------------
METHOD HScroll() CLASS TScrWnd
local nNewPos

	if ::nHPos >= ::oWnd:oHScroll:nMin   ;
		.and. ::nHPos <= ::oWnd:oHScroll:nMax
		nNewPos := ::oWnd:oHScroll:GetPos()
		SysRefresh()
		ScrollWindow( ::oWnd:hWnd,           ;
			(::nHPos - nNewPos )*D_WIDTH,0,   ;
			0 , GetClientRect(::oWnd:hWnd) )
		::nHPos := nNewPos
	endif

return( NIL )

//------------------------------------------------------------------------------
METHOD HScrollThumb(nNewPos) CLASS TScrWnd

	if ::nHPos >= ::oWnd:oHScroll:nMin   ;
		.and. ::nHPos <= ::oWnd:oHScroll:nMax
		::oWnd:oHScroll:SetPos(nNewPos)
		SysRefresh()
		ScrollWindow( ::oWnd:hWnd,           ;
			(::nHPos - nNewPos )*D_WIDTH,0,   ;
			0 , GetClientRect(::oWnd:hWnd) )
		::nHPos := nNewPos
	endif

return( NIL )

//------------------------------------------------------------------------------
METHOD HScrollTrack(nNewPos) CLASS TScrWnd

	if ::nHPos >= ::oWnd:oHScroll:nMin   ;
		.and. ::nHPos <= ::oWnd:oHScroll:nMax
		::oWnd:oHScroll:SetPos(nNewPos)
		SysRefresh()
		ScrollWindow( ::oWnd:hWnd,           ;
			(::nHPos - nNewPos )*D_WIDTH,0,   ;
			0 , GetClientRect(::oWnd:hWnd) )
		::nHPos := nNewPos
	endif

return( NIL )

//------------------------------------------------------------------------------
METHOD HScrollPgDown() CLASS TScrWnd
local nNewPos

	if ::nHPos < ::oWnd:oHScroll:nMax
		nNewPos := ::nHPos + ::oWnd:oHScroll:nPgStep
		nNewPos := iif(nNewPos > ::oWnd:oHScroll:nMax, ::oWnd:oHScroll:nMax, nNewPos)
		SysRefresh()
		ScrollWindow( ::oWnd:hWnd,           ;
			( ::nHPos - nNewPos )*D_WIDTH,0,  ;
			0 , GetClientRect(::oWnd:hWnd) )
		::nHPos := nNewPos
	endif

return( NIL )

//------------------------------------------------------------------------------
METHOD HScrollPgUp() CLASS TScrWnd
local nNewPos

	if ::nHPos > ::oWnd:oHScroll:nMin
		nNewPos := ::nHPos - ::oWnd:oHScroll:nPgStep
		nNewPos := iif(nNewPos < ::oWnd:oHScroll:nMin,::oWnd:oHScroll:nMin,nNewPos)
		SysRefresh()
		ScrollWindow( ::oWnd:hWnd,           ;
			( ::nHPos - nNewPos )*D_WIDTH,0,  ;
			0 , GetClientRect(::oWnd:hWnd) )
		::nHPos := nNewPos
	endif

return( NIL )

//------------------------------------------------------------------------------
//                               Class TSection
//------------------------------------------------------------------------------

CLASS TSection

	 DATA oTree
	 DATA oFont
	 DATA cSection           AS CHARACTER INIT ''
	 DATA nTop               AS NUMERIC   INIT 0
	 DATA nLeft              AS NUMERIC   INIT 0
	 DATA nHeight            AS NUMERIC   INIT 60
	 DATA nWidth             AS NUMERIC   INIT 40
	 DATA nBottom            AS NUMERIC   INIT 0
	 DATA nRight             AS NUMERIC   INIT 0
	 DATA nClrSecFore        AS NUMERIC   INIT CLR_BLACK
	 DATA nClrSecBack        AS NUMERIC   INIT CLR_WHITE
	 DATA nClrSecLine        AS NUMERIC   INIT CLR_WHITE
	 DATA nClrFore           AS NUMERIC   INIT CLR_BLACK
	 DATA nClrBack           AS NUMERIC   INIT 0
	 DATA cFaceName          AS CHARACTER INIT 'Arial'
	 DATA nInpHeight         AS NUMERIC   INIT 10
	 DATA nFontWidth         AS NUMERIC   INIT 0
	 DATA lFontBold          AS LOGICAL   INIT .f.
	 DATA lFontItalic        AS LOGICAL   INIT .f.
	 DATA lFontUnderline     AS LOGICAL   INIT .f.
	 DATA lBorder            AS LOGICAL   INIT .t.
	 DATA lFixed             AS LOGICAL   INIT .t.
	 DATA lHeader            AS LOGICAL   INIT .t.
	 DATA nInterLine         AS NUMERIC   INIT 1
	 DATA nFixHeight         AS NUMERIC   INIT 0
	 DATA lRelative          AS LOGICAL   INIT .F.
	 DATA lPijama            AS LOGICAL   INIT .F.
	 DATA lPijamaOnOff       AS LOGICAL   INIT .F.
	 DATA nPijamaClr1        AS NUMERIC   INIT CLR_GRAY
	 DATA nPijamaClr2        AS NUMERIC   INIT CLR_HGRAY
	 DATA nPijamaClr3        AS NUMERIC   INIT CLR_WHITE
	 DATA nLineWidth         AS NUMERIC   INIT 1
	 DATA nShadow            AS NUMERIC   INIT 0

	 METHOD New( cSection )   CONSTRUCTOR
	 METHOD CopyFromSection( oSection )

ENDCLASS

//------------------------------------------------------------------------------
METHOD New( cSection ) CLASS TSection

	 if ValType( cSection ) == 'C'
		 nSection++
		 DEFAULT cSection := ''
		 ::cSection := cSection
		 ::nClrBack := AssignClr()
	 endif

return Self

//------------------------------------------------------------------------------
METHOD CopyFromSection( oSection ) CLASS TSection

	 ::cSection        := oSection:cSection
	 ::nTop            := oSection:nTop
	 ::nLeft           := oSection:nLeft
	 ::nHeight         := oSection:nHeight
	 ::nWidth          := oSection:nWidth
	 ::nBottom         := oSection:nBottom
	 ::nRight          := oSection:nRight
	 ::nClrSecFore     := oSection:nClrSecFore
	 ::nClrSecBack     := oSection:nClrSecBack
	 ::nClrSecLine     := oSection:nClrSecLine
	 ::nClrFore        := oSection:nClrFore
	 ::nClrBack        := oSection:nClrBack
	 ::cFaceName       := oSection:cFaceName
	 ::nInpHeight      := oSection:nInpHeight
	 ::nFontWidth      := oSection:nFontWidth
	 ::lFontBold       := oSection:lFontBold
	 ::lFontItalic     := oSection:lFontItalic
	 ::lFontUnderline  := oSection:lFontUnderline
	 ::lBorder         := oSection:lBorder
	 ::lHeader         := oSection:lHeader
	 ::nInterLine      := oSection:nInterLine
	 ::nFixHeight      := oSection:nFixHeight
	 ::lRelative       := oSection:lRelative
	 ::lFixed          := oSection:lFixed
	 ::lPijama         := oSection:lPijama
	 ::nPijamaClr1     := oSection:nPijamaClr1
	 ::nPijamaClr2     := oSection:nPijamaClr2
	 ::nPijamaClr3     := oSection:nPijamaClr3
	 ::nLineWidth      := oSection:nLineWidth
	 ::nShadow         := oSection:nShadow

return NIL

//------------------------------------------------------------------------------
static function AssignClr()
local aClr := { Rgb( 250, 240, 230 ) ,;
						  Rgb( 240, 255, 240 ) ,;
						  Rgb( 240, 255, 255 ) ,;
						  Rgb( 255, 240, 255 ) ,;
						  Rgb( 211, 211, 211 )  }

	 if nSection > 5
		 nSection := 1
	 endif

return aClr[ nSection ]


//------------------------------------------------------------------------------
//                              class PMsg
//------------------------------------------------------------------------------

CLASS pMsg


	DATA   oDlg, oFont
	DATA   lExit                AS LOGICAL INIT .F.

	METHOD New( cCaption, cTitle )  CONSTRUCTOR

	METHOD SetText( cText )     INLINE ( ::oDlg:cMsg := cText ,;
													 ::oDlg:Refresh()     )

	METHOD End()                INLINE ( ::lExit := .T., ::oDlg:End(), ::oFont:end() )

ENDCLASS


//------------------------------------------------------------------------------
METHOD New( cCaption, cTitle ) CLASS pMsg

local nWidth

	 DEFAULT cCaption := ''
	 DEFAULT cTitle   := 'Sistema'

	 DEFINE FONT ::oFont NAME 'Arial' SIZE 0, -12

	 DEFINE DIALOG ::oDlg ;
			  FROM 0,0 TO 4, Max( Len( cCaption ), Len( cTitle ) ) + 4 ;
			  TITLE cTitle ;
			  STYLE DS_MODALFRAME

		nWidth := ::oDlg:nRight - ::oDlg:nLeft

		::oDlg:cMsg     := cCaption
		::oDlg:bPainted := {|| ::oDlg:Say( 11, 0, xPadC( ::oDlg:cMsg, nWidth ),,, ::oFont, .T. ) }
		::oDlg:bValid   := {|| ::lExit  }

	 ACTIVATE DIALOG ::oDlg CENTER NOMODAL

	 SysRefresh()

return Self


//------------------------------------------------------------------------------
//                                     funciones pdbg
//------------------------------------------------------------------------------

function Dbg( xVal, cTitle )
local cOrigen := Procname(1) + '(' + ltrim(str(Procline(1))) + ')'

	DEFAULT cTitle := ''

	OutputDebugString( cOrigen + ' ' + cTitle + ' => ' + cValToChar( xVal ) + CRLF )

return NIL

//------------------------------------------------------------------------------
DLL32 function OutputDebugString( cOutStr AS LPSTR ) As VOID PASCAL ;
		FROM "OutputDebugStringA" lib "kernel32.dll"


//------------------------------------------------------------------------------
//                                   class pdat
//------------------------------------------------------------------------------
CLASS pDat

	DATA   aBuffer                AS ARRAY INIT {}

	METHOD New()  CONSTRUCTOR
	METHOD End()
	METHOD AddVar( cName, uVal, cTxt )

	ERROR HANDLER OnError( uParam1 )

ENDCLASS


//------------------------------------------------------------------------------
METHOD New() CLASS pDat

	 ::aBuffer := {}

return Self

//------------------------------------------------------------------------------
METHOD End() CLASS pDat

	 ::aBuffer := {}

return NIL

//------------------------------------------------------------------------------
METHOD AddVar( cName, uVal, cTxt ) CLASS pDat
local nPos   := 0
local oError := NIL

	 DEFAULT uVal := NIL
	 DEFAULT cTxt := ""

	 if ValType( cName ) != 'C'
		 return NIL
	 endif

	 cName  := Upper( cName )
	 nPos   := AScan( ::aBuffer, { |x| x[ DATA_NAME ] == cName } )

	 if nPos == 0
		 Aadd( ::aBuffer, { cName, uVal, cTxt } )
	 else
		 MsgStop( "Variable en uso: " + cName )
	 endif

return NIL

//------------------------------------------------------------------------------
METHOD OnError( uParam1 ) CLASS pDat
local nVar
local cMsg   := __GetMessage()
local nError := If( SubStr( cMsg, 1, 1 ) == "_", 1005, 1004 )

	 cMsg := Upper( cMsg )

	 if SubStr( cMsg, 1, 1 ) == "_"
		 cMsg := Substr( cMsg, 2 )
		 nVar := AScan( ::aBuffer, { |x| x[ DATA_NAME ] == cMsg } )

		 if nVar > 0
			 ::aBuffer[ nVar ][ DATA_VAL ] := uParam1
		 else
			  MsgStop( "Variable no existe: " + cMsg , 'pDat() - Set')
		 endif
	  else
		 if Len( cMsg ) > 9
			 cMsg := Substr( cMsg, 1 )
		 endif

		 nVar := AScan( ::aBuffer, { |x| x[ DATA_NAME ] == cMsg } )

		 if nVar > 0
			 return ::aBuffer[ nVar ][ DATA_VAL ]
		 else
			 MsgBeep()
			 MsgStop( "Variable no existe: " + cMsg , 'pDat() - Get')
		 endif
	 endif

return NIL

//------------------------------------------------------------------------------
static function diruta()
local sal

	sal := hb_curdrive()
	if !empty(curdir())
		sal := sal+':\'+curdir()
	else
		sal := sal + ':'
	endif

return sal



//------------------------------------------------------------------------------
#pragma BEGINDUMP

#include <Windows.h>
#include <hbapi.h>

HB_FUNC( SETWINDOWRGN )
{
  hb_retnl( SetWindowRgn( ( HWND ) hb_parnl( 1 ), ( HRGN ) hb_parnl( 2 ), TRUE ) );
}

#pragma ENDDUMP


//------------------------------------------------------------------------------

#pragma BEGINDUMP

#include <windows.h>
#include <winuser.h>
#include <wingdi.h>
#include "hbapi.h"


HB_FUNC( CREATEBOLD )
{
		  LOGFONT lf;
		GetObject( ( HFONT ) hb_parnl( 1 ) , sizeof( LOGFONT ), &lf );
		lf.lfWeight = FW_BOLD;
						hb_retnl( (LONG) CreateFontIndirect( &lf ));
}

HB_FUNC( WBRWSCROLL ) // ( hWnd, nRows, hFont ) --> nil
{
	HWND hWnd   = ( HWND ) hb_parnl( 1 );
	int wRows  = hb_parni( 2 );
	HFONT hFont = ( HFONT ) hb_parnl( 3 );
	HFONT hOldFont;
	HDC hDC     = GetDC( hWnd );
	int nHLine = hb_parni( 4 );
	RECT rct;
	TEXTMETRIC tm;

	if( hFont )
		hOldFont = ( HFONT ) SelectObject( hDC, hFont );

	GetClientRect( hWnd, &rct );
	GetTextMetrics( hDC, &tm );
	tm.tmHeight = nHLine;

	rct.top += tm.tmHeight;
	//rct.bottom -= ( ( rct.bottom - rct.top ) % tm.tmHeight );

	ScrollWindowEx( hWnd, 0, -( tm.tmHeight * wRows ), 0, &rct, 0, 0, 0 );

	if( hFont )
		SelectObject( hDC, hOldFont );

	ReleaseDC( hWnd, hDC );
}

HB_FUNC( DRAWFRAMECONTROL )
{
		RECT rc;
		rc.top    = hb_parvni( 2, 1);
		rc.left   = hb_parvni( 2, 2);
		rc.bottom = hb_parvni( 2, 3);
		rc.right  = hb_parvni( 2, 4);

		 hb_retl( DrawFrameControl( (HDC) hb_parnl( 1 ), &rc, hb_parni( 3 ), hb_parni( 4 ) ) );
}
HB_FUNC( DRAWFOCUSRECT )  //RECT

{
	RECT rct ;
	HDC  hDC = ( HDC ) hb_parni( 1 );

	rct.top    = hb_parni( 2 );
	rct.left   = hb_parni( 3 );
	rct.bottom = hb_parni( 4 );
	rct.right  = hb_parni( 5 );

	DrawFocusRect( hDC, &rct );

}

HB_FUNC( HWNDCOMBO )
{
	COMBOBOXINFO cbi      ;
	ZeroMemory( &cbi, sizeof( COMBOBOXINFO ) );
	cbi.cbSize = sizeof(COMBOBOXINFO);

	GetComboBoxInfo( (HWND) hb_parnl( 1 ), &cbi );

	hb_retnl( (LONG)cbi.hwndCombo ) ;
}

HB_FUNC( HWNDCOMBOEDIT )
{
	COMBOBOXINFO cbi      ;
	ZeroMemory( &cbi, sizeof( COMBOBOXINFO ) );
	cbi.cbSize = sizeof(COMBOBOXINFO);

	GetComboBoxInfo( (HWND) hb_parnl( 1 ), &cbi );

	hb_retnl( (LONG)cbi.hwndItem ) ;
	//hb_retnl( (LONG)cbi.hwndList ) ;
}

HB_FUNC( HWNDCOMBOLIST )
{
	COMBOBOXINFO cbi      ;
	ZeroMemory( &cbi, sizeof( COMBOBOXINFO ) );
	cbi.cbSize = sizeof(COMBOBOXINFO);

	GetComboBoxInfo( (HWND) hb_parnl( 1 ), &cbi );

	hb_retnl( (LONG)cbi.hwndList ) ;
}

// Add Funtions...

HB_FUNC( PTINRECT )
{
	POINT pt;
	RECT  rct;

	pt.y = hb_parnl( 1 );
	pt.x = hb_parnl( 2 );

	rct.top    = hb_parvni( 3, 1 );
	rct.left   = hb_parvni( 3, 2 );
	rct.bottom = hb_parvni( 3, 3 );
	rct.right  = hb_parvni( 3, 4 );

	hb_retl( PtInRect( &rct, pt ) );
}

void FillSolidRect(HDC hDC, LPCRECT lpRect, COLORREF clr)
{
	SetBkColor(hDC, clr);
	ExtTextOut(hDC, 0, 0, ETO_OPAQUE, lpRect, NULL, 0, NULL);
}

HB_FUNC( FILLSOLIDRECT )
{
	 RECT rct;
	 COLORREF nColor;
	 HPEN hPen, hOldPen;
	 HDC hDC = ( HDC ) hb_parnl( 1 );
	 rct.top    = hb_parvni( 2, 1 );
	 rct.left   = hb_parvni( 2, 2 );
	 rct.bottom = hb_parvni( 2, 3 );
	 rct.right  = hb_parvni( 2, 4 );

	 nColor = SetBkColor( hDC, hb_parnl( 3 ) );
	 ExtTextOut( hDC, 0, 0, ETO_OPAQUE, &rct, NULL, 0, NULL);
	 SetBkColor( hDC, nColor );

	 if( hb_pcount()  > 3 )
	 {
		 hPen = CreatePen( PS_SOLID, 1,(COLORREF)hb_parnl( 4 ));
		 hOldPen = (HPEN) SelectObject( hDC, hPen );
		 MoveToEx( hDC, rct.left, rct.top, NULL );
		 LineTo( hDC, rct.right, rct.top );
		 LineTo( hDC, rct.right, rct.bottom );
		 LineTo( hDC, rct.left, rct.bottom );
		 LineTo( hDC, rct.left, rct.top );
		 SelectObject( hDC, hOldPen );
		 DeleteObject( hPen );
	 }
}

HB_FUNC( SETMENUDEFAULTITEM )
{
	 hb_retl( SetMenuDefaultItem( (HMENU) hb_parnl( 1 ), hb_parni( 2 ), 1));
}

#pragma ENDDUMP



//------------------------------------------------------------------------------
#pragma BEGINDUMP

#include <Windows.h>
#include <hbapi.h>


HB_FUNC( CREATECOMPATIBLEBITMAP )
{
			hb_retnl( (LONG) CreateCompatibleBitmap( ( HDC ) hb_parnl( 1 ), hb_parni( 2 ), hb_parni( 3 ) ));
}


HB_FUNC( CREATECOMPATIBLEDC )
{
			hb_retnl( (LONG) CreateCompatibleDC( ( HDC ) hb_parnl( 1 )));

}

#pragma ENDDUMP


